// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.lang.reflect.Method;
import org.apache.tools.ant.dispatch.Dispatchable;
import org.apache.tools.ant.dispatch.DispatchUtils;


public class TaskAdapter extends org.apache.tools.ant.Task implements org.apache.tools.ant.TypeAdapter
{

    private java.lang.Object proxy;

    public TaskAdapter()
    {
    }

    public TaskAdapter( java.lang.Object proxy )
    {
        this();
        setProxy( proxy );
    }

    public static  void checkTaskClass( final java.lang.Class taskClass, final org.apache.tools.ant.Project project )
    {
        if (!(org.apache.tools.ant.dispatch.Dispatchable.class).isAssignableFrom( taskClass )) {
            try {
                final java.lang.reflect.Method executeM = taskClass.getMethod( "execute", (java.lang.Class[]) null );
                if (!Void.TYPE.equals( executeM.getReturnType() )) {
                    final java.lang.String message = "return type of execute() should be " + "void but was \"" + executeM.getReturnType() + "\" in " + taskClass;
                    project.log( message, Project.MSG_WARN );
                }
            } catch ( java.lang.NoSuchMethodException e ) {
                final java.lang.String message = "No public execute() in " + taskClass;
                project.log( message, Project.MSG_ERR );
                throw new org.apache.tools.ant.BuildException( message );
            } catch ( java.lang.LinkageError e ) {
                java.lang.String message = "Could not load " + taskClass + ": " + e;
                project.log( message, Project.MSG_ERR );
                throw new org.apache.tools.ant.BuildException( message, e );
            }
        }
    }

    public  void checkProxyClass( java.lang.Class proxyClass )
    {
        checkTaskClass( proxyClass, getProject() );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        try {
            java.lang.reflect.Method setLocationM = proxy.getClass().getMethod( "setLocation", new java.lang.Class[]{ org.apache.tools.ant.Location.class } );
            if (setLocationM != null) {
                setLocationM.invoke( proxy, new java.lang.Object[]{ getLocation() } );
            }
        } catch ( java.lang.NoSuchMethodException e ) {
        } catch ( java.lang.Exception ex ) {
            log( "Error setting location in " + proxy.getClass(), Project.MSG_ERR );
            throw new org.apache.tools.ant.BuildException( ex );
        }
        try {
            java.lang.reflect.Method setProjectM = proxy.getClass().getMethod( "setProject", new java.lang.Class[]{ org.apache.tools.ant.Project.class } );
            if (setProjectM != null) {
                setProjectM.invoke( proxy, new java.lang.Object[]{ getProject() } );
            }
        } catch ( java.lang.NoSuchMethodException e ) {
        } catch ( java.lang.Exception ex ) {
            log( "Error setting project in " + proxy.getClass(), Project.MSG_ERR );
            throw new org.apache.tools.ant.BuildException( ex );
        }
        try {
            DispatchUtils.execute( proxy );
        } catch ( org.apache.tools.ant.BuildException be ) {
            throw be;
        } catch ( java.lang.Exception ex ) {
            log( "Error in " + proxy.getClass(), Project.MSG_VERBOSE );
            throw new org.apache.tools.ant.BuildException( ex );
        }
    }

    public  void setProxy( java.lang.Object o )
    {
        this.proxy = o;
    }

    public  java.lang.Object getProxy()
    {
        return proxy;
    }

}
