// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import org.apache.tools.ant.types.Parameter;


public final class ConcatFilter extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private java.io.File prepend;

    private java.io.File append;

    private java.io.Reader prependReader = null;

    private java.io.Reader appendReader = null;

    public ConcatFilter()
    {
        super();
    }

    public ConcatFilter( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = -1;
        if (prependReader != null) {
            ch = prependReader.read();
            if (ch == -1) {
                prependReader.close();
                prependReader = null;
            }
        }
        if (ch == -1) {
            ch = super.read();
        }
        if (ch == -1) {
            if (appendReader != null) {
                ch = appendReader.read();
                if (ch == -1) {
                    appendReader.close();
                    appendReader = null;
                }
            }
        }
        return ch;
    }

    public  void setPrepend( final java.io.File prepend )
    {
        this.prepend = prepend;
    }

    public  java.io.File getPrepend()
    {
        return prepend;
    }

    public  void setAppend( final java.io.File append )
    {
        this.append = append;
    }

    public  java.io.File getAppend()
    {
        return append;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.ConcatFilter newFilter = new org.apache.tools.ant.filters.ConcatFilter( rdr );
        newFilter.setPrepend( getPrepend() );
        newFilter.setAppend( getAppend() );
        return newFilter;
    }

    private  void initialize()
        throws java.io.IOException
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if ("prepend".equals( params[i].getName() )) {
                    setPrepend( new java.io.File( params[i].getValue() ) );
                    continue;
                }
                if ("append".equals( params[i].getName() )) {
                    setAppend( new java.io.File( params[i].getValue() ) );
                    continue;
                }
            }
        }
        if (prepend != null) {
            if (!prepend.isAbsolute()) {
                prepend = new java.io.File( getProject().getBaseDir(), prepend.getPath() );
            }
            prependReader = new java.io.BufferedReader( new java.io.FileReader( prepend ) );
        }
        if (append != null) {
            if (!append.isAbsolute()) {
                append = new java.io.File( getProject().getBaseDir(), append.getPath() );
            }
            appendReader = new java.io.BufferedReader( new java.io.FileReader( append ) );
        }
    }

}
