// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.util.LineTokenizer;
import org.apache.tools.ant.types.Parameter;


public final class HeadFilter extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final java.lang.String LINES_KEY = "lines";

    private static final java.lang.String SKIP_KEY = "skip";

    private long linesRead = 0;

    private static final int DEFAULT_NUM_LINES = 10;

    private long lines = DEFAULT_NUM_LINES;

    private long skip = 0;

    private org.apache.tools.ant.util.LineTokenizer lineTokenizer = null;

    private java.lang.String line = null;

    private int linePos = 0;

    private boolean eof;

    public HeadFilter()
    {
        super();
    }

    public HeadFilter( final java.io.Reader in )
    {
        super( in );
        lineTokenizer = new org.apache.tools.ant.util.LineTokenizer();
        lineTokenizer.setIncludeDelims( true );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        while (line == null || line.length() == 0) {
            line = lineTokenizer.getToken( in );
            if (line == null) {
                return -1;
            }
            line = headFilter( line );
            if (eof) {
                return -1;
            }
            linePos = 0;
        }
        int ch = line.charAt( linePos );
        linePos++;
        if (linePos == line.length()) {
            line = null;
        }
        return ch;
    }

    public  void setLines( final long lines )
    {
        this.lines = lines;
    }

    private  long getLines()
    {
        return lines;
    }

    public  void setSkip( final long skip )
    {
        this.skip = skip;
    }

    private  long getSkip()
    {
        return skip;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.HeadFilter newFilter = new org.apache.tools.ant.filters.HeadFilter( rdr );
        newFilter.setLines( getLines() );
        newFilter.setSkip( getSkip() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (LINES_KEY.equals( params[i].getName() )) {
                    lines = Long.parseLong( params[i].getValue() );
                    continue;
                }
                if (SKIP_KEY.equals( params[i].getName() )) {
                    skip = Long.parseLong( params[i].getValue() );
                    continue;
                }
            }
        }
    }

    private  java.lang.String headFilter( java.lang.String line )
    {
        linesRead++;
        if (skip > 0) {
            if (linesRead - 1 < skip) {
                return null;
            }
        }
        if (lines > 0) {
            if (linesRead > lines + skip) {
                eof = true;
                return null;
            }
        }
        return line;
    }

}
