// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.types.Parameter;


public final class PrefixLines extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final java.lang.String PREFIX_KEY = "prefix";

    private java.lang.String prefix = null;

    private java.lang.String queuedData = null;

    public PrefixLines()
    {
        super();
    }

    public PrefixLines( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = -1;
        if (queuedData != null && queuedData.length() == 0) {
            queuedData = null;
        }
        if (queuedData != null) {
            ch = queuedData.charAt( 0 );
            queuedData = queuedData.substring( 1 );
            if (queuedData.length() == 0) {
                queuedData = null;
            }
        } else {
            queuedData = readLine();
            if (queuedData == null) {
                ch = -1;
            } else {
                if (prefix != null) {
                    queuedData = prefix + queuedData;
                }
                return read();
            }
        }
        return ch;
    }

    public  void setPrefix( final java.lang.String prefix )
    {
        this.prefix = prefix;
    }

    private  java.lang.String getPrefix()
    {
        return prefix;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.PrefixLines newFilter = new org.apache.tools.ant.filters.PrefixLines( rdr );
        newFilter.setPrefix( getPrefix() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (PREFIX_KEY.equals( params[i].getName() )) {
                    prefix = params[i].getValue();
                    break;
                }
            }
        }
    }

}
