// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.types.Parameter;


public final class StripLineBreaks extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final java.lang.String DEFAULT_LINE_BREAKS = "\r\n";

    private static final java.lang.String LINE_BREAKS_KEY = "linebreaks";

    private java.lang.String lineBreaks = DEFAULT_LINE_BREAKS;

    public StripLineBreaks()
    {
        super();
    }

    public StripLineBreaks( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = in.read();
        while (ch != -1) {
            if (lineBreaks.indexOf( ch ) == -1) {
                break;
            } else {
                ch = in.read();
            }
        }
        return ch;
    }

    public  void setLineBreaks( final java.lang.String lineBreaks )
    {
        this.lineBreaks = lineBreaks;
    }

    private  java.lang.String getLineBreaks()
    {
        return lineBreaks;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.StripLineBreaks newFilter = new org.apache.tools.ant.filters.StripLineBreaks( rdr );
        newFilter.setLineBreaks( getLineBreaks() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        java.lang.String userDefinedLineBreaks = null;
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (LINE_BREAKS_KEY.equals( params[i].getName() )) {
                    userDefinedLineBreaks = params[i].getValue();
                    break;
                }
            }
        }
        if (userDefinedLineBreaks != null) {
            lineBreaks = userDefinedLineBreaks;
        }
    }

}
