// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import java.util.Vector;
import org.apache.tools.ant.types.Parameter;


public final class StripLineComments extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final java.lang.String COMMENTS_KEY = "comment";

    private java.util.Vector comments = new java.util.Vector();

    private java.lang.String line = null;

    public StripLineComments()
    {
        super();
    }

    public StripLineComments( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = -1;
        if (line != null) {
            ch = line.charAt( 0 );
            if (line.length() == 1) {
                line = null;
            } else {
                line = line.substring( 1 );
            }
        } else {
            line = readLine();
            final int commentsSize = comments.size();
            while (line != null) {
                for (int i = 0; i < commentsSize; i++) {
                    java.lang.String comment = (java.lang.String) comments.elementAt( i );
                    if (line.startsWith( comment )) {
                        line = null;
                        break;
                    }
                }
                if (line == null) {
                    line = readLine();
                } else {
                    break;
                }
            }
            if (line != null) {
                return read();
            }
        }
        return ch;
    }

    public  void addConfiguredComment( final org.apache.tools.ant.filters.StripLineComments.Comment comment )
    {
        comments.addElement( comment.getValue() );
    }

    private  void setComments( final java.util.Vector comments )
    {
        this.comments = comments;
    }

    private  java.util.Vector getComments()
    {
        return comments;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.StripLineComments newFilter = new org.apache.tools.ant.filters.StripLineComments( rdr );
        newFilter.setComments( getComments() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (COMMENTS_KEY.equals( params[i].getType() )) {
                    comments.addElement( params[i].getValue() );
                }
            }
        }
    }

    public static class Comment
    {

        private java.lang.String value;

        public final  void setValue( java.lang.String comment )
        {
            if (value != null) {
                throw new java.lang.IllegalStateException( "Comment value already set." );
            }
            value = comment;
        }

        public final  java.lang.String getValue()
        {
            return value;
        }

        public  void addText( java.lang.String comment )
        {
            setValue( comment );
        }

    }

}
