// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.types.Parameter;


public final class TabsToSpaces extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final int DEFAULT_TAB_LENGTH = 8;

    private static final java.lang.String TAB_LENGTH_KEY = "tablength";

    private int tabLength = DEFAULT_TAB_LENGTH;

    private int spacesRemaining = 0;

    public TabsToSpaces()
    {
        super();
    }

    public TabsToSpaces( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = -1;
        if (spacesRemaining > 0) {
            spacesRemaining--;
            ch = ' ';
        } else {
            ch = in.read();
            if (ch == '\t') {
                spacesRemaining = tabLength - 1;
                ch = ' ';
            }
        }
        return ch;
    }

    public  void setTablength( final int tabLength )
    {
        this.tabLength = tabLength;
    }

    private  int getTablength()
    {
        return tabLength;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.TabsToSpaces newFilter = new org.apache.tools.ant.filters.TabsToSpaces( rdr );
        newFilter.setTablength( getTablength() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (params[i] != null) {
                    if (TAB_LENGTH_KEY.equals( params[i].getName() )) {
                        tabLength = Integer.parseInt( params[i].getValue() );
                        break;
                    }
                }
            }
        }
    }

}
