// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.helper;


import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import org.xml.sax.Locator;
import org.xml.sax.Attributes;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Location;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.RuntimeConfigurable;
import org.apache.tools.ant.Target;
import org.apache.tools.ant.util.FileUtils;


public class AntXMLContext
{

    private org.apache.tools.ant.Project project;

    private java.io.File buildFile;

    private java.net.URL buildFileURL;

    private java.util.Vector targetVector = new java.util.Vector();

    private java.io.File buildFileParent;

    private java.net.URL buildFileParentURL;

    private java.lang.String currentProjectName;

    private org.xml.sax.Locator locator;

    private org.apache.tools.ant.Target implicitTarget = new org.apache.tools.ant.Target();

    private org.apache.tools.ant.Target currentTarget = null;

    private java.util.Vector wStack = new java.util.Vector();

    private boolean ignoreProjectTag = false;

    private java.util.Map prefixMapping = new java.util.HashMap();

    private java.util.Map currentTargets = null;

    public AntXMLContext( org.apache.tools.ant.Project project )
    {
        this.project = project;
        implicitTarget.setProject( project );
        implicitTarget.setName( "" );
        targetVector.addElement( implicitTarget );
    }

    public  void setBuildFile( java.io.File buildFile )
    {
        this.buildFile = buildFile;
        if (buildFile != null) {
            this.buildFileParent = new java.io.File( buildFile.getParent() );
            implicitTarget.setLocation( new org.apache.tools.ant.Location( buildFile.getAbsolutePath() ) );
            try {
                setBuildFile( FileUtils.getFileUtils().getFileURL( buildFile ) );
            } catch ( java.net.MalformedURLException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            }
        } else {
            this.buildFileParent = null;
        }
    }

    public  void setBuildFile( java.net.URL buildFile )
        throws java.net.MalformedURLException
    {
        this.buildFileURL = buildFile;
        this.buildFileParentURL = new java.net.URL( buildFile, "." );
        if (implicitTarget.getLocation() == null) {
            implicitTarget.setLocation( new org.apache.tools.ant.Location( buildFile.toString() ) );
        }
    }

    public  java.io.File getBuildFile()
    {
        return buildFile;
    }

    public  java.io.File getBuildFileParent()
    {
        return buildFileParent;
    }

    public  java.net.URL getBuildFileURL()
    {
        return buildFileURL;
    }

    public  java.net.URL getBuildFileParentURL()
    {
        return buildFileParentURL;
    }

    public  org.apache.tools.ant.Project getProject()
    {
        return project;
    }

    public  java.lang.String getCurrentProjectName()
    {
        return currentProjectName;
    }

    public  void setCurrentProjectName( java.lang.String name )
    {
        this.currentProjectName = name;
    }

    public  org.apache.tools.ant.RuntimeConfigurable currentWrapper()
    {
        if (wStack.size() < 1) {
            return null;
        }
        return (org.apache.tools.ant.RuntimeConfigurable) wStack.elementAt( wStack.size() - 1 );
    }

    public  org.apache.tools.ant.RuntimeConfigurable parentWrapper()
    {
        if (wStack.size() < 2) {
            return null;
        }
        return (org.apache.tools.ant.RuntimeConfigurable) wStack.elementAt( wStack.size() - 2 );
    }

    public  void pushWrapper( org.apache.tools.ant.RuntimeConfigurable wrapper )
    {
        wStack.addElement( wrapper );
    }

    public  void popWrapper()
    {
        if (wStack.size() > 0) {
            wStack.removeElementAt( wStack.size() - 1 );
        }
    }

    public  java.util.Vector getWrapperStack()
    {
        return wStack;
    }

    public  void addTarget( org.apache.tools.ant.Target target )
    {
        targetVector.addElement( target );
        currentTarget = target;
    }

    public  org.apache.tools.ant.Target getCurrentTarget()
    {
        return currentTarget;
    }

    public  org.apache.tools.ant.Target getImplicitTarget()
    {
        return implicitTarget;
    }

    public  void setCurrentTarget( org.apache.tools.ant.Target target )
    {
        this.currentTarget = target;
    }

    public  void setImplicitTarget( org.apache.tools.ant.Target target )
    {
        this.implicitTarget = target;
    }

    public  java.util.Vector getTargets()
    {
        return targetVector;
    }

    public  void configureId( java.lang.Object element, org.xml.sax.Attributes attr )
    {
        java.lang.String id = attr.getValue( "id" );
        if (id != null) {
            project.addIdReference( id, element );
        }
    }

    public  org.xml.sax.Locator getLocator()
    {
        return locator;
    }

    public  void setLocator( org.xml.sax.Locator locator )
    {
        this.locator = locator;
    }

    public  boolean isIgnoringProjectTag()
    {
        return ignoreProjectTag;
    }

    public  void setIgnoreProjectTag( boolean flag )
    {
        this.ignoreProjectTag = flag;
    }

    public  void startPrefixMapping( java.lang.String prefix, java.lang.String uri )
    {
        java.util.List list = (java.util.List) prefixMapping.get( prefix );
        if (list == null) {
            list = new java.util.ArrayList();
            prefixMapping.put( prefix, list );
        }
        list.add( uri );
    }

    public  void endPrefixMapping( java.lang.String prefix )
    {
        java.util.List list = (java.util.List) prefixMapping.get( prefix );
        if (list == null || list.size() == 0) {
            return;
        }
        list.remove( list.size() - 1 );
    }

    public  java.lang.String getPrefixMapping( java.lang.String prefix )
    {
        java.util.List list = (java.util.List) prefixMapping.get( prefix );
        if (list == null || list.size() == 0) {
            return null;
        }
        return (java.lang.String) list.get( list.size() - 1 );
    }

    public  java.util.Map getCurrentTargets()
    {
        return currentTargets;
    }

    public  void setCurrentTargets( java.util.Map currentTargets )
    {
        this.currentTargets = currentTargets;
    }

}
