// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.input;


import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;
import org.apache.tools.ant.BuildException;


public class PropertyFileInputHandler implements org.apache.tools.ant.input.InputHandler
{

    private java.util.Properties props = null;

    public static final java.lang.String FILE_NAME_KEY = "ant.input.properties";

    public PropertyFileInputHandler()
    {
    }

    public  void handleInput( org.apache.tools.ant.input.InputRequest request )
        throws org.apache.tools.ant.BuildException
    {
        readProps();
        java.lang.Object o = props.get( request.getPrompt() );
        if (o == null) {
            throw new org.apache.tools.ant.BuildException( "Unable to find input for \'" + request.getPrompt() + "\'" );
        }
        request.setInput( o.toString() );
        if (!request.isInputValid()) {
            throw new org.apache.tools.ant.BuildException( "Found invalid input " + o + " for \'" + request.getPrompt() + "\'" );
        }
    }

    private synchronized  void readProps()
        throws org.apache.tools.ant.BuildException
    {
        if (props == null) {
            java.lang.String propsFile = System.getProperty( FILE_NAME_KEY );
            if (propsFile == null) {
                throw new org.apache.tools.ant.BuildException( "System property " + FILE_NAME_KEY + " for PropertyFileInputHandler not" + " set" );
            }
            props = new java.util.Properties();
            try {
                props.load( new java.io.FileInputStream( propsFile ) );
            } catch ( java.io.IOException e ) {
                throw new org.apache.tools.ant.BuildException( "Couldn't load " + propsFile, e );
            }
        }
    }

}
