// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.listener;


import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Properties;
import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.Project;


public class AnsiColorLogger extends org.apache.tools.ant.DefaultLogger
{

    private static final int ATTR_DIM = 2;

    private static final int FG_RED = 31;

    private static final int FG_GREEN = 32;

    private static final int FG_BLUE = 34;

    private static final int FG_MAGENTA = 35;

    private static final int FG_CYAN = 36;

    private static final java.lang.String PREFIX = "[";

    private static final java.lang.String SUFFIX = "m";

    private static final char SEPARATOR = ';';

    private static final java.lang.String END_COLOR = PREFIX + SUFFIX;

    private java.lang.String errColor = PREFIX + ATTR_DIM + SEPARATOR + FG_RED + SUFFIX;

    private java.lang.String warnColor = PREFIX + ATTR_DIM + SEPARATOR + FG_MAGENTA + SUFFIX;

    private java.lang.String infoColor = PREFIX + ATTR_DIM + SEPARATOR + FG_CYAN + SUFFIX;

    private java.lang.String verboseColor = PREFIX + ATTR_DIM + SEPARATOR + FG_GREEN + SUFFIX;

    private java.lang.String debugColor = PREFIX + ATTR_DIM + SEPARATOR + FG_BLUE + SUFFIX;

    private boolean colorsSet = false;

    private  void setColors()
    {
        java.lang.String userColorFile = System.getProperty( "ant.logger.defaults" );
        java.lang.String systemColorFile = "/org/apache/tools/ant/listener/defaults.properties";
        java.io.InputStream in = null;
        try {
            java.util.Properties prop = new java.util.Properties();
            if (userColorFile != null) {
                in = new java.io.FileInputStream( userColorFile );
            } else {
                in = getClass().getResourceAsStream( systemColorFile );
            }
            if (in != null) {
                prop.load( in );
            }
            java.lang.String errC = prop.getProperty( "AnsiColorLogger.ERROR_COLOR" );
            java.lang.String warn = prop.getProperty( "AnsiColorLogger.WARNING_COLOR" );
            java.lang.String info = prop.getProperty( "AnsiColorLogger.INFO_COLOR" );
            java.lang.String verbose = prop.getProperty( "AnsiColorLogger.VERBOSE_COLOR" );
            java.lang.String debug = prop.getProperty( "AnsiColorLogger.DEBUG_COLOR" );
            if (errC != null) {
                errColor = PREFIX + errC + SUFFIX;
            }
            if (warn != null) {
                warnColor = PREFIX + warn + SUFFIX;
            }
            if (info != null) {
                infoColor = PREFIX + info + SUFFIX;
            }
            if (verbose != null) {
                verboseColor = PREFIX + verbose + SUFFIX;
            }
            if (debug != null) {
                debugColor = PREFIX + debug + SUFFIX;
            }
        } catch ( java.io.IOException ioe ) {
        } finally 
{
            if (in != null) {
                try {
                    in.close();
                } catch ( java.io.IOException e ) {
                }
            }
        }
    }

    protected  void printMessage( final java.lang.String message, final java.io.PrintStream stream, final int priority )
    {
        if (message != null && stream != null) {
            if (!colorsSet) {
                setColors();
                colorsSet = true;
            }
            final java.lang.StringBuffer msg = new java.lang.StringBuffer( message );
            switch (priority) {
            case Project.MSG_ERR :
                msg.insert( 0, errColor );
                msg.append( END_COLOR );
                break;

            case Project.MSG_WARN :
                msg.insert( 0, warnColor );
                msg.append( END_COLOR );
                break;

            case Project.MSG_INFO :
                msg.insert( 0, infoColor );
                msg.append( END_COLOR );
                break;

            case Project.MSG_VERBOSE :
                msg.insert( 0, verboseColor );
                msg.append( END_COLOR );
                break;

            case Project.MSG_DEBUG :
            default  :
                msg.insert( 0, debugColor );
                msg.append( END_COLOR );
                break;

            }
            final java.lang.String strmessage = msg.toString();
            stream.println( strmessage );
        }
    }

}
