// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.util.DeweyDecimal;


public class AntVersion extends org.apache.tools.ant.Task implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private java.lang.String atLeast = null;

    private java.lang.String exactly = null;

    private java.lang.String propertyname = null;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (propertyname == null) {
            throw new org.apache.tools.ant.BuildException( "'property' must be set." );
        }
        if (atLeast != null || exactly != null) {
            if (eval()) {
                getProject().setNewProperty( propertyname, getVersion().toString() );
            }
        } else {
            getProject().setNewProperty( propertyname, getVersion().toString() );
        }
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        validate();
        org.apache.tools.ant.util.DeweyDecimal actual = getVersion();
        if (null != atLeast) {
            return actual.isGreaterThanOrEqual( new org.apache.tools.ant.util.DeweyDecimal( atLeast ) );
        }
        if (null != exactly) {
            return actual.isEqual( new org.apache.tools.ant.util.DeweyDecimal( exactly ) );
        }
        return false;
    }

    private  void validate()
        throws org.apache.tools.ant.BuildException
    {
        if (atLeast != null && exactly != null) {
            throw new org.apache.tools.ant.BuildException( "Only one of atleast or exactly may be set." );
        }
        if (null == atLeast && null == exactly) {
            throw new org.apache.tools.ant.BuildException( "One of atleast or exactly must be set." );
        }
        if (atLeast != null) {
            try {
                new org.apache.tools.ant.util.DeweyDecimal( atLeast );
            } catch ( java.lang.NumberFormatException e ) {
                throw new org.apache.tools.ant.BuildException( "The 'atleast' attribute is not a Dewey Decimal eg 1.1.0 : " + atLeast );
            }
        } else {
            try {
                new org.apache.tools.ant.util.DeweyDecimal( exactly );
            } catch ( java.lang.NumberFormatException e ) {
                throw new org.apache.tools.ant.BuildException( "The 'exactly' attribute is not a Dewey Decimal eg 1.1.0 : " + exactly );
            }
        }
    }

    private  org.apache.tools.ant.util.DeweyDecimal getVersion()
    {
        org.apache.tools.ant.Project p = new org.apache.tools.ant.Project();
        p.init();
        char[] versionString = p.getProperty( "ant.version" ).toCharArray();
        java.lang.StringBuffer sb = new java.lang.StringBuffer();
        boolean foundFirstDigit = false;
        for (int i = 0; i < versionString.length; i++) {
            if (Character.isDigit( versionString[i] )) {
                sb.append( versionString[i] );
                foundFirstDigit = true;
            }
            if (versionString[i] == '.' && foundFirstDigit) {
                sb.append( versionString[i] );
            }
            if (Character.isLetter( versionString[i] ) && foundFirstDigit) {
                break;
            }
        }
        return new org.apache.tools.ant.util.DeweyDecimal( sb.toString() );
    }

    public  java.lang.String getAtLeast()
    {
        return atLeast;
    }

    public  void setAtLeast( java.lang.String atLeast )
    {
        this.atLeast = atLeast;
    }

    public  java.lang.String getExactly()
    {
        return exactly;
    }

    public  void setExactly( java.lang.String exactly )
    {
        this.exactly = exactly;
    }

    public  java.lang.String getProperty()
    {
        return propertyname;
    }

    public  void setProperty( java.lang.String propertyname )
    {
        this.propertyname = propertyname;
    }

}
