// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.ProjectComponent;
import java.lang.reflect.Method;
import java.lang.reflect.Field;


public class HasMethod extends org.apache.tools.ant.ProjectComponent implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private java.lang.String classname;

    private java.lang.String method;

    private java.lang.String field;

    private org.apache.tools.ant.types.Path classpath;

    private org.apache.tools.ant.AntClassLoader loader;

    private boolean ignoreSystemClasses = false;

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        createClasspath().append( classpath );
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (this.classpath == null) {
            this.classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return this.classpath.createPath();
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference r )
    {
        createClasspath().setRefid( r );
    }

    public  void setClassname( java.lang.String classname )
    {
        this.classname = classname;
    }

    public  void setMethod( java.lang.String method )
    {
        this.method = method;
    }

    public  void setField( java.lang.String field )
    {
        this.field = field;
    }

    public  void setIgnoreSystemClasses( boolean ignoreSystemClasses )
    {
        this.ignoreSystemClasses = ignoreSystemClasses;
    }

    private  java.lang.Class loadClass( java.lang.String classname )
    {
        try {
            if (ignoreSystemClasses) {
                loader = getProject().createClassLoader( classpath );
                loader.setParentFirst( false );
                loader.addJavaLibraries();
                try {
                    return loader.findClass( classname );
                } catch ( java.lang.SecurityException se ) {
                    throw new org.apache.tools.ant.BuildException( "class \"" + classname + "\" was found but a" + " SecurityException has been" + " raised while loading it", se );
                }
            } else {
                if (loader != null) {
                    return loader.loadClass( classname );
                } else {
                    java.lang.ClassLoader l = this.getClass().getClassLoader();
                    if (l != null) {
                        return Class.forName( classname, true, l );
                    } else {
                        return Class.forName( classname );
                    }
                }
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.tools.ant.BuildException( "class \"" + classname + "\" was not found" );
        } catch ( java.lang.NoClassDefFoundError e ) {
            throw new org.apache.tools.ant.BuildException( "Could not load dependent class \"" + e.getMessage() + "\" for class \"" + classname + "\"" );
        }
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (classname == null) {
            throw new org.apache.tools.ant.BuildException( "No classname defined" );
        }
        java.lang.ClassLoader preLoadClass = loader;
        try {
            java.lang.Class clazz = loadClass( classname );
            if (method != null) {
                return isMethodFound( clazz );
            }
            if (field != null) {
                return isFieldFound( clazz );
            }
            throw new org.apache.tools.ant.BuildException( "Neither method nor field defined" );
        } finally 
{
            if (preLoadClass != loader && loader != null) {
                loader.cleanup();
                loader = null;
            }
        }
    }

    private  boolean isFieldFound( java.lang.Class clazz )
    {
        java.lang.reflect.Field[] fields = clazz.getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            java.lang.reflect.Field fieldEntry = fields[i];
            if (fieldEntry.getName().equals( field )) {
                return true;
            }
        }
        return false;
    }

    private  boolean isMethodFound( java.lang.Class clazz )
    {
        java.lang.reflect.Method[] methods = clazz.getDeclaredMethods();
        for (int i = 0; i < methods.length; i++) {
            java.lang.reflect.Method methodEntry = methods[i];
            if (methodEntry.getName().equals( method )) {
                return true;
            }
        }
        return false;
    }

}
