// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.types.RegularExpression;
import org.apache.tools.ant.util.regexp.Regexp;
import org.apache.tools.ant.util.regexp.RegexpUtil;


public class Matches extends org.apache.tools.ant.ProjectComponent implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private java.lang.String string;

    private boolean caseSensitive = true;

    private boolean multiLine = false;

    private boolean singleLine = false;

    private org.apache.tools.ant.types.RegularExpression regularExpression;

    public  void setString( java.lang.String string )
    {
        this.string = string;
    }

    public  void setPattern( java.lang.String pattern )
    {
        if (regularExpression != null) {
            throw new org.apache.tools.ant.BuildException( "Only one regular expression is allowed." );
        }
        regularExpression = new org.apache.tools.ant.types.RegularExpression();
        regularExpression.setPattern( pattern );
    }

    public  void addRegexp( org.apache.tools.ant.types.RegularExpression regularExpression )
    {
        if (this.regularExpression != null) {
            throw new org.apache.tools.ant.BuildException( "Only one regular expression is allowed." );
        }
        this.regularExpression = regularExpression;
    }

    public  void setCasesensitive( boolean b )
    {
        caseSensitive = b;
    }

    public  void setMultiline( boolean b )
    {
        multiLine = b;
    }

    public  void setSingleLine( boolean b )
    {
        singleLine = b;
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (string == null) {
            throw new org.apache.tools.ant.BuildException( "Parameter string is required in matches." );
        }
        if (regularExpression == null) {
            throw new org.apache.tools.ant.BuildException( "Missing pattern in matches." );
        }
        int options = RegexpUtil.asOptions( caseSensitive, multiLine, singleLine );
        org.apache.tools.ant.util.regexp.Regexp regexp = regularExpression.getRegexp( getProject() );
        return regexp.matches( string, options );
    }

}
