// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.util.JAXPUtils;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.XMLReader;


public class ParserSupports extends org.apache.tools.ant.ProjectComponent implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private java.lang.String feature;

    private java.lang.String property;

    private java.lang.String value;

    public static final java.lang.String ERROR_BOTH_ATTRIBUTES = "Property and feature attributes are exclusive";

    public static final java.lang.String FEATURE = "feature";

    public static final java.lang.String PROPERTY = "property";

    public static final java.lang.String NOT_RECOGNIZED = " not recognized: ";

    public static final java.lang.String NOT_SUPPORTED = " not supported: ";

    public static final java.lang.String ERROR_NO_ATTRIBUTES = "Neither feature or property are set";

    public static final java.lang.String ERROR_NO_VALUE = "A value is needed when testing for property support";

    public  void setFeature( java.lang.String feature )
    {
        this.feature = feature;
    }

    public  void setProperty( java.lang.String property )
    {
        this.property = property;
    }

    public  void setValue( java.lang.String value )
    {
        this.value = value;
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (feature != null && property != null) {
            throw new org.apache.tools.ant.BuildException( ERROR_BOTH_ATTRIBUTES );
        }
        if (feature == null && property == null) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_ATTRIBUTES );
        }
        if (feature != null) {
            return evalFeature();
        }
        if (value == null) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_VALUE );
        }
        return evalProperty();
    }

    private  org.xml.sax.XMLReader getReader()
    {
        JAXPUtils.getParser();
        return JAXPUtils.getXMLReader();
    }

    public  boolean evalFeature()
    {
        org.xml.sax.XMLReader reader = getReader();
        if (value == null) {
            value = "true";
        }
        boolean v = Project.toBoolean( value );
        try {
            reader.setFeature( feature, v );
        } catch ( org.xml.sax.SAXNotRecognizedException e ) {
            log( FEATURE + NOT_RECOGNIZED + feature, Project.MSG_VERBOSE );
            return false;
        } catch ( org.xml.sax.SAXNotSupportedException e ) {
            log( FEATURE + NOT_SUPPORTED + feature, Project.MSG_VERBOSE );
            return false;
        }
        return true;
    }

    public  boolean evalProperty()
    {
        org.xml.sax.XMLReader reader = getReader();
        try {
            reader.setProperty( property, value );
        } catch ( org.xml.sax.SAXNotRecognizedException e ) {
            log( PROPERTY + NOT_RECOGNIZED + property, Project.MSG_VERBOSE );
            return false;
        } catch ( org.xml.sax.SAXNotSupportedException e ) {
            log( PROPERTY + NOT_SUPPORTED + property, Project.MSG_VERBOSE );
            return false;
        }
        return true;
    }

}
