// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.util.FileUtils;


public class ResourceContains implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private org.apache.tools.ant.Project project;

    private java.lang.String substring;

    private org.apache.tools.ant.types.Resource resource;

    private java.lang.String refid;

    private boolean casesensitive = true;

    public  void setProject( org.apache.tools.ant.Project project )
    {
        this.project = project;
    }

    public  org.apache.tools.ant.Project getProject()
    {
        return project;
    }

    public  void setResource( java.lang.String r )
    {
        this.resource = new org.apache.tools.ant.types.resources.FileResource( new java.io.File( r ) );
    }

    public  void setRefid( java.lang.String refid )
    {
        this.refid = refid;
    }

    private  void resolveRefid()
    {
        try {
            if (getProject() == null) {
                throw new org.apache.tools.ant.BuildException( "Cannot retrieve refid; project unset" );
            }
            java.lang.Object o = getProject().getReference( refid );
            if (!(o instanceof org.apache.tools.ant.types.Resource)) {
                if (o instanceof org.apache.tools.ant.types.ResourceCollection) {
                    org.apache.tools.ant.types.ResourceCollection rc = (org.apache.tools.ant.types.ResourceCollection) o;
                    if (rc.size() == 1) {
                        o = rc.iterator().next();
                    }
                } else {
                    throw new org.apache.tools.ant.BuildException( "Illegal value at '" + refid + "': " + String.valueOf( o ) );
                }
            }
            this.resource = (org.apache.tools.ant.types.Resource) o;
        } finally 
{
            refid = null;
        }
    }

    public  void setSubstring( java.lang.String substring )
    {
        this.substring = substring;
    }

    public  void setCasesensitive( boolean casesensitive )
    {
        this.casesensitive = casesensitive;
    }

    private  void validate()
    {
        if (resource != null && refid != null) {
            throw new org.apache.tools.ant.BuildException( "Cannot set both resource and refid" );
        }
        if (resource == null && refid != null) {
            resolveRefid();
        }
        if (resource == null || substring == null) {
            throw new org.apache.tools.ant.BuildException( "both resource and substring are required " + "in <resourcecontains>" );
        }
    }

    public synchronized  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        validate();
        if (substring.length() == 0) {
            if (getProject() != null) {
                getProject().log( "Substring is empty; returning true", Project.MSG_VERBOSE );
            }
            return true;
        }
        if (resource.getSize() == 0) {
            return false;
        }
        java.io.BufferedReader reader = null;
        try {
            reader = new java.io.BufferedReader( new java.io.InputStreamReader( resource.getInputStream() ) );
            java.lang.String contents = FileUtils.safeReadFully( reader );
            java.lang.String sub = substring;
            if (!casesensitive) {
                contents = contents.toLowerCase();
                sub = sub.toLowerCase();
            }
            return contents.indexOf( sub ) >= 0;
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( "There was a problem accessing resource : " + resource );
        } finally 
{
            FileUtils.close( reader );
        }
    }

}
