// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import java.io.IOException;
import java.util.Iterator;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.resources.Union;
import org.apache.tools.ant.util.ResourceUtils;


public class ResourcesMatch implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private org.apache.tools.ant.types.resources.Union resources = null;

    private boolean asText = false;

    public  void setAsText( boolean asText )
    {
        this.asText = asText;
    }

    public  void add( org.apache.tools.ant.types.ResourceCollection rc )
    {
        if (rc == null) {
            return;
        }
        resources = resources == null ? new org.apache.tools.ant.types.resources.Union() : resources;
        resources.add( rc );
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (resources == null) {
            throw new org.apache.tools.ant.BuildException( "You must specify one or more nested resource collections" );
        }
        if (resources.size() > 1) {
            java.util.Iterator i = resources.iterator();
            org.apache.tools.ant.types.Resource r1 = (org.apache.tools.ant.types.Resource) i.next();
            org.apache.tools.ant.types.Resource r2 = null;
            while (i.hasNext()) {
                r2 = (org.apache.tools.ant.types.Resource) i.next();
                try {
                    if (!ResourceUtils.contentEquals( r1, r2, asText )) {
                        return false;
                    }
                } catch ( java.io.IOException ioe ) {
                    throw new org.apache.tools.ant.BuildException( "when comparing resources " + r1.toString() + " and " + r2.toString(), ioe );
                }
                r1 = r2;
            }
        }
        return true;
    }

}
