// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.email;


import java.io.File;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.EnumeratedAttribute;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.resources.FileProvider;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.util.ClasspathUtils;


public class EmailTask extends org.apache.tools.ant.Task
{

    private static final int SMTP_PORT = 25;

    public static final java.lang.String AUTO = "auto";

    public static final java.lang.String MIME = "mime";

    public static final java.lang.String UU = "uu";

    public static final java.lang.String PLAIN = "plain";

    public static class Encoding extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ AUTO, MIME, UU, PLAIN };
        }

    }

    private java.lang.String encoding = AUTO;

    private java.lang.String host = "localhost";

    private java.lang.Integer port = null;

    private java.lang.String subject = null;

    private org.apache.tools.ant.taskdefs.email.Message message = null;

    private boolean failOnError = true;

    private boolean includeFileNames = false;

    private java.lang.String messageMimeType = null;

    private org.apache.tools.ant.taskdefs.email.EmailAddress from = null;

    private java.util.Vector replyToList = new java.util.Vector();

    private java.util.Vector toList = new java.util.Vector();

    private java.util.Vector ccList = new java.util.Vector();

    private java.util.Vector bccList = new java.util.Vector();

    private java.util.Vector headers = new java.util.Vector();

    private org.apache.tools.ant.types.Path attachments = null;

    private java.lang.String charset = null;

    private java.lang.String user = null;

    private java.lang.String password = null;

    private boolean ssl = false;

    private boolean starttls = false;

    private boolean ignoreInvalidRecipients = false;

    public  void setUser( java.lang.String user )
    {
        this.user = user;
    }

    public  void setPassword( java.lang.String password )
    {
        this.password = password;
    }

    public  void setSSL( boolean ssl )
    {
        this.ssl = ssl;
    }

    public  void setEnableStartTLS( boolean b )
    {
        this.starttls = b;
    }

    public  void setEncoding( org.apache.tools.ant.taskdefs.email.EmailTask.Encoding encoding )
    {
        this.encoding = encoding.getValue();
    }

    public  void setMailport( int port )
    {
        this.port = new java.lang.Integer( port );
    }

    public  void setMailhost( java.lang.String host )
    {
        this.host = host;
    }

    public  void setSubject( java.lang.String subject )
    {
        this.subject = subject;
    }

    public  void setMessage( java.lang.String message )
    {
        if (this.message != null) {
            throw new org.apache.tools.ant.BuildException( "Only one message can be sent in an " + "email" );
        }
        this.message = new org.apache.tools.ant.taskdefs.email.Message( message );
        this.message.setProject( getProject() );
    }

    public  void setMessageFile( java.io.File file )
    {
        if (this.message != null) {
            throw new org.apache.tools.ant.BuildException( "Only one message can be sent in an " + "email" );
        }
        this.message = new org.apache.tools.ant.taskdefs.email.Message( file );
        this.message.setProject( getProject() );
    }

    public  void setMessageMimeType( java.lang.String type )
    {
        this.messageMimeType = type;
    }

    public  void addMessage( org.apache.tools.ant.taskdefs.email.Message message )
        throws org.apache.tools.ant.BuildException
    {
        if (this.message != null) {
            throw new org.apache.tools.ant.BuildException( "Only one message can be sent in an email" );
        }
        this.message = message;
    }

    public  void addFrom( org.apache.tools.ant.taskdefs.email.EmailAddress address )
    {
        if (this.from != null) {
            throw new org.apache.tools.ant.BuildException( "Emails can only be from one address" );
        }
        this.from = address;
    }

    public  void setFrom( java.lang.String address )
    {
        if (this.from != null) {
            throw new org.apache.tools.ant.BuildException( "Emails can only be from one address" );
        }
        this.from = new org.apache.tools.ant.taskdefs.email.EmailAddress( address );
    }

    public  void addReplyTo( org.apache.tools.ant.taskdefs.email.EmailAddress address )
    {
        this.replyToList.add( address );
    }

    public  void setReplyTo( java.lang.String address )
    {
        this.replyToList.add( new org.apache.tools.ant.taskdefs.email.EmailAddress( address ) );
    }

    public  void addTo( org.apache.tools.ant.taskdefs.email.EmailAddress address )
    {
        toList.addElement( address );
    }

    public  void setToList( java.lang.String list )
    {
        java.util.StringTokenizer tokens = new java.util.StringTokenizer( list, "," );
        while (tokens.hasMoreTokens()) {
            toList.addElement( new org.apache.tools.ant.taskdefs.email.EmailAddress( tokens.nextToken() ) );
        }
    }

    public  void addCc( org.apache.tools.ant.taskdefs.email.EmailAddress address )
    {
        ccList.addElement( address );
    }

    public  void setCcList( java.lang.String list )
    {
        java.util.StringTokenizer tokens = new java.util.StringTokenizer( list, "," );
        while (tokens.hasMoreTokens()) {
            ccList.addElement( new org.apache.tools.ant.taskdefs.email.EmailAddress( tokens.nextToken() ) );
        }
    }

    public  void addBcc( org.apache.tools.ant.taskdefs.email.EmailAddress address )
    {
        bccList.addElement( address );
    }

    public  void setBccList( java.lang.String list )
    {
        java.util.StringTokenizer tokens = new java.util.StringTokenizer( list, "," );
        while (tokens.hasMoreTokens()) {
            bccList.addElement( new org.apache.tools.ant.taskdefs.email.EmailAddress( tokens.nextToken() ) );
        }
    }

    public  void setFailOnError( boolean failOnError )
    {
        this.failOnError = failOnError;
    }

    public  void setFiles( java.lang.String filenames )
    {
        java.util.StringTokenizer t = new java.util.StringTokenizer( filenames, ", " );
        while (t.hasMoreTokens()) {
            createAttachments().add( new org.apache.tools.ant.types.resources.FileResource( getProject().resolveFile( t.nextToken() ) ) );
        }
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet fs )
    {
        createAttachments().add( fs );
    }

    public  org.apache.tools.ant.types.Path createAttachments()
    {
        if (attachments == null) {
            attachments = new org.apache.tools.ant.types.Path( getProject() );
        }
        return attachments.createPath();
    }

    public  org.apache.tools.ant.taskdefs.email.Header createHeader()
    {
        org.apache.tools.ant.taskdefs.email.Header h = new org.apache.tools.ant.taskdefs.email.Header();
        headers.add( h );
        return h;
    }

    public  void setIncludefilenames( boolean includeFileNames )
    {
        this.includeFileNames = includeFileNames;
    }

    public  boolean getIncludeFileNames()
    {
        return includeFileNames;
    }

    public  void setIgnoreInvalidRecipients( boolean b )
    {
        ignoreInvalidRecipients = b;
    }

    public  void execute()
    {
        org.apache.tools.ant.taskdefs.email.Message savedMessage = message;
        try {
            org.apache.tools.ant.taskdefs.email.Mailer mailer = null;
            boolean autoFound = false;
            if (encoding.equals( MIME ) || encoding.equals( AUTO ) && !autoFound) {
                try {
                    Class.forName( "javax.activation.DataHandler" );
                    Class.forName( "javax.mail.internet.MimeMessage" );
                    mailer = (org.apache.tools.ant.taskdefs.email.Mailer) ClasspathUtils.newInstance( "org.apache.tools.ant.taskdefs.email.MimeMailer", (org.apache.tools.ant.taskdefs.email.EmailTask.class).getClassLoader(), org.apache.tools.ant.taskdefs.email.Mailer.class );
                    autoFound = true;
                    log( "Using MIME mail", Project.MSG_VERBOSE );
                } catch ( org.apache.tools.ant.BuildException e ) {
                    logBuildException( "Failed to initialise MIME mail: ", e );
                }
            }
            if (!autoFound && (user != null || password != null) && (encoding.equals( UU ) || encoding.equals( PLAIN ))) {
                throw new org.apache.tools.ant.BuildException( "SMTP auth only possible with MIME mail" );
            }
            if (!autoFound && (ssl || starttls) && (encoding.equals( UU ) || encoding.equals( PLAIN ))) {
                throw new org.apache.tools.ant.BuildException( "SSL and STARTTLS only possible with" + " MIME mail" );
            }
            if (encoding.equals( UU ) || encoding.equals( AUTO ) && !autoFound) {
                try {
                    mailer = (org.apache.tools.ant.taskdefs.email.Mailer) ClasspathUtils.newInstance( "org.apache.tools.ant.taskdefs.email.UUMailer", (org.apache.tools.ant.taskdefs.email.EmailTask.class).getClassLoader(), org.apache.tools.ant.taskdefs.email.Mailer.class );
                    autoFound = true;
                    log( "Using UU mail", Project.MSG_VERBOSE );
                } catch ( org.apache.tools.ant.BuildException e ) {
                    logBuildException( "Failed to initialise UU mail: ", e );
                }
            }
            if (encoding.equals( PLAIN ) || encoding.equals( AUTO ) && !autoFound) {
                mailer = new org.apache.tools.ant.taskdefs.email.PlainMailer();
                autoFound = true;
                log( "Using plain mail", Project.MSG_VERBOSE );
            }
            if (mailer == null) {
                throw new org.apache.tools.ant.BuildException( "Failed to initialise encoding: " + encoding );
            }
            if (message == null) {
                message = new org.apache.tools.ant.taskdefs.email.Message();
                message.setProject( getProject() );
            }
            if (from == null || from.getAddress() == null) {
                throw new org.apache.tools.ant.BuildException( "A from element is required" );
            }
            if (toList.isEmpty() && ccList.isEmpty() && bccList.isEmpty()) {
                throw new org.apache.tools.ant.BuildException( "At least one of to, cc or bcc must " + "be supplied" );
            }
            if (messageMimeType != null) {
                if (message.isMimeTypeSpecified()) {
                    throw new org.apache.tools.ant.BuildException( "The mime type can only be " + "specified in one location" );
                }
                message.setMimeType( messageMimeType );
            }
            if (charset != null) {
                if (message.getCharset() != null) {
                    throw new org.apache.tools.ant.BuildException( "The charset can only be " + "specified in one location" );
                }
                message.setCharset( charset );
            }
            java.util.Vector files = new java.util.Vector();
            if (attachments != null) {
                java.util.Iterator iter = attachments.iterator();
                while (iter.hasNext()) {
                    org.apache.tools.ant.types.Resource r = (org.apache.tools.ant.types.Resource) iter.next();
                    files.addElement( ((org.apache.tools.ant.types.resources.FileProvider) r.as( org.apache.tools.ant.types.resources.FileProvider.class )).getFile() );
                }
            }
            log( "Sending email: " + subject, Project.MSG_INFO );
            log( "From " + from, Project.MSG_VERBOSE );
            log( "ReplyTo " + replyToList, Project.MSG_VERBOSE );
            log( "To " + toList, Project.MSG_VERBOSE );
            log( "Cc " + ccList, Project.MSG_VERBOSE );
            log( "Bcc " + bccList, Project.MSG_VERBOSE );
            mailer.setHost( host );
            if (port != null) {
                mailer.setPort( port.intValue() );
                mailer.setPortExplicitlySpecified( true );
            } else {
                mailer.setPort( SMTP_PORT );
                mailer.setPortExplicitlySpecified( false );
            }
            mailer.setUser( user );
            mailer.setPassword( password );
            mailer.setSSL( ssl );
            mailer.setEnableStartTLS( starttls );
            mailer.setMessage( message );
            mailer.setFrom( from );
            mailer.setReplyToList( replyToList );
            mailer.setToList( toList );
            mailer.setCcList( ccList );
            mailer.setBccList( bccList );
            mailer.setFiles( files );
            mailer.setSubject( subject );
            mailer.setTask( this );
            mailer.setIncludeFileNames( includeFileNames );
            mailer.setHeaders( headers );
            mailer.setIgnoreInvalidRecipients( ignoreInvalidRecipients );
            mailer.send();
            int count = files.size();
            log( "Sent email with " + count + " attachment" + (count == 1 ? "" : "s"), Project.MSG_INFO );
        } catch ( org.apache.tools.ant.BuildException e ) {
            logBuildException( "Failed to send email: ", e );
            if (failOnError) {
                throw e;
            }
        } catch ( java.lang.Exception e ) {
            log( "Failed to send email: " + e.getMessage(), Project.MSG_WARN );
            if (failOnError) {
                throw new org.apache.tools.ant.BuildException( e );
            }
        } finally 
{
            message = savedMessage;
        }
    }

    private  void logBuildException( java.lang.String reason, org.apache.tools.ant.BuildException e )
    {
        java.lang.Throwable t = e.getCause() == null ? e : e.getCause();
        log( reason + t.getMessage(), Project.MSG_WARN );
    }

    public  void setCharset( java.lang.String charset )
    {
        this.charset = charset;
    }

    public  java.lang.String getCharset()
    {
        return charset;
    }

}
