// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.email;


import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Enumeration;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.mail.MailMessage;


class PlainMailer extends org.apache.tools.ant.taskdefs.email.Mailer
{

    public  void send()
    {
        try {
            org.apache.tools.mail.MailMessage mailMessage = new org.apache.tools.mail.MailMessage( host, port );
            mailMessage.from( from.toString() );
            java.util.Enumeration e;
            boolean atLeastOneRcptReached = false;
            e = replyToList.elements();
            while (e.hasMoreElements()) {
                mailMessage.replyto( e.nextElement().toString() );
            }
            e = toList.elements();
            while (e.hasMoreElements()) {
                java.lang.String to = e.nextElement().toString();
                try {
                    mailMessage.to( to );
                    atLeastOneRcptReached = true;
                } catch ( java.io.IOException ex ) {
                    badRecipient( to, ex );
                }
            }
            e = ccList.elements();
            while (e.hasMoreElements()) {
                java.lang.String to = e.nextElement().toString();
                try {
                    mailMessage.cc( to );
                    atLeastOneRcptReached = true;
                } catch ( java.io.IOException ex ) {
                    badRecipient( to, ex );
                }
            }
            e = bccList.elements();
            while (e.hasMoreElements()) {
                java.lang.String to = e.nextElement().toString();
                try {
                    mailMessage.bcc( to );
                    atLeastOneRcptReached = true;
                } catch ( java.io.IOException ex ) {
                    badRecipient( to, ex );
                }
            }
            if (!atLeastOneRcptReached) {
                throw new org.apache.tools.ant.BuildException( "Couldn't reach any recipient" );
            }
            if (subject != null) {
                mailMessage.setSubject( subject );
            }
            mailMessage.setHeader( "Date", getDate() );
            if (message.getCharset() != null) {
                mailMessage.setHeader( "Content-Type", message.getMimeType() + "; charset=\"" + message.getCharset() + "\"" );
            } else {
                mailMessage.setHeader( "Content-Type", message.getMimeType() );
            }
            if (headers != null) {
                e = headers.elements();
                while (e.hasMoreElements()) {
                    org.apache.tools.ant.taskdefs.email.Header h = (org.apache.tools.ant.taskdefs.email.Header) e.nextElement();
                    mailMessage.setHeader( h.getName(), h.getValue() );
                }
            }
            java.io.PrintStream out = mailMessage.getPrintStream();
            message.print( out );
            e = files.elements();
            while (e.hasMoreElements()) {
                attach( (java.io.File) e.nextElement(), out );
            }
            mailMessage.sendAndClose();
        } catch ( java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( "IO error sending mail", ioe );
        }
    }

    protected  void attach( java.io.File file, java.io.PrintStream out )
        throws java.io.IOException
    {
        if (!file.exists() || !file.canRead()) {
            throw new org.apache.tools.ant.BuildException( "File \"" + file.getName() + "\" does not exist or is not " + "readable." );
        }
        if (includeFileNames) {
            out.println();
            java.lang.String filename = file.getName();
            int filenamelength = filename.length();
            out.println( filename );
            for (int star = 0; star < filenamelength; star++) {
                out.print( '=' );
            }
            out.println();
        }
        int length;
        final int maxBuf = 1024;
        byte[] buf = new byte[maxBuf];
        java.io.FileInputStream finstr = new java.io.FileInputStream( file );
        try {
            java.io.BufferedInputStream in = new java.io.BufferedInputStream( finstr, buf.length );
            while ((length = in.read( buf )) != -1) {
                out.write( buf, 0, length );
            }
        } finally 
{
            finstr.close();
        }
    }

    private  void badRecipient( java.lang.String rcpt, java.io.IOException reason )
    {
        java.lang.String msg = "Failed to send mail to " + rcpt;
        if (shouldIgnoreInvalidRecipients()) {
            msg += " because of :" + reason.getMessage();
            if (task != null) {
                task.log( msg, Project.MSG_WARN );
            } else {
                System.err.println( msg );
            }
        } else {
            throw new org.apache.tools.ant.BuildException( msg, reason );
        }
    }

}
