// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ccm;


import java.io.File;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.FileSet;


public class CCMCheck extends org.apache.tools.ant.taskdefs.optional.ccm.Continuus
{

    private java.io.File file = null;

    private java.lang.String comment = null;

    private java.lang.String task = null;

    protected java.util.Vector filesets = new java.util.Vector();

    public CCMCheck()
    {
        super();
    }

    public  java.io.File getFile()
    {
        return file;
    }

    public  void setFile( java.io.File v )
    {
        log( "working file " + v, Project.MSG_VERBOSE );
        this.file = v;
    }

    public  java.lang.String getComment()
    {
        return comment;
    }

    public  void setComment( java.lang.String v )
    {
        this.comment = v;
    }

    public  java.lang.String getTask()
    {
        return task;
    }

    public  void setTask( java.lang.String v )
    {
        this.task = v;
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet set )
    {
        filesets.addElement( set );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (file == null && filesets.size() == 0) {
            throw new org.apache.tools.ant.BuildException( "Specify at least one source - a file or a fileset." );
        }
        if (file != null && file.exists() && file.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "CCMCheck cannot be generated for directories" );
        }
        if (file != null && filesets.size() > 0) {
            throw new org.apache.tools.ant.BuildException( "Choose between file and fileset !" );
        }
        if (getFile() != null) {
            doit();
            return;
        }
        int sizeofFileSet = filesets.size();
        for (int i = 0; i < sizeofFileSet; i++) {
            org.apache.tools.ant.types.FileSet fs = (org.apache.tools.ant.types.FileSet) filesets.elementAt( i );
            org.apache.tools.ant.DirectoryScanner ds = fs.getDirectoryScanner( getProject() );
            java.lang.String[] srcFiles = ds.getIncludedFiles();
            for (int j = 0; j < srcFiles.length; j++) {
                java.io.File src = new java.io.File( fs.getDir( getProject() ), srcFiles[j] );
                setFile( src );
                doit();
            }
        }
    }

    private  void doit()
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        commandLine.setExecutable( getCcmCommand() );
        commandLine.createArgument().setValue( getCcmAction() );
        checkOptions( commandLine );
        int result = run( commandLine );
        if (Execute.isFailure( result )) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() != null) {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
        if (getTask() != null) {
            cmd.createArgument().setValue( FLAG_TASK );
            cmd.createArgument().setValue( getTask() );
        }
        if (getFile() != null) {
            cmd.createArgument().setValue( file.getAbsolutePath() );
        }
    }

    public static final java.lang.String FLAG_COMMENT = "/comment";

    public static final java.lang.String FLAG_TASK = "/task";

}
