// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ccm;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;


public class CCMReconfigure extends org.apache.tools.ant.taskdefs.optional.ccm.Continuus
{

    private java.lang.String ccmProject = null;

    private boolean recurse = false;

    private boolean verbose = false;

    public CCMReconfigure()
    {
        super();
        setCcmAction( COMMAND_RECONFIGURE );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        int result = 0;
        commandLine.setExecutable( getCcmCommand() );
        commandLine.createArgument().setValue( getCcmAction() );
        checkOptions( commandLine );
        result = run( commandLine );
        if (Execute.isFailure( result )) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (isRecurse()) {
            cmd.createArgument().setValue( FLAG_RECURSE );
        }
        if (isVerbose()) {
            cmd.createArgument().setValue( FLAG_VERBOSE );
        }
        if (getCcmProject() != null) {
            cmd.createArgument().setValue( FLAG_PROJECT );
            cmd.createArgument().setValue( getCcmProject() );
        }
    }

    public  java.lang.String getCcmProject()
    {
        return ccmProject;
    }

    public  void setCcmProject( java.lang.String v )
    {
        this.ccmProject = v;
    }

    public  boolean isRecurse()
    {
        return recurse;
    }

    public  void setRecurse( boolean v )
    {
        this.recurse = v;
    }

    public  boolean isVerbose()
    {
        return verbose;
    }

    public  void setVerbose( boolean v )
    {
        this.verbose = v;
    }

    public static final java.lang.String FLAG_RECURSE = "/recurse";

    public static final java.lang.String FLAG_VERBOSE = "/verbose";

    public static final java.lang.String FLAG_PROJECT = "/project";

}
