// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.clearcase;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;


public class CCMklbtype extends org.apache.tools.ant.taskdefs.optional.clearcase.ClearCase
{

    private java.lang.String mTypeName = null;

    private java.lang.String mVOB = null;

    private java.lang.String mComment = null;

    private java.lang.String mCfile = null;

    private boolean mReplace = false;

    private boolean mGlobal = false;

    private boolean mOrdinary = true;

    private boolean mPbranch = false;

    private boolean mShared = false;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        int result = 0;
        if (getTypeName() == null) {
            throw new org.apache.tools.ant.BuildException( "Required attribute TypeName not specified" );
        }
        commandLine.setExecutable( getClearToolCommand() );
        commandLine.createArgument().setValue( COMMAND_MKLBTYPE );
        checkOptions( commandLine );
        if (!getFailOnErr()) {
            getProject().log( "Ignoring any errors that occur for: " + getTypeSpecifier(), Project.MSG_VERBOSE );
        }
        result = run( commandLine );
        if (Execute.isFailure( result ) && getFailOnErr()) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getReplace()) {
            cmd.createArgument().setValue( FLAG_REPLACE );
        }
        if (getOrdinary()) {
            cmd.createArgument().setValue( FLAG_ORDINARY );
        } else {
            if (getGlobal()) {
                cmd.createArgument().setValue( FLAG_GLOBAL );
            }
        }
        if (getPbranch()) {
            cmd.createArgument().setValue( FLAG_PBRANCH );
        }
        if (getShared()) {
            cmd.createArgument().setValue( FLAG_SHARED );
        }
        if (getComment() != null) {
            getCommentCommand( cmd );
        } else {
            if (getCommentFile() != null) {
                getCommentFileCommand( cmd );
            } else {
                cmd.createArgument().setValue( FLAG_NOCOMMENT );
            }
        }
        cmd.createArgument().setValue( getTypeSpecifier() );
    }

    public  void setTypeName( java.lang.String tn )
    {
        mTypeName = tn;
    }

    public  java.lang.String getTypeName()
    {
        return mTypeName;
    }

    public  void setVOB( java.lang.String vob )
    {
        mVOB = vob;
    }

    public  java.lang.String getVOB()
    {
        return mVOB;
    }

    public  void setReplace( boolean repl )
    {
        mReplace = repl;
    }

    public  boolean getReplace()
    {
        return mReplace;
    }

    public  void setGlobal( boolean glob )
    {
        mGlobal = glob;
    }

    public  boolean getGlobal()
    {
        return mGlobal;
    }

    public  void setOrdinary( boolean ordinary )
    {
        mOrdinary = ordinary;
    }

    public  boolean getOrdinary()
    {
        return mOrdinary;
    }

    public  void setPbranch( boolean pbranch )
    {
        mPbranch = pbranch;
    }

    public  boolean getPbranch()
    {
        return mPbranch;
    }

    public  void setShared( boolean shared )
    {
        mShared = shared;
    }

    public  boolean getShared()
    {
        return mShared;
    }

    public  void setComment( java.lang.String comment )
    {
        mComment = comment;
    }

    public  java.lang.String getComment()
    {
        return mComment;
    }

    public  void setCommentFile( java.lang.String cfile )
    {
        mCfile = cfile;
    }

    public  java.lang.String getCommentFile()
    {
        return mCfile;
    }

    private  void getCommentCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() != null) {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
    }

    private  void getCommentFileCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getCommentFile() != null) {
            cmd.createArgument().setValue( FLAG_COMMENTFILE );
            cmd.createArgument().setValue( getCommentFile() );
        }
    }

    private  java.lang.String getTypeSpecifier()
    {
        java.lang.String typenm = null;
        typenm = getTypeName();
        if (getVOB() != null) {
            typenm += "@" + getVOB();
        }
        return typenm;
    }

    public static final java.lang.String FLAG_REPLACE = "-replace";

    public static final java.lang.String FLAG_GLOBAL = "-global";

    public static final java.lang.String FLAG_ORDINARY = "-ordinary";

    public static final java.lang.String FLAG_PBRANCH = "-pbranch";

    public static final java.lang.String FLAG_SHARED = "-shared";

    public static final java.lang.String FLAG_COMMENT = "-c";

    public static final java.lang.String FLAG_COMMENTFILE = "-cfile";

    public static final java.lang.String FLAG_NOCOMMENT = "-nc";

}
