// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.clearcase;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;


public class CCRmtype extends org.apache.tools.ant.taskdefs.optional.clearcase.ClearCase
{

    private java.lang.String mTypeKind = null;

    private java.lang.String mTypeName = null;

    private java.lang.String mVOB = null;

    private java.lang.String mComment = null;

    private java.lang.String mCfile = null;

    private boolean mRmall = false;

    private boolean mIgnore = false;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        int result = 0;
        if (getTypeKind() == null) {
            throw new org.apache.tools.ant.BuildException( "Required attribute TypeKind not specified" );
        }
        if (getTypeName() == null) {
            throw new org.apache.tools.ant.BuildException( "Required attribute TypeName not specified" );
        }
        commandLine.setExecutable( getClearToolCommand() );
        commandLine.createArgument().setValue( COMMAND_RMTYPE );
        checkOptions( commandLine );
        if (!getFailOnErr()) {
            getProject().log( "Ignoring any errors that occur for: " + getTypeSpecifier(), Project.MSG_VERBOSE );
        }
        result = run( commandLine );
        if (Execute.isFailure( result ) && getFailOnErr()) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getIgnore()) {
            cmd.createArgument().setValue( FLAG_IGNORE );
        }
        if (getRmAll()) {
            cmd.createArgument().setValue( FLAG_RMALL );
            cmd.createArgument().setValue( FLAG_FORCE );
        }
        if (getComment() != null) {
            getCommentCommand( cmd );
        } else {
            if (getCommentFile() != null) {
                getCommentFileCommand( cmd );
            } else {
                cmd.createArgument().setValue( FLAG_NOCOMMENT );
            }
        }
        cmd.createArgument().setValue( getTypeSpecifier() );
    }

    public  void setIgnore( boolean ignore )
    {
        mIgnore = ignore;
    }

    public  boolean getIgnore()
    {
        return mIgnore;
    }

    public  void setRmAll( boolean rmall )
    {
        mRmall = rmall;
    }

    public  boolean getRmAll()
    {
        return mRmall;
    }

    public  void setComment( java.lang.String comment )
    {
        mComment = comment;
    }

    public  java.lang.String getComment()
    {
        return mComment;
    }

    public  void setCommentFile( java.lang.String cfile )
    {
        mCfile = cfile;
    }

    public  java.lang.String getCommentFile()
    {
        return mCfile;
    }

    public  void setTypeKind( java.lang.String tk )
    {
        mTypeKind = tk;
    }

    public  java.lang.String getTypeKind()
    {
        return mTypeKind;
    }

    public  void setTypeName( java.lang.String tn )
    {
        mTypeName = tn;
    }

    public  java.lang.String getTypeName()
    {
        return mTypeName;
    }

    public  void setVOB( java.lang.String vob )
    {
        mVOB = vob;
    }

    public  java.lang.String getVOB()
    {
        return mVOB;
    }

    private  java.lang.String getTypeSpecifier()
    {
        java.lang.String tkind = getTypeKind();
        java.lang.String tname = getTypeName();
        java.lang.String typeSpec = null;
        typeSpec = tkind + ":" + tname;
        if (getVOB() != null) {
            typeSpec += "@" + getVOB();
        }
        return typeSpec;
    }

    private  void getCommentCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() != null) {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
    }

    private  void getCommentFileCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getCommentFile() != null) {
            cmd.createArgument().setValue( FLAG_COMMENTFILE );
            cmd.createArgument().setValue( getCommentFile() );
        }
    }

    public static final java.lang.String FLAG_IGNORE = "-ignore";

    public static final java.lang.String FLAG_RMALL = "-rmall";

    public static final java.lang.String FLAG_FORCE = "-force";

    public static final java.lang.String FLAG_COMMENT = "-c";

    public static final java.lang.String FLAG_COMMENTFILE = "-cfile";

    public static final java.lang.String FLAG_NOCOMMENT = "-nc";

}
