// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.clearcase;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;


public class CCUnlock extends org.apache.tools.ant.taskdefs.optional.clearcase.ClearCase
{

    private java.lang.String mComment = null;

    private java.lang.String mPname = null;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        org.apache.tools.ant.Project aProj = getProject();
        int result = 0;
        if (getViewPath() == null) {
            setViewPath( aProj.getBaseDir().getPath() );
        }
        commandLine.setExecutable( getClearToolCommand() );
        commandLine.createArgument().setValue( COMMAND_UNLOCK );
        checkOptions( commandLine );
        if (!getFailOnErr()) {
            getProject().log( "Ignoring any errors that occur for: " + getOpType(), Project.MSG_VERBOSE );
        }
        result = run( commandLine );
        if (Execute.isFailure( result ) && getFailOnErr()) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        getCommentCommand( cmd );
        if (getObjSelect() == null && getPname() == null) {
            throw new org.apache.tools.ant.BuildException( "Should select either an element " + "(pname) or an object (objselect)" );
        }
        getPnameCommand( cmd );
        if (getObjSelect() != null) {
            cmd.createArgument().setValue( getObjSelect() );
        }
    }

    public  void setComment( java.lang.String comment )
    {
        mComment = comment;
    }

    public  java.lang.String getComment()
    {
        return mComment;
    }

    public  void setPname( java.lang.String pname )
    {
        mPname = pname;
    }

    public  java.lang.String getPname()
    {
        return mPname;
    }

    public  void setObjselect( java.lang.String objselect )
    {
        setObjSelect( objselect );
    }

    public  void setObjSel( java.lang.String objsel )
    {
        setObjSelect( objsel );
    }

    public  java.lang.String getObjselect()
    {
        return getObjSelect();
    }

    private  void getCommentCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() == null) {
            return;
        } else {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
    }

    private  void getPnameCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getPname() == null) {
            return;
        } else {
            cmd.createArgument().setValue( FLAG_PNAME );
            cmd.createArgument().setValue( getPname() );
        }
    }

    private  java.lang.String getOpType()
    {
        if (getPname() != null) {
            return getPname();
        } else {
            return getObjSelect();
        }
    }

    public static final java.lang.String FLAG_COMMENT = "-comment";

    public static final java.lang.String FLAG_PNAME = "-pname";

}
