// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.depend;


import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;
import org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo;
import org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool;
import org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPoolEntry;


public class ClassFile
{

    private static final int CLASS_MAGIC = 0xCAFEBABE;

    private org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool constantPool;

    private java.lang.String className;

    public  void read( java.io.InputStream stream )
        throws java.io.IOException, java.lang.ClassFormatError
    {
        java.io.DataInputStream classStream = new java.io.DataInputStream( stream );
        if (classStream.readInt() != CLASS_MAGIC) {
            throw new java.lang.ClassFormatError( "No Magic Code Found " + "- probably not a Java class file." );
        }
        classStream.readUnsignedShort();
        classStream.readUnsignedShort();
        constantPool = new org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool();
        constantPool.read( classStream );
        constantPool.resolve();
        classStream.readUnsignedShort();
        int thisClassIndex = classStream.readUnsignedShort();
        classStream.readUnsignedShort();
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo classInfo = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo) constantPool.getEntry( thisClassIndex );
        className = classInfo.getClassName();
    }

    public  java.util.Vector getClassRefs()
    {
        java.util.Vector classRefs = new java.util.Vector();
        final int size = constantPool.size();
        for (int i = 0; i < size; ++i) {
            org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPoolEntry entry = constantPool.getEntry( i );
            if (entry != null && entry.getTag() == ConstantPoolEntry.CONSTANT_CLASS) {
                org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo classEntry = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo) entry;
                if (!classEntry.getClassName().equals( className )) {
                    classRefs.addElement( ClassFileUtils.convertSlashName( classEntry.getClassName() ) );
                }
            }
        }
        return classRefs;
    }

    public  java.lang.String getFullClassName()
    {
        return ClassFileUtils.convertSlashName( className );
    }

}
