// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.depend.constantpool;


import java.io.DataInputStream;
import java.io.IOException;


public class FieldRefCPInfo extends org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPoolEntry
{

    private java.lang.String fieldClassName;

    private java.lang.String fieldName;

    private java.lang.String fieldType;

    private int classIndex;

    private int nameAndTypeIndex;

    public FieldRefCPInfo()
    {
        super( CONSTANT_FIELDREF, 1 );
    }

    public  void read( java.io.DataInputStream cpStream )
        throws java.io.IOException
    {
        classIndex = cpStream.readUnsignedShort();
        nameAndTypeIndex = cpStream.readUnsignedShort();
    }

    public  void resolve( org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool constantPool )
    {
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo fieldClass = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo) constantPool.getEntry( classIndex );
        fieldClass.resolve( constantPool );
        fieldClassName = fieldClass.getClassName();
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo nt = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo) constantPool.getEntry( nameAndTypeIndex );
        nt.resolve( constantPool );
        fieldName = nt.getName();
        fieldType = nt.getType();
        super.resolve( constantPool );
    }

    public  java.lang.String toString()
    {
        java.lang.String value;
        if (isResolved()) {
            value = "Field : Class = " + fieldClassName + ", name = " + fieldName + ", type = " + fieldType;
        } else {
            value = "Field : Class index = " + classIndex + ", name and type index = " + nameAndTypeIndex;
        }
        return value;
    }

    public  java.lang.String getFieldClassName()
    {
        return fieldClassName;
    }

    public  java.lang.String getFieldName()
    {
        return fieldName;
    }

    public  java.lang.String getFieldType()
    {
        return fieldType;
    }

}
