// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.depend.constantpool;


import java.io.DataInputStream;
import java.io.IOException;


public class InterfaceMethodRefCPInfo extends org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPoolEntry
{

    private java.lang.String interfaceMethodClassName;

    private java.lang.String interfaceMethodName;

    private java.lang.String interfaceMethodType;

    private int classIndex;

    private int nameAndTypeIndex;

    public InterfaceMethodRefCPInfo()
    {
        super( CONSTANT_INTERFACEMETHODREF, 1 );
    }

    public  void read( java.io.DataInputStream cpStream )
        throws java.io.IOException
    {
        classIndex = cpStream.readUnsignedShort();
        nameAndTypeIndex = cpStream.readUnsignedShort();
    }

    public  void resolve( org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool constantPool )
    {
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo interfaceMethodClass = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo) constantPool.getEntry( classIndex );
        interfaceMethodClass.resolve( constantPool );
        interfaceMethodClassName = interfaceMethodClass.getClassName();
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo nt = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo) constantPool.getEntry( nameAndTypeIndex );
        nt.resolve( constantPool );
        interfaceMethodName = nt.getName();
        interfaceMethodType = nt.getType();
        super.resolve( constantPool );
    }

    public  java.lang.String toString()
    {
        java.lang.String value;
        if (isResolved()) {
            value = "InterfaceMethod : Class = " + interfaceMethodClassName + ", name = " + interfaceMethodName + ", type = " + interfaceMethodType;
        } else {
            value = "InterfaceMethod : Class index = " + classIndex + ", name and type index = " + nameAndTypeIndex;
        }
        return value;
    }

    public  java.lang.String getInterfaceMethodClassName()
    {
        return interfaceMethodClassName;
    }

    public  java.lang.String getInterfaceMethodName()
    {
        return interfaceMethodName;
    }

    public  java.lang.String getInterfaceMethodType()
    {
        return interfaceMethodType;
    }

}
