// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.i18n;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Hashtable;
import java.util.Locale;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.LineTokenizer;


public class Translate extends org.apache.tools.ant.taskdefs.MatchingTask
{

    private static final int BUNDLE_SPECIFIED_LANGUAGE_COUNTRY_VARIANT = 0;

    private static final int BUNDLE_SPECIFIED_LANGUAGE_COUNTRY = 1;

    private static final int BUNDLE_SPECIFIED_LANGUAGE = 2;

    private static final int BUNDLE_NOMATCH = 3;

    private static final int BUNDLE_DEFAULT_LANGUAGE_COUNTRY_VARIANT = 4;

    private static final int BUNDLE_DEFAULT_LANGUAGE_COUNTRY = 5;

    private static final int BUNDLE_DEFAULT_LANGUAGE = 6;

    private static final int BUNDLE_MAX_ALTERNATIVES = BUNDLE_DEFAULT_LANGUAGE + 1;

    private java.lang.String bundle;

    private java.lang.String bundleLanguage;

    private java.lang.String bundleCountry;

    private java.lang.String bundleVariant;

    private java.io.File toDir;

    private java.lang.String srcEncoding;

    private java.lang.String destEncoding;

    private java.lang.String bundleEncoding;

    private java.lang.String startToken;

    private java.lang.String endToken;

    private boolean forceOverwrite;

    private java.util.Vector filesets = new java.util.Vector();

    private java.util.Hashtable resourceMap = new java.util.Hashtable();

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private long[] bundleLastModified = new long[BUNDLE_MAX_ALTERNATIVES];

    private long srcLastModified;

    private long destLastModified;

    private boolean loaded = false;

    public  void setBundle( java.lang.String bundle )
    {
        this.bundle = bundle;
    }

    public  void setBundleLanguage( java.lang.String bundleLanguage )
    {
        this.bundleLanguage = bundleLanguage;
    }

    public  void setBundleCountry( java.lang.String bundleCountry )
    {
        this.bundleCountry = bundleCountry;
    }

    public  void setBundleVariant( java.lang.String bundleVariant )
    {
        this.bundleVariant = bundleVariant;
    }

    public  void setToDir( java.io.File toDir )
    {
        this.toDir = toDir;
    }

    public  void setStartToken( java.lang.String startToken )
    {
        this.startToken = startToken;
    }

    public  void setEndToken( java.lang.String endToken )
    {
        this.endToken = endToken;
    }

    public  void setSrcEncoding( java.lang.String srcEncoding )
    {
        this.srcEncoding = srcEncoding;
    }

    public  void setDestEncoding( java.lang.String destEncoding )
    {
        this.destEncoding = destEncoding;
    }

    public  void setBundleEncoding( java.lang.String bundleEncoding )
    {
        this.bundleEncoding = bundleEncoding;
    }

    public  void setForceOverwrite( boolean forceOverwrite )
    {
        this.forceOverwrite = forceOverwrite;
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet set )
    {
        filesets.addElement( set );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (bundle == null) {
            throw new org.apache.tools.ant.BuildException( "The bundle attribute must be set.", getLocation() );
        }
        if (startToken == null) {
            throw new org.apache.tools.ant.BuildException( "The starttoken attribute must be set.", getLocation() );
        }
        if (endToken == null) {
            throw new org.apache.tools.ant.BuildException( "The endtoken attribute must be set.", getLocation() );
        }
        if (bundleLanguage == null) {
            java.util.Locale l = Locale.getDefault();
            bundleLanguage = l.getLanguage();
        }
        if (bundleCountry == null) {
            bundleCountry = Locale.getDefault().getCountry();
        }
        if (bundleVariant == null) {
            java.util.Locale l = new java.util.Locale( bundleLanguage, bundleCountry );
            bundleVariant = l.getVariant();
        }
        if (toDir == null) {
            throw new org.apache.tools.ant.BuildException( "The todir attribute must be set.", getLocation() );
        }
        if (!toDir.exists()) {
            toDir.mkdirs();
        } else {
            if (toDir.isFile()) {
                throw new org.apache.tools.ant.BuildException( toDir + " is not a directory" );
            }
        }
        if (srcEncoding == null) {
            srcEncoding = System.getProperty( "file.encoding" );
        }
        if (destEncoding == null) {
            destEncoding = srcEncoding;
        }
        if (bundleEncoding == null) {
            bundleEncoding = srcEncoding;
        }
        loadResourceMaps();
        translate();
    }

    private  void loadResourceMaps()
        throws org.apache.tools.ant.BuildException
    {
        java.util.Locale locale = new java.util.Locale( bundleLanguage, bundleCountry, bundleVariant );
        java.lang.String language = locale.getLanguage().length() > 0 ? "_" + locale.getLanguage() : "";
        java.lang.String country = locale.getCountry().length() > 0 ? "_" + locale.getCountry() : "";
        java.lang.String variant = locale.getVariant().length() > 0 ? "_" + locale.getVariant() : "";
        java.lang.String bundleFile = bundle + language + country + variant;
        processBundle( bundleFile, BUNDLE_SPECIFIED_LANGUAGE_COUNTRY_VARIANT, false );
        bundleFile = bundle + language + country;
        processBundle( bundleFile, BUNDLE_SPECIFIED_LANGUAGE_COUNTRY, false );
        bundleFile = bundle + language;
        processBundle( bundleFile, BUNDLE_SPECIFIED_LANGUAGE, false );
        bundleFile = bundle;
        processBundle( bundleFile, BUNDLE_NOMATCH, false );
        locale = Locale.getDefault();
        language = locale.getLanguage().length() > 0 ? "_" + locale.getLanguage() : "";
        country = locale.getCountry().length() > 0 ? "_" + locale.getCountry() : "";
        variant = locale.getVariant().length() > 0 ? "_" + locale.getVariant() : "";
        bundleEncoding = System.getProperty( "file.encoding" );
        bundleFile = bundle + language + country + variant;
        processBundle( bundleFile, BUNDLE_DEFAULT_LANGUAGE_COUNTRY_VARIANT, false );
        bundleFile = bundle + language + country;
        processBundle( bundleFile, BUNDLE_DEFAULT_LANGUAGE_COUNTRY, false );
        bundleFile = bundle + language;
        processBundle( bundleFile, BUNDLE_DEFAULT_LANGUAGE, true );
    }

    private  void processBundle( final java.lang.String bundleFile, final int i, final boolean checkLoaded )
        throws org.apache.tools.ant.BuildException
    {
        final java.io.File propsFile = getProject().resolveFile( bundleFile + ".properties" );
        java.io.FileInputStream ins = null;
        try {
            ins = new java.io.FileInputStream( propsFile );
            loaded = true;
            bundleLastModified[i] = propsFile.lastModified();
            log( "Using " + propsFile, Project.MSG_DEBUG );
            loadResourceMap( ins );
        } catch ( java.io.IOException ioe ) {
            log( propsFile + " not found.", Project.MSG_DEBUG );
            if (!loaded && checkLoaded) {
                throw new org.apache.tools.ant.BuildException( ioe.getMessage(), getLocation() );
            }
        }
    }

    private  void loadResourceMap( java.io.FileInputStream ins )
        throws org.apache.tools.ant.BuildException
    {
        try {
            java.io.BufferedReader in = null;
            java.io.InputStreamReader isr = new java.io.InputStreamReader( ins, bundleEncoding );
            in = new java.io.BufferedReader( isr );
            java.lang.String line = null;
            while ((line = in.readLine()) != null) {
                if (line.trim().length() > 1 && '#' != line.charAt( 0 ) && '!' != line.charAt( 0 )) {
                    int sepIndex = line.indexOf( '=' );
                    if (-1 == sepIndex) {
                        sepIndex = line.indexOf( ':' );
                    }
                    if (-1 == sepIndex) {
                        for (int k = 0; k < line.length(); k++) {
                            if (Character.isSpaceChar( line.charAt( k ) )) {
                                sepIndex = k;
                                break;
                            }
                        }
                    }
                    if (-1 != sepIndex) {
                        java.lang.String key = line.substring( 0, sepIndex ).trim();
                        java.lang.String value = line.substring( sepIndex + 1 ).trim();
                        while (value.endsWith( "\\" )) {
                            value = value.substring( 0, value.length() - 1 );
                            line = in.readLine();
                            if (line != null) {
                                value = value + line.trim();
                            } else {
                                break;
                            }
                        }
                        if (key.length() > 0) {
                            if (resourceMap.get( key ) == null) {
                                resourceMap.put( key, value );
                            }
                        }
                    }
                }
            }
            if (in != null) {
                in.close();
            }
        } catch ( java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( ioe.getMessage(), getLocation() );
        }
    }

    private  void translate()
        throws org.apache.tools.ant.BuildException
    {
        int filesProcessed = 0;
        final int size = filesets.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.FileSet fs = (org.apache.tools.ant.types.FileSet) filesets.elementAt( i );
            org.apache.tools.ant.DirectoryScanner ds = fs.getDirectoryScanner( getProject() );
            java.lang.String[] srcFiles = ds.getIncludedFiles();
            for (int j = 0; j < srcFiles.length; j++) {
                try {
                    java.io.File dest = FILE_UTILS.resolveFile( toDir, srcFiles[j] );
                    try {
                        java.io.File destDir = new java.io.File( dest.getParent() );
                        if (!destDir.exists()) {
                            destDir.mkdirs();
                        }
                    } catch ( java.lang.Exception e ) {
                        log( "Exception occurred while trying to check/create " + " parent directory.  " + e.getMessage(), Project.MSG_DEBUG );
                    }
                    destLastModified = dest.lastModified();
                    java.io.File src = FILE_UTILS.resolveFile( ds.getBasedir(), srcFiles[j] );
                    srcLastModified = src.lastModified();
                    boolean needsWork = forceOverwrite || destLastModified < srcLastModified;
                    if (!needsWork) {
                        for (int icounter = 0; icounter < BUNDLE_MAX_ALTERNATIVES; icounter++) {
                            needsWork = destLastModified < bundleLastModified[icounter];
                            if (needsWork) {
                                break;
                            }
                        }
                    }
                    if (needsWork) {
                        log( "Processing " + srcFiles[j], Project.MSG_DEBUG );
                        translateOneFile( src, dest );
                        ++filesProcessed;
                    } else {
                        log( "Skipping " + srcFiles[j] + " as destination file is up to date", Project.MSG_VERBOSE );
                    }
                } catch ( java.io.IOException ioe ) {
                    throw new org.apache.tools.ant.BuildException( ioe.getMessage(), getLocation() );
                }
            }
        }
        log( "Translation performed on " + filesProcessed + " file(s).", Project.MSG_DEBUG );
    }

    private  void translateOneFile( java.io.File src, java.io.File dest )
        throws java.io.IOException
    {
        java.io.BufferedWriter out = null;
        java.io.BufferedReader in = null;
        try {
            java.io.FileOutputStream fos = new java.io.FileOutputStream( dest );
            out = new java.io.BufferedWriter( new java.io.OutputStreamWriter( fos, destEncoding ) );
            java.io.FileInputStream fis = new java.io.FileInputStream( src );
            in = new java.io.BufferedReader( new java.io.InputStreamReader( fis, srcEncoding ) );
            java.lang.String line;
            org.apache.tools.ant.util.LineTokenizer lineTokenizer = new org.apache.tools.ant.util.LineTokenizer();
            lineTokenizer.setIncludeDelims( true );
            line = lineTokenizer.getToken( in );
            while (line != null) {
                int startIndex = line.indexOf( startToken );
                while (startIndex >= 0 && startIndex + startToken.length() <= line.length()) {
                    java.lang.String replace = null;
                    int endIndex = line.indexOf( endToken, startIndex + startToken.length() );
                    if (endIndex < 0) {
                        startIndex += 1;
                    } else {
                        java.lang.String token = line.substring( startIndex + startToken.length(), endIndex );
                        boolean validToken = true;
                        for (int k = 0; k < token.length() && validToken; k++) {
                            char c = token.charAt( k );
                            if (c == ':' || c == '=' || Character.isSpaceChar( c )) {
                                validToken = false;
                            }
                        }
                        if (!validToken) {
                            startIndex += 1;
                        } else {
                            if (resourceMap.containsKey( token )) {
                                replace = (java.lang.String) resourceMap.get( token );
                            } else {
                                log( "Replacement string missing for: " + token, Project.MSG_VERBOSE );
                                replace = startToken + token + endToken;
                            }
                            line = line.substring( 0, startIndex ) + replace + line.substring( endIndex + endToken.length() );
                            startIndex += replace.length();
                        }
                    }
                    startIndex = line.indexOf( startToken, startIndex );
                }
                out.write( line );
                line = lineTokenizer.getToken( in );
            }
        } finally 
{
            FileUtils.close( in );
            FileUtils.close( out );
        }
    }

}
