// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.javah;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.launch.Locator;
import org.apache.tools.ant.taskdefs.ExecuteJava;
import org.apache.tools.ant.taskdefs.optional.Javah;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.Path;


public class SunJavah implements org.apache.tools.ant.taskdefs.optional.javah.JavahAdapter
{

    public static final java.lang.String IMPLEMENTATION_NAME = "sun";

    public  boolean compile( org.apache.tools.ant.taskdefs.optional.Javah javah )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline cmd = setupJavahCommand( javah );
        org.apache.tools.ant.taskdefs.ExecuteJava ej = new org.apache.tools.ant.taskdefs.ExecuteJava();
        java.lang.Class c = null;
        try {
            try {
                c = Class.forName( "com.sun.tools.javah.oldjavah.Main" );
            } catch ( java.lang.ClassNotFoundException cnfe ) {
                c = Class.forName( "com.sun.tools.javah.Main" );
            }
        } catch ( java.lang.ClassNotFoundException ex ) {
            throw new org.apache.tools.ant.BuildException( "Can't load javah", ex, javah.getLocation() );
        }
        cmd.setExecutable( c.getName() );
        ej.setJavaCommand( cmd );
        java.io.File f = Locator.getClassSource( c );
        if (f != null) {
            ej.setClasspath( new org.apache.tools.ant.types.Path( javah.getProject(), f.getPath() ) );
        }
        return ej.fork( javah ) == 0;
    }

    private  org.apache.tools.ant.types.Commandline setupJavahCommand( org.apache.tools.ant.taskdefs.optional.Javah javah )
    {
        org.apache.tools.ant.types.Commandline cmd = new org.apache.tools.ant.types.Commandline();
        if (javah.getDestdir() != null) {
            cmd.createArgument().setValue( "-d" );
            cmd.createArgument().setFile( javah.getDestdir() );
        }
        if (javah.getOutputfile() != null) {
            cmd.createArgument().setValue( "-o" );
            cmd.createArgument().setFile( javah.getOutputfile() );
        }
        if (javah.getClasspath() != null) {
            cmd.createArgument().setValue( "-classpath" );
            cmd.createArgument().setPath( javah.getClasspath() );
        }
        if (javah.getVerbose()) {
            cmd.createArgument().setValue( "-verbose" );
        }
        if (javah.getOld()) {
            cmd.createArgument().setValue( "-old" );
        }
        if (javah.getForce()) {
            cmd.createArgument().setValue( "-force" );
        }
        if (javah.getStubs() && !javah.getOld()) {
            throw new org.apache.tools.ant.BuildException( "stubs only available in old mode.", javah.getLocation() );
        }
        if (javah.getStubs()) {
            cmd.createArgument().setValue( "-stubs" );
        }
        org.apache.tools.ant.types.Path bcp = new org.apache.tools.ant.types.Path( javah.getProject() );
        if (javah.getBootclasspath() != null) {
            bcp.append( javah.getBootclasspath() );
        }
        bcp = bcp.concatSystemBootClasspath( "ignore" );
        if (bcp.size() > 0) {
            cmd.createArgument().setValue( "-bootclasspath" );
            cmd.createArgument().setPath( bcp );
        }
        cmd.addArguments( javah.getCurrentArgs() );
        javah.logAndAddFiles( cmd );
        return cmd;
    }

}
