// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jsp;


import java.io.File;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.taskdefs.optional.jsp.compilers.JspCompilerAdapter;
import org.apache.tools.ant.taskdefs.optional.jsp.compilers.JspCompilerAdapterFactory;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;


public class JspC extends org.apache.tools.ant.taskdefs.MatchingTask
{

    private org.apache.tools.ant.types.Path classpath;

    private org.apache.tools.ant.types.Path compilerClasspath;

    private org.apache.tools.ant.types.Path src;

    private java.io.File destDir;

    private java.lang.String packageName;

    private java.lang.String compilerName = "jasper";

    private java.lang.String iepluginid;

    private boolean mapped;

    private int verbose = 0;

    protected java.util.Vector compileList = new java.util.Vector();

    java.util.Vector javaFiles = new java.util.Vector();

    protected boolean failOnError = true;

    private java.io.File uriroot;

    private java.io.File webinc;

    private java.io.File webxml;

    protected org.apache.tools.ant.taskdefs.optional.jsp.JspC.WebAppParameter webApp;

    private static final java.lang.String FAIL_MSG = "Compile failed, messages should have been provided.";

    public  void setSrcDir( org.apache.tools.ant.types.Path srcDir )
    {
        if (src == null) {
            src = srcDir;
        } else {
            src.append( srcDir );
        }
    }

    public  org.apache.tools.ant.types.Path getSrcDir()
    {
        return src;
    }

    public  void setDestdir( java.io.File destDir )
    {
        this.destDir = destDir;
    }

    public  java.io.File getDestdir()
    {
        return destDir;
    }

    public  void setPackage( java.lang.String pkg )
    {
        this.packageName = pkg;
    }

    public  java.lang.String getPackage()
    {
        return packageName;
    }

    public  void setVerbose( int i )
    {
        verbose = i;
    }

    public  int getVerbose()
    {
        return verbose;
    }

    public  void setFailonerror( boolean fail )
    {
        failOnError = fail;
    }

    public  boolean getFailonerror()
    {
        return failOnError;
    }

    public  java.lang.String getIeplugin()
    {
        return iepluginid;
    }

    public  void setIeplugin( java.lang.String iepluginid )
    {
        this.iepluginid = iepluginid;
    }

    public  boolean isMapped()
    {
        return mapped;
    }

    public  void setMapped( boolean mapped )
    {
        this.mapped = mapped;
    }

    public  void setUribase( java.io.File uribase )
    {
        log( "Uribase is currently an unused parameter", Project.MSG_WARN );
    }

    public  java.io.File getUribase()
    {
        return uriroot;
    }

    public  void setUriroot( java.io.File uriroot )
    {
        this.uriroot = uriroot;
    }

    public  java.io.File getUriroot()
    {
        return uriroot;
    }

    public  void setClasspath( org.apache.tools.ant.types.Path cp )
    {
        if (classpath == null) {
            classpath = cp;
        } else {
            classpath.append( cp );
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (classpath == null) {
            classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return classpath.createPath();
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference r )
    {
        createClasspath().setRefid( r );
    }

    public  org.apache.tools.ant.types.Path getClasspath()
    {
        return classpath;
    }

    public  void setCompilerclasspath( org.apache.tools.ant.types.Path cp )
    {
        if (compilerClasspath == null) {
            compilerClasspath = cp;
        } else {
            compilerClasspath.append( cp );
        }
    }

    public  org.apache.tools.ant.types.Path getCompilerclasspath()
    {
        return compilerClasspath;
    }

    public  org.apache.tools.ant.types.Path createCompilerclasspath()
    {
        if (compilerClasspath == null) {
            compilerClasspath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return compilerClasspath.createPath();
    }

    public  void setWebxml( java.io.File webxml )
    {
        this.webxml = webxml;
    }

    public  java.io.File getWebxml()
    {
        return this.webxml;
    }

    public  void setWebinc( java.io.File webinc )
    {
        this.webinc = webinc;
    }

    public  java.io.File getWebinc()
    {
        return this.webinc;
    }

    public  void addWebApp( org.apache.tools.ant.taskdefs.optional.jsp.JspC.WebAppParameter webappParam )
        throws org.apache.tools.ant.BuildException
    {
        if (webApp == null) {
            webApp = webappParam;
        } else {
            throw new org.apache.tools.ant.BuildException( "Only one webapp can be specified" );
        }
    }

    public  org.apache.tools.ant.taskdefs.optional.jsp.JspC.WebAppParameter getWebApp()
    {
        return webApp;
    }

    public  void setCompiler( java.lang.String compiler )
    {
        this.compilerName = compiler;
    }

    public  java.util.Vector getCompileList()
    {
        return compileList;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (destDir == null) {
            throw new org.apache.tools.ant.BuildException( "destdir attribute must be set!", getLocation() );
        }
        if (!destDir.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "destination directory \"" + destDir + "\" does not exist or is not a directory", getLocation() );
        }
        java.io.File dest = getActualDestDir();
        org.apache.tools.ant.AntClassLoader al = null;
        try {
            org.apache.tools.ant.taskdefs.optional.jsp.compilers.JspCompilerAdapter compiler = JspCompilerAdapterFactory.getCompiler( compilerName, this, al = getProject().createClassLoader( compilerClasspath ) );
            if (webApp != null) {
                doCompilation( compiler );
                return;
            }
            if (src == null) {
                throw new org.apache.tools.ant.BuildException( "srcdir attribute must be set!", getLocation() );
            }
            java.lang.String[] list = src.list();
            if (list.length == 0) {
                throw new org.apache.tools.ant.BuildException( "srcdir attribute must be set!", getLocation() );
            }
            if (compiler.implementsOwnDependencyChecking()) {
                doCompilation( compiler );
                return;
            }
            org.apache.tools.ant.taskdefs.optional.jsp.JspMangler mangler = compiler.createMangler();
            resetFileLists();
            int filecount = 0;
            for (int i = 0; i < list.length; i++) {
                java.io.File srcDir = getProject().resolveFile( list[i] );
                if (!srcDir.exists()) {
                    throw new org.apache.tools.ant.BuildException( "srcdir \"" + srcDir.getPath() + "\" does not exist!", getLocation() );
                }
                org.apache.tools.ant.DirectoryScanner ds = this.getDirectoryScanner( srcDir );
                java.lang.String[] files = ds.getIncludedFiles();
                filecount = files.length;
                scanDir( srcDir, dest, mangler, files );
            }
            log( "compiling " + compileList.size() + " files", Project.MSG_VERBOSE );
            if (compileList.size() > 0) {
                log( "Compiling " + compileList.size() + " source file" + (compileList.size() == 1 ? "" : "s") + " to " + dest );
                doCompilation( compiler );
            } else {
                if (filecount == 0) {
                    log( "there were no files to compile", Project.MSG_INFO );
                } else {
                    log( "all files are up to date", Project.MSG_VERBOSE );
                }
            }
        } finally 
{
            if (al != null) {
                al.cleanup();
            }
        }
    }

    private  java.io.File getActualDestDir()
    {
        java.io.File dest = null;
        if (packageName == null) {
            dest = destDir;
        } else {
            java.lang.String path = destDir.getPath() + File.separatorChar + packageName.replace( '.', File.separatorChar );
            dest = new java.io.File( path );
        }
        return dest;
    }

    private  void doCompilation( org.apache.tools.ant.taskdefs.optional.jsp.compilers.JspCompilerAdapter compiler )
        throws org.apache.tools.ant.BuildException
    {
        compiler.setJspc( this );
        if (!compiler.execute()) {
            if (failOnError) {
                throw new org.apache.tools.ant.BuildException( FAIL_MSG, getLocation() );
            } else {
                log( FAIL_MSG, Project.MSG_ERR );
            }
        }
    }

    protected  void resetFileLists()
    {
        compileList.removeAllElements();
    }

    protected  void scanDir( java.io.File srcDir, java.io.File dest, org.apache.tools.ant.taskdefs.optional.jsp.JspMangler mangler, java.lang.String[] files )
    {
        long now = (new java.util.Date()).getTime();
        for (int i = 0; i < files.length; i++) {
            java.lang.String filename = files[i];
            java.io.File srcFile = new java.io.File( srcDir, filename );
            java.io.File javaFile = mapToJavaFile( mangler, srcFile, srcDir, dest );
            if (javaFile == null) {
                continue;
            }
            if (srcFile.lastModified() > now) {
                log( "Warning: file modified in the future: " + filename, Project.MSG_WARN );
            }
            boolean shouldCompile = false;
            shouldCompile = isCompileNeeded( srcFile, javaFile );
            if (shouldCompile) {
                compileList.addElement( srcFile.getAbsolutePath() );
                javaFiles.addElement( javaFile );
            }
        }
    }

    private  boolean isCompileNeeded( java.io.File srcFile, java.io.File javaFile )
    {
        boolean shouldCompile = false;
        if (!javaFile.exists()) {
            shouldCompile = true;
            log( "Compiling " + srcFile.getPath() + " because java file " + javaFile.getPath() + " does not exist", Project.MSG_VERBOSE );
        } else {
            if (srcFile.lastModified() > javaFile.lastModified()) {
                shouldCompile = true;
                log( "Compiling " + srcFile.getPath() + " because it is out of date with respect to " + javaFile.getPath(), Project.MSG_VERBOSE );
            } else {
                if (javaFile.length() == 0) {
                    shouldCompile = true;
                    log( "Compiling " + srcFile.getPath() + " because java file " + javaFile.getPath() + " is empty", Project.MSG_VERBOSE );
                }
            }
        }
        return shouldCompile;
    }

    protected  java.io.File mapToJavaFile( org.apache.tools.ant.taskdefs.optional.jsp.JspMangler mangler, java.io.File srcFile, java.io.File srcDir, java.io.File dest )
    {
        if (!srcFile.getName().endsWith( ".jsp" )) {
            return null;
        }
        java.lang.String javaFileName = mangler.mapJspToJavaName( srcFile );
        return new java.io.File( dest, javaFileName );
    }

    public  void deleteEmptyJavaFiles()
    {
        if (javaFiles != null) {
            java.util.Enumeration e = javaFiles.elements();
            while (e.hasMoreElements()) {
                java.io.File file = (java.io.File) e.nextElement();
                if (file.exists() && file.length() == 0) {
                    log( "deleting empty output file " + file );
                    file.delete();
                }
            }
        }
    }

    public static class WebAppParameter
    {

        private java.io.File directory;

        public  java.io.File getDirectory()
        {
            return directory;
        }

        public  void setBaseDir( java.io.File directory )
        {
            this.directory = directory;
        }

    }

}
