// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.util.Enumeration;
import java.util.NoSuchElementException;


public final class Enumerations
{

    private Enumerations()
    {
    }

    public static  java.util.Enumeration fromArray( java.lang.Object[] array )
    {
        return new org.apache.tools.ant.taskdefs.optional.junit.ArrayEnumeration( array );
    }

    public static  java.util.Enumeration fromCompound( java.util.Enumeration[] enums )
    {
        return new org.apache.tools.ant.taskdefs.optional.junit.CompoundEnumeration( enums );
    }

}

class ArrayEnumeration implements java.util.Enumeration
{

    private java.lang.Object[] array;

    private int pos;

    public ArrayEnumeration( java.lang.Object[] array )
    {
        this.array = array;
        this.pos = 0;
    }

    public  boolean hasMoreElements()
    {
        return pos < array.length;
    }

    public  java.lang.Object nextElement()
        throws java.util.NoSuchElementException
    {
        if (hasMoreElements()) {
            java.lang.Object o = array[pos];
            pos++;
            return o;
        }
        throw new java.util.NoSuchElementException();
    }

}

class CompoundEnumeration implements java.util.Enumeration
{

    private java.util.Enumeration[] enumArray;

    private int index = 0;

    public CompoundEnumeration( java.util.Enumeration[] enumarray )
    {
        this.enumArray = enumarray;
    }

    public  boolean hasMoreElements()
    {
        while (index < enumArray.length) {
            if (enumArray[index] != null && enumArray[index].hasMoreElements()) {
                return true;
            }
            index++;
        }
        return false;
    }

    public  java.lang.Object nextElement()
        throws java.util.NoSuchElementException
    {
        if (hasMoreElements()) {
            return enumArray[index].nextElement();
        }
        throw new java.util.NoSuchElementException();
    }

}
