// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.IOException;
import java.io.OutputStream;
import java.text.NumberFormat;
import junit.framework.AssertionFailedError;
import junit.framework.Test;
import org.apache.tools.ant.BuildException;


public class SummaryJUnitResultFormatter implements org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter, JUnitTaskMirror.SummaryJUnitResultFormatterMirror
{

    private static final double ONE_SECOND = 1000.0;

    private java.text.NumberFormat nf = NumberFormat.getInstance();

    private java.io.OutputStream out;

    private boolean withOutAndErr = false;

    private java.lang.String systemOutput = null;

    private java.lang.String systemError = null;

    public SummaryJUnitResultFormatter()
    {
    }

    public  void startTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
    {
        java.lang.String newLine = System.getProperty( "line.separator" );
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Running " );
        sb.append( suite.getName() );
        sb.append( newLine );
        try {
            out.write( sb.toString().getBytes() );
            out.flush();
        } catch ( java.io.IOException ioex ) {
            throw new org.apache.tools.ant.BuildException( "Unable to write summary output", ioex );
        }
    }

    public  void startTest( junit.framework.Test t )
    {
    }

    public  void endTest( junit.framework.Test test )
    {
    }

    public  void addFailure( junit.framework.Test test, java.lang.Throwable t )
    {
    }

    public  void addFailure( junit.framework.Test test, junit.framework.AssertionFailedError t )
    {
        addFailure( test, (java.lang.Throwable) t );
    }

    public  void addError( junit.framework.Test test, java.lang.Throwable t )
    {
    }

    public  void setOutput( java.io.OutputStream out )
    {
        this.out = out;
    }

    public  void setSystemOutput( java.lang.String out )
    {
        systemOutput = out;
    }

    public  void setSystemError( java.lang.String err )
    {
        systemError = err;
    }

    public  void setWithOutAndErr( boolean value )
    {
        withOutAndErr = value;
    }

    public  void endTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String newLine = System.getProperty( "line.separator" );
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Tests run: " );
        sb.append( suite.runCount() );
        sb.append( ", Failures: " );
        sb.append( suite.failureCount() );
        sb.append( ", Errors: " );
        sb.append( suite.errorCount() );
        sb.append( ", Time elapsed: " );
        sb.append( nf.format( suite.getRunTime() / ONE_SECOND ) );
        sb.append( " sec" );
        sb.append( newLine );
        if (withOutAndErr) {
            if (systemOutput != null && systemOutput.length() > 0) {
                sb.append( "Output:" ).append( newLine ).append( systemOutput ).append( newLine );
            }
            if (systemError != null && systemError.length() > 0) {
                sb.append( "Error: " ).append( newLine ).append( systemError ).append( newLine );
            }
        }
        try {
            out.write( sb.toString().getBytes() );
            out.flush();
        } catch ( java.io.IOException ioex ) {
            throw new org.apache.tools.ant.BuildException( "Unable to write summary output", ioex );
        } finally 
{
            if (out != System.out && out != System.err) {
                try {
                    out.close();
                } catch ( java.io.IOException e ) {
                }
            }
        }
    }

}
