// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Vector;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.util.DOMElementWriter;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.StringUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;


public class XMLResultAggregator extends org.apache.tools.ant.Task implements org.apache.tools.ant.taskdefs.optional.junit.XMLConstants
{

    protected java.util.Vector filesets = new java.util.Vector();

    protected java.lang.String toFile;

    protected java.io.File toDir;

    protected java.util.Vector transformers = new java.util.Vector();

    public static final java.lang.String DEFAULT_DIR = ".";

    public static final java.lang.String DEFAULT_FILENAME = "TESTS-TestSuites.xml";

    protected int generatedId = 0;

    static final java.lang.String WARNING_IS_POSSIBLY_CORRUPTED = " is not a valid XML document. It is possibly corrupted.";

    static final java.lang.String WARNING_INVALID_ROOT_ELEMENT = " is not a valid testsuite XML document";

    static final java.lang.String WARNING_EMPTY_FILE = " is empty.\nThis can be caused by the test JVM exiting unexpectedly";

    public  org.apache.tools.ant.taskdefs.optional.junit.AggregateTransformer createReport()
    {
        org.apache.tools.ant.taskdefs.optional.junit.AggregateTransformer transformer = new org.apache.tools.ant.taskdefs.optional.junit.AggregateTransformer( this );
        transformers.addElement( transformer );
        return transformer;
    }

    public  void setTofile( java.lang.String value )
    {
        toFile = value;
    }

    public  void setTodir( java.io.File value )
    {
        toDir = value;
    }

    public  void addFileSet( org.apache.tools.ant.types.FileSet fs )
    {
        filesets.addElement( fs );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.w3c.dom.Element rootElement = createDocument();
        java.io.File destFile = getDestinationFile();
        try {
            writeDOMTree( rootElement.getOwnerDocument(), destFile );
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( "Unable to write test aggregate to '" + destFile + "'", e );
        }
        java.util.Enumeration e = transformers.elements();
        while (e.hasMoreElements()) {
            org.apache.tools.ant.taskdefs.optional.junit.AggregateTransformer transformer = (org.apache.tools.ant.taskdefs.optional.junit.AggregateTransformer) e.nextElement();
            transformer.setXmlDocument( rootElement.getOwnerDocument() );
            transformer.transform();
        }
    }

    public  java.io.File getDestinationFile()
    {
        if (toFile == null) {
            toFile = DEFAULT_FILENAME;
        }
        if (toDir == null) {
            toDir = getProject().resolveFile( DEFAULT_DIR );
        }
        return new java.io.File( toDir, toFile );
    }

    protected  java.io.File[] getFiles()
    {
        java.util.Vector v = new java.util.Vector();
        final int size = filesets.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.FileSet fs = (org.apache.tools.ant.types.FileSet) filesets.elementAt( i );
            org.apache.tools.ant.DirectoryScanner ds = fs.getDirectoryScanner( getProject() );
            ds.scan();
            java.lang.String[] f = ds.getIncludedFiles();
            for (int j = 0; j < f.length; j++) {
                java.lang.String pathname = f[j];
                if (pathname.endsWith( ".xml" )) {
                    java.io.File file = new java.io.File( ds.getBasedir(), pathname );
                    file = getProject().resolveFile( file.getPath() );
                    v.addElement( file );
                }
            }
        }
        java.io.File[] files = new java.io.File[v.size()];
        v.copyInto( files );
        return files;
    }

    protected  void writeDOMTree( org.w3c.dom.Document doc, java.io.File file )
        throws java.io.IOException
    {
        java.io.OutputStream out = null;
        java.io.PrintWriter wri = null;
        try {
            out = new java.io.BufferedOutputStream( new java.io.FileOutputStream( file ) );
            wri = new java.io.PrintWriter( new java.io.OutputStreamWriter( out, "UTF8" ) );
            wri.write( "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n" );
            (new org.apache.tools.ant.util.DOMElementWriter()).write( doc.getDocumentElement(), wri, 0, "  " );
            wri.flush();
            if (wri.checkError()) {
                throw new java.io.IOException( "Error while writing DOM content" );
            }
        } finally 
{
            FileUtils.close( wri );
            FileUtils.close( out );
        }
    }

    protected  org.w3c.dom.Element createDocument()
    {
        javax.xml.parsers.DocumentBuilder builder = getDocumentBuilder();
        org.w3c.dom.Document doc = builder.newDocument();
        org.w3c.dom.Element rootElement = doc.createElement( TESTSUITES );
        doc.appendChild( rootElement );
        generatedId = 0;
        java.io.File[] files = getFiles();
        for (int i = 0; i < files.length; i++) {
            java.io.File file = files[i];
            try {
                log( "Parsing file: '" + file + "'", Project.MSG_VERBOSE );
                if (file.length() > 0) {
                    org.w3c.dom.Document testsuiteDoc = builder.parse( FileUtils.getFileUtils().toURI( files[i].getAbsolutePath() ) );
                    org.w3c.dom.Element elem = testsuiteDoc.getDocumentElement();
                    if (TESTSUITE.equals( elem.getNodeName() )) {
                        addTestSuite( rootElement, elem );
                        generatedId++;
                    } else {
                        log( "the file " + file + WARNING_INVALID_ROOT_ELEMENT, Project.MSG_WARN );
                    }
                } else {
                    log( "the file " + file + WARNING_EMPTY_FILE, Project.MSG_WARN );
                }
            } catch ( org.xml.sax.SAXException e ) {
                log( "The file " + file + WARNING_IS_POSSIBLY_CORRUPTED, Project.MSG_WARN );
                log( StringUtils.getStackTrace( e ), Project.MSG_DEBUG );
            } catch ( java.io.IOException e ) {
                log( "Error while accessing file " + file + ": " + e.getMessage(), Project.MSG_ERR );
                log( "Error while accessing file " + file + ": " + e.getMessage(), e, Project.MSG_VERBOSE );
            }
        }
        return rootElement;
    }

    protected  void addTestSuite( org.w3c.dom.Element root, org.w3c.dom.Element testsuite )
    {
        java.lang.String fullclassname = testsuite.getAttribute( ATTR_NAME );
        int pos = fullclassname.lastIndexOf( '.' );
        java.lang.String pkgName = pos == -1 ? "" : fullclassname.substring( 0, pos );
        java.lang.String classname = pos == -1 ? fullclassname : fullclassname.substring( pos + 1 );
        org.w3c.dom.Element copy = (org.w3c.dom.Element) DOMUtil.importNode( root, testsuite );
        copy.setAttribute( ATTR_NAME, classname );
        copy.setAttribute( ATTR_PACKAGE, pkgName );
        copy.setAttribute( ATTR_ID, Integer.toString( generatedId ) );
    }

    private static  javax.xml.parsers.DocumentBuilder getDocumentBuilder()
    {
        try {
            return DocumentBuilderFactory.newInstance().newDocumentBuilder();
        } catch ( java.lang.Exception exc ) {
            throw new java.lang.ExceptionInInitializerError( exc );
        }
    }

}
