// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.native2ascii;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.taskdefs.ExecuteJava;
import org.apache.tools.ant.taskdefs.optional.Native2Ascii;
import org.apache.tools.ant.types.Commandline;


public final class KaffeNative2Ascii extends org.apache.tools.ant.taskdefs.optional.native2ascii.DefaultNative2Ascii
{

    private static final java.lang.String[] N2A_CLASSNAMES = new java.lang.String[]{ "gnu.classpath.tools.native2ascii.Native2Ascii", "kaffe.tools.native2ascii.Native2Ascii", };

    public static final java.lang.String IMPLEMENTATION_NAME = "kaffe";

    protected  void setup( org.apache.tools.ant.types.Commandline cmd, org.apache.tools.ant.taskdefs.optional.Native2Ascii args )
        throws org.apache.tools.ant.BuildException
    {
        if (args.getReverse()) {
            throw new org.apache.tools.ant.BuildException( "-reverse is not supported by Kaffe" );
        }
        super.setup( cmd, args );
    }

    protected  boolean run( org.apache.tools.ant.types.Commandline cmd, org.apache.tools.ant.ProjectComponent log )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.taskdefs.ExecuteJava ej = new org.apache.tools.ant.taskdefs.ExecuteJava();
        java.lang.Class c = getN2aClass();
        if (c == null) {
            throw new org.apache.tools.ant.BuildException( "Couldn't load Kaffe's Native2Ascii" + " class" );
        }
        cmd.setExecutable( c.getName() );
        ej.setJavaCommand( cmd );
        ej.execute( log.getProject() );
        return true;
    }

    private static  java.lang.Class getN2aClass()
    {
        for (int i = 0; i < N2A_CLASSNAMES.length; i++) {
            try {
                return Class.forName( N2A_CLASSNAMES[i] );
            } catch ( java.lang.ClassNotFoundException cnfe ) {
            }
        }
        return null;
    }

}
