// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.net;


import java.io.File;
import java.lang.reflect.Constructor;
import java.util.Locale;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.EnumeratedAttribute;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.LoaderUtils;
import org.apache.tools.ant.util.Retryable;
import org.apache.tools.ant.util.SplitClassLoader;


public class FTPTask extends org.apache.tools.ant.Task implements org.apache.tools.ant.taskdefs.optional.net.FTPTaskConfig
{

    public static final int SEND_FILES = 0;

    public static final int GET_FILES = 1;

    public static final int DEL_FILES = 2;

    public static final int LIST_FILES = 3;

    public static final int MK_DIR = 4;

    public static final int CHMOD = 5;

    public static final int RM_DIR = 6;

    public static final int SITE_CMD = 7;

    private static final long GRANULARITY_MINUTE = 60000L;

    public static final int DEFAULT_FTP_PORT = 21;

    private java.lang.String remotedir;

    private java.lang.String server;

    private java.lang.String userid;

    private java.lang.String password;

    private java.lang.String account;

    private java.io.File listing;

    private boolean binary = true;

    private boolean passive = false;

    private boolean verbose = false;

    private boolean newerOnly = false;

    private long timeDiffMillis = 0;

    private long granularityMillis = 0L;

    private boolean timeDiffAuto = false;

    private int action = SEND_FILES;

    private java.util.Vector filesets = new java.util.Vector();

    private java.lang.String remoteFileSep = "/";

    private int port = DEFAULT_FTP_PORT;

    private boolean skipFailedTransfers = false;

    private boolean ignoreNoncriticalErrors = false;

    private boolean preserveLastModified = false;

    private java.lang.String chmod = null;

    private java.lang.String umask = null;

    private org.apache.tools.ant.taskdefs.optional.net.FTPTask.FTPSystemType systemTypeKey = FTPSystemType.getDefault();

    private java.lang.String defaultDateFormatConfig = null;

    private java.lang.String recentDateFormatConfig = null;

    private java.lang.String serverLanguageCodeConfig = null;

    private java.lang.String serverTimeZoneConfig = null;

    private java.lang.String shortMonthNamesConfig = null;

    private org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity timestampGranularity = Granularity.getDefault();

    private boolean isConfigurationSet = false;

    private int retriesAllowed = 0;

    private java.lang.String siteCommand = null;

    private java.lang.String initialSiteCommand = null;

    private boolean enableRemoteVerification = true;

    private org.apache.tools.ant.types.Path classpath;

    private java.lang.ClassLoader mirrorLoader;

    private org.apache.tools.ant.taskdefs.optional.net.FTPTaskMirror delegate = null;

    public static final java.lang.String[] ACTION_STRS = { "sending", "getting", "deleting", "listing", "making directory", "chmod", "removing", "site" };

    public static final java.lang.String[] COMPLETED_ACTION_STRS = { "sent", "retrieved", "deleted", "listed", "created directory", "mode changed", "removed", "site command executed" };

    public static final java.lang.String[] ACTION_TARGET_STRS = { "files", "files", "files", "files", "directory", "files", "directories", "site command" };

    public  void setRemotedir( java.lang.String dir )
    {
        this.remotedir = dir;
    }

    public  java.lang.String getRemotedir()
    {
        return remotedir;
    }

    public  void setServer( java.lang.String server )
    {
        this.server = server;
    }

    public  java.lang.String getServer()
    {
        return server;
    }

    public  void setPort( int port )
    {
        this.port = port;
    }

    public  int getPort()
    {
        return port;
    }

    public  void setUserid( java.lang.String userid )
    {
        this.userid = userid;
    }

    public  java.lang.String getUserid()
    {
        return userid;
    }

    public  void setPassword( java.lang.String password )
    {
        this.password = password;
    }

    public  java.lang.String getPassword()
    {
        return password;
    }

    public  void setAccount( java.lang.String pAccount )
    {
        this.account = pAccount;
    }

    public  java.lang.String getAccount()
    {
        return account;
    }

    public  void setBinary( boolean binary )
    {
        this.binary = binary;
    }

    public  boolean isBinary()
    {
        return binary;
    }

    public  void setPassive( boolean passive )
    {
        this.passive = passive;
    }

    public  boolean isPassive()
    {
        return passive;
    }

    public  void setVerbose( boolean verbose )
    {
        this.verbose = verbose;
    }

    public  boolean isVerbose()
    {
        return verbose;
    }

    public  void setNewer( boolean newer )
    {
        this.newerOnly = newer;
    }

    public  boolean isNewer()
    {
        return newerOnly;
    }

    public  void setTimeDiffMillis( long timeDiffMillis )
    {
        this.timeDiffMillis = timeDiffMillis;
    }

    public  long getTimeDiffMillis()
    {
        return timeDiffMillis;
    }

    public  void setTimeDiffAuto( boolean timeDiffAuto )
    {
        this.timeDiffAuto = timeDiffAuto;
    }

    public  boolean isTimeDiffAuto()
    {
        return timeDiffAuto;
    }

    public  void setPreserveLastModified( boolean preserveLastModified )
    {
        this.preserveLastModified = preserveLastModified;
    }

    public  boolean isPreserveLastModified()
    {
        return preserveLastModified;
    }

    public  void setDepends( boolean depends )
    {
        this.newerOnly = depends;
    }

    public  void setSeparator( java.lang.String separator )
    {
        remoteFileSep = separator;
    }

    public  java.lang.String getSeparator()
    {
        return remoteFileSep;
    }

    public  void setChmod( java.lang.String theMode )
    {
        this.chmod = theMode;
    }

    public  java.lang.String getChmod()
    {
        return chmod;
    }

    public  void setUmask( java.lang.String theUmask )
    {
        this.umask = theUmask;
    }

    public  java.lang.String getUmask()
    {
        return umask;
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet set )
    {
        filesets.addElement( set );
    }

    public  java.util.Vector getFilesets()
    {
        return filesets;
    }

    public  void setAction( java.lang.String action )
        throws org.apache.tools.ant.BuildException
    {
        log( "DEPRECATED - The setAction(String) method has been deprecated." + " Use setAction(FTP.Action) instead." );
        org.apache.tools.ant.taskdefs.optional.net.FTPTask.Action a = new org.apache.tools.ant.taskdefs.optional.net.FTPTask.Action();
        a.setValue( action );
        this.action = a.getAction();
    }

    public  void setAction( org.apache.tools.ant.taskdefs.optional.net.FTPTask.Action action )
        throws org.apache.tools.ant.BuildException
    {
        this.action = action.getAction();
    }

    public  int getAction()
    {
        return this.action;
    }

    public  void setListing( java.io.File listing )
    {
        this.listing = listing;
    }

    public  java.io.File getListing()
    {
        return listing;
    }

    public  void setSkipFailedTransfers( boolean skipFailedTransfers )
    {
        this.skipFailedTransfers = skipFailedTransfers;
    }

    public  boolean isSkipFailedTransfers()
    {
        return skipFailedTransfers;
    }

    public  void setIgnoreNoncriticalErrors( boolean ignoreNoncriticalErrors )
    {
        this.ignoreNoncriticalErrors = ignoreNoncriticalErrors;
    }

    public  boolean isIgnoreNoncriticalErrors()
    {
        return ignoreNoncriticalErrors;
    }

    private  void configurationHasBeenSet()
    {
        this.isConfigurationSet = true;
    }

    public  boolean isConfigurationSet()
    {
        return this.isConfigurationSet;
    }

    public  void setSystemTypeKey( org.apache.tools.ant.taskdefs.optional.net.FTPTask.FTPSystemType systemKey )
    {
        if (systemKey != null && !systemKey.getValue().equals( "" )) {
            this.systemTypeKey = systemKey;
            configurationHasBeenSet();
        }
    }

    public  void setDefaultDateFormatConfig( java.lang.String defaultDateFormat )
    {
        if (defaultDateFormat != null && !defaultDateFormat.equals( "" )) {
            this.defaultDateFormatConfig = defaultDateFormat;
            configurationHasBeenSet();
        }
    }

    public  void setRecentDateFormatConfig( java.lang.String recentDateFormat )
    {
        if (recentDateFormat != null && !recentDateFormat.equals( "" )) {
            this.recentDateFormatConfig = recentDateFormat;
            configurationHasBeenSet();
        }
    }

    public  void setServerLanguageCodeConfig( java.lang.String serverLanguageCode )
    {
        if (serverLanguageCode != null && !"".equals( serverLanguageCode )) {
            this.serverLanguageCodeConfig = serverLanguageCode;
            configurationHasBeenSet();
        }
    }

    public  void setServerTimeZoneConfig( java.lang.String serverTimeZoneId )
    {
        if (serverTimeZoneId != null && !serverTimeZoneId.equals( "" )) {
            this.serverTimeZoneConfig = serverTimeZoneId;
            configurationHasBeenSet();
        }
    }

    public  void setShortMonthNamesConfig( java.lang.String shortMonthNames )
    {
        if (shortMonthNames != null && !shortMonthNames.equals( "" )) {
            this.shortMonthNamesConfig = shortMonthNames;
            configurationHasBeenSet();
        }
    }

    public  void setRetriesAllowed( java.lang.String retriesAllowed )
    {
        if ("FOREVER".equalsIgnoreCase( retriesAllowed )) {
            this.retriesAllowed = Retryable.RETRY_FOREVER;
        } else {
            try {
                int retries = Integer.parseInt( retriesAllowed );
                if (retries < Retryable.RETRY_FOREVER) {
                    throw new org.apache.tools.ant.BuildException( "Invalid value for retriesAllowed attribute: " + retriesAllowed );
                }
                this.retriesAllowed = retries;
            } catch ( java.lang.NumberFormatException px ) {
                throw new org.apache.tools.ant.BuildException( "Invalid value for retriesAllowed attribute: " + retriesAllowed );
            }
        }
    }

    public  int getRetriesAllowed()
    {
        return retriesAllowed;
    }

    public  java.lang.String getSystemTypeKey()
    {
        return systemTypeKey.getValue();
    }

    public  java.lang.String getDefaultDateFormatConfig()
    {
        return defaultDateFormatConfig;
    }

    public  java.lang.String getRecentDateFormatConfig()
    {
        return recentDateFormatConfig;
    }

    public  java.lang.String getServerLanguageCodeConfig()
    {
        return serverLanguageCodeConfig;
    }

    public  java.lang.String getServerTimeZoneConfig()
    {
        return serverTimeZoneConfig;
    }

    public  java.lang.String getShortMonthNamesConfig()
    {
        return shortMonthNamesConfig;
    }

    public  org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity getTimestampGranularity()
    {
        return timestampGranularity;
    }

    public  void setTimestampGranularity( org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity timestampGranularity )
    {
        if (null == timestampGranularity || "".equals( timestampGranularity.getValue() )) {
            return;
        }
        this.timestampGranularity = timestampGranularity;
    }

    public  void setSiteCommand( java.lang.String siteCommand )
    {
        this.siteCommand = siteCommand;
    }

    public  java.lang.String getSiteCommand()
    {
        return siteCommand;
    }

    public  void setInitialSiteCommand( java.lang.String initialCommand )
    {
        this.initialSiteCommand = initialCommand;
    }

    public  java.lang.String getInitialSiteCommand()
    {
        return initialSiteCommand;
    }

    public  long getGranularityMillis()
    {
        return this.granularityMillis;
    }

    public  void setGranularityMillis( long granularity )
    {
        this.granularityMillis = granularity;
    }

    public  void setEnableRemoteVerification( boolean b )
    {
        enableRemoteVerification = b;
    }

    public  boolean getEnableRemoteVerification()
    {
        return enableRemoteVerification;
    }

    protected  void checkAttributes()
        throws org.apache.tools.ant.BuildException
    {
        if (server == null) {
            throw new org.apache.tools.ant.BuildException( "server attribute must be set!" );
        }
        if (userid == null) {
            throw new org.apache.tools.ant.BuildException( "userid attribute must be set!" );
        }
        if (password == null) {
            throw new org.apache.tools.ant.BuildException( "password attribute must be set!" );
        }
        if (action == LIST_FILES && listing == null) {
            throw new org.apache.tools.ant.BuildException( "listing attribute must be set for list " + "action!" );
        }
        if (action == MK_DIR && remotedir == null) {
            throw new org.apache.tools.ant.BuildException( "remotedir attribute must be set for " + "mkdir action!" );
        }
        if (action == CHMOD && chmod == null) {
            throw new org.apache.tools.ant.BuildException( "chmod attribute must be set for chmod " + "action!" );
        }
        if (action == SITE_CMD && siteCommand == null) {
            throw new org.apache.tools.ant.BuildException( "sitecommand attribute must be set for site " + "action!" );
        }
        if (this.isConfigurationSet) {
            try {
                Class.forName( "org.apache.commons.net.ftp.FTPClientConfig" );
            } catch ( java.lang.ClassNotFoundException e ) {
                throw new org.apache.tools.ant.BuildException( "commons-net.jar >= 1.4.0 is required for at least one" + " of the attributes specified." );
            }
        }
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        checkAttributes();
        try {
            setupFTPDelegate();
            delegate.doFTP();
        } finally 
{
            if (mirrorLoader instanceof org.apache.tools.ant.util.SplitClassLoader) {
                ((org.apache.tools.ant.util.SplitClassLoader) mirrorLoader).cleanup();
            }
            mirrorLoader = null;
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (classpath == null) {
            classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return classpath;
    }

    protected  void setupFTPDelegate()
    {
        java.lang.ClassLoader myLoader = (org.apache.tools.ant.taskdefs.optional.net.FTPTask.class).getClassLoader();
        if (mustSplit()) {
            mirrorLoader = new org.apache.tools.ant.util.SplitClassLoader( myLoader, classpath, getProject(), new java.lang.String[]{ "FTPTaskMirrorImpl", "FTPConfigurator" } );
        } else {
            mirrorLoader = myLoader;
        }
        delegate = createMirror( this, mirrorLoader );
    }

    private static  boolean mustSplit()
    {
        return LoaderUtils.getResourceSource( (org.apache.tools.ant.taskdefs.optional.net.FTPTask.class).getClassLoader(), "/org/apache/commons/net/" + "ftp/FTP.class" ) == null;
    }

    private static  org.apache.tools.ant.taskdefs.optional.net.FTPTaskMirror createMirror( org.apache.tools.ant.taskdefs.optional.net.FTPTask task, java.lang.ClassLoader loader )
    {
        try {
            loader.loadClass( "org.apache.commons.net.ftp.FTP" );
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.tools.ant.BuildException( "The <classpath> for <ftp> must include" + " commons-net.jar if not in Ant's own " + " classpath", e, task.getLocation() );
        }
        try {
            java.lang.Class c = loader.loadClass( (org.apache.tools.ant.taskdefs.optional.net.FTPTaskMirror.class).getName() + "Impl" );
            if (c.getClassLoader() != loader) {
                throw new org.apache.tools.ant.BuildException( "Overdelegating loader", task.getLocation() );
            }
            java.lang.reflect.Constructor cons = c.getConstructor( new java.lang.Class[]{ org.apache.tools.ant.taskdefs.optional.net.FTPTask.class } );
            return (org.apache.tools.ant.taskdefs.optional.net.FTPTaskMirror) cons.newInstance( new java.lang.Object[]{ task } );
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( e, task.getLocation() );
        }
    }

    public static class Action extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private static final java.lang.String[] VALID_ACTIONS = { "send", "put", "recv", "get", "del", "delete", "list", "mkdir", "chmod", "rmdir", "site" };

        public  java.lang.String[] getValues()
        {
            return VALID_ACTIONS;
        }

        public  int getAction()
        {
            java.lang.String actionL = getValue().toLowerCase( Locale.ENGLISH );
            if (actionL.equals( "send" ) || actionL.equals( "put" )) {
                return SEND_FILES;
            } else {
                if (actionL.equals( "recv" ) || actionL.equals( "get" )) {
                    return GET_FILES;
                } else {
                    if (actionL.equals( "del" ) || actionL.equals( "delete" )) {
                        return DEL_FILES;
                    } else {
                        if (actionL.equals( "list" )) {
                            return LIST_FILES;
                        } else {
                            if (actionL.equals( "chmod" )) {
                                return CHMOD;
                            } else {
                                if (actionL.equals( "mkdir" )) {
                                    return MK_DIR;
                                } else {
                                    if (actionL.equals( "rmdir" )) {
                                        return RM_DIR;
                                    } else {
                                        if (actionL.equals( "site" )) {
                                            return SITE_CMD;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return SEND_FILES;
        }

    }

    public static class Granularity extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private static final java.lang.String[] VALID_GRANULARITIES = { "", "MINUTE", "NONE" };

        public  java.lang.String[] getValues()
        {
            return VALID_GRANULARITIES;
        }

        public  long getMilliseconds( int action )
        {
            java.lang.String granularityU = getValue().toUpperCase( Locale.ENGLISH );
            if ("".equals( granularityU )) {
                if (action == SEND_FILES) {
                    return GRANULARITY_MINUTE;
                }
            } else {
                if ("MINUTE".equals( granularityU )) {
                    return GRANULARITY_MINUTE;
                }
            }
            return 0L;
        }

        static final  org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity getDefault()
        {
            org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity g = new org.apache.tools.ant.taskdefs.optional.net.FTPTask.Granularity();
            g.setValue( "" );
            return g;
        }

    }

    public static class FTPSystemType extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private static final java.lang.String[] VALID_SYSTEM_TYPES = { "", "UNIX", "VMS", "WINDOWS", "OS/2", "OS/400", "MVS" };

        public  java.lang.String[] getValues()
        {
            return VALID_SYSTEM_TYPES;
        }

        static final  org.apache.tools.ant.taskdefs.optional.net.FTPTask.FTPSystemType getDefault()
        {
            org.apache.tools.ant.taskdefs.optional.net.FTPTask.FTPSystemType ftpst = new org.apache.tools.ant.taskdefs.optional.net.FTPTask.FTPSystemType();
            ftpst.setValue( "" );
            return ftpst;
        }

    }

}
