// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.rmic;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.ClasspathUtils;


public final class RmicAdapterFactory
{

    public static final java.lang.String ERROR_UNKNOWN_COMPILER = "Class not found: ";

    public static final java.lang.String ERROR_NOT_RMIC_ADAPTER = "Class of unexpected Type: ";

    public static final java.lang.String DEFAULT_COMPILER = "default";

    private RmicAdapterFactory()
    {
    }

    public static  org.apache.tools.ant.taskdefs.rmic.RmicAdapter getRmic( java.lang.String rmicType, org.apache.tools.ant.Task task )
        throws org.apache.tools.ant.BuildException
    {
        return getRmic( rmicType, task, null );
    }

    public static  org.apache.tools.ant.taskdefs.rmic.RmicAdapter getRmic( java.lang.String rmicType, org.apache.tools.ant.Task task, org.apache.tools.ant.types.Path classpath )
        throws org.apache.tools.ant.BuildException
    {
        if (DEFAULT_COMPILER.equalsIgnoreCase( rmicType ) || rmicType.length() == 0) {
            rmicType = KaffeRmic.isAvailable() ? KaffeRmic.COMPILER_NAME : SunRmic.COMPILER_NAME;
        }
        if (SunRmic.COMPILER_NAME.equalsIgnoreCase( rmicType )) {
            return new org.apache.tools.ant.taskdefs.rmic.SunRmic();
        } else {
            if (KaffeRmic.COMPILER_NAME.equalsIgnoreCase( rmicType )) {
                return new org.apache.tools.ant.taskdefs.rmic.KaffeRmic();
            } else {
                if (WLRmic.COMPILER_NAME.equalsIgnoreCase( rmicType )) {
                    return new org.apache.tools.ant.taskdefs.rmic.WLRmic();
                } else {
                    if (ForkingSunRmic.COMPILER_NAME.equalsIgnoreCase( rmicType )) {
                        return new org.apache.tools.ant.taskdefs.rmic.ForkingSunRmic();
                    } else {
                        if (XNewRmic.COMPILER_NAME.equalsIgnoreCase( rmicType )) {
                            return new org.apache.tools.ant.taskdefs.rmic.XNewRmic();
                        }
                    }
                }
            }
        }
        return resolveClassName( rmicType, task.getProject().createClassLoader( classpath ) );
    }

    private static  org.apache.tools.ant.taskdefs.rmic.RmicAdapter resolveClassName( java.lang.String className, java.lang.ClassLoader loader )
        throws org.apache.tools.ant.BuildException
    {
        return (org.apache.tools.ant.taskdefs.rmic.RmicAdapter) ClasspathUtils.newInstance( className, loader != null ? loader : (org.apache.tools.ant.taskdefs.rmic.RmicAdapterFactory.class).getClassLoader(), org.apache.tools.ant.taskdefs.rmic.RmicAdapter.class );
    }

}
