// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.rmic;


import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.LogOutputStream;
import org.apache.tools.ant.types.Commandline;


public class SunRmic extends org.apache.tools.ant.taskdefs.rmic.DefaultRmicAdapter
{

    public static final java.lang.String RMIC_CLASSNAME = "sun.rmi.rmic.Main";

    public static final java.lang.String COMPILER_NAME = "sun";

    public static final java.lang.String RMIC_EXECUTABLE = "rmic";

    public static final java.lang.String ERROR_NO_RMIC_ON_CLASSPATH = "Cannot use SUN rmic, as it is not " + "available.  A common solution is to " + "set the environment variable " + "JAVA_HOME";

    public static final java.lang.String ERROR_RMIC_FAILED = "Error starting SUN rmic: ";

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        getRmic().log( "Using SUN rmic compiler", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Commandline cmd = setupRmicCommand();
        org.apache.tools.ant.taskdefs.LogOutputStream logstr = new org.apache.tools.ant.taskdefs.LogOutputStream( getRmic(), Project.MSG_WARN );
        try {
            java.lang.Class c = Class.forName( RMIC_CLASSNAME );
            java.lang.reflect.Constructor cons = c.getConstructor( new java.lang.Class[]{ java.io.OutputStream.class, java.lang.String.class } );
            java.lang.Object rmic = cons.newInstance( new java.lang.Object[]{ logstr, "rmic" } );
            java.lang.reflect.Method doRmic = c.getMethod( "compile", new java.lang.Class[]{ java.lang.String[].class } );
            java.lang.Boolean ok = (java.lang.Boolean) doRmic.invoke( rmic, new java.lang.Object[]{ cmd.getArguments() } );
            return ok.booleanValue();
        } catch ( java.lang.ClassNotFoundException ex ) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_RMIC_ON_CLASSPATH, getRmic().getLocation() );
        } catch ( java.lang.Exception ex ) {
            if (ex instanceof org.apache.tools.ant.BuildException) {
                throw (org.apache.tools.ant.BuildException) ex;
            } else {
                throw new org.apache.tools.ant.BuildException( ERROR_RMIC_FAILED, ex, getRmic().getLocation() );
            }
        } finally 
{
            try {
                logstr.close();
            } catch ( java.io.IOException e ) {
                throw new org.apache.tools.ant.BuildException( e );
            }
        }
    }

    protected  java.lang.String[] preprocessCompilerArgs( java.lang.String[] compilerArgs )
    {
        return filterJvmCompilerArgs( compilerArgs );
    }

}
