// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.util.Properties;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.util.FileNameMapper;
import org.apache.tools.ant.util.CompositeMapper;
import org.apache.tools.ant.util.ContainerMapper;


public class Mapper extends org.apache.tools.ant.types.DataType implements java.lang.Cloneable
{

    protected org.apache.tools.ant.types.Mapper.MapperType type = null;

    protected java.lang.String classname = null;

    protected org.apache.tools.ant.types.Path classpath = null;

    protected java.lang.String from = null;

    protected java.lang.String to = null;

    private org.apache.tools.ant.util.ContainerMapper container = null;

    public Mapper( org.apache.tools.ant.Project p )
    {
        setProject( p );
    }

    public  void setType( org.apache.tools.ant.types.Mapper.MapperType type )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        this.type = type;
    }

    public  void addConfigured( org.apache.tools.ant.util.FileNameMapper fileNameMapper )
    {
        add( fileNameMapper );
    }

    public  void add( org.apache.tools.ant.util.FileNameMapper fileNameMapper )
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        if (container == null) {
            if (type == null && classname == null) {
                container = new org.apache.tools.ant.util.CompositeMapper();
            } else {
                org.apache.tools.ant.util.FileNameMapper m = getImplementation();
                if (m instanceof org.apache.tools.ant.util.ContainerMapper) {
                    container = (org.apache.tools.ant.util.ContainerMapper) m;
                } else {
                    throw new org.apache.tools.ant.BuildException( String.valueOf( m ) + " mapper implementation does not support nested mappers!" );
                }
            }
        }
        container.add( fileNameMapper );
        setChecked( false );
    }

    public  void addConfiguredMapper( org.apache.tools.ant.types.Mapper mapper )
    {
        add( mapper.getImplementation() );
    }

    public  void setClassname( java.lang.String classname )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        this.classname = classname;
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append( classpath );
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        if (this.classpath == null) {
            this.classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        setChecked( false );
        return this.classpath.createPath();
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference ref )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        createClasspath().setRefid( ref );
    }

    public  void setFrom( java.lang.String from )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        this.from = from;
    }

    public  void setTo( java.lang.String to )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        this.to = to;
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
        throws org.apache.tools.ant.BuildException
    {
        if (type != null || from != null || to != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  org.apache.tools.ant.util.FileNameMapper getImplementation()
        throws org.apache.tools.ant.BuildException
    {
        if (isReference()) {
            dieOnCircularReference();
            org.apache.tools.ant.types.Reference r = getRefid();
            java.lang.Object o = r.getReferencedObject( getProject() );
            if (o instanceof org.apache.tools.ant.util.FileNameMapper) {
                return (org.apache.tools.ant.util.FileNameMapper) o;
            }
            if (o instanceof org.apache.tools.ant.types.Mapper) {
                return ((org.apache.tools.ant.types.Mapper) o).getImplementation();
            }
            java.lang.String od = o == null ? "null" : o.getClass().getName();
            throw new org.apache.tools.ant.BuildException( od + " at reference '" + r.getRefId() + "' is not a valid mapper reference." );
        }
        if (type == null && classname == null && container == null) {
            throw new org.apache.tools.ant.BuildException( "nested mapper or " + "one of the attributes type or classname is required" );
        }
        if (container != null) {
            return container;
        }
        if (type != null && classname != null) {
            throw new org.apache.tools.ant.BuildException( "must not specify both type and classname attribute" );
        }
        try {
            org.apache.tools.ant.util.FileNameMapper m = (org.apache.tools.ant.util.FileNameMapper) getImplementationClass().newInstance();
            final org.apache.tools.ant.Project p = getProject();
            if (p != null) {
                p.setProjectReference( m );
            }
            m.setFrom( from );
            m.setTo( to );
            return m;
        } catch ( org.apache.tools.ant.BuildException be ) {
            throw be;
        } catch ( java.lang.Throwable t ) {
            throw new org.apache.tools.ant.BuildException( t );
        }
    }

    protected  java.lang.Class getImplementationClass()
        throws java.lang.ClassNotFoundException
    {
        java.lang.String cName = this.classname;
        if (type != null) {
            cName = type.getImplementation();
        }
        java.lang.ClassLoader loader = classpath == null ? getClass().getClassLoader() : getProject().createClassLoader( classpath );
        return Class.forName( cName, true, loader );
    }

    protected  org.apache.tools.ant.types.Mapper getRef()
    {
        return (org.apache.tools.ant.types.Mapper) getCheckedRef();
    }

    public static class MapperType extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private java.util.Properties implementations;

        public MapperType()
        {
            implementations = new java.util.Properties();
            implementations.put( "identity", "org.apache.tools.ant.util.IdentityMapper" );
            implementations.put( "flatten", "org.apache.tools.ant.util.FlatFileNameMapper" );
            implementations.put( "glob", "org.apache.tools.ant.util.GlobPatternMapper" );
            implementations.put( "merge", "org.apache.tools.ant.util.MergingMapper" );
            implementations.put( "regexp", "org.apache.tools.ant.util.RegexpPatternMapper" );
            implementations.put( "package", "org.apache.tools.ant.util.PackageNameMapper" );
            implementations.put( "unpackage", "org.apache.tools.ant.util.UnPackageNameMapper" );
        }

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "identity", "flatten", "glob", "merge", "regexp", "package", "unpackage" };
        }

        public  java.lang.String getImplementation()
        {
            return implementations.getProperty( getValue() );
        }

    }

}
