// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;


public class TarFileSet extends org.apache.tools.ant.types.ArchiveFileSet
{

    private boolean userNameSet;

    private boolean groupNameSet;

    private boolean userIdSet;

    private boolean groupIdSet;

    private java.lang.String userName = "";

    private java.lang.String groupName = "";

    private int uid;

    private int gid;

    public TarFileSet()
    {
        super();
    }

    protected TarFileSet( org.apache.tools.ant.types.FileSet fileset )
    {
        super( fileset );
    }

    protected TarFileSet( org.apache.tools.ant.types.TarFileSet fileset )
    {
        super( fileset );
    }

    public  void setUserName( java.lang.String userName )
    {
        checkTarFileSetAttributesAllowed();
        userNameSet = true;
        this.userName = userName;
    }

    public  java.lang.String getUserName()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.TarFileSet) getCheckedRef()).getUserName();
        }
        return userName;
    }

    public  boolean hasUserNameBeenSet()
    {
        return userNameSet;
    }

    public  void setUid( int uid )
    {
        checkTarFileSetAttributesAllowed();
        userIdSet = true;
        this.uid = uid;
    }

    public  int getUid()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.TarFileSet) getCheckedRef()).getUid();
        }
        return uid;
    }

    public  boolean hasUserIdBeenSet()
    {
        return userIdSet;
    }

    public  void setGroup( java.lang.String groupName )
    {
        checkTarFileSetAttributesAllowed();
        groupNameSet = true;
        this.groupName = groupName;
    }

    public  java.lang.String getGroup()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.TarFileSet) getCheckedRef()).getGroup();
        }
        return groupName;
    }

    public  boolean hasGroupBeenSet()
    {
        return groupNameSet;
    }

    public  void setGid( int gid )
    {
        checkTarFileSetAttributesAllowed();
        groupIdSet = true;
        this.gid = gid;
    }

    public  int getGid()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.TarFileSet) getCheckedRef()).getGid();
        }
        return gid;
    }

    public  boolean hasGroupIdBeenSet()
    {
        return groupIdSet;
    }

    protected  org.apache.tools.ant.types.ArchiveScanner newArchiveScanner()
    {
        org.apache.tools.ant.types.TarScanner zs = new org.apache.tools.ant.types.TarScanner();
        return zs;
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
        throws org.apache.tools.ant.BuildException
    {
        if (userNameSet || userIdSet || groupNameSet || groupIdSet) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    protected  org.apache.tools.ant.types.AbstractFileSet getRef( org.apache.tools.ant.Project p )
    {
        dieOnCircularReference( p );
        java.lang.Object o = getRefid().getReferencedObject( p );
        if (o instanceof org.apache.tools.ant.types.TarFileSet) {
            return (org.apache.tools.ant.types.AbstractFileSet) o;
        } else {
            if (o instanceof org.apache.tools.ant.types.FileSet) {
                org.apache.tools.ant.types.TarFileSet zfs = new org.apache.tools.ant.types.TarFileSet( (org.apache.tools.ant.types.FileSet) o );
                configureFileSet( zfs );
                return zfs;
            } else {
                java.lang.String msg = getRefid().getRefId() + " doesn\'t denote a tarfileset or a fileset";
                throw new org.apache.tools.ant.BuildException( msg );
            }
        }
    }

    protected  void configureFileSet( org.apache.tools.ant.types.ArchiveFileSet zfs )
    {
        super.configureFileSet( zfs );
        if (zfs instanceof org.apache.tools.ant.types.TarFileSet) {
            org.apache.tools.ant.types.TarFileSet tfs = (org.apache.tools.ant.types.TarFileSet) zfs;
            tfs.setUserName( userName );
            tfs.setGroup( groupName );
            tfs.setUid( uid );
            tfs.setGid( gid );
        }
    }

    public  java.lang.Object clone()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.TarFileSet) getRef( getProject() )).clone();
        } else {
            return super.clone();
        }
    }

    private  void checkTarFileSetAttributesAllowed()
    {
        if (getProject() == null || isReference() && getRefid().getReferencedObject( getProject() ) instanceof org.apache.tools.ant.types.TarFileSet) {
            checkAttributesAllowed();
        }
    }

}
