// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.FileUtils;


public class TimeComparison extends org.apache.tools.ant.types.EnumeratedAttribute
{

    private static final java.lang.String[] VALUES = new java.lang.String[]{ "before", "after", "equal" };

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    public static final org.apache.tools.ant.types.TimeComparison BEFORE = new org.apache.tools.ant.types.TimeComparison( "before" );

    public static final org.apache.tools.ant.types.TimeComparison AFTER = new org.apache.tools.ant.types.TimeComparison( "after" );

    public static final org.apache.tools.ant.types.TimeComparison EQUAL = new org.apache.tools.ant.types.TimeComparison( "equal" );

    public TimeComparison()
    {
    }

    public TimeComparison( java.lang.String value )
    {
        setValue( value );
    }

    public  java.lang.String[] getValues()
    {
        return VALUES;
    }

    public  boolean evaluate( long t1, long t2 )
    {
        return evaluate( t1, t2, FILE_UTILS.getFileTimestampGranularity() );
    }

    public  boolean evaluate( long t1, long t2, long g )
    {
        int cmp = getIndex();
        if (cmp == -1) {
            throw new org.apache.tools.ant.BuildException( "TimeComparison value not set." );
        }
        if (cmp == 0) {
            return t1 - g < t2;
        }
        if (cmp == 1) {
            return t1 + g > t2;
        }
        return Math.abs( t1 - t2 ) <= g;
    }

    public static  int compare( long t1, long t2 )
    {
        return compare( t1, t2, FILE_UTILS.getFileTimestampGranularity() );
    }

    public static  int compare( long t1, long t2, long g )
    {
        long diff = t1 - t2;
        long abs = Math.abs( diff );
        return abs > Math.abs( g ) ? (int) (diff / abs) : 0;
    }

}
