// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.optional.image;


import javax.media.jai.PlanarImage;
import javax.media.jai.InterpolationNearest;
import javax.media.jai.JAI;
import java.awt.image.renderable.ParameterBlock;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;


public class Rotate extends org.apache.tools.ant.types.optional.image.TransformOperation implements org.apache.tools.ant.types.optional.image.DrawOperation
{

    private static final float HALF_CIRCLE = 180.0F;

    protected float angle = 0.0F;

    public  void setAngle( java.lang.String ang )
    {
        angle = Float.parseFloat( ang );
    }

    public  javax.media.jai.PlanarImage performRotate( javax.media.jai.PlanarImage image )
    {
        float tAngle = (float) (angle * (Math.PI / HALF_CIRCLE));
        java.awt.image.renderable.ParameterBlock pb = new java.awt.image.renderable.ParameterBlock();
        pb.addSource( image );
        pb.add( 0.0F );
        pb.add( 0.0F );
        pb.add( tAngle );
        pb.add( new javax.media.jai.InterpolationNearest() );
        return JAI.create( "Rotate", pb, null );
    }

    public  javax.media.jai.PlanarImage executeTransformOperation( javax.media.jai.PlanarImage image )
    {
        java.awt.image.BufferedImage bi = null;
        java.awt.Graphics2D graphics = null;
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                System.out.println( "Execing Draws" );
                javax.media.jai.PlanarImage op = ((org.apache.tools.ant.types.optional.image.DrawOperation) instr).executeDrawOperation();
                image = performRotate( op );
                return image;
            } else {
                if (instr instanceof org.apache.tools.ant.types.optional.image.TransformOperation) {
                    bi = image.getAsBufferedImage();
                    graphics = (java.awt.Graphics2D) bi.getGraphics();
                    System.out.println( "Execing Transforms" );
                    image = ((org.apache.tools.ant.types.optional.image.TransformOperation) instr).executeTransformOperation( PlanarImage.wrapRenderedImage( bi ) );
                    bi = image.getAsBufferedImage();
                }
            }
        }
        System.out.println( "Execing as TransformOperation" );
        image = performRotate( image );
        System.out.println( image );
        return image;
    }

    public  javax.media.jai.PlanarImage executeDrawOperation()
    {
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                javax.media.jai.PlanarImage op = ((org.apache.tools.ant.types.optional.image.DrawOperation) instr).executeDrawOperation();
                op = performRotate( op );
                return op;
            }
        }
        return null;
    }

}
