// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import org.apache.tools.ant.types.Path;


public class JavaResource extends org.apache.tools.ant.types.resources.AbstractClasspathResource implements org.apache.tools.ant.types.resources.URLProvider
{

    public JavaResource()
    {
    }

    public JavaResource( java.lang.String name, org.apache.tools.ant.types.Path path )
    {
        setName( name );
        setClasspath( path );
    }

    protected  java.io.InputStream openInputStream( java.lang.ClassLoader cl )
        throws java.io.IOException
    {
        java.io.InputStream inputStream;
        if (cl == null) {
            inputStream = ClassLoader.getSystemResourceAsStream( getName() );
            if (inputStream == null) {
                throw new java.io.FileNotFoundException( "No resource " + getName() + " on Ant's classpath" );
            }
        } else {
            inputStream = cl.getResourceAsStream( getName() );
            if (inputStream == null) {
                throw new java.io.FileNotFoundException( "No resource " + getName() + " on the classpath " + cl );
            }
        }
        return inputStream;
    }

    public  java.net.URL getURL()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.JavaResource) getCheckedRef()).getURL();
        }
        org.apache.tools.ant.types.resources.AbstractClasspathResource.ClassLoaderWithFlag classLoader = getClassLoader();
        if (classLoader.getLoader() == null) {
            return ClassLoader.getSystemResource( getName() );
        } else {
            try {
                return classLoader.getLoader().getResource( getName() );
            } finally 
{
                classLoader.cleanup();
            }
        }
    }

    public  int compareTo( java.lang.Object another )
    {
        if (isReference()) {
            return ((java.lang.Comparable) getCheckedRef()).compareTo( another );
        }
        if (another.getClass().equals( getClass() )) {
            org.apache.tools.ant.types.resources.JavaResource otherjr = (org.apache.tools.ant.types.resources.JavaResource) another;
            if (!getName().equals( otherjr.getName() )) {
                return getName().compareTo( otherjr.getName() );
            }
            if (getLoader() != otherjr.getLoader()) {
                if (getLoader() == null) {
                    return -1;
                }
                if (otherjr.getLoader() == null) {
                    return 1;
                }
                return getLoader().getRefId().compareTo( otherjr.getLoader().getRefId() );
            }
            org.apache.tools.ant.types.Path p = getClasspath();
            org.apache.tools.ant.types.Path op = otherjr.getClasspath();
            if (p != op) {
                if (p == null) {
                    return -1;
                }
                if (op == null) {
                    return 1;
                }
                return p.toString().compareTo( op.toString() );
            }
            return 0;
        }
        return super.compareTo( another );
    }

}
