// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.ByteArrayInputStream;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.PropertyHelper;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.util.PropertyOutputStream;


public class PropertyResource extends org.apache.tools.ant.types.Resource
{

    private static final int PROPERTY_MAGIC = Resource.getMagicNumber( "PropertyResource".getBytes() );

    private static final java.io.InputStream UNSET = new java.io.InputStream(){
        public  int read()
        {
            return -1;
        }
    };

    public PropertyResource()
    {
    }

    public PropertyResource( org.apache.tools.ant.Project p, java.lang.String n )
    {
        super( n );
        setProject( p );
    }

    public  java.lang.String getValue()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.PropertyResource) getCheckedRef()).getValue();
        }
        org.apache.tools.ant.Project p = getProject();
        return p == null ? null : p.getProperty( getName() );
    }

    public  java.lang.Object getObjectValue()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.PropertyResource) getCheckedRef()).getObjectValue();
        }
        org.apache.tools.ant.Project p = getProject();
        return p == null ? null : PropertyHelper.getProperty( p, getName() );
    }

    public  boolean isExists()
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().isExists();
        }
        return getObjectValue() != null;
    }

    public  long getSize()
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().getSize();
        }
        java.lang.Object o = getObjectValue();
        return o == null ? 0L : (long) String.valueOf( o ).length();
    }

    public  boolean equals( java.lang.Object o )
    {
        if (super.equals( o )) {
            return true;
        }
        return isReferenceOrProxy() && getReferencedOrProxied().equals( o );
    }

    public  int hashCode()
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().hashCode();
        }
        return super.hashCode() * PROPERTY_MAGIC;
    }

    public  java.lang.String toString()
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().toString();
        }
        return getValue();
    }

    public  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().getInputStream();
        }
        java.lang.Object o = getObjectValue();
        return o == null ? UNSET : new java.io.ByteArrayInputStream( String.valueOf( o ).getBytes() );
    }

    public  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReferenceOrProxy()) {
            return getReferencedOrProxied().getOutputStream();
        }
        if (isExists()) {
            throw new org.apache.tools.ant.types.resources.ImmutableResourceException();
        }
        return new org.apache.tools.ant.util.PropertyOutputStream( getProject(), getName() );
    }

    protected  boolean isReferenceOrProxy()
    {
        return isReference() || getObjectValue() instanceof org.apache.tools.ant.types.Resource;
    }

    protected  org.apache.tools.ant.types.Resource getReferencedOrProxied()
    {
        if (isReference()) {
            return (org.apache.tools.ant.types.Resource) getCheckedRef( org.apache.tools.ant.types.Resource.class, "resource" );
        }
        java.lang.Object o = getObjectValue();
        if (o instanceof org.apache.tools.ant.types.Resource) {
            return (org.apache.tools.ant.types.Resource) o;
        }
        throw new java.lang.IllegalStateException( "This PropertyResource does not reference or proxy another Resource" );
    }

}
