// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.BuildException;
import java.io.File;
import java.io.IOException;


public class DifferentSelector extends org.apache.tools.ant.types.selectors.MappingSelector
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private boolean ignoreFileTimes = true;

    private boolean ignoreContents = false;

    public  void setIgnoreFileTimes( boolean ignoreFileTimes )
    {
        this.ignoreFileTimes = ignoreFileTimes;
    }

    public  void setIgnoreContents( boolean ignoreContents )
    {
        this.ignoreContents = ignoreContents;
    }

    protected  boolean selectionTest( java.io.File srcfile, java.io.File destfile )
    {
        if (srcfile.exists() != destfile.exists()) {
            return true;
        }
        if (srcfile.length() != destfile.length()) {
            return true;
        }
        if (!ignoreFileTimes) {
            boolean sameDate;
            sameDate = destfile.lastModified() >= srcfile.lastModified() - granularity && destfile.lastModified() <= srcfile.lastModified() + granularity;
            if (!sameDate) {
                return true;
            }
        }
        if (!ignoreContents) {
            try {
                return !FILE_UTILS.contentEquals( srcfile, destfile );
            } catch ( java.io.IOException e ) {
                throw new org.apache.tools.ant.BuildException( "while comparing " + srcfile + " and " + destfile, e );
            }
        } else {
            return false;
        }
    }

}
