// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.EnumeratedAttribute;
import org.apache.tools.ant.types.Mapper;
import org.apache.tools.ant.util.FileNameMapper;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.IdentityMapper;


public class PresentSelector extends org.apache.tools.ant.types.selectors.BaseSelector
{

    private java.io.File targetdir = null;

    private org.apache.tools.ant.types.Mapper mapperElement = null;

    private org.apache.tools.ant.util.FileNameMapper map = null;

    private boolean destmustexist = true;

    public PresentSelector()
    {
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "{presentselector targetdir: " );
        if (targetdir == null) {
            buf.append( "NOT YET SET" );
        } else {
            buf.append( targetdir.getName() );
        }
        buf.append( " present: " );
        if (destmustexist) {
            buf.append( "both" );
        } else {
            buf.append( "srconly" );
        }
        if (map != null) {
            buf.append( map.toString() );
        } else {
            if (mapperElement != null) {
                buf.append( mapperElement.toString() );
            }
        }
        buf.append( "}" );
        return buf.toString();
    }

    public  void setTargetdir( java.io.File targetdir )
    {
        this.targetdir = targetdir;
    }

    public  org.apache.tools.ant.types.Mapper createMapper()
        throws org.apache.tools.ant.BuildException
    {
        if (map != null || mapperElement != null) {
            throw new org.apache.tools.ant.BuildException( "Cannot define more than one mapper" );
        }
        mapperElement = new org.apache.tools.ant.types.Mapper( getProject() );
        return mapperElement;
    }

    public  void addConfigured( org.apache.tools.ant.util.FileNameMapper fileNameMapper )
    {
        if (map != null || mapperElement != null) {
            throw new org.apache.tools.ant.BuildException( "Cannot define more than one mapper" );
        }
        this.map = fileNameMapper;
    }

    public  void setPresent( org.apache.tools.ant.types.selectors.PresentSelector.FilePresence fp )
    {
        if (fp.getIndex() == 0) {
            destmustexist = false;
        }
    }

    public  void verifySettings()
    {
        if (targetdir == null) {
            setError( "The targetdir attribute is required." );
        }
        if (map == null) {
            if (mapperElement == null) {
                map = new org.apache.tools.ant.util.IdentityMapper();
            } else {
                map = mapperElement.getImplementation();
                if (map == null) {
                    setError( "Could not set <mapper> element." );
                }
            }
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        validate();
        java.lang.String[] destfiles = map.mapFileName( filename );
        if (destfiles == null) {
            return false;
        }
        if (destfiles.length != 1 || destfiles[0] == null) {
            throw new org.apache.tools.ant.BuildException( "Invalid destination file results for " + targetdir + " with filename " + filename );
        }
        java.lang.String destname = destfiles[0];
        java.io.File destfile = FileUtils.getFileUtils().resolveFile( targetdir, destname );
        return destfile.exists() == destmustexist;
    }

    public static class FilePresence extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "srconly", "both" };
        }

    }

}
