// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.util.Enumeration;
import java.io.File;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.PropertyHelper;


public class SelectSelector extends org.apache.tools.ant.types.selectors.BaseSelectorContainer
{

    private java.lang.Object ifCondition;

    private java.lang.Object unlessCondition;

    public SelectSelector()
    {
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        if (hasSelectors()) {
            buf.append( "{select" );
            if (ifCondition != null) {
                buf.append( " if: " );
                buf.append( ifCondition );
            }
            if (unlessCondition != null) {
                buf.append( " unless: " );
                buf.append( unlessCondition );
            }
            buf.append( " " );
            buf.append( super.toString() );
            buf.append( "}" );
        }
        return buf.toString();
    }

    private  org.apache.tools.ant.types.selectors.SelectSelector getRef()
    {
        java.lang.Object o = getCheckedRef( this.getClass(), "SelectSelector" );
        return (org.apache.tools.ant.types.selectors.SelectSelector) o;
    }

    public  boolean hasSelectors()
    {
        if (isReference()) {
            return getRef().hasSelectors();
        }
        return super.hasSelectors();
    }

    public  int selectorCount()
    {
        if (isReference()) {
            return getRef().selectorCount();
        }
        return super.selectorCount();
    }

    public  org.apache.tools.ant.types.selectors.FileSelector[] getSelectors( org.apache.tools.ant.Project p )
    {
        if (isReference()) {
            return getRef().getSelectors( p );
        }
        return super.getSelectors( p );
    }

    public  java.util.Enumeration selectorElements()
    {
        if (isReference()) {
            return getRef().selectorElements();
        }
        return super.selectorElements();
    }

    public  void appendSelector( org.apache.tools.ant.types.selectors.FileSelector selector )
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        super.appendSelector( selector );
    }

    public  void verifySettings()
    {
        int cnt = selectorCount();
        if (cnt < 0 || cnt > 1) {
            setError( "Only one selector is allowed within the " + "<selector> tag" );
        }
    }

    public  boolean passesConditions()
    {
        org.apache.tools.ant.PropertyHelper ph = PropertyHelper.getPropertyHelper( getProject() );
        return ph.testIfCondition( ifCondition ) && ph.testUnlessCondition( unlessCondition );
    }

    public  void setIf( java.lang.Object ifProperty )
    {
        this.ifCondition = ifProperty;
    }

    public  void setIf( java.lang.String ifProperty )
    {
        setIf( (java.lang.Object) ifProperty );
    }

    public  void setUnless( java.lang.Object unlessProperty )
    {
        this.unlessCondition = unlessProperty;
    }

    public  void setUnless( java.lang.String unlessProperty )
    {
        setUnless( (java.lang.Object) unlessProperty );
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        validate();
        if (!passesConditions()) {
            return false;
        }
        java.util.Enumeration e = selectorElements();
        if (!e.hasMoreElements()) {
            return true;
        }
        org.apache.tools.ant.types.selectors.FileSelector f = (org.apache.tools.ant.types.selectors.FileSelector) e.nextElement();
        return f.isSelected( basedir, filename, file );
    }

}
