// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors.modifiedselector;


import java.util.Locale;
import java.util.zip.Checksum;
import java.util.zip.CRC32;
import java.util.zip.Adler32;
import java.util.zip.CheckedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.security.NoSuchAlgorithmException;
import org.apache.tools.ant.BuildException;


public class ChecksumAlgorithm implements org.apache.tools.ant.types.selectors.modifiedselector.Algorithm
{

    private java.lang.String algorithm = "CRC";

    private java.util.zip.Checksum checksum = null;

    public  void setAlgorithm( java.lang.String algorithm )
    {
        this.algorithm = algorithm != null ? algorithm.toUpperCase( Locale.ENGLISH ) : null;
    }

    public  void initChecksum()
    {
        if (checksum != null) {
            return;
        }
        if ("CRC".equals( algorithm )) {
            checksum = new java.util.zip.CRC32();
        } else {
            if ("ADLER".equals( algorithm )) {
                checksum = new java.util.zip.Adler32();
            } else {
                throw new org.apache.tools.ant.BuildException( new java.security.NoSuchAlgorithmException() );
            }
        }
    }

    public  boolean isValid()
    {
        return "CRC".equals( algorithm ) || "ADLER".equals( algorithm );
    }

    public  java.lang.String getValue( java.io.File file )
    {
        initChecksum();
        java.lang.String rval = null;
        try {
            if (file.canRead()) {
                checksum.reset();
                java.io.FileInputStream fis = new java.io.FileInputStream( file );
                java.util.zip.CheckedInputStream check = new java.util.zip.CheckedInputStream( fis, checksum );
                java.io.BufferedInputStream in = new java.io.BufferedInputStream( check );
                while (in.read() != -1)  ;
                rval = Long.toString( check.getChecksum().getValue() );
                in.close();
            }
        } catch ( java.lang.Exception e ) {
            rval = null;
        }
        return rval;
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        buf.append( "<ChecksumAlgorithm:" );
        buf.append( "algorithm=" ).append( algorithm );
        buf.append( ">" );
        return buf.toString();
    }

}
