// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.FileInputStream;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.Task;


public class ConcatFileInputStream extends java.io.InputStream
{

    private static final int EOF = -1;

    private int currentIndex = -1;

    private boolean eof = false;

    private java.io.File[] file;

    private java.io.InputStream currentStream;

    private org.apache.tools.ant.ProjectComponent managingPc;

    public ConcatFileInputStream( java.io.File[] file )
        throws java.io.IOException
    {
        this.file = file;
    }

    public  void close()
        throws java.io.IOException
    {
        closeCurrent();
        eof = true;
    }

    public  int read()
        throws java.io.IOException
    {
        int result = readCurrent();
        if (result == EOF && !eof) {
            openFile( ++currentIndex );
            result = readCurrent();
        }
        return result;
    }

    public  void setManagingTask( org.apache.tools.ant.Task task )
    {
        setManagingComponent( task );
    }

    public  void setManagingComponent( org.apache.tools.ant.ProjectComponent pc )
    {
        this.managingPc = pc;
    }

    public  void log( java.lang.String message, int loglevel )
    {
        if (managingPc != null) {
            managingPc.log( message, loglevel );
        } else {
            if (loglevel > Project.MSG_WARN) {
                System.out.println( message );
            } else {
                System.err.println( message );
            }
        }
    }

    private  int readCurrent()
        throws java.io.IOException
    {
        return eof || currentStream == null ? EOF : currentStream.read();
    }

    private  void openFile( int index )
        throws java.io.IOException
    {
        closeCurrent();
        if (file != null && index < file.length) {
            log( "Opening " + file[index], Project.MSG_VERBOSE );
            try {
                currentStream = new java.io.BufferedInputStream( new java.io.FileInputStream( file[index] ) );
            } catch ( java.io.IOException eyeOhEx ) {
                log( "Failed to open " + file[index], Project.MSG_ERR );
                throw eyeOhEx;
            }
        } else {
            eof = true;
        }
    }

    private  void closeCurrent()
    {
        FileUtils.close( currentStream );
        currentStream = null;
    }

}
