// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.apache.tools.ant.BuildException;
import org.xml.sax.Parser;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;


public class JAXPUtils
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private static javax.xml.parsers.SAXParserFactory parserFactory = null;

    private static javax.xml.parsers.SAXParserFactory nsParserFactory = null;

    private static javax.xml.parsers.DocumentBuilderFactory builderFactory = null;

    public static synchronized  javax.xml.parsers.SAXParserFactory getParserFactory()
        throws org.apache.tools.ant.BuildException
    {
        if (parserFactory == null) {
            parserFactory = newParserFactory();
        }
        return parserFactory;
    }

    public static synchronized  javax.xml.parsers.SAXParserFactory getNSParserFactory()
        throws org.apache.tools.ant.BuildException
    {
        if (nsParserFactory == null) {
            nsParserFactory = newParserFactory();
            nsParserFactory.setNamespaceAware( true );
        }
        return nsParserFactory;
    }

    public static  javax.xml.parsers.SAXParserFactory newParserFactory()
        throws org.apache.tools.ant.BuildException
    {
        try {
            return SAXParserFactory.newInstance();
        } catch ( javax.xml.parsers.FactoryConfigurationError e ) {
            throw new org.apache.tools.ant.BuildException( "XML parser factory has not been " + "configured correctly: " + e.getMessage(), e );
        }
    }

    public static  org.xml.sax.Parser getParser()
        throws org.apache.tools.ant.BuildException
    {
        try {
            return newSAXParser( getParserFactory() ).getParser();
        } catch ( org.xml.sax.SAXException e ) {
            throw convertToBuildException( e );
        }
    }

    public static  org.xml.sax.XMLReader getXMLReader()
        throws org.apache.tools.ant.BuildException
    {
        try {
            return newSAXParser( getParserFactory() ).getXMLReader();
        } catch ( org.xml.sax.SAXException e ) {
            throw convertToBuildException( e );
        }
    }

    public static  org.xml.sax.XMLReader getNamespaceXMLReader()
        throws org.apache.tools.ant.BuildException
    {
        try {
            return newSAXParser( getNSParserFactory() ).getXMLReader();
        } catch ( org.xml.sax.SAXException e ) {
            throw convertToBuildException( e );
        }
    }

    public static  java.lang.String getSystemId( java.io.File file )
    {
        return FILE_UTILS.toURI( file.getAbsolutePath() );
    }

    public static  javax.xml.parsers.DocumentBuilder getDocumentBuilder()
        throws org.apache.tools.ant.BuildException
    {
        try {
            return getDocumentBuilderFactory().newDocumentBuilder();
        } catch ( javax.xml.parsers.ParserConfigurationException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    private static  javax.xml.parsers.SAXParser newSAXParser( javax.xml.parsers.SAXParserFactory factory )
        throws org.apache.tools.ant.BuildException
    {
        try {
            return factory.newSAXParser();
        } catch ( javax.xml.parsers.ParserConfigurationException e ) {
            throw new org.apache.tools.ant.BuildException( "Cannot create parser for the given " + "configuration: " + e.getMessage(), e );
        } catch ( org.xml.sax.SAXException e ) {
            throw convertToBuildException( e );
        }
    }

    private static  org.apache.tools.ant.BuildException convertToBuildException( org.xml.sax.SAXException e )
    {
        java.lang.Exception nested = e.getException();
        if (nested != null) {
            return new org.apache.tools.ant.BuildException( nested );
        } else {
            return new org.apache.tools.ant.BuildException( e );
        }
    }

    private static synchronized  javax.xml.parsers.DocumentBuilderFactory getDocumentBuilderFactory()
        throws org.apache.tools.ant.BuildException
    {
        if (builderFactory == null) {
            try {
                builderFactory = DocumentBuilderFactory.newInstance();
            } catch ( javax.xml.parsers.FactoryConfigurationError e ) {
                throw new org.apache.tools.ant.BuildException( "Document builder factory has not " + "been configured correctly: " + e.getMessage(), e );
            }
        }
        return builderFactory;
    }

}
