// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.Project;


public class ProxySetup
{

    private org.apache.tools.ant.Project owner;

    public static final java.lang.String USE_SYSTEM_PROXIES = "java.net.useSystemProxies";

    public static final java.lang.String HTTP_PROXY_HOST = "http.proxyHost";

    public static final java.lang.String HTTP_PROXY_PORT = "http.proxyPort";

    public static final java.lang.String HTTPS_PROXY_HOST = "https.proxyHost";

    public static final java.lang.String HTTPS_PROXY_PORT = "https.proxyPort";

    public static final java.lang.String FTP_PROXY_HOST = "ftp.proxyHost";

    public static final java.lang.String FTP_PROXY_PORT = "ftp.proxyPort";

    public static final java.lang.String HTTP_NON_PROXY_HOSTS = "http.nonProxyHosts";

    public static final java.lang.String HTTPS_NON_PROXY_HOSTS = "https.nonProxyHosts";

    public static final java.lang.String FTP_NON_PROXY_HOSTS = "ftp.nonProxyHosts";

    public static final java.lang.String HTTP_PROXY_USERNAME = "http.proxyUser";

    public static final java.lang.String HTTP_PROXY_PASSWORD = "http.proxyPassword";

    public static final java.lang.String SOCKS_PROXY_HOST = "socksProxyHost";

    public static final java.lang.String SOCKS_PROXY_PORT = "socksProxyPort";

    public static final java.lang.String SOCKS_PROXY_USERNAME = "java.net.socks.username";

    public static final java.lang.String SOCKS_PROXY_PASSWORD = "java.net.socks.password";

    public ProxySetup( org.apache.tools.ant.Project owner )
    {
        this.owner = owner;
    }

    public static  java.lang.String getSystemProxySetting()
    {
        try {
            return System.getProperty( USE_SYSTEM_PROXIES );
        } catch ( java.lang.SecurityException e ) {
            return null;
        }
    }

    public  void enableProxies()
    {
        if (!(getSystemProxySetting() != null)) {
            java.lang.String proxies = owner.getProperty( USE_SYSTEM_PROXIES );
            if (proxies == null || Project.toBoolean( proxies )) {
                proxies = "true";
            }
            java.lang.String message = "setting " + USE_SYSTEM_PROXIES + " to " + proxies;
            try {
                owner.log( message, Project.MSG_DEBUG );
                System.setProperty( USE_SYSTEM_PROXIES, proxies );
            } catch ( java.lang.SecurityException e ) {
                owner.log( "Security Exception when " + message );
            }
        }
    }

}
