// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.regexp.RegexpMatcher;
import org.apache.tools.ant.util.regexp.RegexpMatcherFactory;
import org.apache.tools.ant.util.regexp.RegexpUtil;


public class RegexpPatternMapper implements org.apache.tools.ant.util.FileNameMapper
{

    private static final int DECIMAL = 10;

    protected org.apache.tools.ant.util.regexp.RegexpMatcher reg = null;

    protected char[] to = null;

    protected java.lang.StringBuffer result = new java.lang.StringBuffer();

    public RegexpPatternMapper()
        throws org.apache.tools.ant.BuildException
    {
        reg = (new org.apache.tools.ant.util.regexp.RegexpMatcherFactory()).newRegexpMatcher();
    }

    private boolean handleDirSep = false;

    private int regexpOptions = 0;

    public  void setHandleDirSep( boolean handleDirSep )
    {
        this.handleDirSep = handleDirSep;
    }

    public  void setCaseSensitive( boolean caseSensitive )
    {
        regexpOptions = RegexpUtil.asOptions( caseSensitive );
    }

    public  void setFrom( java.lang.String from )
        throws org.apache.tools.ant.BuildException
    {
        if (from != null) {
            try {
                reg.setPattern( from );
            } catch ( java.lang.NoClassDefFoundError e ) {
                throw new org.apache.tools.ant.BuildException( "Cannot load regular expression matcher", e );
            }
        } else {
            throw new org.apache.tools.ant.BuildException( "this mapper requires a 'from' attribute" );
        }
    }

    public  void setTo( java.lang.String to )
    {
        if (to != null) {
            this.to = to.toCharArray();
        } else {
            throw new org.apache.tools.ant.BuildException( "this mapper requires a 'to' attribute" );
        }
    }

    public  java.lang.String[] mapFileName( java.lang.String sourceFileName )
    {
        if (handleDirSep) {
            if (sourceFileName.indexOf( "\\" ) != -1) {
                sourceFileName = sourceFileName.replace( '\\', '/' );
            }
        }
        if (reg == null || to == null || !reg.matches( sourceFileName, regexpOptions )) {
            return null;
        }
        return new java.lang.String[]{ replaceReferences( sourceFileName ) };
    }

    protected  java.lang.String replaceReferences( java.lang.String source )
    {
        java.util.Vector v = reg.getGroups( source, regexpOptions );
        result.setLength( 0 );
        for (int i = 0; i < to.length; i++) {
            if (to[i] == '\\') {
                if (++i < to.length) {
                    int value = Character.digit( to[i], DECIMAL );
                    if (value > -1) {
                        result.append( (java.lang.String) v.elementAt( value ) );
                    } else {
                        result.append( to[i] );
                    }
                } else {
                    result.append( '\\' );
                }
            } else {
                result.append( to[i] );
            }
        }
        return result.substring( 0 );
    }

}
