// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import java.io.File;
import java.util.Map;
import java.util.HashMap;


public class ScriptFixBSFPath
{

    private static final java.lang.String UTIL_OPTIONAL_PACKAGE = "org.apache.tools.ant.util.optional";

    private static final java.lang.String BSF_PACKAGE = "org.apache.bsf";

    private static final java.lang.String BSF_MANAGER = BSF_PACKAGE + ".BSFManager";

    private static final java.lang.String BSF_SCRIPT_RUNNER = UTIL_OPTIONAL_PACKAGE + ".ScriptRunner";

    private static final java.lang.String[] BSF_LANGUAGES = new java.lang.String[]{ "js", "org.mozilla.javascript.Scriptable", "javascript", "org.mozilla.javascript.Scriptable", "jacl", "tcl.lang.Interp", "netrexx", "netrexx.lang.Rexx", "nrx", "netrexx.lang.Rexx", "jython", "org.python.core.Py", "py", "org.python.core.Py", "xslt", "org.apache.xpath.objects.XObject" };

    private static final java.util.Map BSF_LANGUAGE_MAP = new java.util.HashMap();

    static {
        for (int i = 0; i < BSF_LANGUAGES.length; i = i + 2) {
            BSF_LANGUAGE_MAP.put( BSF_LANGUAGES[i], BSF_LANGUAGES[i + 1] );
        }
    }

    private  java.io.File getClassSource( java.lang.ClassLoader loader, java.lang.String className )
    {
        return LoaderUtils.getResourceSource( loader, LoaderUtils.classNameToResource( className ) );
    }

    private  java.io.File getClassSource( java.lang.String className )
    {
        return getClassSource( getClass().getClassLoader(), className );
    }

    public  void fixClassLoader( java.lang.ClassLoader loader, java.lang.String language )
    {
        if (loader == getClass().getClassLoader() || !(loader instanceof org.apache.tools.ant.AntClassLoader)) {
            return;
        }
        java.lang.ClassLoader myLoader = getClass().getClassLoader();
        org.apache.tools.ant.AntClassLoader fixLoader = (org.apache.tools.ant.AntClassLoader) loader;
        java.io.File bsfSource = getClassSource( BSF_MANAGER );
        boolean needMoveRunner = bsfSource == null;
        java.lang.String languageClassName = (java.lang.String) BSF_LANGUAGE_MAP.get( language );
        boolean needMoveBsf = bsfSource != null && languageClassName != null && !LoaderUtils.classExists( myLoader, languageClassName ) && LoaderUtils.classExists( loader, languageClassName );
        needMoveRunner = needMoveRunner || needMoveBsf;
        if (bsfSource == null) {
            bsfSource = getClassSource( loader, BSF_MANAGER );
        }
        if (bsfSource == null) {
            throw new org.apache.tools.ant.BuildException( "Unable to find BSF classes for scripting" );
        }
        if (needMoveBsf) {
            fixLoader.addPathComponent( bsfSource );
            fixLoader.addLoaderPackageRoot( BSF_PACKAGE );
        }
        if (needMoveRunner) {
            fixLoader.addPathComponent( LoaderUtils.getResourceSource( fixLoader, LoaderUtils.classNameToResource( BSF_SCRIPT_RUNNER ) ) );
            fixLoader.addLoaderPackageRoot( UTIL_OPTIONAL_PACKAGE );
        }
    }

}
