// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;


public class ScriptRunnerCreator
{

    private static final java.lang.String AUTO = "auto";

    private static final java.lang.String OATAU = "org.apache.tools.ant.util";

    private static final java.lang.String UTIL_OPT = OATAU + ".optional";

    private static final java.lang.String BSF = "bsf";

    private static final java.lang.String BSF_PACK = "org.apache.bsf";

    private static final java.lang.String BSF_MANAGER = BSF_PACK + ".BSFManager";

    private static final java.lang.String BSF_RUNNER = UTIL_OPT + ".ScriptRunner";

    private static final java.lang.String JAVAX = "javax";

    private static final java.lang.String JAVAX_MANAGER = "javax.script.ScriptEngineManager";

    private static final java.lang.String JAVAX_RUNNER = UTIL_OPT + ".JavaxScriptRunner";

    private org.apache.tools.ant.Project project;

    private java.lang.String manager;

    private java.lang.String language;

    private java.lang.ClassLoader scriptLoader = null;

    public ScriptRunnerCreator( org.apache.tools.ant.Project project )
    {
        this.project = project;
    }

    public synchronized  org.apache.tools.ant.util.ScriptRunnerBase createRunner( java.lang.String manager, java.lang.String language, java.lang.ClassLoader classLoader )
    {
        this.manager = manager;
        this.language = language;
        this.scriptLoader = classLoader;
        if (language == null) {
            throw new org.apache.tools.ant.BuildException( "script language must be specified" );
        }
        if (!manager.equals( AUTO ) && !manager.equals( JAVAX ) && !manager.equals( BSF )) {
            throw new org.apache.tools.ant.BuildException( "Unsupported language prefix " + manager );
        }
        org.apache.tools.ant.util.ScriptRunnerBase ret = null;
        ret = createRunner( BSF, BSF_MANAGER, BSF_RUNNER );
        if (ret == null) {
            ret = createRunner( JAVAX, JAVAX_MANAGER, JAVAX_RUNNER );
        }
        if (ret != null) {
            return ret;
        }
        if (JAVAX.equals( manager )) {
            throw new org.apache.tools.ant.BuildException( "Unable to load the script engine manager " + "(" + JAVAX_MANAGER + ")" );
        }
        if (BSF.equals( manager )) {
            throw new org.apache.tools.ant.BuildException( "Unable to load the BSF script engine manager " + "(" + BSF_MANAGER + ")" );
        }
        throw new org.apache.tools.ant.BuildException( "Unable to load a script engine manager " + "(" + BSF_MANAGER + " or " + JAVAX_MANAGER + ")" );
    }

    private  org.apache.tools.ant.util.ScriptRunnerBase createRunner( java.lang.String checkManager, java.lang.String managerClass, java.lang.String runnerClass )
    {
        org.apache.tools.ant.util.ScriptRunnerBase runner = null;
        if (!manager.equals( AUTO ) && !manager.equals( checkManager )) {
            return null;
        }
        if (scriptLoader.getResource( LoaderUtils.classNameToResource( managerClass ) ) == null) {
            return null;
        }
        if (managerClass.equals( BSF_MANAGER )) {
            (new org.apache.tools.ant.util.ScriptFixBSFPath()).fixClassLoader( scriptLoader, language );
        }
        try {
            runner = (org.apache.tools.ant.util.ScriptRunnerBase) Class.forName( runnerClass, true, scriptLoader ).newInstance();
            runner.setProject( project );
        } catch ( java.lang.Exception ex ) {
            throw ReflectUtil.toBuildException( ex );
        }
        runner.setLanguage( language );
        runner.setScriptClassLoader( scriptLoader );
        return runner;
    }

}
