// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Path;


public final class SplitClassLoader extends org.apache.tools.ant.AntClassLoader
{

    private final java.lang.String[] splitClasses;

    public SplitClassLoader( java.lang.ClassLoader parent, org.apache.tools.ant.types.Path path, org.apache.tools.ant.Project project, java.lang.String[] splitClasses )
    {
        super( parent, project, path, true );
        this.splitClasses = splitClasses;
    }

    protected synchronized  java.lang.Class loadClass( java.lang.String classname, boolean resolve )
        throws java.lang.ClassNotFoundException
    {
        java.lang.Class theClass = findLoadedClass( classname );
        if (theClass != null) {
            return theClass;
        }
        if (isSplit( classname )) {
            theClass = findClass( classname );
            if (resolve) {
                resolveClass( theClass );
            }
            return theClass;
        } else {
            return super.loadClass( classname, resolve );
        }
    }

    private  boolean isSplit( java.lang.String classname )
    {
        java.lang.String simplename = classname.substring( classname.lastIndexOf( '.' ) + 1 );
        for (int i = 0; i < splitClasses.length; i++) {
            if (simplename.equals( splitClasses[i] ) || simplename.startsWith( splitClasses[i] + '$' )) {
                return true;
            }
        }
        return false;
    }

}
