// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.IOException;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Execute;


public class SymbolicLinkUtils
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private static final org.apache.tools.ant.util.SymbolicLinkUtils PRIMARY_INSTANCE = new org.apache.tools.ant.util.SymbolicLinkUtils();

    public static  org.apache.tools.ant.util.SymbolicLinkUtils getSymbolicLinkUtils()
    {
        return PRIMARY_INSTANCE;
    }

    protected SymbolicLinkUtils()
    {
    }

    public  boolean isSymbolicLink( java.io.File file )
        throws java.io.IOException
    {
        return isSymbolicLink( file.getParentFile(), file.getName() );
    }

    public  boolean isSymbolicLink( java.lang.String name )
        throws java.io.IOException
    {
        return isSymbolicLink( new java.io.File( name ) );
    }

    public  boolean isSymbolicLink( java.io.File parent, java.lang.String name )
        throws java.io.IOException
    {
        java.io.File toTest = parent != null ? new java.io.File( parent.getCanonicalPath(), name ) : new java.io.File( name );
        return !toTest.getAbsolutePath().equals( toTest.getCanonicalPath() );
    }

    public  boolean isDanglingSymbolicLink( java.lang.String name )
        throws java.io.IOException
    {
        return isDanglingSymbolicLink( new java.io.File( name ) );
    }

    public  boolean isDanglingSymbolicLink( java.io.File file )
        throws java.io.IOException
    {
        return isDanglingSymbolicLink( file.getParentFile(), file.getName() );
    }

    public  boolean isDanglingSymbolicLink( java.io.File parent, java.lang.String name )
        throws java.io.IOException
    {
        java.io.File f = new java.io.File( parent, name );
        if (!f.exists()) {
            final java.lang.String localName = f.getName();
            java.lang.String[] c = parent.list( new java.io.FilenameFilter(){
                public  boolean accept( java.io.File d, java.lang.String n )
                {
                    return localName.equals( n );
                }
            } );
            return c != null && c.length > 0;
        }
        return false;
    }

    public  void deleteSymbolicLink( java.io.File link, org.apache.tools.ant.Task task )
        throws java.io.IOException
    {
        if (isDanglingSymbolicLink( link )) {
            if (!link.delete()) {
                throw new java.io.IOException( "failed to remove dangling symbolic link " + link );
            }
            return;
        }
        if (!isSymbolicLink( link )) {
            return;
        }
        if (!link.exists()) {
            throw new java.io.FileNotFoundException( "No such symbolic link: " + link );
        }
        java.io.File target = link.getCanonicalFile();
        if (task == null || target.getParentFile().canWrite()) {
            java.io.File temp = FILE_UTILS.createTempFile( "symlink", ".tmp", target.getParentFile(), false, false );
            if (FILE_UTILS.isLeadingPath( target, link )) {
                link = new java.io.File( temp, FILE_UTILS.removeLeadingPath( target, link ) );
            }
            boolean renamedTarget = false;
            try {
                try {
                    FILE_UTILS.rename( target, temp );
                    renamedTarget = true;
                } catch ( java.io.IOException e ) {
                    throw new java.io.IOException( "Couldn't rename resource when " + "attempting to delete '" + link + "'.  Reason: " + e.getMessage() );
                }
                if (!link.delete()) {
                    throw new java.io.IOException( "Couldn't delete symlink: " + link + " (was it a real file? is this " + "not a UNIX system?)" );
                }
            } finally 
{
                if (renamedTarget) {
                    try {
                        FILE_UTILS.rename( temp, target );
                    } catch ( java.io.IOException e ) {
                        throw new java.io.IOException( "Couldn't return resource " + temp + " to its original name: " + target.getAbsolutePath() + ". Reason: " + e.getMessage() + "\n THE RESOURCE'S NAME ON DISK" + " HAS BEEN CHANGED BY THIS" + " ERROR!\n" );
                    }
                }
            }
        } else {
            Execute.runCommand( task, new java.lang.String[]{ "rm", link.getAbsolutePath() } );
        }
    }

}
