// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.Task;
import org.apache.tools.ant.BuildException;


public class WorkerAnt extends java.lang.Thread
{

    private org.apache.tools.ant.Task task;

    private java.lang.Object notify;

    private volatile boolean finished = false;

    private volatile org.apache.tools.ant.BuildException buildException;

    private volatile java.lang.Throwable exception;

    public static final java.lang.String ERROR_NO_TASK = "No task defined";

    public WorkerAnt( org.apache.tools.ant.Task task, java.lang.Object notify )
    {
        this.task = task;
        this.notify = notify != null ? notify : this;
    }

    public WorkerAnt( org.apache.tools.ant.Task task )
    {
        this( task, null );
    }

    public synchronized  org.apache.tools.ant.BuildException getBuildException()
    {
        return buildException;
    }

    public synchronized  java.lang.Throwable getException()
    {
        return exception;
    }

    public  org.apache.tools.ant.Task getTask()
    {
        return task;
    }

    public synchronized  boolean isFinished()
    {
        return finished;
    }

    public  void waitUntilFinished( long timeout )
        throws java.lang.InterruptedException
    {
        synchronized (notify)
{
            if (!finished) {
                notify.wait( timeout );
            }
        }
    }

    public  void rethrowAnyBuildException()
    {
        org.apache.tools.ant.BuildException ex = getBuildException();
        if (ex != null) {
            throw ex;
        }
    }

    private synchronized  void caught( java.lang.Throwable thrown )
    {
        exception = thrown;
        buildException = thrown instanceof org.apache.tools.ant.BuildException ? (org.apache.tools.ant.BuildException) thrown : new org.apache.tools.ant.BuildException( thrown );
    }

    public  void run()
    {
        try {
            if (task != null) {
                task.execute();
            }
        } catch ( java.lang.Throwable thrown ) {
            caught( thrown );
        } finally 
{
            synchronized (notify)
{
                finished = true;
                notify.notifyAll();
            }
        }
    }

}
