// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util.regexp;


import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;
import org.apache.tools.ant.BuildException;


public class Jdk14RegexpMatcher implements org.apache.tools.ant.util.regexp.RegexpMatcher
{

    private java.lang.String pattern;

    public Jdk14RegexpMatcher()
    {
    }

    public  void setPattern( java.lang.String pattern )
    {
        this.pattern = pattern;
    }

    public  java.lang.String getPattern()
    {
        return pattern;
    }

    protected  java.util.regex.Pattern getCompiledPattern( int options )
        throws org.apache.tools.ant.BuildException
    {
        int cOptions = getCompilerOptions( options );
        try {
            java.util.regex.Pattern p = Pattern.compile( this.pattern, cOptions );
            return p;
        } catch ( java.util.regex.PatternSyntaxException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public  boolean matches( java.lang.String argument )
        throws org.apache.tools.ant.BuildException
    {
        return matches( argument, MATCH_DEFAULT );
    }

    public  boolean matches( java.lang.String input, int options )
        throws org.apache.tools.ant.BuildException
    {
        try {
            java.util.regex.Pattern p = getCompiledPattern( options );
            return p.matcher( input ).find();
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public  java.util.Vector getGroups( java.lang.String argument )
        throws org.apache.tools.ant.BuildException
    {
        return getGroups( argument, MATCH_DEFAULT );
    }

    public  java.util.Vector getGroups( java.lang.String input, int options )
        throws org.apache.tools.ant.BuildException
    {
        java.util.regex.Pattern p = getCompiledPattern( options );
        java.util.regex.Matcher matcher = p.matcher( input );
        if (!matcher.find()) {
            return null;
        }
        java.util.Vector v = new java.util.Vector();
        int cnt = matcher.groupCount();
        for (int i = 0; i <= cnt; i++) {
            java.lang.String match = matcher.group( i );
            if (match == null) {
                match = "";
            }
            v.addElement( match );
        }
        return v;
    }

    protected  int getCompilerOptions( int options )
    {
        int cOptions = Pattern.UNIX_LINES;
        if (RegexpUtil.hasFlag( options, MATCH_CASE_INSENSITIVE )) {
            cOptions |= Pattern.CASE_INSENSITIVE;
        }
        if (RegexpUtil.hasFlag( options, MATCH_MULTILINE )) {
            cOptions |= Pattern.MULTILINE;
        }
        if (RegexpUtil.hasFlag( options, MATCH_SINGLELINE )) {
            cOptions |= Pattern.DOTALL;
        }
        return cOptions;
    }

}
