// This is a mutant program.
// Author : ysma

package org.apache.tools.zip;


import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.nio.charset.CharsetEncoder;
import java.nio.charset.CoderResult;
import java.nio.charset.CodingErrorAction;


class NioZipEncoding implements org.apache.tools.zip.ZipEncoding
{

    private final java.nio.charset.Charset charset;

    public NioZipEncoding( java.nio.charset.Charset charset )
    {
        this.charset = charset;
    }

    public  boolean canEncode( java.lang.String name )
    {
        java.nio.charset.CharsetEncoder enc = this.charset.newEncoder();
        enc.onMalformedInput( CodingErrorAction.REPORT );
        enc.onUnmappableCharacter( CodingErrorAction.REPORT );
        return enc.canEncode( name );
    }

    public  java.nio.ByteBuffer encode( java.lang.String name )
    {
        java.nio.charset.CharsetEncoder enc = this.charset.newEncoder();
        enc.onMalformedInput( CodingErrorAction.REPORT );
        enc.onUnmappableCharacter( CodingErrorAction.REPORT );
        java.nio.CharBuffer cb = CharBuffer.wrap( name );
        java.nio.ByteBuffer out = ByteBuffer.allocate( name.length() + (name.length() + 1) / 2 );
        while (cb.remaining() > 0) {
            java.nio.charset.CoderResult res = enc.encode( cb, out, true );
            if (res.isUnmappable() || res.isMalformed()) {
                if (res.length() * 6 > out.remaining()) {
                    out = ZipEncodingHelper.growBuffer( out, out.position() + res.length() * 6 );
                }
                for (int i = 0; i < res.length(); ++i) {
                    ZipEncodingHelper.appendSurrogate( out, cb.get() );
                }
            } else {
                if (res.isOverflow()) {
                    out = ZipEncodingHelper.growBuffer( out, 0 );
                } else {
                    if (res.isUnderflow()) {
                        enc.flush( out );
                        break;
                    }
                }
            }
        }
        out.limit( out.position() );
        out.rewind();
        return out;
    }

    public  java.lang.String decode( byte[] data )
        throws java.io.IOException
    {
        return this.charset.newDecoder().onMalformedInput( CodingErrorAction.REPORT ).onUnmappableCharacter( CodingErrorAction.REPORT ).decode( ByteBuffer.wrap( data ) ).toString();
    }

}
