// This is a mutant program.
// Author : ysma

package org.apache.tools.zip;


import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


class Simple8BitZipEncoding implements org.apache.tools.zip.ZipEncoding
{

    private static final class Simple8BitChar implements java.lang.Comparable
    {

        public final char unicode;

        public final byte code;

        Simple8BitChar( byte code, char unicode )
        {
            this.code = code;
            this.unicode = unicode;
        }

        public  int compareTo( java.lang.Object o )
        {
            org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar a = (org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar) o;
            return this.unicode - a.unicode;
        }

        public  java.lang.String toString()
        {
            return "0x" + Integer.toHexString( 0xffff & (int) unicode ) + "->0x" + Integer.toHexString( 0xff & (int) code );
        }

    }

    private final char[] highChars;

    private final java.util.List reverseMapping;

    public Simple8BitZipEncoding( char[] highChars )
    {
        this.highChars = highChars;
        this.reverseMapping = new java.util.ArrayList( this.highChars.length );
        byte code = 127;
        for (int i = 0; i < this.highChars.length; ++i) {
            this.reverseMapping.add( new org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar( ++code, this.highChars[i] ) );
        }
        Collections.sort( this.reverseMapping );
    }

    public  char decodeByte( byte b )
    {
        if (b >= 0) {
            return (char) b;
        }
        return this.highChars[128 + (int) b];
    }

    public  boolean canEncodeChar( char c )
    {
        if (c >= 0 && c < 128) {
            return true;
        }
        org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar r = this.encodeHighChar( c );
        return r != null;
    }

    public  boolean pushEncodedChar( java.nio.ByteBuffer bb, char c )
    {
        if (c >= 0 && c < 128) {
            bb.put( (byte) c );
            return true;
        }
        org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar r = this.encodeHighChar( c );
        if (r == null) {
            return false;
        }
        bb.put( r.code );
        return true;
    }

    private  org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar encodeHighChar( char c )
    {
        int i0 = 0;
        int i1 = this.reverseMapping.size();
        while (i1 > i0) {
            int i = i0 + (i1 - i0) / 2;
            org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar m = (org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar) this.reverseMapping.get( i );
            if (m.unicode == c) {
                return m;
            }
            if (m.unicode < c) {
                i0 = i + 1;
            } else {
                i1 = i;
            }
        }
        if (i0 >= this.reverseMapping.size()) {
            return null;
        }
        org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar r = (org.apache.tools.zip.Simple8BitZipEncoding.Simple8BitChar) this.reverseMapping.get( i0 );
        if (r.unicode != c) {
            return null;
        }
        return r;
    }

    public  boolean canEncode( java.lang.String name )
    {
        for (int i = 0; i < name.length(); ++i) {
            char c = name.charAt( i );
            if (!this.canEncodeChar( c )) {
                return false;
            }
        }
        return true;
    }

    public  java.nio.ByteBuffer encode( java.lang.String name )
    {
        java.nio.ByteBuffer out = ByteBuffer.allocate( name.length() + 6 + (name.length() + 1) / 2 );
        for (int i = 0; i < name.length(); ++i) {
            char c = name.charAt( i );
            if (out.remaining() < 6) {
                out = ZipEncodingHelper.growBuffer( out, out.position() + 6 );
            }
            if (!this.pushEncodedChar( out, c )) {
                ZipEncodingHelper.appendSurrogate( out, c );
            }
        }
        out.limit( out.position() );
        out.rewind();
        return out;
    }

    public  java.lang.String decode( byte[] data )
        throws java.io.IOException
    {
        char[] ret = new char[data.length];
        for (int i = 0; i < data.length; ++i) {
            ret[i] = this.decodeByte( data[i] );
        }
        return new java.lang.String( ret );
    }

}
