// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class ConstantValue extends org.apache.bcel.classfile.Attribute
{

    private int constantvalue_index;

    public ConstantValue( org.apache.bcel.classfile.ConstantValue c )
    {
        this( c.getNameIndex(), c.getLength(), c.getConstantValueIndex(), c.getConstantPool() );
    }

    ConstantValue( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, file.readUnsignedShort(), constant_pool );
    }

    public ConstantValue( int name_index, int length, int constantvalue_index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_CONSTANT_VALUE, name_index, length, constant_pool );
        this.constantvalue_index = constantvalue_index;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitConstantValue( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( constantvalue_index );
    }

    public final  int getConstantValueIndex()
    {
        return constantvalue_index;
    }

    public final  void setConstantValueIndex( int constantvalue_index )
    {
        this.constantvalue_index = constantvalue_index;
    }

    public final  java.lang.String toString()
    {
        org.apache.bcel.classfile.Constant c = constant_pool.getConstant( constantvalue_index );
        java.lang.String buf;
        int i;
        switch (c.getTag()) {
        case Constants.CONSTANT_Long :
            buf = "" + ((org.apache.bcel.classfile.ConstantLong) c).getBytes();
            break;

        case Constants.CONSTANT_Float :
            buf = "" + ((org.apache.bcel.classfile.ConstantFloat) c).getBytes();
            break;

        case Constants.CONSTANT_Double :
            buf = "" + ((org.apache.bcel.classfile.ConstantDouble) c).getBytes();
            break;

        case Constants.CONSTANT_Integer :
            buf = "" + ((org.apache.bcel.classfile.ConstantInteger) c).getBytes();
            break;

        case Constants.CONSTANT_String :
            i = ((org.apache.bcel.classfile.ConstantString) c).getStringIndex();
            c = constant_pool.getConstant( i, Constants.CONSTANT_Utf8 );
            buf = "\"" + Utility.convertString( ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes() ) + "\"";
            break;

        default  :
            throw new java.lang.IllegalStateException( "Type of ConstValue invalid: " + c );

        }
        return buf;
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.ConstantValue c = (org.apache.bcel.classfile.ConstantValue) clone();
        c.constant_pool = _constant_pool;
        return c;
    }

}
