// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class ExceptionTable extends org.apache.bcel.classfile.Attribute
{

    private int number_of_exceptions;

    private int[] exception_index_table;

    public ExceptionTable( org.apache.bcel.classfile.ExceptionTable c )
    {
        this( c.getNameIndex(), c.getLength(), c.getExceptionIndexTable(), c.getConstantPool() );
    }

    public ExceptionTable( int name_index, int length, int[] exception_index_table, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_EXCEPTIONS, name_index, length, constant_pool );
        setExceptionIndexTable( exception_index_table );
    }

    ExceptionTable( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (int[]) null, constant_pool );
        number_of_exceptions = file.readUnsignedShort();
        exception_index_table = new int[number_of_exceptions];
        for (int i = 0; i < number_of_exceptions; i++) {
            exception_index_table[i] = file.readUnsignedShort();
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitExceptionTable( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( number_of_exceptions );
        for (int i = 0; i < number_of_exceptions; i++) {
            file.writeShort( exception_index_table[i] );
        }
    }

    public final  int[] getExceptionIndexTable()
    {
        return exception_index_table;
    }

    public final  int getNumberOfExceptions()
    {
        return number_of_exceptions;
    }

    public final  java.lang.String[] getExceptionNames()
    {
        java.lang.String[] names = new java.lang.String[number_of_exceptions];
        for (int i = 0; i < number_of_exceptions; i++) {
            names[i] = constant_pool.getConstantString( exception_index_table[i], Constants.CONSTANT_Class ).replace( '/', '.' );
        }
        return names;
    }

    public final  void setExceptionIndexTable( int[] exception_index_table )
    {
        this.exception_index_table = exception_index_table;
        number_of_exceptions = exception_index_table == null ? 0 : exception_index_table.length;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "" );
        java.lang.String str;
        for (int i = 0; i < number_of_exceptions; i++) {
            str = constant_pool.getConstantString( exception_index_table[i], Constants.CONSTANT_Class );
            buf.append( Utility.compactClassName( str, false ) );
            if (i < number_of_exceptions - 1) {
                buf.append( ", " );
            }
        }
        return buf.toString();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.ExceptionTable c = (org.apache.bcel.classfile.ExceptionTable) clone();
        if (exception_index_table != null) {
            c.exception_index_table = new int[exception_index_table.length];
            System.arraycopy( exception_index_table, 0, c.exception_index_table, 0, exception_index_table.length );
        }
        c.constant_pool = _constant_pool;
        return c;
    }

}
