// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;
import org.apache.bcel.Constants;


public final class InnerClass implements java.lang.Cloneable, org.apache.bcel.classfile.Node, java.io.Serializable
{

    private int inner_class_index;

    private int outer_class_index;

    private int inner_name_index;

    private int inner_access_flags;

    public InnerClass( org.apache.bcel.classfile.InnerClass c )
    {
        this( c.getInnerClassIndex(), c.getOuterClassIndex(), c.getInnerNameIndex(), c.getInnerAccessFlags() );
    }

    InnerClass( java.io.DataInputStream file )
        throws java.io.IOException
    {
        this( file.readUnsignedShort(), file.readUnsignedShort(), file.readUnsignedShort(), file.readUnsignedShort() );
    }

    public InnerClass( int inner_class_index, int outer_class_index, int inner_name_index, int inner_access_flags )
    {
        this.inner_class_index = inner_class_index;
        this.outer_class_index = outer_class_index;
        this.inner_name_index = inner_name_index;
        this.inner_access_flags = inner_access_flags;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitInnerClass( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        file.writeShort( inner_class_index );
        file.writeShort( outer_class_index );
        file.writeShort( inner_name_index );
        file.writeShort( inner_access_flags );
    }

    public final  int getInnerAccessFlags()
    {
        return inner_access_flags;
    }

    public final  int getInnerClassIndex()
    {
        return inner_class_index;
    }

    public final  int getInnerNameIndex()
    {
        return inner_name_index;
    }

    public final  int getOuterClassIndex()
    {
        return outer_class_index;
    }

    public final  void setInnerAccessFlags( int inner_access_flags )
    {
        this.inner_access_flags = inner_access_flags;
    }

    public final  void setInnerClassIndex( int inner_class_index )
    {
        this.inner_class_index = inner_class_index;
    }

    public final  void setInnerNameIndex( int inner_name_index )
    {
        this.inner_name_index = inner_name_index;
    }

    public final  void setOuterClassIndex( int outer_class_index )
    {
        this.outer_class_index = outer_class_index;
    }

    public final  java.lang.String toString()
    {
        return "InnerClass(" + inner_class_index + ", " + outer_class_index + ", " + inner_name_index + ", " + inner_access_flags + ")";
    }

    public final  java.lang.String toString( org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        java.lang.String inner_class_name;
        java.lang.String outer_class_name;
        java.lang.String inner_name;
        java.lang.String access;
        inner_class_name = constant_pool.getConstantString( inner_class_index, Constants.CONSTANT_Class );
        inner_class_name = Utility.compactClassName( inner_class_name );
        if (outer_class_index != 0) {
            outer_class_name = constant_pool.getConstantString( outer_class_index, Constants.CONSTANT_Class );
            outer_class_name = Utility.compactClassName( outer_class_name );
        } else {
            outer_class_name = "<not a member>";
        }
        if (inner_name_index != 0) {
            inner_name = ((org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( inner_name_index, Constants.CONSTANT_Utf8 )).getBytes();
        } else {
            inner_name = "<anonymous>";
        }
        access = Utility.accessToString( inner_access_flags, true );
        access = access.equals( "" ) ? "" : access + " ";
        return "InnerClass:" + access + inner_class_name + "(\"" + outer_class_name + "\", \"" + inner_name + "\")";
    }

    public  org.apache.bcel.classfile.InnerClass copy()
    {
        try {
            return (org.apache.bcel.classfile.InnerClass) clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
        }
        return null;
    }

}
