// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class PMGClass extends org.apache.bcel.classfile.Attribute
{

    private int pmg_class_index;

    private int pmg_index;

    public PMGClass( org.apache.bcel.classfile.PMGClass c )
    {
        this( c.getNameIndex(), c.getLength(), c.getPMGIndex(), c.getPMGClassIndex(), c.getConstantPool() );
    }

    PMGClass( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, file.readUnsignedShort(), file.readUnsignedShort(), constant_pool );
    }

    public PMGClass( int name_index, int length, int pmg_index, int pmg_class_index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_PMG, name_index, length, constant_pool );
        this.pmg_index = pmg_index;
        this.pmg_class_index = pmg_class_index;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        System.err.println( "Visiting non-standard PMGClass object" );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( pmg_index );
        file.writeShort( pmg_class_index );
    }

    public final  int getPMGClassIndex()
    {
        return pmg_class_index;
    }

    public final  void setPMGClassIndex( int pmg_class_index )
    {
        this.pmg_class_index = pmg_class_index;
    }

    public final  int getPMGIndex()
    {
        return pmg_index;
    }

    public final  void setPMGIndex( int pmg_index )
    {
        this.pmg_index = pmg_index;
    }

    public final  java.lang.String getPMGName()
    {
        org.apache.bcel.classfile.ConstantUtf8 c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( pmg_index, Constants.CONSTANT_Utf8 );
        return c.getBytes();
    }

    public final  java.lang.String getPMGClassName()
    {
        org.apache.bcel.classfile.ConstantUtf8 c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( pmg_class_index, Constants.CONSTANT_Utf8 );
        return c.getBytes();
    }

    public final  java.lang.String toString()
    {
        return "PMGClass(" + getPMGName() + ", " + getPMGClassName() + ")";
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        return (org.apache.bcel.classfile.PMGClass) clone();
    }

}
