// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class Signature extends org.apache.bcel.classfile.Attribute
{

    private int signature_index;

    public Signature( org.apache.bcel.classfile.Signature c )
    {
        this( c.getNameIndex(), c.getLength(), c.getSignatureIndex(), c.getConstantPool() );
    }

    Signature( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, file.readUnsignedShort(), constant_pool );
    }

    public Signature( int name_index, int length, int signature_index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_SIGNATURE, name_index, length, constant_pool );
        this.signature_index = signature_index;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitSignature( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( signature_index );
    }

    public final  int getSignatureIndex()
    {
        return signature_index;
    }

    public final  void setSignatureIndex( int signature_index )
    {
        this.signature_index = signature_index;
    }

    public final  java.lang.String getSignature()
    {
        org.apache.bcel.classfile.ConstantUtf8 c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( signature_index, Constants.CONSTANT_Utf8 );
        return c.getBytes();
    }

    private static final class MyByteArrayInputStream extends java.io.ByteArrayInputStream
    {

        MyByteArrayInputStream( java.lang.String data )
        {
            super( data.getBytes() );
        }

        final  int mark()
        {
            return pos;
        }

        final  java.lang.String getData()
        {
            return new java.lang.String( buf );
        }

        final  void reset( int p )
        {
            pos = p;
        }

        final  void unread()
        {
            if (pos > 0) {
                pos--;
            }
        }

    }

    private static  boolean identStart( int ch )
    {
        return ch == 'T' || ch == 'L';
    }

    private static final  void matchIdent( org.apache.bcel.classfile.Signature.MyByteArrayInputStream in, java.lang.StringBuffer buf )
    {
        int ch;
        if ((ch = in.read()) == -1) {
            throw new java.lang.RuntimeException( "Illegal signature: " + in.getData() + " no ident, reaching EOF" );
        }
        if (!identStart( ch )) {
            java.lang.StringBuffer buf2 = new java.lang.StringBuffer();
            int count = 1;
            while (Character.isJavaIdentifierPart( (char) ch )) {
                buf2.append( (char) ch );
                count++;
                ch = in.read();
            }
            if (ch == ':') {
                in.skip( "Ljava/lang/Object".length() );
                buf.append( buf2 );
                ch = in.read();
                in.unread();
            } else {
                for (int i = 0; i < count; i++) {
                    in.unread();
                }
            }
            return;
        }
        java.lang.StringBuffer buf2 = new java.lang.StringBuffer();
        ch = in.read();
        do {
            buf2.append( (char) ch );
            ch = in.read();
        } while (ch != -1 && (Character.isJavaIdentifierPart( (char) ch ) || ch == '/'));
        buf.append( buf2.toString().replace( '/', '.' ) );
        if (ch != -1) {
            in.unread();
        }
    }

    private static final  void matchGJIdent( org.apache.bcel.classfile.Signature.MyByteArrayInputStream in, java.lang.StringBuffer buf )
    {
        int ch;
        matchIdent( in, buf );
        ch = in.read();
        if (ch == '<' || ch == '(') {
            buf.append( (char) ch );
            matchGJIdent( in, buf );
            while ((ch = in.read()) != '>' && ch != ')') {
                if (ch == -1) {
                    throw new java.lang.RuntimeException( "Illegal signature: " + in.getData() + " reaching EOF" );
                }
                buf.append( ", " );
                in.unread();
                matchGJIdent( in, buf );
            }
            buf.append( (char) ch );
        } else {
            in.unread();
        }
        ch = in.read();
        if (identStart( ch )) {
            in.unread();
            matchGJIdent( in, buf );
        } else {
            if (ch == ')') {
                in.unread();
                return;
            } else {
                if (ch != ';') {
                    throw new java.lang.RuntimeException( "Illegal signature: " + in.getData() + " read " + (char) ch );
                }
            }
        }
    }

    public static  java.lang.String translate( java.lang.String s )
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        matchGJIdent( new org.apache.bcel.classfile.Signature.MyByteArrayInputStream( s ), buf );
        return buf.toString();
    }

    public static final  boolean isFormalParameterList( java.lang.String s )
    {
        return s.startsWith( "<" ) && s.indexOf( ':' ) > 0;
    }

    public static final  boolean isActualParameterList( java.lang.String s )
    {
        return s.startsWith( "L" ) && s.endsWith( ">;" );
    }

    public final  java.lang.String toString()
    {
        java.lang.String s = getSignature();
        return "Signature(" + s + ")";
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        return (org.apache.bcel.classfile.Signature) clone();
    }

}
