// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class StackMap extends org.apache.bcel.classfile.Attribute implements org.apache.bcel.classfile.Node
{

    private int map_length;

    private org.apache.bcel.classfile.StackMapEntry[] map;

    public StackMap( int name_index, int length, org.apache.bcel.classfile.StackMapEntry[] map, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_STACK_MAP, name_index, length, constant_pool );
        setStackMap( map );
    }

    StackMap( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (org.apache.bcel.classfile.StackMapEntry[]) null, constant_pool );
        map_length = file.readUnsignedShort();
        map = new org.apache.bcel.classfile.StackMapEntry[map_length];
        for (int i = 0; i < map_length; i++) {
            map[i] = new org.apache.bcel.classfile.StackMapEntry( file, constant_pool );
        }
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( map_length );
        for (int i = 0; i < map_length; i++) {
            map[i].dump( file );
        }
    }

    public final  org.apache.bcel.classfile.StackMapEntry[] getStackMap()
    {
        return map;
    }

    public final  void setStackMap( org.apache.bcel.classfile.StackMapEntry[] map )
    {
        this.map = map;
        map_length = map == null ? 0 : map.length;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "StackMap(" );
        for (int i = 0; i < map_length; i++) {
            buf.append( map[i].toString() );
            if (i < map_length - 1) {
                buf.append( ", " );
            }
        }
        buf.append( ')' );
        return buf.toString();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.StackMap c = (org.apache.bcel.classfile.StackMap) clone();
        c.map = new org.apache.bcel.classfile.StackMapEntry[map_length];
        for (int i = 0; i < map_length; i++) {
            c.map[i] = map[i].copy();
        }
        c.constant_pool = _constant_pool;
        return c;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitStackMap( this );
    }

    public final  int getMapLength()
    {
        return map_length;
    }

}
