// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.apache.bcel.Constants;


public final class Unknown extends org.apache.bcel.classfile.Attribute
{

    private byte[] bytes;

    private java.lang.String name;

    private static java.util.Map unknown_attributes = new java.util.HashMap();

    static  org.apache.bcel.classfile.Unknown[] getUnknownAttributes()
    {
        org.apache.bcel.classfile.Unknown[] unknowns = new org.apache.bcel.classfile.Unknown[unknown_attributes.size()];
        java.util.Iterator entries = unknown_attributes.values().iterator();
        for (int i = 0; entries.hasNext(); i++) {
            unknowns[i] = (org.apache.bcel.classfile.Unknown) entries.next();
        }
        unknown_attributes.clear();
        return unknowns;
    }

    public Unknown( org.apache.bcel.classfile.Unknown c )
    {
        this( c.getNameIndex(), c.getLength(), c.getBytes(), c.getConstantPool() );
    }

    public Unknown( int name_index, int length, byte[] bytes, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_UNKNOWN, name_index, length, constant_pool );
        this.bytes = bytes;
        name = ((org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( name_index, Constants.CONSTANT_Utf8 )).getBytes();
        unknown_attributes.put( name, this );
    }

    Unknown( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (byte[]) null, constant_pool );
        if (length > 0) {
            bytes = new byte[length];
            file.readFully( bytes );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitUnknown( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        if (length > 0) {
            file.write( bytes, 0, length );
        }
    }

    public final  byte[] getBytes()
    {
        return bytes;
    }

    public final  java.lang.String getName()
    {
        return name;
    }

    public final  void setBytes( byte[] bytes )
    {
        this.bytes = bytes;
    }

    public final  java.lang.String toString()
    {
        if (length == 0 || bytes == null) {
            return "(Unknown attribute " + name + ")";
        }
        java.lang.String hex;
        if (length > 10) {
            byte[] tmp = new byte[10];
            System.arraycopy( bytes, 0, tmp, 0, 10 );
            hex = Utility.toHexString( tmp ) + "... (truncated)";
        } else {
            hex = Utility.toHexString( bytes );
        }
        return "(Unknown attribute " + name + ": " + hex + ")";
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.Unknown c = (org.apache.bcel.classfile.Unknown) clone();
        if (bytes != null) {
            c.bytes = new byte[bytes.length];
            System.arraycopy( bytes, 0, c.bytes, 0, bytes.length );
        }
        c.constant_pool = _constant_pool;
        return c;
    }

}
