// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import org.apache.bcel.Constants;


public final class ArrayType extends org.apache.bcel.generic.ReferenceType
{

    private int dimensions;

    private org.apache.bcel.generic.Type basic_type;

    public ArrayType( byte type, int dimensions )
    {
        this( BasicType.getType( type ), dimensions );
    }

    public ArrayType( java.lang.String class_name, int dimensions )
    {
        this( new org.apache.bcel.generic.ObjectType( class_name ), dimensions );
    }

    public ArrayType( org.apache.bcel.generic.Type type, int dimensions )
    {
        super( Constants.T_ARRAY, "<dummy>" );
        if (dimensions < 1 || dimensions > Constants.MAX_BYTE) {
            throw new org.apache.bcel.generic.ClassGenException( "Invalid number of dimensions: " + dimensions );
        }
        switch (type.getType()) {
        case Constants.T_ARRAY :
            org.apache.bcel.generic.ArrayType array = (org.apache.bcel.generic.ArrayType) type;
            this.dimensions = dimensions + array.dimensions;
            basic_type = array.basic_type;
            break;

        case Constants.T_VOID :
            throw new org.apache.bcel.generic.ClassGenException( "Invalid type: void[]" );

        default  :
            this.dimensions = dimensions;
            basic_type = type;
            break;

        }
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        for (int i = 0; i < this.dimensions; i++) {
            buf.append( '[' );
        }
        buf.append( basic_type.getSignature() );
        signature = buf.toString();
    }

    public  org.apache.bcel.generic.Type getBasicType()
    {
        return basic_type;
    }

    public  org.apache.bcel.generic.Type getElementType()
    {
        if (dimensions == 1) {
            return basic_type;
        }
        return new org.apache.bcel.generic.ArrayType( basic_type, dimensions - 1 );
    }

    public  int getDimensions()
    {
        return dimensions;
    }

    public  int hashCode()
    {
        return basic_type.hashCode() ^ dimensions;
    }

    public  boolean equals( java.lang.Object _type )
    {
        if (_type instanceof org.apache.bcel.generic.ArrayType) {
            org.apache.bcel.generic.ArrayType array = (org.apache.bcel.generic.ArrayType) _type;
            return array.dimensions == dimensions && array.basic_type.equals( basic_type );
        }
        return false;
    }

}
