// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import org.apache.bcel.classfile.CodeException;


public final class CodeExceptionGen implements org.apache.bcel.generic.InstructionTargeter, java.lang.Cloneable, java.io.Serializable
{

    private org.apache.bcel.generic.InstructionHandle start_pc;

    private org.apache.bcel.generic.InstructionHandle end_pc;

    private org.apache.bcel.generic.InstructionHandle handler_pc;

    private org.apache.bcel.generic.ObjectType catch_type;

    public CodeExceptionGen( org.apache.bcel.generic.InstructionHandle start_pc, org.apache.bcel.generic.InstructionHandle end_pc, org.apache.bcel.generic.InstructionHandle handler_pc, org.apache.bcel.generic.ObjectType catch_type )
    {
        setStartPC( start_pc );
        setEndPC( end_pc );
        setHandlerPC( handler_pc );
        this.catch_type = catch_type;
    }

    public  org.apache.bcel.classfile.CodeException getCodeException( org.apache.bcel.generic.ConstantPoolGen cp )
    {
        return new org.apache.bcel.classfile.CodeException( start_pc.getPosition(), end_pc.getPosition() + end_pc.getInstruction().getLength(), handler_pc.getPosition(), catch_type == null ? 0 : cp.addClass( catch_type ) );
    }

    public  void setStartPC( org.apache.bcel.generic.InstructionHandle start_pc )
    {
        BranchInstruction.notifyTarget( this.start_pc, start_pc, this );
        this.start_pc = start_pc;
    }

    public  void setEndPC( org.apache.bcel.generic.InstructionHandle end_pc )
    {
        BranchInstruction.notifyTarget( this.end_pc, end_pc, this );
        this.end_pc = end_pc;
    }

    public  void setHandlerPC( org.apache.bcel.generic.InstructionHandle handler_pc )
    {
        BranchInstruction.notifyTarget( this.handler_pc, handler_pc, this );
        this.handler_pc = handler_pc;
    }

    public  void updateTarget( org.apache.bcel.generic.InstructionHandle old_ih, org.apache.bcel.generic.InstructionHandle new_ih )
    {
        boolean targeted = false;
        if (start_pc == old_ih) {
            targeted = true;
            setStartPC( new_ih );
        }
        if (end_pc == old_ih) {
            targeted = true;
            setEndPC( new_ih );
        }
        if (handler_pc == old_ih) {
            targeted = true;
            setHandlerPC( new_ih );
        }
        if (!targeted) {
            throw new org.apache.bcel.generic.ClassGenException( "Not targeting " + old_ih + ", but {" + start_pc + ", " + end_pc + ", " + handler_pc + "}" );
        }
    }

    public  boolean containsTarget( org.apache.bcel.generic.InstructionHandle ih )
    {
        return start_pc == ih || end_pc == ih || handler_pc == ih;
    }

    public  void setCatchType( org.apache.bcel.generic.ObjectType catch_type )
    {
        this.catch_type = catch_type;
    }

    public  org.apache.bcel.generic.ObjectType getCatchType()
    {
        return catch_type;
    }

    public  org.apache.bcel.generic.InstructionHandle getStartPC()
    {
        return start_pc;
    }

    public  org.apache.bcel.generic.InstructionHandle getEndPC()
    {
        return end_pc;
    }

    public  org.apache.bcel.generic.InstructionHandle getHandlerPC()
    {
        return handler_pc;
    }

    public  java.lang.String toString()
    {
        return "CodeExceptionGen(" + start_pc + ", " + end_pc + ", " + handler_pc + ")";
    }

    public  java.lang.Object clone()
    {
        try {
            return super.clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
            System.err.println( e );
            return null;
        }
    }

}
