// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;
import org.apache.bcel.ExceptionConstants;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.util.ByteSequence;


public final class INVOKEINTERFACE extends org.apache.bcel.generic.InvokeInstruction
{

    private int nargs;

    INVOKEINTERFACE()
    {
    }

    public INVOKEINTERFACE( int index, int nargs )
    {
        super( Constants.INVOKEINTERFACE, index );
        length = 5;
        if (nargs < 1) {
            throw new org.apache.bcel.generic.ClassGenException( "Number of arguments must be > 0 " + nargs );
        }
        this.nargs = nargs;
    }

    public  void dump( java.io.DataOutputStream out )
        throws java.io.IOException
    {
        out.writeByte( opcode );
        out.writeShort( index );
        out.writeByte( nargs );
        out.writeByte( 0 );
    }

    public  int getCount()
    {
        return nargs;
    }

    protected  void initFromFile( org.apache.bcel.util.ByteSequence bytes, boolean wide )
        throws java.io.IOException
    {
        super.initFromFile( bytes, wide );
        length = 5;
        nargs = bytes.readUnsignedByte();
        bytes.readByte();
    }

    public  java.lang.String toString( org.apache.bcel.classfile.ConstantPool cp )
    {
        return super.toString( cp ) + " " + nargs;
    }

    public  int consumeStack( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        return nargs;
    }

    public  java.lang.Class[] getExceptions()
    {
        java.lang.Class[] cs = new java.lang.Class[4 + ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length];
        System.arraycopy( ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION, 0, cs, 0, ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length );
        cs[ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length + 3] = ExceptionConstants.INCOMPATIBLE_CLASS_CHANGE_ERROR;
        cs[ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length + 2] = ExceptionConstants.ILLEGAL_ACCESS_ERROR;
        cs[ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length + 1] = ExceptionConstants.ABSTRACT_METHOD_ERROR;
        cs[ExceptionConstants.EXCS_INTERFACE_METHOD_RESOLUTION.length] = ExceptionConstants.UNSATISFIED_LINK_ERROR;
        return cs;
    }

    public  void accept( org.apache.bcel.generic.Visitor v )
    {
        v.visitExceptionThrower( this );
        v.visitTypedInstruction( this );
        v.visitStackConsumer( this );
        v.visitStackProducer( this );
        v.visitLoadClass( this );
        v.visitCPInstruction( this );
        v.visitFieldOrMethod( this );
        v.visitInvokeInstruction( this );
        v.visitINVOKEINTERFACE( this );
    }

}
