// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import org.apache.bcel.classfile.Utility;


public class InstructionHandle implements java.io.Serializable
{

    org.apache.bcel.generic.InstructionHandle next;

    org.apache.bcel.generic.InstructionHandle prev;

    org.apache.bcel.generic.Instruction instruction;

    protected int i_position = -1;

    private java.util.Set targeters;

    private java.util.Map attributes;

    public final  org.apache.bcel.generic.InstructionHandle getNext()
    {
        return next;
    }

    public final  org.apache.bcel.generic.InstructionHandle getPrev()
    {
        return prev;
    }

    public final  org.apache.bcel.generic.Instruction getInstruction()
    {
        return instruction;
    }

    public  void setInstruction( org.apache.bcel.generic.Instruction i )
    {
        if (i == null) {
            throw new org.apache.bcel.generic.ClassGenException( "Assigning null to handle" );
        }
        if (this.getClass() != org.apache.bcel.generic.BranchHandle.class && i instanceof org.apache.bcel.generic.BranchInstruction) {
            throw new org.apache.bcel.generic.ClassGenException( "Assigning branch instruction " + i + " to plain handle" );
        }
        if (instruction != null) {
            instruction.dispose();
        }
        instruction = i;
    }

    public  org.apache.bcel.generic.Instruction swapInstruction( org.apache.bcel.generic.Instruction i )
    {
        org.apache.bcel.generic.Instruction oldInstruction = instruction;
        instruction = i;
        return oldInstruction;
    }

    protected InstructionHandle( org.apache.bcel.generic.Instruction i )
    {
        setInstruction( i );
    }

    private static org.apache.bcel.generic.InstructionHandle ih_list = null;

    static final  org.apache.bcel.generic.InstructionHandle getInstructionHandle( org.apache.bcel.generic.Instruction i )
    {
        if (ih_list == null) {
            return new org.apache.bcel.generic.InstructionHandle( i );
        } else {
            org.apache.bcel.generic.InstructionHandle ih = ih_list;
            ih_list = ih.next;
            ih.setInstruction( i );
            return ih;
        }
    }

    protected  int updatePosition( int offset, int max_offset )
    {
        i_position += offset;
        return 0;
    }

    public  int getPosition()
    {
        return i_position;
    }

     void setPosition( int pos )
    {
        i_position = pos;
    }

    protected  void addHandle()
    {
        next = ih_list;
        ih_list = this;
    }

     void dispose()
    {
        next = prev = null;
        instruction.dispose();
        instruction = null;
        i_position = -1;
        attributes = null;
        removeAllTargeters();
        addHandle();
    }

    public  void removeAllTargeters()
    {
        if (targeters != null) {
            targeters.clear();
        }
    }

    public  void removeTargeter( org.apache.bcel.generic.InstructionTargeter t )
    {
        if (targeters != null) {
            targeters.remove( t );
        }
    }

    public  void addTargeter( org.apache.bcel.generic.InstructionTargeter t )
    {
        if (targeters == null) {
            targeters = new java.util.HashSet();
        }
        targeters.add( t );
    }

    public  boolean hasTargeters()
    {
        return targeters != null && targeters.size() > 0;
    }

    public  org.apache.bcel.generic.InstructionTargeter[] getTargeters()
    {
        if (!hasTargeters()) {
            return null;
        }
        org.apache.bcel.generic.InstructionTargeter[] t = new org.apache.bcel.generic.InstructionTargeter[targeters.size()];
        targeters.toArray( t );
        return t;
    }

    public  java.lang.String toString( boolean verbose )
    {
        return Utility.format( i_position, 4, false, ' ' ) + ": " + instruction.toString( verbose );
    }

    public  java.lang.String toString()
    {
        return toString( true );
    }

    public  void addAttribute( java.lang.Object key, java.lang.Object attr )
    {
        if (attributes == null) {
            attributes = new java.util.HashMap( 3 );
        }
        attributes.put( key, attr );
    }

    public  void removeAttribute( java.lang.Object key )
    {
        if (attributes != null) {
            attributes.remove( key );
        }
    }

    public  java.lang.Object getAttribute( java.lang.Object key )
    {
        if (attributes != null) {
            return attributes.get( key );
        }
        return null;
    }

    public  java.util.Collection getAttributes()
    {
        if (attributes == null) {
            attributes = new java.util.HashMap( 3 );
        }
        return attributes.values();
    }

    public  void accept( org.apache.bcel.generic.Visitor v )
    {
        instruction.accept( v );
    }

}
