// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import org.apache.bcel.Constants;
import org.apache.bcel.classfile.LocalVariable;


public class LocalVariableGen implements org.apache.bcel.generic.InstructionTargeter, org.apache.bcel.generic.NamedAndTyped, java.lang.Cloneable, java.io.Serializable
{

    private int index;

    private java.lang.String name;

    private org.apache.bcel.generic.Type type;

    private org.apache.bcel.generic.InstructionHandle start;

    private org.apache.bcel.generic.InstructionHandle end;

    public LocalVariableGen( int index, java.lang.String name, org.apache.bcel.generic.Type type, org.apache.bcel.generic.InstructionHandle start, org.apache.bcel.generic.InstructionHandle end )
    {
        if (index < 0 || index > Constants.MAX_SHORT) {
            throw new org.apache.bcel.generic.ClassGenException( "Invalid index index: " + index );
        }
        this.name = name;
        this.type = type;
        this.index = index;
        setStart( start );
        setEnd( end );
    }

    public  org.apache.bcel.classfile.LocalVariable getLocalVariable( org.apache.bcel.generic.ConstantPoolGen cp )
    {
        int start_pc = start.getPosition();
        int length = end.getPosition() - start_pc;
        if (length > 0) {
            length += end.getInstruction().getLength();
        }
        int name_index = cp.addUtf8( name );
        int signature_index = cp.addUtf8( type.getSignature() );
        return new org.apache.bcel.classfile.LocalVariable( start_pc, length, name_index, signature_index, index, cp.getConstantPool() );
    }

    public  void setIndex( int index )
    {
        this.index = index;
    }

    public  int getIndex()
    {
        return index;
    }

    public  void setName( java.lang.String name )
    {
        this.name = name;
    }

    public  java.lang.String getName()
    {
        return name;
    }

    public  void setType( org.apache.bcel.generic.Type type )
    {
        this.type = type;
    }

    public  org.apache.bcel.generic.Type getType()
    {
        return type;
    }

    public  org.apache.bcel.generic.InstructionHandle getStart()
    {
        return start;
    }

    public  org.apache.bcel.generic.InstructionHandle getEnd()
    {
        return end;
    }

    public  void setStart( org.apache.bcel.generic.InstructionHandle start )
    {
        BranchInstruction.notifyTarget( this.start, start, this );
        this.start = start;
    }

    public  void setEnd( org.apache.bcel.generic.InstructionHandle end )
    {
        BranchInstruction.notifyTarget( this.end, end, this );
        this.end = end;
    }

    public  void updateTarget( org.apache.bcel.generic.InstructionHandle old_ih, org.apache.bcel.generic.InstructionHandle new_ih )
    {
        boolean targeted = false;
        if (start == old_ih) {
            targeted = true;
            setStart( new_ih );
        }
        if (end == old_ih) {
            targeted = true;
            setEnd( new_ih );
        }
        if (!targeted) {
            throw new org.apache.bcel.generic.ClassGenException( "Not targeting " + old_ih + ", but {" + start + ", " + end + "}" );
        }
    }

    public  boolean containsTarget( org.apache.bcel.generic.InstructionHandle ih )
    {
        return start == ih || end == ih;
    }

    public  int hashCode()
    {
        int hc = index ^ name.hashCode() ^ type.hashCode();
        return hc;
    }

    public  boolean equals( java.lang.Object o )
    {
        if (!(o instanceof org.apache.bcel.generic.LocalVariableGen)) {
            return false;
        }
        org.apache.bcel.generic.LocalVariableGen l = (org.apache.bcel.generic.LocalVariableGen) o;
        return l.index == index && l.start == start && l.end == end;
    }

    public  java.lang.String toString()
    {
        return "LocalVariableGen(" + name + ", " + type + ", " + start + ", " + end + ")";
    }

    public  java.lang.Object clone()
    {
        try {
            return super.clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
            System.err.println( e );
            return null;
        }
    }

}
