// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.ExceptionConstants;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.util.ByteSequence;


public class MULTIANEWARRAY extends org.apache.bcel.generic.CPInstruction implements org.apache.bcel.generic.LoadClass, org.apache.bcel.generic.AllocationInstruction, org.apache.bcel.generic.ExceptionThrower
{

    private short dimensions;

    MULTIANEWARRAY()
    {
    }

    public MULTIANEWARRAY( int index, short dimensions )
    {
        super( org.apache.bcel.Constants.MULTIANEWARRAY, index );
        if (dimensions < 1) {
            throw new org.apache.bcel.generic.ClassGenException( "Invalid dimensions value: " + dimensions );
        }
        this.dimensions = dimensions;
        length = 4;
    }

    public  void dump( java.io.DataOutputStream out )
        throws java.io.IOException
    {
        out.writeByte( opcode );
        out.writeShort( index );
        out.writeByte( dimensions );
    }

    protected  void initFromFile( org.apache.bcel.util.ByteSequence bytes, boolean wide )
        throws java.io.IOException
    {
        super.initFromFile( bytes, wide );
        dimensions = bytes.readByte();
        length = 4;
    }

    public final  short getDimensions()
    {
        return dimensions;
    }

    public  java.lang.String toString( boolean verbose )
    {
        return super.toString( verbose ) + " " + index + " " + dimensions;
    }

    public  java.lang.String toString( org.apache.bcel.classfile.ConstantPool cp )
    {
        return super.toString( cp ) + " " + dimensions;
    }

    public  int consumeStack( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        return dimensions;
    }

    public  java.lang.Class[] getExceptions()
    {
        java.lang.Class[] cs = new java.lang.Class[2 + ExceptionConstants.EXCS_CLASS_AND_INTERFACE_RESOLUTION.length];
        System.arraycopy( ExceptionConstants.EXCS_CLASS_AND_INTERFACE_RESOLUTION, 0, cs, 0, ExceptionConstants.EXCS_CLASS_AND_INTERFACE_RESOLUTION.length );
        cs[ExceptionConstants.EXCS_CLASS_AND_INTERFACE_RESOLUTION.length + 1] = ExceptionConstants.NEGATIVE_ARRAY_SIZE_EXCEPTION;
        cs[ExceptionConstants.EXCS_CLASS_AND_INTERFACE_RESOLUTION.length] = ExceptionConstants.ILLEGAL_ACCESS_ERROR;
        return cs;
    }

    public  org.apache.bcel.generic.ObjectType getLoadClassType( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        org.apache.bcel.generic.Type t = getType( cpg );
        if (t instanceof org.apache.bcel.generic.ArrayType) {
            t = ((org.apache.bcel.generic.ArrayType) t).getBasicType();
        }
        return t instanceof org.apache.bcel.generic.ObjectType ? (org.apache.bcel.generic.ObjectType) t : null;
    }

    public  void accept( org.apache.bcel.generic.Visitor v )
    {
        v.visitLoadClass( this );
        v.visitAllocationInstruction( this );
        v.visitExceptionThrower( this );
        v.visitTypedInstruction( this );
        v.visitCPInstruction( this );
        v.visitMULTIANEWARRAY( this );
    }

}
