// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.Code;
import org.apache.bcel.classfile.CodeException;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.ConstantValue;
import org.apache.bcel.classfile.ExceptionTable;
import org.apache.bcel.classfile.InnerClass;
import org.apache.bcel.classfile.InnerClasses;
import org.apache.bcel.classfile.LineNumber;
import org.apache.bcel.classfile.LineNumberTable;
import org.apache.bcel.classfile.LocalVariable;
import org.apache.bcel.classfile.LocalVariableTable;
import org.apache.bcel.classfile.SourceFile;
import org.apache.bcel.classfile.Utility;


final class AttributeHTML implements org.apache.bcel.Constants
{

    private java.lang.String class_name;

    private java.io.PrintWriter file;

    private int attr_count = 0;

    private org.apache.bcel.util.ConstantHTML constant_html;

    private org.apache.bcel.classfile.ConstantPool constant_pool;

    AttributeHTML( java.lang.String dir, java.lang.String class_name, org.apache.bcel.classfile.ConstantPool constant_pool, org.apache.bcel.util.ConstantHTML constant_html )
        throws java.io.IOException
    {
        this.class_name = class_name;
        this.constant_pool = constant_pool;
        this.constant_html = constant_html;
        file = new java.io.PrintWriter( new java.io.FileOutputStream( dir + class_name + "_attributes.html" ) );
        file.println( "<HTML><BODY BGCOLOR=\"#C0C0C0\"><TABLE BORDER=0>" );
    }

    private final  java.lang.String codeLink( int link, int method_number )
    {
        return "<A HREF=\"" + class_name + "_code.html#code" + method_number + "@" + link + "\" TARGET=Code>" + link + "</A>";
    }

    final  void close()
    {
        file.println( "</TABLE></BODY></HTML>" );
        file.close();
    }

    final  void writeAttribute( org.apache.bcel.classfile.Attribute attribute, java.lang.String anchor )
        throws java.io.IOException
    {
        writeAttribute( attribute, anchor, 0 );
    }

    final  void writeAttribute( org.apache.bcel.classfile.Attribute attribute, java.lang.String anchor, int method_number )
        throws java.io.IOException
    {
        byte tag = attribute.getTag();
        int index;
        if (tag == ATTR_UNKNOWN) {
            return;
        }
        attr_count++;
        if (attr_count % 2 == 0) {
            file.print( "<TR BGCOLOR=\"#C0C0C0\"><TD>" );
        } else {
            file.print( "<TR BGCOLOR=\"#A0A0A0\"><TD>" );
        }
        file.println( "<H4><A NAME=\"" + anchor + "\">" + attr_count + " " + ATTRIBUTE_NAMES[tag] + "</A></H4>" );
        switch (tag) {
        case ATTR_CODE :
            org.apache.bcel.classfile.Code c = (org.apache.bcel.classfile.Code) attribute;
            file.print( "<UL><LI>Maximum stack size = " + c.getMaxStack() + "</LI>\n<LI>Number of local variables = " + c.getMaxLocals() + "</LI>\n<LI><A HREF=\"" + class_name + "_code.html#method" + method_number + "\" TARGET=Code>Byte code</A></LI></UL>\n" );
            org.apache.bcel.classfile.CodeException[] ce = c.getExceptionTable();
            int len = ce.length;
            if (len > 0) {
                file.print( "<P><B>Exceptions handled</B><UL>" );
                for (int i = 0; i < len; i++) {
                    int catch_type = ce[i].getCatchType();
                    file.print( "<LI>" );
                    if (catch_type != 0) {
                        file.print( constant_html.referenceConstant( catch_type ) );
                    } else {
                        file.print( "Any Exception" );
                    }
                    file.print( "<BR>(Ranging from lines " + codeLink( ce[i].getStartPC(), method_number ) + " to " + codeLink( ce[i].getEndPC(), method_number ) + ", handled at line " + codeLink( ce[i].getHandlerPC(), method_number ) + ")</LI>" );
                }
                file.print( "</UL>" );
            }
            break;

        case ATTR_CONSTANT_VALUE :
            index = ((org.apache.bcel.classfile.ConstantValue) attribute).getConstantValueIndex();
            file.print( "<UL><LI><A HREF=\"" + class_name + "_cp.html#cp" + index + "\" TARGET=\"ConstantPool\">Constant value index(" + index + ")</A></UL>\n" );
            break;

        case ATTR_SOURCE_FILE :
            index = ((org.apache.bcel.classfile.SourceFile) attribute).getSourceFileIndex();
            file.print( "<UL><LI><A HREF=\"" + class_name + "_cp.html#cp" + index + "\" TARGET=\"ConstantPool\">Source file index(" + index + ")</A></UL>\n" );
            break;

        case ATTR_EXCEPTIONS :
            int[] indices = ((org.apache.bcel.classfile.ExceptionTable) attribute).getExceptionIndexTable();
            file.print( "<UL>" );
            for (int i = 0; i < indices.length; i++) {
                file.print( "<LI><A HREF=\"" + class_name + "_cp.html#cp" + indices[i] + "\" TARGET=\"ConstantPool\">Exception class index(" + indices[i] + ")</A>\n" );
            }
            file.print( "</UL>\n" );
            break;

        case ATTR_LINE_NUMBER_TABLE :
            org.apache.bcel.classfile.LineNumber[] line_numbers = ((org.apache.bcel.classfile.LineNumberTable) attribute).getLineNumberTable();
            file.print( "<P>" );
            for (int i = 0; i < line_numbers.length; i++) {
                file.print( "(" + line_numbers[i].getStartPC() + ",&nbsp;" + line_numbers[i].getLineNumber() + ")" );
                if (i < line_numbers.length - 1) {
                    file.print( ", " );
                }
            }
            break;

        case ATTR_LOCAL_VARIABLE_TABLE :
            org.apache.bcel.classfile.LocalVariable[] vars = ((org.apache.bcel.classfile.LocalVariableTable) attribute).getLocalVariableTable();
            file.print( "<UL>" );
            for (int i = 0; i < vars.length; i++) {
                index = vars[i].getSignatureIndex();
                java.lang.String signature = ((org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( index, CONSTANT_Utf8 )).getBytes();
                signature = Utility.signatureToString( signature, false );
                int start = vars[i].getStartPC();
                int end = start + vars[i].getLength();
                file.println( "<LI>" + Class2HTML.referenceType( signature ) + "&nbsp;<B>" + vars[i].getName() + "</B> in slot %" + vars[i].getIndex() + "<BR>Valid from lines " + "<A HREF=\"" + class_name + "_code.html#code" + method_number + "@" + start + "\" TARGET=Code>" + start + "</A> to " + "<A HREF=\"" + class_name + "_code.html#code" + method_number + "@" + end + "\" TARGET=Code>" + end + "</A></LI>" );
            }
            file.print( "</UL>\n" );
            break;

        case ATTR_INNER_CLASSES :
            org.apache.bcel.classfile.InnerClass[] classes = ((org.apache.bcel.classfile.InnerClasses) attribute).getInnerClasses();
            file.print( "<UL>" );
            for (int i = 0; i < classes.length; i++) {
                java.lang.String name;
                java.lang.String access;
                index = classes[i].getInnerNameIndex();
                if (index > 0) {
                    name = ((org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( index, CONSTANT_Utf8 )).getBytes();
                } else {
                    name = "&lt;anonymous&gt;";
                }
                access = Utility.accessToString( classes[i].getInnerAccessFlags() );
                file.print( "<LI><FONT COLOR=\"#FF0000\">" + access + "</FONT> " + constant_html.referenceConstant( classes[i].getInnerClassIndex() ) + " in&nbsp;class " + constant_html.referenceConstant( classes[i].getOuterClassIndex() ) + " named " + name + "</LI>\n" );
            }
            file.print( "</UL>\n" );
            break;

        default  :
            file.print( "<P>" + attribute.toString() );

        }
        file.println( "</TD></TR>" );
        file.flush();
    }

}
