// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Locale;
import org.apache.bcel.Constants;
import org.apache.bcel.Repository;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantValue;
import org.apache.bcel.classfile.Field;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.generic.ArrayType;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.MethodGen;
import org.apache.bcel.generic.Type;


public class BCELifier extends org.apache.bcel.classfile.EmptyVisitor
{

    private static final int FLAG_FOR_UNKNOWN = -1;

    private static final int FLAG_FOR_CLASS = 0;

    private static final int FLAG_FOR_METHOD = 1;

    private org.apache.bcel.classfile.JavaClass _clazz;

    private java.io.PrintWriter _out;

    private org.apache.bcel.generic.ConstantPoolGen _cp;

    public BCELifier( org.apache.bcel.classfile.JavaClass clazz, java.io.OutputStream out )
    {
        _clazz = clazz;
        _out = new java.io.PrintWriter( out );
        _cp = new org.apache.bcel.generic.ConstantPoolGen( _clazz.getConstantPool() );
    }

    public  void start()
    {
        visitJavaClass( _clazz );
        _out.flush();
    }

    public  void visitJavaClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        java.lang.String class_name = clazz.getClassName();
        java.lang.String super_name = clazz.getSuperclassName();
        java.lang.String package_name = clazz.getPackageName();
        java.lang.String inter = Utility.printArray( clazz.getInterfaceNames(), false, true );
        if (!"".equals( package_name )) {
            class_name = class_name.substring( package_name.length() + 1 );
            _out.println( "package " + package_name + ";" );
            _out.println();
        }
        _out.println( "import org.apache.bcel.generic.*;" );
        _out.println( "import org.apache.bcel.classfile.*;" );
        _out.println( "import org.apache.bcel.*;" );
        _out.println( "import java.io.*;" );
        _out.println();
        _out.println( "public class " + class_name + "Creator implements Constants {" );
        _out.println( "  private InstructionFactory _factory;" );
        _out.println( "  private ConstantPoolGen    _cp;" );
        _out.println( "  private ClassGen           _cg;" );
        _out.println();
        _out.println( "  public " + class_name + "Creator() {" );
        _out.println( "    _cg = new ClassGen(\"" + ("".equals( package_name ) ? class_name : package_name + "." + class_name) + "\", \"" + super_name + "\", " + "\"" + clazz.getSourceFileName() + "\", " + printFlags( clazz.getAccessFlags(), FLAG_FOR_CLASS ) + ", " + "new String[] { " + inter + " });" );
        _out.println();
        _out.println( "    _cp = _cg.getConstantPool();" );
        _out.println( "    _factory = new InstructionFactory(_cg, _cp);" );
        _out.println( "  }" );
        _out.println();
        printCreate();
        org.apache.bcel.classfile.Field[] fields = clazz.getFields();
        if (fields.length > 0) {
            _out.println( "  private void createFields() {" );
            _out.println( "    FieldGen field;" );
            for (int i = 0; i < fields.length; i++) {
                fields[i].accept( this );
            }
            _out.println( "  }" );
            _out.println();
        }
        org.apache.bcel.classfile.Method[] methods = clazz.getMethods();
        for (int i = 0; i < methods.length; i++) {
            _out.println( "  private void createMethod_" + i + "() {" );
            methods[i].accept( this );
            _out.println( "  }" );
            _out.println();
        }
        printMain();
        _out.println( "}" );
    }

    private  void printCreate()
    {
        _out.println( "  public void create(OutputStream out) throws IOException {" );
        org.apache.bcel.classfile.Field[] fields = _clazz.getFields();
        if (fields.length > 0) {
            _out.println( "    createFields();" );
        }
        org.apache.bcel.classfile.Method[] methods = _clazz.getMethods();
        for (int i = 0; i < methods.length; i++) {
            _out.println( "    createMethod_" + i + "();" );
        }
        _out.println( "    _cg.getJavaClass().dump(out);" );
        _out.println( "  }" );
        _out.println();
    }

    private  void printMain()
    {
        java.lang.String class_name = _clazz.getClassName();
        _out.println( "  public static void main(String[] args) throws Exception {" );
        _out.println( "    " + class_name + "Creator creator = new " + class_name + "Creator();" );
        _out.println( "    creator.create(new FileOutputStream(\"" + class_name + ".class\"));" );
        _out.println( "  }" );
    }

    public  void visitField( org.apache.bcel.classfile.Field field )
    {
        _out.println();
        _out.println( "    field = new FieldGen(" + printFlags( field.getAccessFlags() ) + ", " + printType( field.getSignature() ) + ", \"" + field.getName() + "\", _cp);" );
        org.apache.bcel.classfile.ConstantValue cv = field.getConstantValue();
        if (cv != null) {
            java.lang.String value = cv.toString();
            _out.println( "    field.setInitValue(" + value + ")" );
        }
        _out.println( "    _cg.addField(field.getField());" );
    }

    public  void visitMethod( org.apache.bcel.classfile.Method method )
    {
        org.apache.bcel.generic.MethodGen mg = new org.apache.bcel.generic.MethodGen( method, _clazz.getClassName(), _cp );
        org.apache.bcel.generic.Type result_type = mg.getReturnType();
        org.apache.bcel.generic.Type[] arg_types = mg.getArgumentTypes();
        _out.println( "    InstructionList il = new InstructionList();" );
        _out.println( "    MethodGen method = new MethodGen(" + printFlags( method.getAccessFlags(), FLAG_FOR_METHOD ) + ", " + printType( result_type ) + ", " + printArgumentTypes( arg_types ) + ", " + "new String[] { " + Utility.printArray( mg.getArgumentNames(), false, true ) + " }, \"" + method.getName() + "\", \"" + _clazz.getClassName() + "\", il, _cp);" );
        _out.println();
        org.apache.bcel.util.BCELFactory factory = new org.apache.bcel.util.BCELFactory( mg, _out );
        factory.start();
        _out.println( "    method.setMaxStack();" );
        _out.println( "    method.setMaxLocals();" );
        _out.println( "    _cg.addMethod(method.getMethod());" );
        _out.println( "    il.dispose();" );
    }

    static  java.lang.String printFlags( int flags )
    {
        return printFlags( flags, FLAG_FOR_UNKNOWN );
    }

    static  java.lang.String printFlags( int flags, int reason )
    {
        if (flags == 0) {
            return "0";
        }
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        for (int i = 0, pow = 1; pow <= Constants.MAX_ACC_FLAG; i++) {
            if ((flags & pow) != 0) {
                if (pow == Constants.ACC_SYNCHRONIZED && reason == FLAG_FOR_CLASS) {
                    buf.append( "ACC_SUPER | " );
                } else {
                    if (pow == Constants.ACC_VOLATILE && reason == FLAG_FOR_METHOD) {
                        buf.append( "ACC_BRIDGE | " );
                    } else {
                        if (pow == Constants.ACC_TRANSIENT && reason == FLAG_FOR_METHOD) {
                            buf.append( "ACC_VARARGS | " );
                        } else {
                            buf.append( "ACC_" ).append( Constants.ACCESS_NAMES[i].toUpperCase( Locale.ENGLISH ) ).append( " | " );
                        }
                    }
                }
            }
            pow <<= 1;
        }
        java.lang.String str = buf.toString();
        return str.substring( 0, str.length() - 3 );
    }

    static  java.lang.String printArgumentTypes( org.apache.bcel.generic.Type[] arg_types )
    {
        if (arg_types.length == 0) {
            return "Type.NO_ARGS";
        }
        java.lang.StringBuffer args = new java.lang.StringBuffer();
        for (int i = 0; i < arg_types.length; i++) {
            args.append( printType( arg_types[i] ) );
            if (i < arg_types.length - 1) {
                args.append( ", " );
            }
        }
        return "new Type[] { " + args.toString() + " }";
    }

    static  java.lang.String printType( org.apache.bcel.generic.Type type )
    {
        return printType( type.getSignature() );
    }

    static  java.lang.String printType( java.lang.String signature )
    {
        org.apache.bcel.generic.Type type = Type.getType( signature );
        byte t = type.getType();
        if (t <= Constants.T_VOID) {
            return "Type." + Constants.TYPE_NAMES[t].toUpperCase( Locale.ENGLISH );
        } else {
            if (type.toString().equals( "java.lang.String" )) {
                return "Type.STRING";
            } else {
                if (type.toString().equals( "java.lang.Object" )) {
                    return "Type.OBJECT";
                } else {
                    if (type.toString().equals( "java.lang.StringBuffer" )) {
                        return "Type.STRINGBUFFER";
                    } else {
                        if (type instanceof org.apache.bcel.generic.ArrayType) {
                            org.apache.bcel.generic.ArrayType at = (org.apache.bcel.generic.ArrayType) type;
                            return "new ArrayType(" + printType( at.getBasicType() ) + ", " + at.getDimensions() + ")";
                        } else {
                            return "new ObjectType(\"" + Utility.signatureToString( signature, false ) + "\")";
                        }
                    }
                }
            }
        }
    }

    public static  void main( java.lang.String[] argv )
        throws java.lang.Exception
    {
        org.apache.bcel.classfile.JavaClass java_class;
        java.lang.String name = argv[0];
        if ((java_class = Repository.lookupClass( name )) == null) {
            java_class = (new org.apache.bcel.classfile.ClassParser( name )).parse();
        }
        org.apache.bcel.util.BCELifier bcelifier = new org.apache.bcel.util.BCELifier( java_class, System.out );
        bcelifier.start();
    }

}
