// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import org.apache.bcel.Constants;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.classfile.Utility;


public class Class2HTML implements org.apache.bcel.Constants
{

    private org.apache.bcel.classfile.JavaClass java_class;

    private java.lang.String dir;

    private static java.lang.String class_package;

    private static java.lang.String class_name;

    private static org.apache.bcel.classfile.ConstantPool constant_pool;

    public Class2HTML( org.apache.bcel.classfile.JavaClass java_class, java.lang.String dir )
        throws java.io.IOException
    {
        org.apache.bcel.classfile.Method[] methods = java_class.getMethods();
        this.java_class = java_class;
        this.dir = dir;
        class_name = java_class.getClassName();
        constant_pool = java_class.getConstantPool();
        int index = class_name.lastIndexOf( '.' );
        if (index > -1) {
            class_package = class_name.substring( 0, index );
        } else {
            class_package = "";
        }
        org.apache.bcel.util.ConstantHTML constant_html = new org.apache.bcel.util.ConstantHTML( dir, class_name, class_package, methods, constant_pool );
        org.apache.bcel.util.AttributeHTML attribute_html = new org.apache.bcel.util.AttributeHTML( dir, class_name, constant_pool, constant_html );
        org.apache.bcel.util.MethodHTML method_html = new org.apache.bcel.util.MethodHTML( dir, class_name, methods, java_class.getFields(), constant_html, attribute_html );
        writeMainHTML( attribute_html );
        new org.apache.bcel.util.CodeHTML( dir, class_name, methods, constant_pool, constant_html );
        attribute_html.close();
    }

    public static  void main( java.lang.String[] argv )
    {
        java.lang.String[] file_name = new java.lang.String[argv.length];
        int files = 0;
        org.apache.bcel.classfile.ClassParser parser = null;
        org.apache.bcel.classfile.JavaClass java_class = null;
        java.lang.String zip_file = null;
        char sep = System.getProperty( "file.separator" ).toCharArray()[0];
        java.lang.String dir = "." + sep;
        try {
            for (int i = 0; i < argv.length; i++) {
                if (argv[i].charAt( 0 ) == '-') {
                    if (argv[i].equals( "-d" )) {
                        dir = argv[++i];
                        if (!dir.endsWith( "" + sep )) {
                            dir = dir + sep;
                        }
                        (new java.io.File( dir )).mkdirs();
                    } else {
                        if (argv[i].equals( "-zip" )) {
                            zip_file = argv[++i];
                        } else {
                            System.out.println( "Unknown option " + argv[i] );
                        }
                    }
                } else {
                    file_name[files++] = argv[i];
                }
            }
            if (files == 0) {
                System.err.println( "Class2HTML: No input files specified." );
            } else {
                for (int i = 0; i < files; i++) {
                    System.out.print( "Processing " + file_name[i] + "..." );
                    if (zip_file == null) {
                        parser = new org.apache.bcel.classfile.ClassParser( file_name[i] );
                    } else {
                        parser = new org.apache.bcel.classfile.ClassParser( zip_file, file_name[i] );
                    }
                    java_class = parser.parse();
                    new org.apache.bcel.util.Class2HTML( java_class, dir );
                    System.out.println( "Done." );
                }
            }
        } catch ( java.lang.Exception e ) {
            System.out.println( e );
            e.printStackTrace( System.out );
        }
    }

    static  java.lang.String referenceClass( int index )
    {
        java.lang.String str = constant_pool.getConstantString( index, CONSTANT_Class );
        str = Utility.compactClassName( str );
        str = Utility.compactClassName( str, class_package + ".", true );
        return "<A HREF=\"" + class_name + "_cp.html#cp" + index + "\" TARGET=ConstantPool>" + str + "</A>";
    }

    static final  java.lang.String referenceType( java.lang.String type )
    {
        java.lang.String short_type = Utility.compactClassName( type );
        short_type = Utility.compactClassName( short_type, class_package + ".", true );
        int index = type.indexOf( '[' );
        java.lang.String base_type = type;
        if (index > -1) {
            base_type = type.substring( 0, index );
        }
        if (base_type.equals( "int" ) || base_type.equals( "short" ) || base_type.equals( "boolean" ) || base_type.equals( "void" ) || base_type.equals( "char" ) || base_type.equals( "byte" ) || base_type.equals( "long" ) || base_type.equals( "double" ) || base_type.equals( "float" )) {
            return "<FONT COLOR=\"#00FF00\">" + type + "</FONT>";
        } else {
            return "<A HREF=\"" + base_type + ".html\" TARGET=_top>" + short_type + "</A>";
        }
    }

    static  java.lang.String toHTML( java.lang.String str )
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        try {
            for (int i = 0; i < str.length(); i++) {
                char ch;
                switch (ch = str.charAt( i )) {
                case '<' :
                    buf.append( "&lt;" );
                    break;

                case '>' :
                    buf.append( "&gt;" );
                    break;

                case '\n' :
                    buf.append( "\\n" );
                    break;

                case '\r' :
                    buf.append( "\\r" );
                    break;

                default  :
                    buf.append( ch );

                }
            }
        } catch ( java.lang.StringIndexOutOfBoundsException e ) {
        }
        return buf.toString();
    }

    private  void writeMainHTML( org.apache.bcel.util.AttributeHTML attribute_html )
        throws java.io.IOException
    {
        java.io.PrintWriter file = new java.io.PrintWriter( new java.io.FileOutputStream( dir + class_name + ".html" ) );
        org.apache.bcel.classfile.Attribute[] attributes = java_class.getAttributes();
        file.println( "<HTML>\n" + "<HEAD><TITLE>Documentation for " + class_name + "</TITLE>" + "</HEAD>\n" + "<FRAMESET BORDER=1 cols=\"30%,*\">\n" + "<FRAMESET BORDER=1 rows=\"80%,*\">\n" + "<FRAME NAME=\"ConstantPool\" SRC=\"" + class_name + "_cp.html" + "\"\n MARGINWIDTH=\"0\" " + "MARGINHEIGHT=\"0\" FRAMEBORDER=\"1\" SCROLLING=\"AUTO\">\n" + "<FRAME NAME=\"Attributes\" SRC=\"" + class_name + "_attributes.html" + "\"\n MARGINWIDTH=\"0\" " + "MARGINHEIGHT=\"0\" FRAMEBORDER=\"1\" SCROLLING=\"AUTO\">\n" + "</FRAMESET>\n" + "<FRAMESET BORDER=1 rows=\"80%,*\">\n" + "<FRAME NAME=\"Code\" SRC=\"" + class_name + "_code.html\"\n MARGINWIDTH=0 " + "MARGINHEIGHT=0 FRAMEBORDER=1 SCROLLING=\"AUTO\">\n" + "<FRAME NAME=\"Methods\" SRC=\"" + class_name + "_methods.html\"\n MARGINWIDTH=0 " + "MARGINHEIGHT=0 FRAMEBORDER=1 SCROLLING=\"AUTO\">\n" + "</FRAMESET></FRAMESET></HTML>" );
        file.close();
        for (int i = 0; i < attributes.length; i++) {
            attribute_html.writeAttribute( attributes[i], "class" + i );
        }
    }

}
