// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.JavaClass;


public class ClassLoaderRepository implements org.apache.bcel.util.Repository
{

    private java.lang.ClassLoader loader;

    private java.util.Map loadedClasses = new java.util.HashMap();

    public ClassLoaderRepository( java.lang.ClassLoader loader )
    {
        this.loader = loader;
    }

    public  void storeClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        loadedClasses.put( clazz.getClassName(), clazz );
        clazz.setRepository( this );
    }

    public  void removeClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        loadedClasses.remove( clazz.getClassName() );
    }

    public  org.apache.bcel.classfile.JavaClass findClass( java.lang.String className )
    {
        if (loadedClasses.containsKey( className )) {
            return (org.apache.bcel.classfile.JavaClass) loadedClasses.get( className );
        } else {
            return null;
        }
    }

    public  org.apache.bcel.classfile.JavaClass loadClass( java.lang.String className )
        throws java.lang.ClassNotFoundException
    {
        java.lang.String classFile = className.replace( '.', '/' );
        org.apache.bcel.classfile.JavaClass RC = findClass( className );
        if (RC != null) {
            return RC;
        }
        try {
            java.io.InputStream is = loader.getResourceAsStream( classFile + ".class" );
            if (is == null) {
                throw new java.lang.ClassNotFoundException( className + " not found." );
            }
            org.apache.bcel.classfile.ClassParser parser = new org.apache.bcel.classfile.ClassParser( is, className );
            RC = parser.parse();
            storeClass( RC );
            return RC;
        } catch ( java.io.IOException e ) {
            throw new java.lang.ClassNotFoundException( e.toString() );
        }
    }

    public  org.apache.bcel.classfile.JavaClass loadClass( java.lang.Class clazz )
        throws java.lang.ClassNotFoundException
    {
        return loadClass( clazz.getName() );
    }

    public  void clear()
    {
        loadedClasses.clear();
    }

    public  org.apache.bcel.util.ClassPath getClassPath()
    {
        return null;
    }

}
