// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.IOException;
import java.io.InputStream;
import java.lang.ref.SoftReference;
import java.util.HashMap;
import java.util.Map;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.JavaClass;


public class SyntheticRepository implements org.apache.bcel.util.Repository
{

    private static final java.lang.String DEFAULT_PATH = ClassPath.getClassPath();

    private static java.util.Map _instances = new java.util.HashMap();

    private org.apache.bcel.util.ClassPath _path = null;

    private java.util.Map _loadedClasses = new java.util.HashMap();

    private SyntheticRepository( org.apache.bcel.util.ClassPath path )
    {
        _path = path;
    }

    public static  org.apache.bcel.util.SyntheticRepository getInstance()
    {
        return getInstance( ClassPath.SYSTEM_CLASS_PATH );
    }

    public static  org.apache.bcel.util.SyntheticRepository getInstance( org.apache.bcel.util.ClassPath classPath )
    {
        org.apache.bcel.util.SyntheticRepository rep = (org.apache.bcel.util.SyntheticRepository) _instances.get( classPath );
        if (rep == null) {
            rep = new org.apache.bcel.util.SyntheticRepository( classPath );
            _instances.put( classPath, rep );
        }
        return rep;
    }

    public  void storeClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        _loadedClasses.put( clazz.getClassName(), new java.lang.ref.SoftReference( clazz ) );
        clazz.setRepository( this );
    }

    public  void removeClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        _loadedClasses.remove( clazz.getClassName() );
    }

    public  org.apache.bcel.classfile.JavaClass findClass( java.lang.String className )
    {
        java.lang.ref.SoftReference ref = (java.lang.ref.SoftReference) _loadedClasses.get( className );
        if (ref == null) {
            return null;
        }
        return (org.apache.bcel.classfile.JavaClass) ref.get();
    }

    public  org.apache.bcel.classfile.JavaClass loadClass( java.lang.String className )
        throws java.lang.ClassNotFoundException
    {
        if (className == null || className.equals( "" )) {
            throw new java.lang.IllegalArgumentException( "Invalid class name " + className );
        }
        className = className.replace( '/', '.' );
        org.apache.bcel.classfile.JavaClass clazz = findClass( className );
        if (clazz != null) {
            return clazz;
        }
        try {
            return loadClass( _path.getInputStream( className ), className );
        } catch ( java.io.IOException e ) {
            throw new java.lang.ClassNotFoundException( "Exception while looking for class " + className + ": " + e.toString() );
        }
    }

    public  org.apache.bcel.classfile.JavaClass loadClass( java.lang.Class clazz )
        throws java.lang.ClassNotFoundException
    {
        java.lang.String className = clazz.getName();
        org.apache.bcel.classfile.JavaClass repositoryClass = findClass( className );
        if (repositoryClass != null) {
            return repositoryClass;
        }
        java.lang.String name = className;
        int i = name.lastIndexOf( '.' );
        if (i > 0) {
            name = name.substring( i + 1 );
        }
        return loadClass( clazz.getResourceAsStream( name + ".class" ), className );
    }

    private  org.apache.bcel.classfile.JavaClass loadClass( java.io.InputStream is, java.lang.String className )
        throws java.lang.ClassNotFoundException
    {
        try {
            if (is != null) {
                org.apache.bcel.classfile.ClassParser parser = new org.apache.bcel.classfile.ClassParser( is, className );
                org.apache.bcel.classfile.JavaClass clazz = parser.parse();
                storeClass( clazz );
                return clazz;
            }
        } catch ( java.io.IOException e ) {
            throw new java.lang.ClassNotFoundException( "Exception while looking for class " + className + ": " + e.toString() );
        }
        throw new java.lang.ClassNotFoundException( "SyntheticRepository could not load " + className );
    }

    public  org.apache.bcel.util.ClassPath getClassPath()
    {
        return _path;
    }

    public  void clear()
    {
        _loadedClasses.clear();
    }

}
