// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.concurrent.TimeUnit;
import static java.util.concurrent.TimeUnit.MILLISECONDS;


public class AggregationOptions
{

    private final java.lang.Integer batchSize;

    private final java.lang.Boolean allowDiskUsage;

    private final com.mongodb.AggregationOptions.OutputMode outputMode;

    private final long maxTimeMS;

    public enum OutputMode 
    {
        INLINE,
        CURSOR;

    }

    AggregationOptions( final com.mongodb.AggregationOptions.Builder builder )
    {
        batchSize = builder.batchSize;
        allowDiskUsage = builder.allowDiskUsage;
        outputMode = builder.outputMode;
        maxTimeMS = builder.maxTimeMS;
    }

    public  java.lang.Boolean getAllowDiskUsage()
    {
        return allowDiskUsage;
    }

    public  java.lang.Integer getBatchSize()
    {
        return batchSize;
    }

    public  com.mongodb.AggregationOptions.OutputMode getOutputMode()
    {
        return outputMode;
    }

    public  long getMaxTime( final java.util.concurrent.TimeUnit timeUnit )
    {
        return timeUnit.convert( maxTimeMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  java.lang.String toString()
    {
        return "AggregationOptions{" + "batchSize=" + batchSize + ", allowDiskUsage=" + allowDiskUsage + ", outputMode=" + outputMode + ", maxTimeMS=" + maxTimeMS + '}';
    }

    public static  com.mongodb.AggregationOptions.Builder builder()
    {
        return new com.mongodb.AggregationOptions.Builder();
    }

    public static class Builder
    {

        private java.lang.Integer batchSize;

        private java.lang.Boolean allowDiskUsage;

        private com.mongodb.AggregationOptions.OutputMode outputMode = OutputMode.INLINE;

        private long maxTimeMS;

        private Builder()
        {
        }

        public  com.mongodb.AggregationOptions.Builder batchSize( final java.lang.Integer size )
        {
            batchSize = size;
            return this;
        }

        public  com.mongodb.AggregationOptions.Builder allowDiskUsage( final java.lang.Boolean allow )
        {
            allowDiskUsage = allow;
            return this;
        }

        public  com.mongodb.AggregationOptions.Builder outputMode( final com.mongodb.AggregationOptions.OutputMode mode )
        {
            outputMode = mode;
            return this;
        }

        public  com.mongodb.AggregationOptions.Builder maxTime( final long maxTime, final java.util.concurrent.TimeUnit timeUnit )
        {
            maxTimeMS = MILLISECONDS.convert( maxTime, timeUnit );
            return this;
        }

        public  com.mongodb.AggregationOptions build()
        {
            return new com.mongodb.AggregationOptions( this );
        }

    }

}
