// This is a mutant program.
// Author : ysma

package com.mongodb;


enum BSONType
{
    END_OF_DOCUMENT( 0x00 ),
    DOUBLE( 0x01 ),
    STRING( 0x02 ),
    DOCUMENT( 0x03 ),
    ARRAY( 0x04 ),
    BINARY( 0x05 ),
    UNDEFINED( 0x06 ),
    OBJECT_ID( 0x07 ),
    BOOLEAN( 0x08 ),
    DATE_TIME( 0x09 ),
    NULL( 0x0a ),
    REGULAR_EXPRESSION( 0x0b ),
    DB_POINTER( 0x0c ),
    JAVASCRIPT( 0x0d ),
    SYMBOL( 0x0e ),
    JAVASCRIPT_WITH_SCOPE( 0x0f ),
    INT32( 0x10 ),
    TIMESTAMP( 0x11 ),
    INT64( 0x12 ),
    MIN_KEY( 0xff ),
    MAX_KEY( 0x7f );

    private static final com.mongodb.BSONType[] LOOKUP_TABLE = new com.mongodb.BSONType[MIN_KEY.getValue() + 1];

    private final int value;

    static {
        for (final com.mongodb.BSONType cur: BSONType.values()) {
            LOOKUP_TABLE[cur.getValue()] = cur;
        }
    }

    BSONType( final int value )
    {
        this.value = value;
    }

    public  int getValue()
    {
        return value;
    }

    public static  com.mongodb.BSONType findByValue( final int value )
    {
        return LOOKUP_TABLE[value & 0xFF];
    }

    public  boolean isContainer()
    {
        return this == DOCUMENT || this == ARRAY;
    }

}