// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.nio.ByteOrder;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.bson.BSON;
import org.bson.types.BSONTimestamp;
import org.bson.types.Code;
import org.bson.types.CodeWScope;
import org.bson.types.ObjectId;


public class Bytes extends org.bson.BSON
{

    static final java.util.logging.Logger LOGGER = Logger.getLogger( "com.mongodb" );

    static final boolean D = Boolean.getBoolean( "DEBUG.MONGO" );

    static {
        if (LOGGER.getLevel() == null) {
            if (D) {
                LOGGER.setLevel( Level.ALL );
            } else {
                LOGGER.setLevel( Level.WARNING );
            }
        }
    }

    public static final java.nio.ByteOrder ORDER = ByteOrder.LITTLE_ENDIAN;

    static final int MAX_OBJECT_SIZE = 1024 * 1024 * 4;

    static final int BATCH_INSERT_SIZE = 1024 * 1024 * 8;

    static final int CONNECTIONS_PER_HOST = Integer.parseInt( System.getProperty( "MONGO.POOLSIZE", "10" ) );

    public static final int QUERYOPTION_TAILABLE = 1 << 1;

    public static final int QUERYOPTION_SLAVEOK = 1 << 2;

    public static final int QUERYOPTION_OPLOGREPLAY = 1 << 3;

    public static final int QUERYOPTION_NOTIMEOUT = 1 << 4;

    public static final int QUERYOPTION_AWAITDATA = 1 << 5;

    public static final int QUERYOPTION_EXHAUST = 1 << 6;

    public static final int QUERYOPTION_PARTIAL = 1 << 7;

    public static final int RESULTFLAG_CURSORNOTFOUND = 1;

    public static final int RESULTFLAG_ERRSET = 2;

    public static final int RESULTFLAG_SHARDCONFIGSTALE = 4;

    public static final int RESULTFLAG_AWAITCAPABLE = 8;

    static class OptionHolder
    {

        OptionHolder( com.mongodb.Bytes.OptionHolder parent )
        {
            _parent = parent;
        }

         void set( int options )
        {
            _options = options;
            _hasOptions = true;
        }

         int get()
        {
            if (_hasOptions) {
                return _options;
            }
            if (_parent == null) {
                return 0;
            }
            return _parent.get();
        }

         void add( int option )
        {
            set( get() | option );
        }

         void reset()
        {
            _hasOptions = false;
        }

        final com.mongodb.Bytes.OptionHolder _parent;

        int _options = 0;

        boolean _hasOptions = false;

    }

    public static  byte getType( java.lang.Object o )
    {
        if (o == null) {
            return NULL;
        }
        if (o instanceof com.mongodb.DBPointer) {
            return REF;
        }
        if (o instanceof java.lang.Integer || o instanceof java.lang.Short || o instanceof java.lang.Byte || o instanceof java.util.concurrent.atomic.AtomicInteger) {
            return NUMBER_INT;
        }
        if (o instanceof java.lang.Long || o instanceof java.util.concurrent.atomic.AtomicLong) {
            return NUMBER_LONG;
        }
        if (o instanceof java.lang.Number) {
            return NUMBER;
        }
        if (o instanceof java.lang.String) {
            return STRING;
        }
        if (o instanceof java.util.List) {
            return ARRAY;
        }
        if (o instanceof byte[]) {
            return BINARY;
        }
        if (o instanceof org.bson.types.ObjectId) {
            return OID;
        }
        if (o instanceof java.lang.Boolean) {
            return BOOLEAN;
        }
        if (o instanceof java.util.Date) {
            return DATE;
        }
        if (o instanceof org.bson.types.BSONTimestamp) {
            return TIMESTAMP;
        }
        if (o instanceof java.util.regex.Pattern) {
            return REGEX;
        }
        if (o instanceof com.mongodb.DBObject || o instanceof com.mongodb.DBRefBase) {
            return OBJECT;
        }
        if (o instanceof org.bson.types.Code) {
            return CODE;
        }
        if (o instanceof org.bson.types.CodeWScope) {
            return CODE_W_SCOPE;
        }
        return -1;
    }

    static final org.bson.types.ObjectId COLLECTION_REF_ID = new org.bson.types.ObjectId( -1, -1, -1 );

}
