// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.atomic.AtomicInteger;


final class Clusters
{

    private static final java.util.concurrent.atomic.AtomicInteger NEXT_CLUSTER_ID = new java.util.concurrent.atomic.AtomicInteger( 1 );

    private Clusters()
    {
    }

    public static  com.mongodb.Cluster create( final com.mongodb.ClusterSettings settings, final com.mongodb.ServerSettings serverSettings, final java.util.concurrent.ScheduledExecutorService scheduledExecutorService, final com.mongodb.ClusterListener clusterListener, final com.mongodb.Mongo mongo )
    {
        java.lang.String clusterId = Integer.toString( NEXT_CLUSTER_ID.getAndIncrement() );
        com.mongodb.ClusterableServerFactory serverFactory = new com.mongodb.DefaultClusterableServerFactory( serverSettings, scheduledExecutorService, mongo );
        if (settings.getMode() == ClusterConnectionMode.Single) {
            return new com.mongodb.SingleServerCluster( clusterId, settings, serverFactory, clusterListener != null ? clusterListener : new com.mongodb.NoOpClusterListener() );
        } else {
            if (settings.getMode() == ClusterConnectionMode.Multiple) {
                return new com.mongodb.MultiServerCluster( clusterId, settings, serverFactory, clusterListener != null ? clusterListener : new com.mongodb.NoOpClusterListener() );
            } else {
                throw new java.lang.UnsupportedOperationException( "Unsupported cluster mode: " + settings.getMode() );
            }
        }
    }

}
