// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.net.InetAddress;
import java.net.UnknownHostException;


public class DBAddress extends com.mongodb.ServerAddress
{

    public DBAddress( java.lang.String urlFormat )
        throws java.net.UnknownHostException
    {
        super( _getHostSection( urlFormat ) );
        _check( urlFormat, "urlFormat" );
        _db = _fixName( _getDBSection( urlFormat ) );
        _check( _host, "host" );
        _check( _db, "db" );
    }

    static  java.lang.String _getHostSection( java.lang.String urlFormat )
    {
        if (urlFormat == null) {
            throw new java.lang.NullPointerException( "urlFormat can't be null" );
        }
        int idx = urlFormat.indexOf( "/" );
        if (idx >= 0) {
            return urlFormat.substring( 0, idx );
        }
        return null;
    }

    static  java.lang.String _getDBSection( java.lang.String urlFormat )
    {
        if (urlFormat == null) {
            throw new java.lang.NullPointerException( "urlFormat can't be null" );
        }
        int idx = urlFormat.indexOf( "/" );
        if (idx >= 0) {
            return urlFormat.substring( idx + 1 );
        }
        return urlFormat;
    }

    static  java.lang.String _fixName( java.lang.String name )
    {
        name = name.replace( '.', '-' );
        return name;
    }

    public DBAddress( com.mongodb.DBAddress other, java.lang.String dbname )
        throws java.net.UnknownHostException
    {
        this( other._host, other._port, dbname );
    }

    public DBAddress( java.lang.String host, java.lang.String dbname )
        throws java.net.UnknownHostException
    {
        this( host, DBPort.PORT, dbname );
    }

    public DBAddress( java.lang.String host, int port, java.lang.String dbname )
        throws java.net.UnknownHostException
    {
        super( host, port );
        _db = dbname.trim();
    }

    public DBAddress( java.net.InetAddress addr, int port, java.lang.String dbname )
    {
        super( addr, port );
        _check( dbname, "name" );
        _db = dbname.trim();
    }

    static  void _check( java.lang.String thing, java.lang.String name )
    {
        if (thing == null) {
            throw new java.lang.NullPointerException( name + " can't be null " );
        }
        thing = thing.trim();
        if (thing.length() == 0) {
            throw new java.lang.IllegalArgumentException( name + " can't be empty" );
        }
    }

    public  int hashCode()
    {
        return super.hashCode() + _db.hashCode();
    }

    public  boolean equals( java.lang.Object other )
    {
        if (other instanceof com.mongodb.DBAddress) {
            com.mongodb.DBAddress a = (com.mongodb.DBAddress) other;
            return a._port == _port && a._db.equals( _db ) && a._host.equals( _host );
        } else {
            if (other instanceof com.mongodb.ServerAddress) {
                return other.equals( this );
            }
        }
        return false;
    }

    public  com.mongodb.DBAddress getSister( java.lang.String name )
    {
        try {
            return new com.mongodb.DBAddress( _host, _port, name );
        } catch ( java.net.UnknownHostException uh ) {
            throw new com.mongodb.MongoInternalException( "shouldn't be possible", uh );
        }
    }

    public  java.lang.String getDBName()
    {
        return _db;
    }

    public  java.lang.String toString()
    {
        return super.toString() + "/" + _db;
    }

    final java.lang.String _db;

}
