// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.io.OutputBuffer;
import java.util.List;


class DeleteCommandMessage extends com.mongodb.BaseWriteCommandMessage
{

    private final java.util.List<Remove> deletes;

    private final com.mongodb.DBEncoder queryEncoder;

    public DeleteCommandMessage( final com.mongodb.MongoNamespace namespace, final com.mongodb.WriteConcern writeConcern, final java.util.List<Remove> deletes, final com.mongodb.DBEncoder commandEncoder, final com.mongodb.DBEncoder queryEncoder, final com.mongodb.MessageSettings settings )
    {
        super( namespace, writeConcern, commandEncoder, settings );
        this.deletes = deletes;
        this.queryEncoder = queryEncoder;
    }

    protected  java.lang.String getCommandName()
    {
        return "delete";
    }

    protected  com.mongodb.BaseWriteCommandMessage writeTheWrites( final org.bson.io.OutputBuffer buffer, final int commandStartPosition, final com.mongodb.BSONBinaryWriter writer )
    {
        com.mongodb.DeleteCommandMessage nextMessage = null;
        writer.writeStartArray( "deletes" );
        for (int i = 0; i < deletes.size(); i++) {
            writer.mark();
            com.mongodb.Remove remove = deletes.get( i );
            writer.writeStartDocument();
            writer.pushMaxDocumentSize( getSettings().getMaxDocumentSize() );
            writer.writeName( "q" );
            writer.encodeDocument( getCommandEncoder(), remove.getFilter() );
            writer.writeInt32( "limit", remove.isMulti() ? 0 : 1 );
            writer.popMaxDocumentSize();
            writer.writeEndDocument();
            if (maximumCommandDocumentSizeExceeded( buffer, commandStartPosition )) {
                writer.reset();
                nextMessage = new com.mongodb.DeleteCommandMessage( getWriteNamespace(), getWriteConcern(), deletes.subList( i, deletes.size() ), getCommandEncoder(), queryEncoder, getSettings() );
                break;
            }
        }
        writer.writeEndArray();
        return nextMessage;
    }

}
