// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.util.annotations.ThreadSafe;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;


class MongoCredentialsStore
{

    private final java.util.Map<String,MongoCredential> credentialsMap = new java.util.HashMap<String,MongoCredential>();

    private volatile java.util.Set<String> allDatabasesWithCredentials = new java.util.HashSet<String>();

    public MongoCredentialsStore()
    {
    }

    public MongoCredentialsStore( com.mongodb.MongoCredential credentials )
    {
        if (credentials == null) {
            return;
        }
        add( credentials );
    }

    public MongoCredentialsStore( java.lang.Iterable<MongoCredential> credentialsList )
    {
        if (credentialsList == null) {
            return;
        }
        for (com.mongodb.MongoCredential cur: credentialsList) {
            add( cur );
        }
    }

    synchronized  void add( com.mongodb.MongoCredential credentials )
    {
        com.mongodb.MongoCredential existingCredentials = credentialsMap.get( credentials.getSource() );
        if (existingCredentials != null) {
            if (existingCredentials.equals( credentials )) {
                return;
            }
            throw new java.lang.IllegalArgumentException( "Can't add more than one credentials for the same database" );
        }
        credentialsMap.put( credentials.getSource(), credentials );
        allDatabasesWithCredentials = new java.util.HashSet<String>( allDatabasesWithCredentials );
        allDatabasesWithCredentials.add( credentials.getSource() );
    }

    public  java.util.Set<String> getDatabases()
    {
        return Collections.unmodifiableSet( allDatabasesWithCredentials );
    }

    public synchronized  com.mongodb.MongoCredential get( java.lang.String database )
    {
        return credentialsMap.get( database );
    }

    public synchronized  java.util.List<MongoCredential> asList()
    {
        return new java.util.ArrayList<MongoCredential>( credentialsMap.values() );
    }

    public synchronized  boolean equals( final java.lang.Object o )
    {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final com.mongodb.MongoCredentialsStore that = (com.mongodb.MongoCredentialsStore) o;
        if (!credentialsMap.equals( that.credentialsMap )) {
            return false;
        }
        return true;
    }

    public synchronized  int hashCode()
    {
        return credentialsMap.hashCode();
    }

    public  java.lang.String toString()
    {
        return "{" + "credentials=" + credentialsMap + '}';
    }

}
