// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.util.annotations.Immutable;


final class MongoNamespace
{

    private static final java.lang.String NAMESPACE_TEMPLATE = "%s.%s";

    public static final java.lang.String COMMAND_COLLECTION_NAME = "$cmd";

    private final java.lang.String databaseName;

    private final java.lang.String collectionName;

    public MongoNamespace( final java.lang.String databaseName, final java.lang.String collectionName )
    {
        if (databaseName == null) {
            throw new java.lang.IllegalArgumentException( "database name can not be null" );
        }
        if (collectionName == null) {
            throw new java.lang.IllegalArgumentException( "Collection name can not be null" );
        }
        this.databaseName = databaseName;
        this.collectionName = collectionName;
    }

    public  java.lang.String getDatabaseName()
    {
        return databaseName;
    }

    public  java.lang.String getCollectionName()
    {
        return collectionName;
    }

    public  java.lang.String getFullName()
    {
        return getDatabaseName() + "." + getCollectionName();
    }

    public  boolean equals( final java.lang.Object o )
    {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final com.mongodb.MongoNamespace that = (com.mongodb.MongoNamespace) o;
        if (collectionName != null ? !collectionName.equals( that.collectionName ) : that.collectionName != null) {
            return false;
        }
        if (databaseName != null ? !databaseName.equals( that.databaseName ) : that.databaseName != null) {
            return false;
        }
        return true;
    }

    public  java.lang.String toString()
    {
        return databaseName + "." + collectionName;
    }

    public  int hashCode()
    {
        int result = databaseName != null ? databaseName.hashCode() : 0;
        result = 31 * result + (collectionName != null ? collectionName.hashCode() : 0);
        return result;
    }

    public static  java.lang.String asNamespaceString( final java.lang.String databaseName, final java.lang.String collectionName )
    {
        return String.format( NAMESPACE_TEMPLATE, databaseName, collectionName );
    }

}
