// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.io.Bits;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;


class Response
{

    Response( com.mongodb.ServerAddress addr, com.mongodb.DBCollection collection, java.io.InputStream in, com.mongodb.DBDecoder decoder )
        throws java.io.IOException
    {
        _host = addr;
        final byte[] b = new byte[36];
        Bits.readFully( in, b );
        int pos = 0;
        _len = Bits.readInt( b, pos );
        pos += 4;
        if (_len > MAX_LENGTH) {
            throw new java.lang.IllegalArgumentException( "response too long: " + _len );
        }
        _id = Bits.readInt( b, pos );
        pos += 4;
        _responseTo = Bits.readInt( b, pos );
        pos += 4;
        _operation = Bits.readInt( b, pos );
        pos += 4;
        _flags = Bits.readInt( b, pos );
        pos += 4;
        _cursor = Bits.readLong( b, pos );
        pos += 8;
        _startingFrom = Bits.readInt( b, pos );
        pos += 4;
        _num = Bits.readInt( b, pos );
        pos += 4;
        final com.mongodb.Response.MyInputStream user = new com.mongodb.Response.MyInputStream( in, _len - b.length );
        if (_num < 2) {
            _objects = new java.util.LinkedList<DBObject>();
        } else {
            _objects = new java.util.ArrayList<DBObject>( _num );
        }
        for (int i = 0; i < _num; i++) {
            if (user._toGo < 5) {
                throw new java.io.IOException( "should have more objects, but only " + user._toGo + " bytes left" );
            }
            _objects.add( decoder.decode( user, collection ) );
        }
        if (user._toGo != 0) {
            throw new java.io.IOException( "finished reading objects but still have: " + user._toGo + " bytes to read!' " );
        }
        if (_num != _objects.size()) {
            throw new java.lang.RuntimeException( "something is really broken" );
        }
    }

    public  int size()
    {
        return _num;
    }

    public  com.mongodb.ServerAddress serverUsed()
    {
        return _host;
    }

    public  com.mongodb.DBObject get( int i )
    {
        return _objects.get( i );
    }

    public  java.util.Iterator<DBObject> iterator()
    {
        return _objects.iterator();
    }

    public  boolean hasGetMore( int queryOptions )
    {
        if (_cursor == 0) {
            return false;
        }
        if (_num > 0) {
            return true;
        }
        if ((queryOptions & Bytes.QUERYOPTION_TAILABLE) == 0) {
            return false;
        }
        return true;
    }

    public  long cursor()
    {
        return _cursor;
    }

    public  com.mongodb.ServerError getError()
    {
        if (_num != 1) {
            return null;
        }
        com.mongodb.DBObject obj = get( 0 );
        if (ServerError.getMsg( obj, null ) == null) {
            return null;
        }
        return new com.mongodb.ServerError( obj );
    }

    static class MyInputStream extends java.io.InputStream
    {

        MyInputStream( java.io.InputStream in, int max )
        {
            _in = in;
            _toGo = max;
        }

        public  int available()
                throws java.io.IOException
        {
            return _in.available();
        }

        public  int read()
                throws java.io.IOException
        {
            if (_toGo <= 0) {
                return -1;
            }
            int val = _in.read();
            _toGo--;
            return val;
        }

        public  int read( byte[] b, int off, int len )
                throws java.io.IOException
        {
            if (_toGo <= 0) {
                return -1;
            }
            int n = _in.read( b, off, Math.min( _toGo, len ) );
            _toGo -= n;
            return n;
        }

        public  void close()
        {
            throw new java.lang.RuntimeException( "can't close thos" );
        }

        final java.io.InputStream _in;

        private int _toGo;

    }

    public  java.lang.String toString()
    {
        return "flags:" + _flags + " _cursor:" + _cursor + " _startingFrom:" + _startingFrom + " _num:" + _num;
    }

    final com.mongodb.ServerAddress _host;

    final int _len;

    final int _id;

    final int _responseTo;

    final int _operation;

    final int _flags;

    long _cursor;

    final int _startingFrom;

    final int _num;

    final java.util.List<DBObject> _objects;

    private static final int MAX_LENGTH = 32 * 1024 * 1024;

}
