// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.util.annotations.Immutable;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;


public class ServerAddress
{

    public ServerAddress()
        throws java.net.UnknownHostException
    {
        this( defaultHost(), defaultPort() );
    }

    public ServerAddress( java.lang.String host )
        throws java.net.UnknownHostException
    {
        this( host, defaultPort() );
    }

    public ServerAddress( java.lang.String host, int port )
        throws java.net.UnknownHostException
    {
        if (host == null) {
            host = defaultHost();
        }
        host = host.trim();
        if (host.length() == 0) {
            host = defaultHost();
        }
        int idx = host.indexOf( ":" );
        if (idx > 0) {
            if (port != defaultPort()) {
                throw new java.lang.IllegalArgumentException( "can't specify port in construct and via host" );
            }
            port = Integer.parseInt( host.substring( idx + 1 ) );
            host = host.substring( 0, idx ).trim();
        }
        _host = host;
        _port = port;
    }

    public ServerAddress( java.net.InetAddress addr )
    {
        this( new java.net.InetSocketAddress( addr, defaultPort() ) );
    }

    public ServerAddress( java.net.InetAddress addr, int port )
    {
        this( new java.net.InetSocketAddress( addr, port ) );
    }

    public ServerAddress( java.net.InetSocketAddress addr )
    {
        _host = addr.getHostName();
        _port = addr.getPort();
    }

    public  boolean sameHost( java.lang.String host )
    {
        int idx = host.indexOf( ":" );
        int port = defaultPort();
        if (idx > 0) {
            port = Integer.parseInt( host.substring( idx + 1 ) );
            host = host.substring( 0, idx );
        }
        return _port == port && _host.equalsIgnoreCase( host );
    }

    public  boolean equals( final java.lang.Object o )
    {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final com.mongodb.ServerAddress that = (com.mongodb.ServerAddress) o;
        if (_port != that._port) {
            return false;
        }
        if (!_host.equals( that._host )) {
            return false;
        }
        return true;
    }

    public  int hashCode()
    {
        int result = _host.hashCode();
        result = 31 * result + _port;
        return result;
    }

    public  java.lang.String getHost()
    {
        return _host;
    }

    public  int getPort()
    {
        return _port;
    }

    public  java.net.InetSocketAddress getSocketAddress()
        throws java.net.UnknownHostException
    {
        return new java.net.InetSocketAddress( InetAddress.getByName( _host ), _port );
    }

    public  java.lang.String toString()
    {
        return _host + ":" + _port;
    }

    final java.lang.String _host;

    final int _port;

    public static  java.lang.String defaultHost()
    {
        return "127.0.0.1";
    }

    public static  int defaultPort()
    {
        return DBPort.PORT;
    }

}
