// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.BSONObject;


public class ServerError
{

    ServerError( com.mongodb.DBObject o )
    {
        _err = getMsg( o, null );
        if (_err == null) {
            throw new java.lang.IllegalArgumentException( "need to have $err" );
        }
        _code = getCode( o );
    }

    static  java.lang.String getMsg( org.bson.BSONObject o, java.lang.String def )
    {
        java.lang.Object e = o.get( "$err" );
        if (e == null) {
            e = o.get( "err" );
        }
        if (e == null) {
            e = o.get( "errmsg" );
        }
        if (e == null) {
            return def;
        }
        return e.toString();
    }

    static  int getCode( org.bson.BSONObject o )
    {
        java.lang.Object c = o.get( "code" );
        if (c == null) {
            c = o.get( "$code" );
        }
        if (c == null) {
            c = o.get( "assertionCode" );
        }
        if (c == null) {
            return -5;
        }
        return ((java.lang.Number) c).intValue();
    }

    public  java.lang.String getError()
    {
        return _err;
    }

    public  int getCode()
    {
        return _code;
    }

    public  boolean isNotMasterError()
    {
        switch (_code) {
        case 10054 :
        case 10056 :
        case 10058 :
        case 10107 :
        case 13435 :
        case 13436 :
            return true;

        }
        return _err.startsWith( "not master" );
    }

    public  java.lang.String toString()
    {
        if (_code > 0) {
            return _code + " " + _err;
        }
        return _err;
    }

    final java.lang.String _err;

    final int _code;

}
