// This is a mutant program.
// Author : ysma

package com.mongodb;


import javax.net.SocketFactory;
import java.util.concurrent.TimeUnit;
import static java.util.concurrent.TimeUnit.MILLISECONDS;
import static org.bson.util.Assertions.notNull;


final class SocketSettings
{

    private final long connectTimeoutMS;

    private final long readTimeoutMS;

    private final javax.net.SocketFactory socketFactory;

    public static  com.mongodb.SocketSettings.Builder builder()
    {
        return new com.mongodb.SocketSettings.Builder();
    }

    public static class Builder
    {

        private long connectTimeoutMS;

        private long readTimeoutMS;

        private javax.net.SocketFactory socketFactory = SocketFactory.getDefault();

        public  com.mongodb.SocketSettings.Builder connectTimeout( final int connectTimeout, final java.util.concurrent.TimeUnit timeUnit )
        {
            this.connectTimeoutMS = MILLISECONDS.convert( connectTimeout, timeUnit );
            return this;
        }

        public  com.mongodb.SocketSettings.Builder readTimeout( final int readTimeout, final java.util.concurrent.TimeUnit timeUnit )
        {
            this.readTimeoutMS = MILLISECONDS.convert( readTimeout, timeUnit );
            return this;
        }

        public  com.mongodb.SocketSettings.Builder socketFactory( final javax.net.SocketFactory socketFactory )
        {
            this.socketFactory = org.bson.util.Assertions.notNull( "socketFactory", socketFactory );
            return this;
        }

        public  com.mongodb.SocketSettings build()
        {
            return new com.mongodb.SocketSettings( this );
        }

    }

    public  int getConnectTimeout( final java.util.concurrent.TimeUnit timeUnit )
    {
        return (int) timeUnit.convert( connectTimeoutMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  int getReadTimeout( final java.util.concurrent.TimeUnit timeUnit )
    {
        return (int) timeUnit.convert( readTimeoutMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  javax.net.SocketFactory getSocketFactory()
    {
        return socketFactory;
    }

    SocketSettings( final com.mongodb.SocketSettings.Builder builder )
    {
        connectTimeoutMS = builder.connectTimeoutMS;
        readTimeoutMS = builder.readTimeoutMS;
        socketFactory = builder.socketFactory;
    }

}
