// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.io.OutputBuffer;
import java.util.List;


class UpdateCommandMessage extends com.mongodb.BaseWriteCommandMessage
{

    private final java.util.List<Update> updates;

    private final com.mongodb.DBEncoder encoder;

    public UpdateCommandMessage( final com.mongodb.MongoNamespace writeNamespace, final com.mongodb.WriteConcern writeConcern, final java.util.List<Update> updates, final com.mongodb.DBEncoder commandEncoder, final com.mongodb.DBEncoder encoder, final com.mongodb.MessageSettings settings )
    {
        super( writeNamespace, writeConcern, commandEncoder, settings );
        this.updates = updates;
        this.encoder = encoder;
    }

    protected  com.mongodb.UpdateCommandMessage writeTheWrites( final org.bson.io.OutputBuffer buffer, final int commandStartPosition, final com.mongodb.BSONBinaryWriter writer )
    {
        com.mongodb.UpdateCommandMessage nextMessage = null;
        writer.writeStartArray( "updates" );
        for (int i = 0; i < updates.size(); i++) {
            writer.mark();
            com.mongodb.Update update = updates.get( i );
            writer.writeStartDocument();
            writer.pushMaxDocumentSize( getSettings().getMaxDocumentSize() );
            writer.writeName( "q" );
            writer.encodeDocument( getCommandEncoder(), update.getFilter() );
            writer.writeName( "u" );
            writer.encodeDocument( encoder, update.getUpdateOperations() );
            writer.writeBoolean( "multi", update.isMulti() );
            writer.writeBoolean( "upsert", update.isUpsert() );
            writer.popMaxDocumentSize();
            writer.writeEndDocument();
            if (maximumCommandDocumentSizeExceeded( buffer, commandStartPosition )) {
                writer.reset();
                nextMessage = new com.mongodb.UpdateCommandMessage( getWriteNamespace(), getWriteConcern(), updates.subList( i, updates.size() ), getCommandEncoder(), encoder, getSettings() );
                break;
            }
        }
        writer.writeEndArray();
        return nextMessage;
    }

    protected  java.lang.String getCommandName()
    {
        return "update";
    }

}
