// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.io.IOException;


public class WriteResult
{

    WriteResult( com.mongodb.CommandResult o, com.mongodb.WriteConcern concern )
    {
        _lastErrorResult = o;
        _lastConcern = concern;
        _lazy = false;
        _port = null;
        _db = null;
    }

    WriteResult( com.mongodb.DB db, com.mongodb.DBPort p, com.mongodb.WriteConcern concern )
    {
        _db = db;
        _port = p;
        _lastCall = p._calls.get();
        _lastConcern = concern;
        _lazy = true;
    }

    public  com.mongodb.CommandResult getCachedLastError()
    {
        return _lastErrorResult;
    }

    public  com.mongodb.WriteConcern getLastConcern()
    {
        return _lastConcern;
    }

    public synchronized  com.mongodb.CommandResult getLastError()
    {
        return getLastError( null );
    }

    public synchronized  com.mongodb.CommandResult getLastError( com.mongodb.WriteConcern concern )
    {
        if (_lastErrorResult != null) {
            if (concern == null || _lastConcern != null && _lastConcern.getW() >= concern.getW()) {
                return _lastErrorResult;
            }
        }
        if (_port != null) {
            try {
                _lastErrorResult = _port.tryGetLastError( _db, _lastCall, concern == null ? new com.mongodb.WriteConcern() : concern );
            } catch ( java.io.IOException ioe ) {
                throw new com.mongodb.MongoException.Network( ioe.getMessage(), ioe );
            }
            if (_lastErrorResult == null) {
                throw new java.lang.IllegalStateException( "The connection may have been used since this write, cannot obtain a result" );
            }
            _lastConcern = concern;
            _lastCall++;
        } else {
            throw new java.lang.IllegalStateException( "Don't have a port to obtain a write result, and existing one is not good enough." );
        }
        return _lastErrorResult;
    }

    public  java.lang.String getError()
    {
        java.lang.Object foo = getField( "err" );
        if (foo == null) {
            return null;
        }
        return foo.toString();
    }

    public  int getN()
    {
        return getLastError().getInt( "n" );
    }

    public  java.lang.Object getField( java.lang.String name )
    {
        return getLastError().get( name );
    }

    public  boolean isLazy()
    {
        return _lazy;
    }

    public  java.lang.String toString()
    {
        com.mongodb.CommandResult res = getCachedLastError();
        if (res != null) {
            return res.toString();
        }
        return "N/A";
    }

    private long _lastCall;

    private com.mongodb.WriteConcern _lastConcern;

    private com.mongodb.CommandResult _lastErrorResult;

    private final com.mongodb.DB _db;

    private final com.mongodb.DBPort _port;

    private final boolean _lazy;

}
