// This is a mutant program.
// Author : ysma

package com.mongodb.io;


import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;


public class ByteBufferOutputStream extends java.io.OutputStream
{

    public ByteBufferOutputStream()
    {
        this( _defaultFactory );
    }

    public ByteBufferOutputStream( int size )
    {
        this( new com.mongodb.io.ByteBufferFactory.SimpleHeapByteBufferFactory( size ) );
    }

    public ByteBufferOutputStream( com.mongodb.io.ByteBufferFactory factory )
    {
        _factory = factory;
    }

    public  void close()
    {
    }

    public  void flush()
    {
    }

    public  void write( byte[] b )
    {
        write( b, 0, b.length );
    }

    public  void write( byte[] b, int off, int len )
    {
        java.nio.ByteBuffer cur = _need( 1 );
        int toWrite = Math.min( len, cur.remaining() );
        cur.put( b, off, toWrite );
        if (toWrite == len) {
            return;
        }
        write( b, off + toWrite, len - toWrite );
    }

    public  void write( int b )
    {
        _need( 1 ).put( (byte) b );
    }

    public  java.util.List<ByteBuffer> getBuffers()
    {
        return _lst;
    }

    public  java.util.List<ByteBuffer> getBuffers( boolean flip )
    {
        if (flip) {
            for (java.nio.ByteBuffer buf: _lst) {
                buf.flip();
            }
        }
        return _lst;
    }

    private  java.nio.ByteBuffer _need( int space )
    {
        if (_lst.size() == 0) {
            _lst.add( _factory.get() );
            return _lst.get( 0 );
        }
        java.nio.ByteBuffer cur = _lst.get( _lst.size() - 1 );
        if (space <= cur.remaining()) {
            return cur;
        }
        _lst.add( _factory.get() );
        return _lst.get( _lst.size() - 1 );
    }

    final java.util.List<ByteBuffer> _lst = new java.util.ArrayList<ByteBuffer>();

    final com.mongodb.io.ByteBufferFactory _factory;

    static final com.mongodb.io.ByteBufferFactory _defaultFactory = new com.mongodb.io.ByteBufferFactory.SimpleHeapByteBufferFactory( 1024 * 4 );

}
