// This is a mutant program.
// Author : ysma

package com.mongodb.util;


public final class Hash
{

    public static final  int hashBackward( java.lang.String s )
    {
        int hash = 0;
        for (int i = s.length() - 1; i >= 0; i--) {
            hash = hash * 31 + s.charAt( i );
        }
        return hash;
    }

    public static final  long hashBackwardLong( java.lang.String s )
    {
        long hash = 0;
        for (int i = s.length() - 1; i >= 0; i--) {
            hash = hash * 63 + s.charAt( i );
        }
        return hash;
    }

    static final long _longHashConstant = 4095;

    public static final  long longHash( java.lang.String s )
    {
        return longHash( s, 0, s.length() );
    }

    public static final  long longHash( java.lang.String s, int start, int end )
    {
        long hash = 0;
        for (; start < end; start++) {
            hash = _longHashConstant * hash + s.charAt( start );
        }
        return hash;
    }

    public static final  long longLowerHash( java.lang.String s )
    {
        return longLowerHash( s, 0, s.length() );
    }

    public static final  long longLowerHash( java.lang.String s, int start, int end )
    {
        long hash = 0;
        for (; start < end; start++) {
            hash = _longHashConstant * hash + Character.toLowerCase( s.charAt( start ) );
        }
        return hash;
    }

    public static final  long longLowerHash( java.lang.String s, int start, int end, long hash )
    {
        for (; start < end; start++) {
            hash = _longHashConstant * hash + Character.toLowerCase( s.charAt( start ) );
        }
        return hash;
    }

    public static final  long longLowerHashAppend( long hash, char c )
    {
        return hash * _longHashConstant + Character.toLowerCase( c );
    }

    public static final  long longHashAppend( long hash, char c )
    {
        return hash * _longHashConstant + c;
    }

    public static final  int lowerCaseHash( java.lang.String s )
    {
        int h = 0;
        final int len = s.length();
        for (int i = 0; i < len; i++) {
            h = 31 * h + Character.toLowerCase( s.charAt( i ) );
        }
        return h;
    }

    public static final  int lowerCaseHash( java.lang.String s, int start, int end )
    {
        int h = 0;
        final int len = s.length();
        for (int i = start; i < len && i < end; i++) {
            h = 31 * h + Character.toLowerCase( s.charAt( i ) );
        }
        return h;
    }

    public static final  int hashCode( java.lang.CharSequence s, int start, int end )
    {
        int h = 0;
        final int len = s.length();
        for (int i = start; i < len && i < end; i++) {
            h = 31 * h + s.charAt( i );
        }
        return h;
    }

    public static final  int nospaceLowerHash( java.lang.String s, int start, int end )
    {
        int h = 0;
        final int len = s.length();
        for (int i = start; i < len && i < end; i++) {
            char c = s.charAt( i );
            if (Character.isWhitespace( c )) {
                continue;
            }
            h = 31 * h + Character.toLowerCase( c );
        }
        return h;
    }

    public static final  int lowerCaseSpaceTrimHash( java.lang.String s )
    {
        int h = 0;
        int len = s.length();
        while (len > 1 && Character.isWhitespace( s.charAt( len - 1 ) )) {
            len--;
        }
        boolean lastWasSpace = true;
        for (int i = 0; i < len; i++) {
            boolean isSpace = Character.isWhitespace( s.charAt( i ) );
            if (isSpace && lastWasSpace) {
                continue;
            }
            lastWasSpace = isSpace;
            h = 31 * h + Character.toLowerCase( s.charAt( i ) );
        }
        return h;
    }

    public static final  int lowerCaseSpaceTrimHash( java.lang.String s, int start, int end )
    {
        int h = 0;
        int len = s.length();
        while (len > 1 && Character.isWhitespace( s.charAt( len - 1 ) )) {
            len--;
        }
        boolean lastWasSpace = true;
        for (int i = start; i < len && i < end; i++) {
            boolean isSpace = Character.isWhitespace( s.charAt( i ) );
            if (isSpace && lastWasSpace) {
                continue;
            }
            lastWasSpace = isSpace;
            h = 31 * h + Character.toLowerCase( s.charAt( i ) );
        }
        return h;
    }

    public static final  int hashCode( java.lang.String... strings )
    {
        int h = 0;
        for (java.lang.String s: strings) {
            int len = s.length();
            for (int i = 0; i < len; i++) {
                h = 31 * h + s.charAt( i );
            }
        }
        return h;
    }

}
