// This is a mutant program.
// Author : ysma

package com.mongodb.util;


import com.mongodb.BasicDBList;
import com.mongodb.BasicDBObject;
import com.mongodb.DBObject;
import com.mongodb.DBRef;
import org.bson.BSON;
import org.bson.BSONObject;
import org.bson.BasicBSONCallback;
import org.bson.types.*;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.SimpleTimeZone;
import java.util.UUID;
import java.util.regex.Pattern;


public class JSONCallback extends org.bson.BasicBSONCallback
{

    public  org.bson.BSONObject create()
    {
        return new com.mongodb.BasicDBObject();
    }

    protected  org.bson.BSONObject createList()
    {
        return new com.mongodb.BasicDBList();
    }

    public  void objectStart( boolean array, java.lang.String name )
    {
        _lastArray = array;
        super.objectStart( array, name );
    }

    public  java.lang.Object objectDone()
    {
        java.lang.String name = curName();
        java.lang.Object o = super.objectDone();
        if (_lastArray) {
            return o;
        }
        org.bson.BSONObject b = (org.bson.BSONObject) o;
        if (b.containsField( "$oid" )) {
            o = new org.bson.types.ObjectId( (java.lang.String) b.get( "$oid" ) );
        } else {
            if (b.containsField( "$date" )) {
                if (b.get( "$date" ) instanceof java.lang.Number) {
                    o = new java.util.Date( ((java.lang.Number) b.get( "$date" )).longValue() );
                } else {
                    java.text.SimpleDateFormat format = new java.text.SimpleDateFormat( _msDateFormat );
                    format.setCalendar( new java.util.GregorianCalendar( new java.util.SimpleTimeZone( 0, "GMT" ) ) );
                    o = format.parse( b.get( "$date" ).toString(), new java.text.ParsePosition( 0 ) );
                    if (o == null) {
                        format = new java.text.SimpleDateFormat( _secDateFormat );
                        format.setCalendar( new java.util.GregorianCalendar( new java.util.SimpleTimeZone( 0, "GMT" ) ) );
                        o = format.parse( b.get( "$date" ).toString(), new java.text.ParsePosition( 0 ) );
                    }
                }
            } else {
                if (b.containsField( "$regex" )) {
                    o = Pattern.compile( (java.lang.String) b.get( "$regex" ), BSON.regexFlags( (java.lang.String) b.get( "$options" ) ) );
                } else {
                    if (b.containsField( "$ts" )) {
                        java.lang.Integer ts = ((java.lang.Number) b.get( "$ts" )).intValue();
                        java.lang.Integer inc = ((java.lang.Number) b.get( "$inc" )).intValue();
                        o = new org.bson.types.BSONTimestamp( ts, inc );
                    } else {
                        if (b.containsField( "$timestamp" )) {
                            org.bson.BSONObject tsObject = (org.bson.BSONObject) b.get( "$timestamp" );
                            java.lang.Integer ts = ((java.lang.Number) tsObject.get( "t" )).intValue();
                            java.lang.Integer inc = ((java.lang.Number) tsObject.get( "i" )).intValue();
                            o = new org.bson.types.BSONTimestamp( ts, inc );
                        } else {
                            if (b.containsField( "$code" )) {
                                if (b.containsField( "$scope" )) {
                                    o = new org.bson.types.CodeWScope( (java.lang.String) b.get( "$code" ), (com.mongodb.DBObject) b.get( "$scope" ) );
                                } else {
                                    o = new org.bson.types.Code( (java.lang.String) b.get( "$code" ) );
                                }
                            } else {
                                if (b.containsField( "$ref" )) {
                                    o = new com.mongodb.DBRef( null, (java.lang.String) b.get( "$ref" ), b.get( "$id" ) );
                                } else {
                                    if (b.containsField( "$minKey" )) {
                                        o = new org.bson.types.MinKey();
                                    } else {
                                        if (b.containsField( "$maxKey" )) {
                                            o = new org.bson.types.MaxKey();
                                        } else {
                                            if (b.containsField( "$uuid" )) {
                                                o = UUID.fromString( (java.lang.String) b.get( "$uuid" ) );
                                            } else {
                                                if (b.containsField( "$binary" )) {
                                                    int type = (java.lang.Integer) b.get( "$type" );
                                                    byte[] bytes = (new com.mongodb.util.Base64Codec()).decode( (java.lang.String) b.get( "$binary" ) );
                                                    o = new org.bson.types.Binary( (byte) type, bytes );
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        if (!isStackEmpty()) {
            _put( name, o );
        } else {
            o = !BSON.hasDecodeHooks() ? o : BSON.applyDecodingHooks( o );
            setRoot( o );
        }
        return o;
    }

    private boolean _lastArray = false;

    public static final java.lang.String _msDateFormat = "yyyy-MM-dd'T'HH:mm:ss.SSS'Z'";

    public static final java.lang.String _secDateFormat = "yyyy-MM-dd'T'HH:mm:ss'Z'";

}
