package com.mongodb;



import java.lang.Object;
import com.mongodb.MongoCredential;
import java.util.List;
import org.bson.util.StringRangeSet;
import java.lang.String;
import java.util.Set;
import java.util.Arrays;
import org.testng.annotations.Test;
import com.mongodb.util.TestCase;


public class MongoCredentialsStoreGenTest extends TestCase{
	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore670() throws Exception {
		List<MongoCredential> var889;
		char[] var890 = "pwd".toCharArray();
		MongoCredential var891 = MongoCredential.createMongoCRCredential(
				"user", "db1", var890);
		MongoCredential var892 = MongoCredential.createMongoCRCredential(
				"user", "db2", var890);
		var889 = Arrays.asList(var891, var892);
		MongoCredentialsStore var893 = new MongoCredentialsStore(var889);
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore671() throws Exception {
		List<MongoCredential> var889;
		char[] var890 = "pwd".toCharArray();
		MongoCredential var891 = MongoCredential.createMongoCRCredential(
				"user", "db1", var890);
		MongoCredential var892 = MongoCredential.createMongoCRCredential(
				"user", "db2", var890);
		var889 = Arrays.asList(var891, var892);
		MongoCredentialsStore var893 = new MongoCredentialsStore(var889);
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore672() throws Exception {
		List<MongoCredential> var889;
		char[] var890 = "pwd".toCharArray();
		MongoCredential var891 = MongoCredential.createMongoCRCredential(
				"user", "db1", var890);
		MongoCredential var892 = MongoCredential.createMongoCRCredential(
				"user", "db2", var890);
		var889 = Arrays.asList(var891, var892);
		MongoCredentialsStore var893 = new MongoCredentialsStore(var889);
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
	}

	public StringRangeSet instantiateStringRangeSet88() {
		int var895 = 250;
		return new StringRangeSet(var895);
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	//@Test
	public void testMongoCredentialsStore673() throws Exception {
		StringRangeSet var896 = instantiateStringRangeSet88();
		List<MongoCredential> var889;
		char[] var890 = "pwd".toCharArray();
		MongoCredential var891 = MongoCredential.createMongoCRCredential(
				"user", "db1", var890);
		MongoCredential var892 = MongoCredential.createMongoCRCredential(
				"user", "db2", var890);
		var889 = Arrays.asList(var891, var892);
		var889 = Arrays
				.asList(var891, MongoCredential.createMongoCRCredential(
						"user2", "db1", var890));
		MongoCredentialsStore var893 = new MongoCredentialsStore(var889);
		var896.toArray();
		var896.toArray();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore674() throws Exception {
		List<MongoCredential> var889;
		char[] var890 = "pwd".toCharArray();
		MongoCredential var891 = MongoCredential.createMongoCRCredential(
				"user", "db1", var890);
		MongoCredential var892 = MongoCredential.createMongoCRCredential(
				"user", "db2", var890);
		var889 = Arrays.asList(var891, var892);
		MongoCredentialsStore var893 = new MongoCredentialsStore(var889);
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
		var893.getDatabases();
		var893.get("db1");
		var893.get("db2");
		var893.get("db3");
		var893.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore680() throws Exception {
		char[] var903 = "pwd".toCharArray();
		MongoCredential var904 = MongoCredential.createMongoCRCredential(
				"user", "admin", var903);
		MongoCredentialsStore var905 = new MongoCredentialsStore(var904);
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
		var905.getDatabases();
		var905.get("test");
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore681() throws Exception {
		char[] var903 = "pwd".toCharArray();
		MongoCredential var904 = MongoCredential.createMongoCRCredential(
				"user", "admin", var903);
		MongoCredentialsStore var905 = new MongoCredentialsStore(var904);
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore682() throws Exception {
		char[] var903 = "pwd".toCharArray();
		MongoCredential var904 = MongoCredential.createMongoCRCredential(
				"user", "admin", var903);
		MongoCredentialsStore var905 = new MongoCredentialsStore(var904);
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
		var905.getDatabases();
		var905.get("test");
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore683() throws Exception {
		char[] var903 = "pwd".toCharArray();
		MongoCredential var904 = MongoCredential.createMongoCRCredential(
				"user", "admin", var903);
		MongoCredentialsStore var905 = new MongoCredentialsStore(var904);
		var905.getDatabases();
		var905.get("test");
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
		var905.getDatabases();
		var905.get("admin");
		var905.get("test");
		var905.getDatabases();
		var905.get("db1");
		var905.get("db2");
		var905.get("db3");
		var905.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore684() throws Exception {
		MongoCredentialsStore var907 = new MongoCredentialsStore(
				(MongoCredential) null);
		var907.getDatabases();
		var907.get("admin");
		var907.get("test");
		var907.getDatabases();
		var907.get("db1");
		var907.get("db2");
		var907.get("db3");
		var907.asList();
		var907.getDatabases();
		var907.get("admin");
		var907.get("test");
		var907.getDatabases();
		var907.get("db1");
		var907.get("db2");
		var907.get("db3");
		var907.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore685() throws Exception {
		MongoCredentialsStore var908 = new MongoCredentialsStore();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore686() throws Exception {
		MongoCredentialsStore var908 = new MongoCredentialsStore();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore687() throws Exception {
		MongoCredentialsStore var908 = new MongoCredentialsStore();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore688() throws Exception {
		MongoCredentialsStore var908 = new MongoCredentialsStore();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
	}

	/**
	 * Test method for the class com.mongodb.MongoCredentialsStore
	 */
	@Test
	public void testMongoCredentialsStore689() throws Exception {
		MongoCredentialsStore var908 = new MongoCredentialsStore();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("test");
		var908.getDatabases();
		var908.get("admin");
		var908.get("test");
		var908.getDatabases();
		var908.get("db1");
		var908.get("db2");
		var908.get("db3");
		var908.asList();
	}
}