// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Constructor;


public class AntTypeDefinition
{

    private java.lang.String name;

    private java.lang.Class clazz;

    private java.lang.Class adapterClass;

    private java.lang.Class adaptToClass;

    private java.lang.String className;

    private java.lang.ClassLoader classLoader;

    private boolean restrict = false;

    public  void setRestrict( boolean restrict )
    {
        this.restrict = restrict;
    }

    public  boolean isRestrict()
    {
        return restrict;
    }

    public  void setName( java.lang.String name )
    {
        this.name = name;
    }

    public  java.lang.String getName()
    {
        return name;
    }

    public  void setClass( java.lang.Class clazz )
    {
        this.clazz = clazz;
        if (clazz == null) {
            return;
        }
        this.classLoader = classLoader == null ? clazz.getClassLoader() : classLoader;
        this.className = className == null ? clazz.getName() : className;
    }

    public  void setClassName( java.lang.String className )
    {
        this.className = className;
    }

    public  java.lang.String getClassName()
    {
        return className;
    }

    public  void setAdapterClass( java.lang.Class adapterClass )
    {
        this.adapterClass = adapterClass;
    }

    public  void setAdaptToClass( java.lang.Class adaptToClass )
    {
        this.adaptToClass = adaptToClass;
    }

    public  void setClassLoader( java.lang.ClassLoader classLoader )
    {
        this.classLoader = classLoader;
    }

    public  java.lang.ClassLoader getClassLoader()
    {
        return classLoader;
    }

    public  java.lang.Class getExposedClass( org.apache.tools.ant.Project project )
    {
        if (adaptToClass != null) {
            java.lang.Class z = getTypeClass( project );
            if (z == null || adaptToClass.isAssignableFrom( z )) {
                return z;
            }
        }
        return adapterClass == null ? getTypeClass( project ) : adapterClass;
    }

    public  java.lang.Class getTypeClass( org.apache.tools.ant.Project project )
    {
        try {
            return innerGetTypeClass();
        } catch ( java.lang.NoClassDefFoundError ncdfe ) {
            project.log( "Could not load a dependent class (" + ncdfe.getMessage() + ") for type " + name, Project.MSG_DEBUG );
        } catch ( java.lang.ClassNotFoundException cnfe ) {
            project.log( "Could not load class (" + className + ") for type " + name, Project.MSG_DEBUG );
        }
        return null;
    }

    public  java.lang.Class innerGetTypeClass()
        throws java.lang.ClassNotFoundException
    {
        if (clazz != null) {
            return clazz;
        }
        if (classLoader == null) {
            clazz = Class.forName( className );
        } else {
            clazz = classLoader.loadClass( className );
        }
        return clazz;
    }

    public  java.lang.Object create( org.apache.tools.ant.Project project )
    {
        return icreate( project );
    }

    private  java.lang.Object icreate( org.apache.tools.ant.Project project )
    {
        java.lang.Class c = getTypeClass( project );
        if (c == null) {
            return null;
        }
        java.lang.Object o = createAndSet( project, c );
        if (o == null || adapterClass == null) {
            return o;
        }
        if (adaptToClass != null) {
            if (adaptToClass.isAssignableFrom( o.getClass() )) {
                return o;
            }
        }
        org.apache.tools.ant.TypeAdapter adapterObject = (org.apache.tools.ant.TypeAdapter) createAndSet( project, adapterClass );
        if (adapterObject == null) {
            return null;
        }
        adapterObject.setProxy( o );
        return adapterObject;
    }

    public  void checkClass( org.apache.tools.ant.Project project )
    {
        if (clazz == null) {
            clazz = getTypeClass( project );
            if (clazz == null) {
                throw new org.apache.tools.ant.BuildException( "Unable to create class for " + getName() );
            }
        }
        if (adapterClass != null && (adaptToClass == null || !adaptToClass.isAssignableFrom( clazz ))) {
            org.apache.tools.ant.TypeAdapter adapter = (org.apache.tools.ant.TypeAdapter) createAndSet( project, adapterClass );
            if (adapter == null) {
                throw new org.apache.tools.ant.BuildException( "Unable to create adapter object" );
            }
            adapter.checkProxyClass( clazz );
        }
    }

    private  java.lang.Object createAndSet( org.apache.tools.ant.Project project, java.lang.Class c )
    {
        try {
            java.lang.Object o = innerCreateAndSet( c, project );
            return o;
        } catch ( java.lang.reflect.InvocationTargetException ex ) {
            java.lang.Throwable t = ex.getTargetException();
            throw new org.apache.tools.ant.BuildException( "Could not create type " + name + " due to " + t, t );
        } catch ( java.lang.NoClassDefFoundError ncdfe ) {
            java.lang.String msg = "Type " + name + ": A class needed by class " + c + " cannot be found: " + ncdfe.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, ncdfe );
        } catch ( java.lang.NoSuchMethodException nsme ) {
            throw new org.apache.tools.ant.BuildException( "Could not create type " + name + " as the class " + c + " has no compatible constructor" );
        } catch ( java.lang.InstantiationException nsme ) {
            throw new org.apache.tools.ant.BuildException( "Could not create type " + name + " as the class " + c + " is abstract" );
        } catch ( java.lang.IllegalAccessException e ) {
            throw new org.apache.tools.ant.BuildException( "Could not create type " + name + " as the constructor " + c + " is not accessible" );
        } catch ( java.lang.Throwable t ) {
            throw new org.apache.tools.ant.BuildException( "Could not create type " + name + " due to " + t, t );
        }
    }

    public  java.lang.Object innerCreateAndSet( java.lang.Class newclass, org.apache.tools.ant.Project project )
        throws java.lang.NoSuchMethodException, java.lang.InstantiationException, java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException
    {
        java.lang.reflect.Constructor ctor = null;
        boolean noArg = false;
        try {
            ctor = newclass.getConstructor( new java.lang.Class[0] );
            noArg = true;
        } catch ( java.lang.NoSuchMethodException nse ) {
            ctor = newclass.getConstructor( new java.lang.Class[]{ org.apache.tools.ant.Project.class } );
            noArg = false;
        }
        java.lang.Object o = ctor.newInstance( noArg ? new java.lang.Object[0] : new java.lang.Object[]{ project } );
        project.setProjectReference( o );
        return o;
    }

    public  boolean sameDefinition( org.apache.tools.ant.AntTypeDefinition other, org.apache.tools.ant.Project project )
    {
        return other != null && other.getClass() == getClass() && other.getTypeClass( project ).equals( getTypeClass( project ) ) && other.getExposedClass( project ).equals( getExposedClass( project ) ) && other.restrict == restrict && other.adapterClass == adapterClass && other.adaptToClass == adaptToClass;
    }

    public  boolean similarDefinition( org.apache.tools.ant.AntTypeDefinition other, org.apache.tools.ant.Project project )
    {
        if (other == null || getClass() != other.getClass() || !getClassName().equals( other.getClassName() ) || !extractClassname( adapterClass ).equals( extractClassname( other.adapterClass ) ) || !extractClassname( adaptToClass ).equals( extractClassname( other.adaptToClass ) ) || restrict != other.restrict) {
            return false;
        }
        java.lang.ClassLoader oldLoader = other.getClassLoader();
        java.lang.ClassLoader newLoader = getClassLoader();
        return oldLoader == newLoader || oldLoader instanceof org.apache.tools.ant.AntClassLoader && newLoader instanceof org.apache.tools.ant.AntClassLoader && ((org.apache.tools.ant.AntClassLoader) oldLoader).getClasspath().equals( ((org.apache.tools.ant.AntClassLoader) newLoader).getClasspath() );
    }

    private  java.lang.String extractClassname( java.lang.Class c )
    {
        return c == null ? "<null>" : c.getClass().getName();
    }

}
