// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.WeakHashMap;


public class DemuxOutputStream extends java.io.OutputStream
{

    private static class BufferInfo
    {

        private java.io.ByteArrayOutputStream buffer;

        private boolean crSeen = false;

    }

    private static final int MAX_SIZE = 1024;

    private static final int INTIAL_SIZE = 132;

    private static final int CR = 0x0d;

    private static final int LF = 0x0a;

    private java.util.WeakHashMap buffers = new java.util.WeakHashMap();

    private org.apache.tools.ant.Project project;

    private boolean isErrorStream;

    public DemuxOutputStream( org.apache.tools.ant.Project project, boolean isErrorStream )
    {
        this.project = project;
        this.isErrorStream = isErrorStream;
    }

    private  org.apache.tools.ant.DemuxOutputStream.BufferInfo getBufferInfo()
    {
        java.lang.Thread current = Thread.currentThread();
        org.apache.tools.ant.DemuxOutputStream.BufferInfo bufferInfo = (org.apache.tools.ant.DemuxOutputStream.BufferInfo) buffers.get( current );
        if (bufferInfo == null) {
            bufferInfo = new org.apache.tools.ant.DemuxOutputStream.BufferInfo();
            bufferInfo.buffer = new java.io.ByteArrayOutputStream( INTIAL_SIZE );
            bufferInfo.crSeen = false;
            buffers.put( current, bufferInfo );
        }
        return bufferInfo;
    }

    private  void resetBufferInfo()
    {
        java.lang.Thread current = Thread.currentThread();
        org.apache.tools.ant.DemuxOutputStream.BufferInfo bufferInfo = (org.apache.tools.ant.DemuxOutputStream.BufferInfo) buffers.get( current );
        try {
            bufferInfo.buffer.close();
        } catch ( java.io.IOException e ) {
        }
        bufferInfo.buffer = new java.io.ByteArrayOutputStream();
        bufferInfo.crSeen = false;
    }

    private  void removeBuffer()
    {
        java.lang.Thread current = Thread.currentThread();
        buffers.remove( current );
    }

    public  void write( int cc )
        throws java.io.IOException
    {
        final byte c = (byte) cc;
        org.apache.tools.ant.DemuxOutputStream.BufferInfo bufferInfo = getBufferInfo();
        if (c == '\n') {
            bufferInfo.buffer.write( cc );
            processBuffer( bufferInfo.buffer );
        } else {
            if (bufferInfo.crSeen) {
                processBuffer( bufferInfo.buffer );
            }
            bufferInfo.buffer.write( cc );
        }
        bufferInfo.crSeen = c == '\r';
        if (!bufferInfo.crSeen && bufferInfo.buffer.size() > MAX_SIZE) {
            processBuffer( bufferInfo.buffer );
        }
    }

    protected  void processBuffer( java.io.ByteArrayOutputStream buffer )
    {
        java.lang.String output = buffer.toString();
        project.demuxOutput( output, isErrorStream );
        resetBufferInfo();
    }

    protected  void processFlush( java.io.ByteArrayOutputStream buffer )
    {
        java.lang.String output = buffer.toString();
        project.demuxFlush( output, isErrorStream );
        resetBufferInfo();
    }

    public  void close()
        throws java.io.IOException
    {
        flush();
        removeBuffer();
    }

    public  void flush()
        throws java.io.IOException
    {
        org.apache.tools.ant.DemuxOutputStream.BufferInfo bufferInfo = getBufferInfo();
        if (bufferInfo.buffer.size() > 0) {
            processFlush( bufferInfo.buffer );
        }
    }

    public  void write( byte[] b, int off, int len )
        throws java.io.IOException
    {
        int offset = off;
        int blockStartOffset = offset;
        int remaining = len;
        org.apache.tools.ant.DemuxOutputStream.BufferInfo bufferInfo = getBufferInfo();
        while (remaining > 0) {
            while (remaining > 0 && b[offset] != LF && b[offset] != CR) {
                offset++;
                remaining--;
            }
            int blockLength = offset - blockStartOffset;
            if (blockLength > 0) {
                bufferInfo.buffer.write( b, blockStartOffset, blockLength );
            }
            while (remaining > 0 && (b[offset] == LF || b[offset] == CR)) {
                write( b[offset] );
                offset++;
                remaining--;
            }
            blockStartOffset = offset;
        }
    }

}
