// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import org.apache.tools.ant.types.EnumeratedAttribute;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.resources.FileProvider;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.taskdefs.PreSetDef;
import org.apache.tools.ant.util.StringUtils;


public final class IntrospectionHelper
{

    private static final java.util.Map HELPERS = new java.util.Hashtable();

    private static final java.util.Map PRIMITIVE_TYPE_MAP = new java.util.HashMap( 8 );

    static {
        java.lang.Class[] primitives = { Boolean.TYPE, Byte.TYPE, Character.TYPE, Short.TYPE, Integer.TYPE, Long.TYPE, Float.TYPE, Double.TYPE };
        java.lang.Class[] wrappers = { java.lang.Boolean.class, java.lang.Byte.class, java.lang.Character.class, java.lang.Short.class, java.lang.Integer.class, java.lang.Long.class, java.lang.Float.class, java.lang.Double.class };
        for (int i = 0; i < primitives.length; i++) {
            PRIMITIVE_TYPE_MAP.put( primitives[i], wrappers[i] );
        }
    }

    private static final int MAX_REPORT_NESTED_TEXT = 20;

    private static final java.lang.String ELLIPSIS = "...";

    private final java.util.Hashtable attributeTypes = new java.util.Hashtable();

    private final java.util.Hashtable attributeSetters = new java.util.Hashtable();

    private final java.util.Hashtable nestedTypes = new java.util.Hashtable();

    private final java.util.Hashtable nestedCreators = new java.util.Hashtable();

    private final java.util.List addTypeMethods = new java.util.ArrayList();

    private final java.lang.reflect.Method addText;

    private final java.lang.Class bean;

    private IntrospectionHelper( final java.lang.Class bean )
    {
        this.bean = bean;
        java.lang.reflect.Method[] methods = bean.getMethods();
        java.lang.reflect.Method addTextMethod = null;
        for (int i = 0; i < methods.length; i++) {
            final java.lang.reflect.Method m = methods[i];
            final java.lang.String name = m.getName();
            java.lang.Class returnType = m.getReturnType();
            java.lang.Class[] args = m.getParameterTypes();
            if (args.length == 1 && java.lang.Void.TYPE.equals( returnType ) && ("add".equals( name ) || "addConfigured".equals( name ))) {
                insertAddTypeMethod( m );
                continue;
            }
            if ((org.apache.tools.ant.ProjectComponent.class).isAssignableFrom( bean ) && args.length == 1 && isHiddenSetMethod( name, args[0] )) {
                continue;
            }
            if (isContainer() && args.length == 1 && "addTask".equals( name ) && (org.apache.tools.ant.Task.class).equals( args[0] )) {
                continue;
            }
            if ("addText".equals( name ) && java.lang.Void.TYPE.equals( returnType ) && args.length == 1 && (java.lang.String.class).equals( args[0] )) {
                addTextMethod = methods[i];
            } else {
                if (name.startsWith( "set" ) && java.lang.Void.TYPE.equals( returnType ) && args.length == 1 && !args[0].isArray()) {
                    java.lang.String propName = getPropertyName( name, "set" );
                    org.apache.tools.ant.IntrospectionHelper.AttributeSetter as = (org.apache.tools.ant.IntrospectionHelper.AttributeSetter) attributeSetters.get( propName );
                    if (as != null) {
                        if ((java.lang.String.class).equals( args[0] )) {
                            continue;
                        }
                        if ((java.io.File.class).equals( args[0] )) {
                            if ((org.apache.tools.ant.types.Resource.class).equals( as.type ) || (org.apache.tools.ant.types.resources.FileProvider.class).equals( as.type )) {
                                continue;
                            }
                        }
                    }
                    as = createAttributeSetter( m, args[0], propName );
                    if (as != null) {
                        attributeTypes.put( propName, args[0] );
                        attributeSetters.put( propName, as );
                    }
                } else {
                    if (name.startsWith( "create" ) && !returnType.isArray() && !returnType.isPrimitive() && args.length == 0) {
                        java.lang.String propName = getPropertyName( name, "create" );
                        if (nestedCreators.get( propName ) == null) {
                            nestedTypes.put( propName, returnType );
                            nestedCreators.put( propName, new org.apache.tools.ant.IntrospectionHelper.CreateNestedCreator( m ) );
                        }
                    } else {
                        if (name.startsWith( "addConfigured" ) && java.lang.Void.TYPE.equals( returnType ) && args.length == 1 && !(java.lang.String.class).equals( args[0] ) && !args[0].isArray() && !args[0].isPrimitive()) {
                            try {
                                java.lang.reflect.Constructor constructor = null;
                                try {
                                    constructor = args[0].getConstructor( new java.lang.Class[]{  } );
                                } catch ( java.lang.NoSuchMethodException ex ) {
                                    constructor = args[0].getConstructor( new java.lang.Class[]{ org.apache.tools.ant.Project.class } );
                                }
                                java.lang.String propName = getPropertyName( name, "addConfigured" );
                                nestedTypes.put( propName, args[0] );
                                nestedCreators.put( propName, new org.apache.tools.ant.IntrospectionHelper.AddNestedCreator( m, constructor, AddNestedCreator.ADD_CONFIGURED ) );
                            } catch ( java.lang.NoSuchMethodException nse ) {
                            }
                        } else {
                            if (name.startsWith( "add" ) && java.lang.Void.TYPE.equals( returnType ) && args.length == 1 && !(java.lang.String.class).equals( args[0] ) && !args[0].isArray() && !args[0].isPrimitive()) {
                                try {
                                    java.lang.reflect.Constructor constructor = null;
                                    try {
                                        constructor = args[0].getConstructor( new java.lang.Class[]{  } );
                                    } catch ( java.lang.NoSuchMethodException ex ) {
                                        constructor = args[0].getConstructor( new java.lang.Class[]{ org.apache.tools.ant.Project.class } );
                                    }
                                    java.lang.String propName = getPropertyName( name, "add" );
                                    if (nestedTypes.get( propName ) != null) {
                                        continue;
                                    }
                                    nestedTypes.put( propName, args[0] );
                                    nestedCreators.put( propName, new org.apache.tools.ant.IntrospectionHelper.AddNestedCreator( m, constructor, AddNestedCreator.ADD ) );
                                } catch ( java.lang.NoSuchMethodException nse ) {
                                }
                            }
                        }
                    }
                }
            }
        }
        addText = addTextMethod;
    }

    private  boolean isHiddenSetMethod( java.lang.String name, java.lang.Class type )
    {
        if ("setLocation".equals( name ) && (org.apache.tools.ant.Location.class).equals( type )) {
            return true;
        }
        if ("setTaskType".equals( name ) && (java.lang.String.class).equals( type )) {
            return true;
        }
        return false;
    }

    public static synchronized  org.apache.tools.ant.IntrospectionHelper getHelper( java.lang.Class c )
    {
        return getHelper( null, c );
    }

    public static  org.apache.tools.ant.IntrospectionHelper getHelper( org.apache.tools.ant.Project p, java.lang.Class c )
    {
        org.apache.tools.ant.IntrospectionHelper ih = (org.apache.tools.ant.IntrospectionHelper) HELPERS.get( c.getName() );
        if (ih == null || ih.bean != c) {
            ih = new org.apache.tools.ant.IntrospectionHelper( c );
            if (p != null) {
                HELPERS.put( c.getName(), ih );
            }
        }
        return ih;
    }

    public  void setAttribute( org.apache.tools.ant.Project p, java.lang.Object element, java.lang.String attributeName, java.lang.Object value )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.IntrospectionHelper.AttributeSetter as = (org.apache.tools.ant.IntrospectionHelper.AttributeSetter) attributeSetters.get( attributeName.toLowerCase( Locale.ENGLISH ) );
        if (as == null && value != null) {
            if (element instanceof org.apache.tools.ant.DynamicAttributeNS) {
                org.apache.tools.ant.DynamicAttributeNS dc = (org.apache.tools.ant.DynamicAttributeNS) element;
                java.lang.String uriPlusPrefix = ProjectHelper.extractUriFromComponentName( attributeName );
                java.lang.String uri = ProjectHelper.extractUriFromComponentName( uriPlusPrefix );
                java.lang.String localName = ProjectHelper.extractNameFromComponentName( attributeName );
                java.lang.String qName = "".equals( uri ) ? localName : uri + ":" + localName;
                dc.setDynamicAttribute( uri, localName, qName, value.toString() );
                return;
            }
            if (element instanceof org.apache.tools.ant.DynamicAttribute) {
                org.apache.tools.ant.DynamicAttribute dc = (org.apache.tools.ant.DynamicAttribute) element;
                dc.setDynamicAttribute( attributeName.toLowerCase( Locale.ENGLISH ), value.toString() );
                return;
            }
            if (attributeName.indexOf( ':' ) >= 0) {
                return;
            }
            java.lang.String msg = getElementName( p, element ) + " doesn't support the \"" + attributeName + "\" attribute.";
            throw new org.apache.tools.ant.UnsupportedAttributeException( msg, attributeName );
        }
        try {
            as.setObject( p, element, value );
        } catch ( java.lang.IllegalAccessException ie ) {
            throw new org.apache.tools.ant.BuildException( ie );
        } catch ( java.lang.reflect.InvocationTargetException ite ) {
            throw extractBuildException( ite );
        }
    }

    public  void setAttribute( org.apache.tools.ant.Project p, java.lang.Object element, java.lang.String attributeName, java.lang.String value )
        throws org.apache.tools.ant.BuildException
    {
        setAttribute( p, element, attributeName, (java.lang.Object) value );
    }

    public  void addText( org.apache.tools.ant.Project project, java.lang.Object element, java.lang.String text )
        throws org.apache.tools.ant.BuildException
    {
        if (addText == null) {
            text = text.trim();
            if (text.length() == 0) {
                return;
            }
            throw new org.apache.tools.ant.BuildException( project.getElementName( element ) + " doesn't support nested text data (\"" + condenseText( text ) + "\")." );
        }
        try {
            addText.invoke( element, new java.lang.Object[]{ text } );
        } catch ( java.lang.IllegalAccessException ie ) {
            throw new org.apache.tools.ant.BuildException( ie );
        } catch ( java.lang.reflect.InvocationTargetException ite ) {
            throw extractBuildException( ite );
        }
    }

    protected static final java.lang.String NOT_SUPPORTED_CHILD_PREFIX = " doesn't support the nested \"";

    protected static final java.lang.String NOT_SUPPORTED_CHILD_POSTFIX = "\" element.";

    public  void throwNotSupported( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.String elementName )
    {
        java.lang.String msg = project.getElementName( parent ) + NOT_SUPPORTED_CHILD_PREFIX + elementName + NOT_SUPPORTED_CHILD_POSTFIX;
        throw new org.apache.tools.ant.UnsupportedElementException( msg, elementName );
    }

    private  org.apache.tools.ant.IntrospectionHelper.NestedCreator getNestedCreator( org.apache.tools.ant.Project project, java.lang.String parentUri, java.lang.Object parent, java.lang.String elementName, org.apache.tools.ant.UnknownElement child )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String uri = ProjectHelper.extractUriFromComponentName( elementName );
        java.lang.String name = ProjectHelper.extractNameFromComponentName( elementName );
        if (uri.equals( ProjectHelper.ANT_CORE_URI )) {
            uri = "";
        }
        if (parentUri.equals( ProjectHelper.ANT_CORE_URI )) {
            parentUri = "";
        }
        org.apache.tools.ant.IntrospectionHelper.NestedCreator nc = null;
        if (uri.equals( parentUri ) || uri.length() == 0) {
            nc = (org.apache.tools.ant.IntrospectionHelper.NestedCreator) nestedCreators.get( name.toLowerCase( Locale.ENGLISH ) );
        }
        if (nc == null) {
            nc = createAddTypeCreator( project, parent, elementName );
        }
        if (nc == null && (parent instanceof org.apache.tools.ant.DynamicElementNS || parent instanceof org.apache.tools.ant.DynamicElement)) {
            java.lang.String qName = child == null ? name : child.getQName();
            final java.lang.Object nestedElement = createDynamicElement( parent, child == null ? "" : child.getNamespace(), name, qName );
            if (nestedElement != null) {
                nc = new org.apache.tools.ant.IntrospectionHelper.NestedCreator( null ){
                     java.lang.Object create( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object ignore )
                    {
                        return nestedElement;
                    }
                };
            }
        }
        if (nc == null) {
            throwNotSupported( project, parent, elementName );
        }
        return nc;
    }

    private  java.lang.Object createDynamicElement( java.lang.Object parent, java.lang.String ns, java.lang.String localName, java.lang.String qName )
    {
        java.lang.Object nestedElement = null;
        if (parent instanceof org.apache.tools.ant.DynamicElementNS) {
            org.apache.tools.ant.DynamicElementNS dc = (org.apache.tools.ant.DynamicElementNS) parent;
            nestedElement = dc.createDynamicElement( ns, localName, qName );
        }
        if (nestedElement == null && parent instanceof org.apache.tools.ant.DynamicElement) {
            org.apache.tools.ant.DynamicElement dc = (org.apache.tools.ant.DynamicElement) parent;
            nestedElement = dc.createDynamicElement( localName.toLowerCase( Locale.ENGLISH ) );
        }
        return nestedElement;
    }

    public  java.lang.Object createElement( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.String elementName )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.IntrospectionHelper.NestedCreator nc = getNestedCreator( project, "", parent, elementName, null );
        try {
            java.lang.Object nestedElement = nc.create( project, parent, null );
            if (project != null) {
                project.setProjectReference( nestedElement );
            }
            return nestedElement;
        } catch ( java.lang.IllegalAccessException ie ) {
            throw new org.apache.tools.ant.BuildException( ie );
        } catch ( java.lang.InstantiationException ine ) {
            throw new org.apache.tools.ant.BuildException( ine );
        } catch ( java.lang.reflect.InvocationTargetException ite ) {
            throw extractBuildException( ite );
        }
    }

    public  org.apache.tools.ant.IntrospectionHelper.Creator getElementCreator( org.apache.tools.ant.Project project, java.lang.String parentUri, java.lang.Object parent, java.lang.String elementName, org.apache.tools.ant.UnknownElement ue )
    {
        org.apache.tools.ant.IntrospectionHelper.NestedCreator nc = getNestedCreator( project, parentUri, parent, elementName, ue );
        return new org.apache.tools.ant.IntrospectionHelper.Creator( project, parent, nc );
    }

    public  boolean isDynamic()
    {
        return (org.apache.tools.ant.DynamicElement.class).isAssignableFrom( bean ) || (org.apache.tools.ant.DynamicElementNS.class).isAssignableFrom( bean );
    }

    public  boolean isContainer()
    {
        return (org.apache.tools.ant.TaskContainer.class).isAssignableFrom( bean );
    }

    public  boolean supportsNestedElement( java.lang.String elementName )
    {
        return supportsNestedElement( "", elementName );
    }

    public  boolean supportsNestedElement( java.lang.String parentUri, java.lang.String elementName )
    {
        if (isDynamic() || addTypeMethods.size() > 0) {
            return true;
        }
        return supportsReflectElement( parentUri, elementName );
    }

    public  boolean supportsNestedElement( java.lang.String parentUri, java.lang.String elementName, org.apache.tools.ant.Project project, java.lang.Object parent )
    {
        if (addTypeMethods.size() > 0 && createAddTypeCreator( project, parent, elementName ) != null) {
            return true;
        }
        return isDynamic() || supportsReflectElement( parentUri, elementName );
    }

    public  boolean supportsReflectElement( java.lang.String parentUri, java.lang.String elementName )
    {
        java.lang.String name = ProjectHelper.extractNameFromComponentName( elementName );
        if (!nestedCreators.containsKey( name.toLowerCase( Locale.ENGLISH ) )) {
            return false;
        }
        java.lang.String uri = ProjectHelper.extractUriFromComponentName( elementName );
        if (uri.equals( ProjectHelper.ANT_CORE_URI )) {
            uri = "";
        }
        if ("".equals( uri )) {
            return true;
        }
        if (parentUri.equals( ProjectHelper.ANT_CORE_URI )) {
            parentUri = "";
        }
        return uri.equals( parentUri );
    }

    public  void storeElement( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object child, java.lang.String elementName )
        throws org.apache.tools.ant.BuildException
    {
        if (elementName == null) {
            return;
        }
        org.apache.tools.ant.IntrospectionHelper.NestedCreator ns = (org.apache.tools.ant.IntrospectionHelper.NestedCreator) nestedCreators.get( elementName.toLowerCase( Locale.ENGLISH ) );
        if (ns == null) {
            return;
        }
        try {
            ns.store( parent, child );
        } catch ( java.lang.IllegalAccessException ie ) {
            throw new org.apache.tools.ant.BuildException( ie );
        } catch ( java.lang.InstantiationException ine ) {
            throw new org.apache.tools.ant.BuildException( ine );
        } catch ( java.lang.reflect.InvocationTargetException ite ) {
            throw extractBuildException( ite );
        }
    }

    private static  org.apache.tools.ant.BuildException extractBuildException( java.lang.reflect.InvocationTargetException ite )
    {
        java.lang.Throwable t = ite.getTargetException();
        if (t instanceof org.apache.tools.ant.BuildException) {
            return (org.apache.tools.ant.BuildException) t;
        }
        return new org.apache.tools.ant.BuildException( t );
    }

    public  java.lang.Class getElementType( java.lang.String elementName )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.Class nt = (java.lang.Class) nestedTypes.get( elementName );
        if (nt == null) {
            throw new org.apache.tools.ant.UnsupportedElementException( "Class " + bean.getName() + " doesn't support the nested \"" + elementName + "\" element.", elementName );
        }
        return nt;
    }

    public  java.lang.Class getAttributeType( java.lang.String attributeName )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.Class at = (java.lang.Class) attributeTypes.get( attributeName );
        if (at == null) {
            throw new org.apache.tools.ant.UnsupportedAttributeException( "Class " + bean.getName() + " doesn't support the \"" + attributeName + "\" attribute.", attributeName );
        }
        return at;
    }

    public  java.lang.reflect.Method getAddTextMethod()
        throws org.apache.tools.ant.BuildException
    {
        if (!supportsCharacters()) {
            throw new org.apache.tools.ant.BuildException( "Class " + bean.getName() + " doesn't support nested text data." );
        }
        return addText;
    }

    public  java.lang.reflect.Method getElementMethod( java.lang.String elementName )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.Object creator = nestedCreators.get( elementName );
        if (creator == null) {
            throw new org.apache.tools.ant.UnsupportedElementException( "Class " + bean.getName() + " doesn't support the nested \"" + elementName + "\" element.", elementName );
        }
        return ((org.apache.tools.ant.IntrospectionHelper.NestedCreator) creator).method;
    }

    public  java.lang.reflect.Method getAttributeMethod( java.lang.String attributeName )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.Object setter = attributeSetters.get( attributeName );
        if (setter == null) {
            throw new org.apache.tools.ant.UnsupportedAttributeException( "Class " + bean.getName() + " doesn't support the \"" + attributeName + "\" attribute.", attributeName );
        }
        return ((org.apache.tools.ant.IntrospectionHelper.AttributeSetter) setter).method;
    }

    public  boolean supportsCharacters()
    {
        return addText != null;
    }

    public  java.util.Enumeration getAttributes()
    {
        return attributeSetters.keys();
    }

    public  java.util.Map getAttributeMap()
    {
        return attributeTypes.isEmpty() ? Collections.EMPTY_MAP : Collections.unmodifiableMap( attributeTypes );
    }

    public  java.util.Enumeration getNestedElements()
    {
        return nestedTypes.keys();
    }

    public  java.util.Map getNestedElementMap()
    {
        return nestedTypes.isEmpty() ? Collections.EMPTY_MAP : Collections.unmodifiableMap( nestedTypes );
    }

    public  java.util.List getExtensionPoints()
    {
        return addTypeMethods.isEmpty() ? Collections.EMPTY_LIST : Collections.unmodifiableList( addTypeMethods );
    }

    private  org.apache.tools.ant.IntrospectionHelper.AttributeSetter createAttributeSetter( final java.lang.reflect.Method m, java.lang.Class arg, final java.lang.String attrName )
    {
        final java.lang.Class reflectedArg = PRIMITIVE_TYPE_MAP.containsKey( arg ) ? (java.lang.Class) PRIMITIVE_TYPE_MAP.get( arg ) : arg;
        if (java.lang.Object.class == reflectedArg) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
                {
                    throw new org.apache.tools.ant.BuildException( "Internal ant problem - this should not get called" );
                }
            };
        }
        if ((java.lang.String.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
                {
                    m.invoke( parent, (java.lang.Object[]) new java.lang.String[]{ value } );
                }
            };
        }
        if ((java.lang.Character.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
                {
                    if (value.length() == 0) {
                        throw new org.apache.tools.ant.BuildException( "The value \"\" is not a " + "legal value for attribute \"" + attrName + "\"" );
                    }
                    m.invoke( parent, (java.lang.Object[]) new java.lang.Character[]{ new java.lang.Character( value.charAt( 0 ) ) } );
                }
            };
        }
        if ((java.lang.Boolean.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
                {
                    m.invoke( parent, (java.lang.Object[]) new java.lang.Boolean[]{ Project.toBoolean( value ) ? Boolean.TRUE : Boolean.FALSE } );
                }
            };
        }
        if ((java.lang.Class.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
                {
                    try {
                        m.invoke( parent, new java.lang.Object[]{ Class.forName( value ) } );
                    } catch ( java.lang.ClassNotFoundException ce ) {
                        throw new org.apache.tools.ant.BuildException( ce );
                    }
                }
            };
        }
        if ((java.io.File.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
                {
                    m.invoke( parent, new java.lang.Object[]{ p.resolveFile( value ) } );
                }
            };
        }
        if ((org.apache.tools.ant.types.Resource.class).equals( reflectedArg ) || (org.apache.tools.ant.types.resources.FileProvider.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                 void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
                {
                    m.invoke( parent, new java.lang.Object[]{ new org.apache.tools.ant.types.resources.FileResource( p, p.resolveFile( value ) ) } );
                }
            };
        }
        if ((org.apache.tools.ant.types.EnumeratedAttribute.class).isAssignableFrom( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
                {
                    try {
                        org.apache.tools.ant.types.EnumeratedAttribute ea = (org.apache.tools.ant.types.EnumeratedAttribute) reflectedArg.newInstance();
                        ea.setValue( value );
                        m.invoke( parent, new java.lang.Object[]{ ea } );
                    } catch ( java.lang.InstantiationException ie ) {
                        throw new org.apache.tools.ant.BuildException( ie );
                    }
                }
            };
        }
        org.apache.tools.ant.IntrospectionHelper.AttributeSetter setter = getEnumSetter( reflectedArg, m, arg );
        if (setter != null) {
            return setter;
        }
        if ((java.lang.Long.class).equals( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
                {
                    try {
                        m.invoke( parent, new java.lang.Object[]{ new java.lang.Long( StringUtils.parseHumanSizes( value ) ) } );
                    } catch ( java.lang.NumberFormatException e ) {
                        throw new org.apache.tools.ant.BuildException( "Can't assign non-numeric" + " value '" + value + "' to" + " attribute " + attrName );
                    } catch ( java.lang.reflect.InvocationTargetException e ) {
                        throw e;
                    } catch ( java.lang.IllegalAccessException e ) {
                        throw e;
                    } catch ( java.lang.Exception e ) {
                        throw new org.apache.tools.ant.BuildException( e );
                    }
                }
            };
        }
        boolean includeProject;
        java.lang.reflect.Constructor c;
        try {
            c = reflectedArg.getConstructor( new java.lang.Class[]{ org.apache.tools.ant.Project.class, java.lang.String.class } );
            includeProject = true;
        } catch ( java.lang.NoSuchMethodException nme ) {
            try {
                c = reflectedArg.getConstructor( new java.lang.Class[]{ java.lang.String.class } );
                includeProject = false;
            } catch ( java.lang.NoSuchMethodException nme2 ) {
                return null;
            }
        }
        final boolean finalIncludeProject = includeProject;
        final java.lang.reflect.Constructor finalConstructor = c;
        return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
            public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                        throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
            {
                try {
                    java.lang.Object[] args = finalIncludeProject ? new java.lang.Object[]{ p, value } : new java.lang.Object[]{ value };
                    java.lang.Object attribute = finalConstructor.newInstance( args );
                    if (p != null) {
                        p.setProjectReference( attribute );
                    }
                    m.invoke( parent, new java.lang.Object[]{ attribute } );
                } catch ( java.lang.reflect.InvocationTargetException e ) {
                    java.lang.Throwable cause = e.getCause();
                    if (cause instanceof java.lang.IllegalArgumentException) {
                        throw new org.apache.tools.ant.BuildException( "Can't assign value '" + value + "' to attribute " + attrName + ", reason: " + cause.getClass() + " with message '" + cause.getMessage() + "'" );
                    }
                    throw e;
                } catch ( java.lang.InstantiationException ie ) {
                    throw new org.apache.tools.ant.BuildException( ie );
                }
            }
        };
    }

    private  org.apache.tools.ant.IntrospectionHelper.AttributeSetter getEnumSetter( final java.lang.Class reflectedArg, final java.lang.reflect.Method m, java.lang.Class arg )
    {
        java.lang.Class enumClass = null;
        try {
            enumClass = Class.forName( "java.lang.Enum" );
        } catch ( java.lang.ClassNotFoundException e ) {
        }
        if (enumClass != null && enumClass.isAssignableFrom( reflectedArg )) {
            return new org.apache.tools.ant.IntrospectionHelper.AttributeSetter( m, arg ){
                public  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
                {
                    try {
                        m.invoke( parent, new java.lang.Object[]{ reflectedArg.getMethod( "valueOf", new java.lang.Class[]{ java.lang.String.class } ).invoke( null, new java.lang.Object[]{ value } ) } );
                    } catch ( java.lang.reflect.InvocationTargetException x ) {
                        if (x.getTargetException() instanceof java.lang.IllegalArgumentException) {
                            throw new org.apache.tools.ant.BuildException( "'" + value + "' is not a permitted value for " + reflectedArg.getName() );
                        }
                        throw extractBuildException( x );
                    } catch ( java.lang.Exception x ) {
                        throw new org.apache.tools.ant.BuildException( x );
                    }
                }
            };
        }
        return null;
    }

    private  java.lang.String getElementName( org.apache.tools.ant.Project project, java.lang.Object element )
    {
        return project.getElementName( element );
    }

    private static  java.lang.String getPropertyName( java.lang.String methodName, java.lang.String prefix )
    {
        return methodName.substring( prefix.length() ).toLowerCase( Locale.ENGLISH );
    }

    public static final class Creator
    {

        private org.apache.tools.ant.IntrospectionHelper.NestedCreator nestedCreator;

        private java.lang.Object parent;

        private org.apache.tools.ant.Project project;

        private java.lang.Object nestedObject;

        private java.lang.String polyType;

        private Creator( org.apache.tools.ant.Project project, java.lang.Object parent, org.apache.tools.ant.IntrospectionHelper.NestedCreator nestedCreator )
        {
            this.project = project;
            this.parent = parent;
            this.nestedCreator = nestedCreator;
        }

        public  void setPolyType( java.lang.String polyType )
        {
            this.polyType = polyType;
        }

        public  java.lang.Object create()
        {
            if (polyType != null) {
                if (!nestedCreator.isPolyMorphic()) {
                    throw new org.apache.tools.ant.BuildException( "Not allowed to use the polymorphic form for this element" );
                }
                org.apache.tools.ant.ComponentHelper helper = ComponentHelper.getComponentHelper( project );
                nestedObject = helper.createComponent( polyType );
                if (nestedObject == null) {
                    throw new org.apache.tools.ant.BuildException( "Unable to create object of type " + polyType );
                }
            }
            try {
                nestedObject = nestedCreator.create( project, parent, nestedObject );
                if (project != null) {
                    project.setProjectReference( nestedObject );
                }
                return nestedObject;
            } catch ( java.lang.IllegalAccessException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            } catch ( java.lang.InstantiationException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            } catch ( java.lang.IllegalArgumentException ex ) {
                if (polyType == null) {
                    throw ex;
                }
                throw new org.apache.tools.ant.BuildException( "Invalid type used " + polyType );
            } catch ( java.lang.reflect.InvocationTargetException ex ) {
                throw extractBuildException( ex );
            }
        }

        public  java.lang.Object getRealObject()
        {
            return nestedCreator.getRealObject();
        }

        public  void store()
        {
            try {
                nestedCreator.store( parent, nestedObject );
            } catch ( java.lang.IllegalAccessException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            } catch ( java.lang.InstantiationException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            } catch ( java.lang.IllegalArgumentException ex ) {
                if (polyType == null) {
                    throw ex;
                }
                throw new org.apache.tools.ant.BuildException( "Invalid type used " + polyType );
            } catch ( java.lang.reflect.InvocationTargetException ex ) {
                throw extractBuildException( ex );
            }
        }

    }

    private abstract static class NestedCreator
    {

        private java.lang.reflect.Method method;

        protected NestedCreator( java.lang.reflect.Method m )
        {
            method = m;
        }

         java.lang.reflect.Method getMethod()
        {
            return method;
        }

         boolean isPolyMorphic()
        {
            return false;
        }

         java.lang.Object getRealObject()
        {
            return null;
        }

        abstract  java.lang.Object create( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object child )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException;

         void store( java.lang.Object parent, java.lang.Object child )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException
        {
        }

    }

    private static class CreateNestedCreator extends org.apache.tools.ant.IntrospectionHelper.NestedCreator
    {

        CreateNestedCreator( java.lang.reflect.Method m )
        {
            super( m );
        }

         java.lang.Object create( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object ignore )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
        {
            return getMethod().invoke( parent, new java.lang.Object[]{  } );
        }

    }

    private static class AddNestedCreator extends org.apache.tools.ant.IntrospectionHelper.NestedCreator
    {

        static final int ADD = 1;

        static final int ADD_CONFIGURED = 2;

        private java.lang.reflect.Constructor constructor;

        private int behavior;

        AddNestedCreator( java.lang.reflect.Method m, java.lang.reflect.Constructor c, int behavior )
        {
            super( m );
            this.constructor = c;
            this.behavior = behavior;
        }

         boolean isPolyMorphic()
        {
            return true;
        }

         java.lang.Object create( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object child )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException
        {
            if (child == null) {
                child = constructor.newInstance( constructor.getParameterTypes().length == 0 ? new java.lang.Object[]{  } : new java.lang.Object[]{ project } );
            }
            if (child instanceof org.apache.tools.ant.taskdefs.PreSetDef.PreSetDefinition) {
                child = ((org.apache.tools.ant.taskdefs.PreSetDef.PreSetDefinition) child).createObject( project );
            }
            if (behavior == ADD) {
                istore( parent, child );
            }
            return child;
        }

         void store( java.lang.Object parent, java.lang.Object child )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException
        {
            if (behavior == ADD_CONFIGURED) {
                istore( parent, child );
            }
        }

        private  void istore( java.lang.Object parent, java.lang.Object child )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException
        {
            getMethod().invoke( parent, new java.lang.Object[]{ child } );
        }

    }

    private abstract static class AttributeSetter
    {

        private java.lang.reflect.Method method;

        private java.lang.Class type;

        protected AttributeSetter( java.lang.reflect.Method m, java.lang.Class type )
        {
            method = m;
            this.type = type;
        }

         void setObject( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.Object value )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException
        {
            if (type != null) {
                java.lang.Class useType = type;
                if (type.isPrimitive()) {
                    if (value == null) {
                        throw new org.apache.tools.ant.BuildException( "Attempt to set primitive " + getPropertyName( method.getName(), "set" ) + " to null on " + parent );
                    }
                    useType = (java.lang.Class) PRIMITIVE_TYPE_MAP.get( type );
                }
                if (value == null || useType.isInstance( value )) {
                    method.invoke( parent, new java.lang.Object[]{ value } );
                    return;
                }
            }
            set( p, parent, value.toString() );
        }

        abstract  void set( org.apache.tools.ant.Project p, java.lang.Object parent, java.lang.String value )
                throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, org.apache.tools.ant.BuildException;

    }

    public static  void clearCache()
    {
        HELPERS.clear();
    }

    private  org.apache.tools.ant.IntrospectionHelper.NestedCreator createAddTypeCreator( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.String elementName )
        throws org.apache.tools.ant.BuildException
    {
        if (addTypeMethods.size() == 0) {
            return null;
        }
        org.apache.tools.ant.ComponentHelper helper = ComponentHelper.getComponentHelper( project );
        org.apache.tools.ant.IntrospectionHelper.MethodAndObject restricted = createRestricted( helper, elementName, addTypeMethods );
        org.apache.tools.ant.IntrospectionHelper.MethodAndObject topLevel = createTopLevel( helper, elementName, addTypeMethods );
        if (restricted == null && topLevel == null) {
            return null;
        }
        if (restricted != null && topLevel != null) {
            throw new org.apache.tools.ant.BuildException( "ambiguous: type and component definitions for " + elementName );
        }
        org.apache.tools.ant.IntrospectionHelper.MethodAndObject methodAndObject = restricted != null ? restricted : topLevel;
        java.lang.Object rObject = methodAndObject.object;
        if (methodAndObject.object instanceof org.apache.tools.ant.taskdefs.PreSetDef.PreSetDefinition) {
            rObject = ((org.apache.tools.ant.taskdefs.PreSetDef.PreSetDefinition) methodAndObject.object).createObject( project );
        }
        final java.lang.Object nestedObject = methodAndObject.object;
        final java.lang.Object realObject = rObject;
        return new org.apache.tools.ant.IntrospectionHelper.NestedCreator( methodAndObject.method ){
             java.lang.Object create( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object ignore )
                        throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException
            {
                if (!getMethod().getName().endsWith( "Configured" )) {
                    getMethod().invoke( parent, new java.lang.Object[]{ realObject } );
                }
                return nestedObject;
            }

             java.lang.Object getRealObject()
            {
                return realObject;
            }

             void store( java.lang.Object parent, java.lang.Object child )
                        throws java.lang.reflect.InvocationTargetException, java.lang.IllegalAccessException, java.lang.InstantiationException
            {
                if (getMethod().getName().endsWith( "Configured" )) {
                    getMethod().invoke( parent, new java.lang.Object[]{ realObject } );
                }
            }
        };
    }

    private  void insertAddTypeMethod( java.lang.reflect.Method method )
    {
        java.lang.Class argClass = method.getParameterTypes()[0];
        final int size = addTypeMethods.size();
        for (int c = 0; c < size; ++c) {
            java.lang.reflect.Method current = (java.lang.reflect.Method) addTypeMethods.get( c );
            if (current.getParameterTypes()[0].equals( argClass )) {
                if (method.getName().equals( "addConfigured" )) {
                    addTypeMethods.set( c, method );
                }
                return;
            }
            if (current.getParameterTypes()[0].isAssignableFrom( argClass )) {
                addTypeMethods.add( c, method );
                return;
            }
        }
        addTypeMethods.add( method );
    }

    private  java.lang.reflect.Method findMatchingMethod( java.lang.Class paramClass, java.util.List methods )
    {
        if (paramClass == null) {
            return null;
        }
        java.lang.Class matchedClass = null;
        java.lang.reflect.Method matchedMethod = null;
        final int size = methods.size();
        for (int i = 0; i < size; ++i) {
            java.lang.reflect.Method method = (java.lang.reflect.Method) methods.get( i );
            java.lang.Class methodClass = method.getParameterTypes()[0];
            if (methodClass.isAssignableFrom( paramClass )) {
                if (matchedClass == null) {
                    matchedClass = methodClass;
                    matchedMethod = method;
                } else {
                    if (!methodClass.isAssignableFrom( matchedClass )) {
                        throw new org.apache.tools.ant.BuildException( "ambiguous: types " + matchedClass.getName() + " and " + methodClass.getName() + " match " + paramClass.getName() );
                    }
                }
            }
        }
        return matchedMethod;
    }

    private  java.lang.String condenseText( final java.lang.String text )
    {
        if (text.length() <= MAX_REPORT_NESTED_TEXT) {
            return text;
        }
        int ends = (MAX_REPORT_NESTED_TEXT - ELLIPSIS.length()) / 2;
        return (new java.lang.StringBuffer( text )).replace( ends, text.length() - ends, ELLIPSIS ).toString();
    }

    private static class MethodAndObject
    {

        private java.lang.reflect.Method method;

        private java.lang.Object object;

        public MethodAndObject( java.lang.reflect.Method method, java.lang.Object object )
        {
            this.method = method;
            this.object = object;
        }

    }

    private  org.apache.tools.ant.AntTypeDefinition findRestrictedDefinition( org.apache.tools.ant.ComponentHelper helper, java.lang.String componentName, java.util.List methods )
    {
        org.apache.tools.ant.AntTypeDefinition definition = null;
        java.lang.Class matchedDefinitionClass = null;
        java.util.List definitions = helper.getRestrictedDefinitions( componentName );
        if (definitions == null) {
            return null;
        }
        synchronized (definitions)
{
            final int size = definitions.size();
            for (int i = 0; i < size; ++i) {
                org.apache.tools.ant.AntTypeDefinition d = (org.apache.tools.ant.AntTypeDefinition) definitions.get( i );
                java.lang.Class exposedClass = d.getExposedClass( helper.getProject() );
                if (exposedClass == null) {
                    continue;
                }
                java.lang.reflect.Method method = findMatchingMethod( exposedClass, methods );
                if (method == null) {
                    continue;
                }
                if (matchedDefinitionClass != null) {
                    throw new org.apache.tools.ant.BuildException( "ambiguous: restricted definitions for " + componentName + " " + matchedDefinitionClass + " and " + exposedClass );
                }
                matchedDefinitionClass = exposedClass;
                definition = d;
            }
        }
        return definition;
    }

    private  org.apache.tools.ant.IntrospectionHelper.MethodAndObject createRestricted( org.apache.tools.ant.ComponentHelper helper, java.lang.String elementName, java.util.List addTypeMethods )
    {
        org.apache.tools.ant.Project project = helper.getProject();
        org.apache.tools.ant.AntTypeDefinition restrictedDefinition = findRestrictedDefinition( helper, elementName, addTypeMethods );
        if (restrictedDefinition == null) {
            return null;
        }
        java.lang.reflect.Method addMethod = findMatchingMethod( restrictedDefinition.getExposedClass( project ), addTypeMethods );
        if (addMethod == null) {
            throw new org.apache.tools.ant.BuildException( "Ant Internal Error - contract mismatch for " + elementName );
        }
        java.lang.Object addedObject = restrictedDefinition.create( project );
        if (addedObject == null) {
            throw new org.apache.tools.ant.BuildException( "Failed to create object " + elementName + " of type " + restrictedDefinition.getTypeClass( project ) );
        }
        return new org.apache.tools.ant.IntrospectionHelper.MethodAndObject( addMethod, addedObject );
    }

    private  org.apache.tools.ant.IntrospectionHelper.MethodAndObject createTopLevel( org.apache.tools.ant.ComponentHelper helper, java.lang.String elementName, java.util.List methods )
    {
        java.lang.Class clazz = helper.getComponentClass( elementName );
        if (clazz == null) {
            return null;
        }
        java.lang.reflect.Method addMethod = findMatchingMethod( clazz, addTypeMethods );
        if (addMethod == null) {
            return null;
        }
        java.lang.Object addedObject = helper.createComponent( elementName );
        return new org.apache.tools.ant.IntrospectionHelper.MethodAndObject( addMethod, addedObject );
    }

}
