// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.ResourceUtils;


public final class ClassConstants extends org.apache.tools.ant.filters.BaseFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private java.lang.String queuedData = null;

    private static final java.lang.String JAVA_CLASS_HELPER = "org.apache.tools.ant.filters.util.JavaClassHelper";

    public ClassConstants()
    {
        super();
    }

    public ClassConstants( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        int ch = -1;
        if (queuedData != null && queuedData.length() == 0) {
            queuedData = null;
        }
        if (queuedData != null) {
            ch = queuedData.charAt( 0 );
            queuedData = queuedData.substring( 1 );
            if (queuedData.length() == 0) {
                queuedData = null;
            }
        } else {
            final java.lang.String clazz = readFully();
            if (clazz == null || clazz.length() == 0) {
                ch = -1;
            } else {
                final byte[] bytes = clazz.getBytes( ResourceUtils.ISO_8859_1 );
                try {
                    final java.lang.Class javaClassHelper = Class.forName( JAVA_CLASS_HELPER );
                    if (javaClassHelper != null) {
                        final java.lang.Class[] params = { byte[].class };
                        final java.lang.reflect.Method getConstants = javaClassHelper.getMethod( "getConstants", params );
                        final java.lang.Object[] args = { bytes };
                        final java.lang.StringBuffer sb = (java.lang.StringBuffer) getConstants.invoke( null, args );
                        if (sb.length() > 0) {
                            queuedData = sb.toString();
                            return read();
                        }
                    }
                } catch ( java.lang.NoClassDefFoundError ex ) {
                    throw ex;
                } catch ( java.lang.RuntimeException ex ) {
                    throw ex;
                } catch ( java.lang.reflect.InvocationTargetException ex ) {
                    java.lang.Throwable t = ex.getTargetException();
                    if (t instanceof java.lang.NoClassDefFoundError) {
                        throw (java.lang.NoClassDefFoundError) t;
                    }
                    if (t instanceof java.lang.RuntimeException) {
                        throw (java.lang.RuntimeException) t;
                    }
                    throw new org.apache.tools.ant.BuildException( t );
                } catch ( java.lang.Exception ex ) {
                    throw new org.apache.tools.ant.BuildException( ex );
                }
            }
        }
        return ch;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.ClassConstants newFilter = new org.apache.tools.ant.filters.ClassConstants( rdr );
        return newFilter;
    }

}
