// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import java.util.Properties;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.PropertyHelper;
import org.apache.tools.ant.property.GetProperty;
import org.apache.tools.ant.property.ParseProperties;
import org.apache.tools.ant.types.PropertySet;


public final class ExpandProperties extends org.apache.tools.ant.filters.BaseFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final int EOF = -1;

    private char[] buffer;

    private int index;

    private org.apache.tools.ant.types.PropertySet propertySet;

    public ExpandProperties()
    {
        super();
    }

    public ExpandProperties( final java.io.Reader in )
    {
        super( in );
    }

    public  void add( org.apache.tools.ant.types.PropertySet propertySet )
    {
        if (this.propertySet != null) {
            throw new org.apache.tools.ant.BuildException( "expandproperties filter accepts only one propertyset" );
        }
        this.propertySet = propertySet;
    }

    public  int read()
        throws java.io.IOException
    {
        if (index > EOF) {
            if (buffer == null) {
                java.lang.String data = readFully();
                org.apache.tools.ant.Project project = getProject();
                org.apache.tools.ant.property.GetProperty getProperty;
                if (propertySet == null) {
                    getProperty = PropertyHelper.getPropertyHelper( project );
                } else {
                    final java.util.Properties props = propertySet.getProperties();
                    getProperty = new org.apache.tools.ant.property.GetProperty(){
                        public  java.lang.Object getProperty( java.lang.String name )
                        {
                            return props.getProperty( name );
                        }
                    };
                }
                buffer = (new org.apache.tools.ant.property.ParseProperties( project, PropertyHelper.getPropertyHelper( project ).getExpanders(), getProperty )).parseProperties( data ).toString().toCharArray();
            }
            if (index < buffer.length) {
                return buffer[index++];
            }
            index = EOF;
        }
        return EOF;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.ExpandProperties newFilter = new org.apache.tools.ant.filters.ExpandProperties( rdr );
        newFilter.setProject( getProject() );
        newFilter.add( propertySet );
        return newFilter;
    }

}
