// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.types.Parameter;


public final class SuffixLines extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final java.lang.String SUFFIX_KEY = "suffix";

    private java.lang.String suffix = null;

    private java.lang.String queuedData = null;

    public SuffixLines()
    {
        super();
    }

    public SuffixLines( final java.io.Reader in )
    {
        super( in );
    }

    public  int read()
        throws java.io.IOException
    {
        if (!getInitialized()) {
            initialize();
            setInitialized( true );
        }
        int ch = -1;
        if (queuedData != null && queuedData.length() == 0) {
            queuedData = null;
        }
        if (queuedData != null) {
            ch = queuedData.charAt( 0 );
            queuedData = queuedData.substring( 1 );
            if (queuedData.length() == 0) {
                queuedData = null;
            }
        } else {
            queuedData = readLine();
            if (queuedData == null) {
                ch = -1;
            } else {
                if (suffix != null) {
                    java.lang.String lf = "";
                    if (queuedData.endsWith( "\r\n" )) {
                        lf = "\r\n";
                    } else {
                        if (queuedData.endsWith( "\n" )) {
                            lf = "\n";
                        }
                    }
                    queuedData = queuedData.substring( 0, queuedData.length() - lf.length() ) + suffix + lf;
                }
                return read();
            }
        }
        return ch;
    }

    public  void setSuffix( final java.lang.String suffix )
    {
        this.suffix = suffix;
    }

    private  java.lang.String getSuffix()
    {
        return suffix;
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        org.apache.tools.ant.filters.SuffixLines newFilter = new org.apache.tools.ant.filters.SuffixLines( rdr );
        newFilter.setSuffix( getSuffix() );
        newFilter.setInitialized( true );
        return newFilter;
    }

    private  void initialize()
    {
        org.apache.tools.ant.types.Parameter[] params = getParameters();
        if (params != null) {
            for (int i = 0; i < params.length; i++) {
                if (SUFFIX_KEY.equals( params[i].getName() )) {
                    suffix = params[i].getValue();
                    break;
                }
            }
        }
    }

}
