// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.input;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Enumeration;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.KeepAliveInputStream;


public class DefaultInputHandler implements org.apache.tools.ant.input.InputHandler
{

    public DefaultInputHandler()
    {
    }

    public  void handleInput( org.apache.tools.ant.input.InputRequest request )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String prompt = getPrompt( request );
        java.io.BufferedReader r = null;
        try {
            r = new java.io.BufferedReader( new java.io.InputStreamReader( getInputStream() ) );
            do {
                System.err.println( prompt );
                System.err.flush();
                try {
                    java.lang.String input = r.readLine();
                    request.setInput( input );
                } catch ( java.io.IOException e ) {
                    throw new org.apache.tools.ant.BuildException( "Failed to read input from" + " Console.", e );
                }
            } while (!request.isInputValid());
        } finally 
{
            if (r != null) {
                try {
                    r.close();
                } catch ( java.io.IOException e ) {
                    throw new org.apache.tools.ant.BuildException( "Failed to close input.", e );
                }
            }
        }
    }

    protected  java.lang.String getPrompt( org.apache.tools.ant.input.InputRequest request )
    {
        java.lang.String prompt = request.getPrompt();
        java.lang.String def = request.getDefaultValue();
        if (request instanceof org.apache.tools.ant.input.MultipleChoiceInputRequest) {
            java.lang.StringBuffer sb = new java.lang.StringBuffer( prompt );
            sb.append( " (" );
            java.util.Enumeration e = ((org.apache.tools.ant.input.MultipleChoiceInputRequest) request).getChoices().elements();
            boolean first = true;
            while (e.hasMoreElements()) {
                if (!first) {
                    sb.append( ", " );
                }
                java.lang.String next = (java.lang.String) e.nextElement();
                if (next.equals( def )) {
                    sb.append( '[' );
                }
                sb.append( next );
                if (next.equals( def )) {
                    sb.append( ']' );
                }
                first = false;
            }
            sb.append( ")" );
            return sb.toString();
        } else {
            if (def != null) {
                return prompt + " [" + def + "]";
            } else {
                return prompt;
            }
        }
    }

    protected  java.io.InputStream getInputStream()
    {
        return KeepAliveInputStream.wrapSystemIn();
    }

}
