// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.listener;


import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.SubBuildListener;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.util.StringUtils;
import java.io.File;


public class BigProjectLogger extends org.apache.tools.ant.listener.SimpleBigProjectLogger implements org.apache.tools.ant.SubBuildListener
{

    private volatile boolean subBuildStartedRaised = false;

    private final java.lang.Object subBuildLock = new java.lang.Object();

    public static final java.lang.String HEADER = "======================================================================";

    public static final java.lang.String FOOTER = HEADER;

    protected  java.lang.String getBuildFailedMessage()
    {
        return super.getBuildFailedMessage() + TimestampedLogger.SPACER + getTimestamp();
    }

    protected  java.lang.String getBuildSuccessfulMessage()
    {
        return super.getBuildSuccessfulMessage() + TimestampedLogger.SPACER + getTimestamp();
    }

    public  void targetStarted( org.apache.tools.ant.BuildEvent event )
    {
        maybeRaiseSubBuildStarted( event );
        super.targetStarted( event );
    }

    public  void taskStarted( org.apache.tools.ant.BuildEvent event )
    {
        maybeRaiseSubBuildStarted( event );
        super.taskStarted( event );
    }

    public  void buildFinished( org.apache.tools.ant.BuildEvent event )
    {
        maybeRaiseSubBuildStarted( event );
        subBuildFinished( event );
        super.buildFinished( event );
    }

    public  void messageLogged( org.apache.tools.ant.BuildEvent event )
    {
        maybeRaiseSubBuildStarted( event );
        super.messageLogged( event );
    }

    public  void subBuildStarted( org.apache.tools.ant.BuildEvent event )
    {
        java.lang.String name = extractNameOrDefault( event );
        org.apache.tools.ant.Project project = event.getProject();
        java.io.File base = project == null ? null : project.getBaseDir();
        java.lang.String path = base == null ? "With no base directory" : "In " + base.getAbsolutePath();
        printMessage( StringUtils.LINE_SEP + getHeader() + StringUtils.LINE_SEP + "Entering project " + name + StringUtils.LINE_SEP + path + StringUtils.LINE_SEP + getFooter(), out, event.getPriority() );
    }

    protected  java.lang.String extractNameOrDefault( org.apache.tools.ant.BuildEvent event )
    {
        java.lang.String name = extractProjectName( event );
        if (name == null) {
            name = "";
        } else {
            name = '"' + name + '"';
        }
        return name;
    }

    public  void subBuildFinished( org.apache.tools.ant.BuildEvent event )
    {
        java.lang.String name = extractNameOrDefault( event );
        java.lang.String failed = event.getException() != null ? "failing " : "";
        printMessage( StringUtils.LINE_SEP + getHeader() + StringUtils.LINE_SEP + "Exiting " + failed + "project " + name + StringUtils.LINE_SEP + getFooter(), out, event.getPriority() );
    }

    protected  java.lang.String getHeader()
    {
        return HEADER;
    }

    protected  java.lang.String getFooter()
    {
        return FOOTER;
    }

    private  void maybeRaiseSubBuildStarted( org.apache.tools.ant.BuildEvent event )
    {
        if (!subBuildStartedRaised) {
            synchronized (subBuildLock)
{
                if (!subBuildStartedRaised) {
                    subBuildStartedRaised = true;
                    subBuildStarted( event );
                }
            }
        }
    }

}
