// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.listener;


import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.util.StringUtils;


public class ProfileLogger extends org.apache.tools.ant.DefaultLogger
{

    private java.util.Map profileData = new java.util.HashMap();

    public  void targetStarted( org.apache.tools.ant.BuildEvent event )
    {
        java.util.Date now = new java.util.Date();
        java.lang.String name = "Target " + event.getTarget().getName();
        logStart( event, now, name );
        profileData.put( event.getTarget(), now );
    }

    public  void targetFinished( org.apache.tools.ant.BuildEvent event )
    {
        java.util.Date start = (java.util.Date) profileData.remove( event.getTarget() );
        java.lang.String name = "Target " + event.getTarget().getName();
        logFinish( event, start, name );
    }

    public  void taskStarted( org.apache.tools.ant.BuildEvent event )
    {
        java.lang.String name = event.getTask().getTaskName();
        java.util.Date now = new java.util.Date();
        logStart( event, now, name );
        profileData.put( event.getTask(), now );
    }

    public  void taskFinished( org.apache.tools.ant.BuildEvent event )
    {
        java.util.Date start = (java.util.Date) profileData.remove( event.getTask() );
        java.lang.String name = event.getTask().getTaskName();
        logFinish( event, start, name );
    }

    private  void logFinish( org.apache.tools.ant.BuildEvent event, java.util.Date start, java.lang.String name )
    {
        java.util.Date now = new java.util.Date();
        java.lang.String msg = null;
        if (start != null) {
            long diff = now.getTime() - start.getTime();
            msg = StringUtils.LINE_SEP + name + ": finished " + now + " (" + diff + "ms)";
        } else {
            msg = StringUtils.LINE_SEP + name + ": finished " + now + " (unknown duration, start not detected)";
        }
        printMessage( msg, out, event.getPriority() );
        log( msg );
    }

    private  void logStart( org.apache.tools.ant.BuildEvent event, java.util.Date start, java.lang.String name )
    {
        java.lang.String msg = StringUtils.LINE_SEP + name + ": started " + start;
        printMessage( msg, out, event.getPriority() );
        log( msg );
    }

}
