// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.compilers;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.Path;


public class Jvc extends org.apache.tools.ant.taskdefs.compilers.DefaultCompilerAdapter
{

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        attributes.log( "Using jvc compiler", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Path classpath = new org.apache.tools.ant.types.Path( project );
        org.apache.tools.ant.types.Path p = getBootClassPath();
        if (p.size() > 0) {
            classpath.append( p );
        }
        if (includeJavaRuntime) {
            classpath.addExtdirs( extdirs );
        }
        classpath.append( getCompileClasspath() );
        if (compileSourcepath != null) {
            classpath.append( compileSourcepath );
        } else {
            classpath.append( src );
        }
        org.apache.tools.ant.types.Commandline cmd = new org.apache.tools.ant.types.Commandline();
        java.lang.String exec = getJavac().getExecutable();
        cmd.setExecutable( exec == null ? "jvc" : exec );
        if (destDir != null) {
            cmd.createArgument().setValue( "/d" );
            cmd.createArgument().setFile( destDir );
        }
        cmd.createArgument().setValue( "/cp:p" );
        cmd.createArgument().setPath( classpath );
        boolean msExtensions = true;
        java.lang.String mse = getProject().getProperty( "build.compiler.jvc.extensions" );
        if (mse != null) {
            msExtensions = Project.toBoolean( mse );
        }
        if (msExtensions) {
            cmd.createArgument().setValue( "/x-" );
            cmd.createArgument().setValue( "/nomessage" );
        }
        cmd.createArgument().setValue( "/nologo" );
        if (debug) {
            cmd.createArgument().setValue( "/g" );
        }
        if (optimize) {
            cmd.createArgument().setValue( "/O" );
        }
        if (verbose) {
            cmd.createArgument().setValue( "/verbose" );
        }
        addCurrentCompilerArgs( cmd );
        int firstFileName = cmd.size();
        logAndAddFilesToCompile( cmd );
        return executeExternalCompile( cmd.getCommandline(), firstFileName, false ) == 0;
    }

}
