// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.compilers;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.ExecuteJava;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.Path;


public class Kjc extends org.apache.tools.ant.taskdefs.compilers.DefaultCompilerAdapter
{

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        attributes.log( "Using kjc compiler", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Commandline cmd = setupKjcCommand();
        cmd.setExecutable( "at.dms.kjc.Main" );
        org.apache.tools.ant.taskdefs.ExecuteJava ej = new org.apache.tools.ant.taskdefs.ExecuteJava();
        ej.setJavaCommand( cmd );
        return ej.fork( getJavac() ) == 0;
    }

    protected  org.apache.tools.ant.types.Commandline setupKjcCommand()
    {
        org.apache.tools.ant.types.Commandline cmd = new org.apache.tools.ant.types.Commandline();
        org.apache.tools.ant.types.Path classpath = getCompileClasspath();
        if (deprecation) {
            cmd.createArgument().setValue( "-deprecation" );
        }
        if (destDir != null) {
            cmd.createArgument().setValue( "-d" );
            cmd.createArgument().setFile( destDir );
        }
        cmd.createArgument().setValue( "-classpath" );
        org.apache.tools.ant.types.Path cp = new org.apache.tools.ant.types.Path( project );
        org.apache.tools.ant.types.Path p = getBootClassPath();
        if (p.size() > 0) {
            cp.append( p );
        }
        if (extdirs != null) {
            cp.addExtdirs( extdirs );
        }
        cp.append( classpath );
        if (compileSourcepath != null) {
            cp.append( compileSourcepath );
        } else {
            cp.append( src );
        }
        cmd.createArgument().setPath( cp );
        if (encoding != null) {
            cmd.createArgument().setValue( "-encoding" );
            cmd.createArgument().setValue( encoding );
        }
        if (debug) {
            cmd.createArgument().setValue( "-g" );
        }
        if (optimize) {
            cmd.createArgument().setValue( "-O2" );
        }
        if (verbose) {
            cmd.createArgument().setValue( "-verbose" );
        }
        addCurrentCompilerArgs( cmd );
        logAndAddFilesToCompile( cmd );
        return cmd;
    }

}
