// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import java.util.Locale;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectComponent;


public class Http extends org.apache.tools.ant.ProjectComponent implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private static final int ERROR_BEGINS = 400;

    private static final java.lang.String DEFAULT_REQUEST_METHOD = "GET";

    private java.lang.String spec = null;

    private java.lang.String requestMethod = DEFAULT_REQUEST_METHOD;

    public  void setUrl( java.lang.String url )
    {
        spec = url;
    }

    private int errorsBeginAt = ERROR_BEGINS;

    public  void setErrorsBeginAt( int errorsBeginAt )
    {
        this.errorsBeginAt = errorsBeginAt;
    }

    public  void setRequestMethod( java.lang.String method )
    {
        this.requestMethod = method == null ? DEFAULT_REQUEST_METHOD : method.toUpperCase( Locale.ENGLISH );
    }

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (spec == null) {
            throw new org.apache.tools.ant.BuildException( "No url specified in http condition" );
        }
        log( "Checking for " + spec, Project.MSG_VERBOSE );
        try {
            java.net.URL url = new java.net.URL( spec );
            try {
                java.net.URLConnection conn = url.openConnection();
                if (conn instanceof java.net.HttpURLConnection) {
                    java.net.HttpURLConnection http = (java.net.HttpURLConnection) conn;
                    http.setRequestMethod( requestMethod );
                    int code = http.getResponseCode();
                    log( "Result code for " + spec + " was " + code, Project.MSG_VERBOSE );
                    if (code > 0 && code < errorsBeginAt) {
                        return true;
                    }
                    return false;
                }
            } catch ( java.net.ProtocolException pe ) {
                throw new org.apache.tools.ant.BuildException( "Invalid HTTP protocol: " + requestMethod, pe );
            } catch ( java.io.IOException e ) {
                return false;
            }
        } catch ( java.net.MalformedURLException e ) {
            throw new org.apache.tools.ant.BuildException( "Badly formed URL: " + spec, e );
        }
        return true;
    }

}
