// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectComponent;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;


public class IsReachable extends org.apache.tools.ant.ProjectComponent implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private static final int SECOND = 1000;

    private java.lang.String host;

    private java.lang.String url;

    public static final int DEFAULT_TIMEOUT = 30;

    private int timeout = DEFAULT_TIMEOUT;

    public static final java.lang.String ERROR_NO_HOSTNAME = "No hostname defined";

    public static final java.lang.String ERROR_BAD_TIMEOUT = "Invalid timeout value";

    private static final java.lang.String WARN_UNKNOWN_HOST = "Unknown host: ";

    public static final java.lang.String ERROR_ON_NETWORK = "network error to ";

    public static final java.lang.String ERROR_BOTH_TARGETS = "Both url and host have been specified";

    public static final java.lang.String MSG_NO_REACHABLE_TEST = "cannot do a proper reachability test on this Java version";

    public static final java.lang.String ERROR_BAD_URL = "Bad URL ";

    public static final java.lang.String ERROR_NO_HOST_IN_URL = "No hostname in URL ";

    public static final java.lang.String METHOD_NAME = "isReachable";

    public  void setHost( java.lang.String host )
    {
        this.host = host;
    }

    public  void setUrl( java.lang.String url )
    {
        this.url = url;
    }

    public  void setTimeout( int timeout )
    {
        this.timeout = timeout;
    }

    private  boolean empty( java.lang.String string )
    {
        return string == null || string.length() == 0;
    }

    private static java.lang.Class[] parameterTypes = { Integer.TYPE };

    public  boolean eval()
        throws org.apache.tools.ant.BuildException
    {
        if (empty( host ) && empty( url )) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_HOSTNAME );
        }
        if (timeout < 0) {
            throw new org.apache.tools.ant.BuildException( ERROR_BAD_TIMEOUT );
        }
        java.lang.String target = host;
        if (!empty( url )) {
            if (!empty( host )) {
                throw new org.apache.tools.ant.BuildException( ERROR_BOTH_TARGETS );
            }
            try {
                java.net.URL realURL = new java.net.URL( url );
                target = realURL.getHost();
                if (empty( target )) {
                    throw new org.apache.tools.ant.BuildException( ERROR_NO_HOST_IN_URL + url );
                }
            } catch ( java.net.MalformedURLException e ) {
                throw new org.apache.tools.ant.BuildException( ERROR_BAD_URL + url, e );
            }
        }
        log( "Probing host " + target, Project.MSG_VERBOSE );
        java.net.InetAddress address;
        try {
            address = InetAddress.getByName( target );
        } catch ( java.net.UnknownHostException e1 ) {
            log( WARN_UNKNOWN_HOST + target );
            return false;
        }
        log( "Host address = " + address.getHostAddress(), Project.MSG_VERBOSE );
        boolean reachable;
        java.lang.reflect.Method reachableMethod = null;
        try {
            reachableMethod = (java.net.InetAddress.class).getMethod( METHOD_NAME, parameterTypes );
            java.lang.Object[] params = new java.lang.Object[1];
            params[0] = new java.lang.Integer( timeout * SECOND );
            try {
                reachable = ((java.lang.Boolean) reachableMethod.invoke( address, params )).booleanValue();
            } catch ( java.lang.IllegalAccessException e ) {
                throw new org.apache.tools.ant.BuildException( "When calling " + reachableMethod );
            } catch ( java.lang.reflect.InvocationTargetException e ) {
                java.lang.Throwable nested = e.getTargetException();
                log( ERROR_ON_NETWORK + target + ": " + nested.toString() );
                reachable = false;
            }
        } catch ( java.lang.NoSuchMethodException e ) {
            log( "Not found: InetAddress." + METHOD_NAME, Project.MSG_VERBOSE );
            log( MSG_NO_REACHABLE_TEST );
            reachable = true;
        }
        log( "host is" + (reachable ? "" : " not") + " reachable", Project.MSG_VERBOSE );
        return reachable;
    }

}
