// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.condition;


import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.ManifestTask;
import org.apache.tools.ant.types.DataType;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipFile;


public class IsSigned extends org.apache.tools.ant.types.DataType implements org.apache.tools.ant.taskdefs.condition.Condition
{

    private static final java.lang.String SIG_START = "META-INF/";

    private static final java.lang.String SIG_END = ".SF";

    private static final int SHORT_SIG_LIMIT = 8;

    private java.lang.String name;

    private java.io.File file;

    public  void setFile( java.io.File file )
    {
        this.file = file;
    }

    public  void setName( java.lang.String name )
    {
        this.name = name;
    }

    public static  boolean isSigned( java.io.File zipFile, java.lang.String name )
        throws java.io.IOException
    {
        org.apache.tools.zip.ZipFile jarFile = null;
        try {
            jarFile = new org.apache.tools.zip.ZipFile( zipFile );
            if (null == name) {
                java.util.Enumeration entries = jarFile.getEntries();
                while (entries.hasMoreElements()) {
                    java.lang.String eName = ((org.apache.tools.zip.ZipEntry) entries.nextElement()).getName();
                    if (eName.startsWith( SIG_START ) && eName.endsWith( SIG_END )) {
                        return true;
                    }
                }
                return false;
            }
            name = replaceInvalidChars( name );
            boolean shortSig = jarFile.getEntry( SIG_START + name.toUpperCase() + SIG_END ) != null;
            boolean longSig = false;
            if (name.length() > SHORT_SIG_LIMIT) {
                longSig = jarFile.getEntry( SIG_START + name.substring( 0, SHORT_SIG_LIMIT ).toUpperCase() + SIG_END ) != null;
            }
            return shortSig || longSig;
        } finally 
{
            ZipFile.closeQuietly( jarFile );
        }
    }

    public  boolean eval()
    {
        if (file == null) {
            throw new org.apache.tools.ant.BuildException( "The file attribute must be set." );
        }
        if (!file.exists()) {
            log( "The file \"" + file.getAbsolutePath() + "\" does not exist.", Project.MSG_VERBOSE );
            return false;
        }
        boolean r = false;
        try {
            r = isSigned( file, name );
        } catch ( java.io.IOException e ) {
            log( "Got IOException reading file \"" + file.getAbsolutePath() + "\"" + e, Project.MSG_WARN );
        }
        if (r) {
            log( "File \"" + file.getAbsolutePath() + "\" is signed.", Project.MSG_VERBOSE );
        }
        return r;
    }

    private static  java.lang.String replaceInvalidChars( final java.lang.String name )
    {
        java.lang.StringBuffer sb = new java.lang.StringBuffer();
        final int len = name.length();
        boolean changes = false;
        for (int i = 0; i < len; i++) {
            final char ch = name.charAt( i );
            if (ManifestTask.VALID_ATTRIBUTE_CHARS.indexOf( ch ) < 0) {
                sb.append( "_" );
                changes = true;
            } else {
                sb.append( ch );
            }
        }
        return changes ? sb.toString() : name;
    }

}
