// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ccm;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.ExecuteStreamHandler;
import org.apache.tools.ant.types.Commandline;


public class CCMCreateTask extends org.apache.tools.ant.taskdefs.optional.ccm.Continuus implements org.apache.tools.ant.taskdefs.ExecuteStreamHandler
{

    private java.lang.String comment = null;

    private java.lang.String platform = null;

    private java.lang.String resolver = null;

    private java.lang.String release = null;

    private java.lang.String subSystem = null;

    private java.lang.String task = null;

    public CCMCreateTask()
    {
        super();
        setCcmAction( COMMAND_CREATE_TASK );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        int result = 0;
        commandLine.setExecutable( getCcmCommand() );
        commandLine.createArgument().setValue( getCcmAction() );
        checkOptions( commandLine );
        result = run( commandLine, this );
        if (Execute.isFailure( result )) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        org.apache.tools.ant.types.Commandline commandLine2 = new org.apache.tools.ant.types.Commandline();
        commandLine2.setExecutable( getCcmCommand() );
        commandLine2.createArgument().setValue( COMMAND_DEFAULT_TASK );
        commandLine2.createArgument().setValue( getTask() );
        log( commandLine.describeCommand(), Project.MSG_DEBUG );
        result = run( commandLine2 );
        if (result != 0) {
            java.lang.String msg = "Failed executing: " + commandLine2.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() != null) {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( "\"" + getComment() + "\"" );
        }
        if (getPlatform() != null) {
            cmd.createArgument().setValue( FLAG_PLATFORM );
            cmd.createArgument().setValue( getPlatform() );
        }
        if (getResolver() != null) {
            cmd.createArgument().setValue( FLAG_RESOLVER );
            cmd.createArgument().setValue( getResolver() );
        }
        if (getSubSystem() != null) {
            cmd.createArgument().setValue( FLAG_SUBSYSTEM );
            cmd.createArgument().setValue( "\"" + getSubSystem() + "\"" );
        }
        if (getRelease() != null) {
            cmd.createArgument().setValue( FLAG_RELEASE );
            cmd.createArgument().setValue( getRelease() );
        }
    }

    public  java.lang.String getComment()
    {
        return comment;
    }

    public  void setComment( java.lang.String v )
    {
        this.comment = v;
    }

    public  java.lang.String getPlatform()
    {
        return platform;
    }

    public  void setPlatform( java.lang.String v )
    {
        this.platform = v;
    }

    public  java.lang.String getResolver()
    {
        return resolver;
    }

    public  void setResolver( java.lang.String v )
    {
        this.resolver = v;
    }

    public  java.lang.String getRelease()
    {
        return release;
    }

    public  void setRelease( java.lang.String v )
    {
        this.release = v;
    }

    public  java.lang.String getSubSystem()
    {
        return subSystem;
    }

    public  void setSubSystem( java.lang.String v )
    {
        this.subSystem = v;
    }

    public  java.lang.String getTask()
    {
        return task;
    }

    public  void setTask( java.lang.String v )
    {
        this.task = v;
    }

    public static final java.lang.String FLAG_COMMENT = "/synopsis";

    public static final java.lang.String FLAG_PLATFORM = "/plat";

    public static final java.lang.String FLAG_RESOLVER = "/resolver";

    public static final java.lang.String FLAG_RELEASE = "/release";

    public static final java.lang.String FLAG_SUBSYSTEM = "/subsystem";

    public static final java.lang.String FLAG_TASK = "/task";

    public  void start()
        throws java.io.IOException
    {
    }

    public  void stop()
    {
    }

    public  void setProcessInputStream( java.io.OutputStream param1 )
        throws java.io.IOException
    {
    }

    public  void setProcessErrorStream( java.io.InputStream is )
        throws java.io.IOException
    {
        java.io.BufferedReader reader = new java.io.BufferedReader( new java.io.InputStreamReader( is ) );
        java.lang.String s = reader.readLine();
        if (s != null) {
            log( "err " + s, Project.MSG_DEBUG );
        }
    }

    public  void setProcessOutputStream( java.io.InputStream is )
        throws java.io.IOException
    {
        java.lang.String buffer = "";
        try {
            java.io.BufferedReader reader = new java.io.BufferedReader( new java.io.InputStreamReader( is ) );
            buffer = reader.readLine();
            if (buffer != null) {
                log( "buffer:" + buffer, Project.MSG_DEBUG );
                java.lang.String taskstring = buffer.substring( buffer.indexOf( ' ' ) ).trim();
                taskstring = taskstring.substring( 0, taskstring.lastIndexOf( ' ' ) ).trim();
                setTask( taskstring );
                log( "task is " + getTask(), Project.MSG_DEBUG );
            }
        } catch ( java.lang.NullPointerException npe ) {
            log( "error procession stream , null pointer exception", Project.MSG_ERR );
            npe.printStackTrace();
            throw new org.apache.tools.ant.BuildException( npe.getClass().getName() );
        } catch ( java.lang.Exception e ) {
            log( "error procession stream " + e.getMessage(), Project.MSG_ERR );
            throw new org.apache.tools.ant.BuildException( e.getMessage() );
        }
    }

}
