// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.clearcase;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;


public class CCLock extends org.apache.tools.ant.taskdefs.optional.clearcase.ClearCase
{

    private boolean mReplace = false;

    private boolean mObsolete = false;

    private java.lang.String mComment = null;

    private java.lang.String mNusers = null;

    private java.lang.String mPname = null;

    private java.lang.String mObjselect = null;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        org.apache.tools.ant.Project aProj = getProject();
        int result = 0;
        if (getViewPath() == null) {
            setViewPath( aProj.getBaseDir().getPath() );
        }
        commandLine.setExecutable( getClearToolCommand() );
        commandLine.createArgument().setValue( COMMAND_LOCK );
        checkOptions( commandLine );
        if (!getFailOnErr()) {
            getProject().log( "Ignoring any errors that occur for: " + getOpType(), Project.MSG_VERBOSE );
        }
        result = run( commandLine );
        if (Execute.isFailure( result ) && getFailOnErr()) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getReplace()) {
            cmd.createArgument().setValue( FLAG_REPLACE );
        }
        if (getObsolete()) {
            cmd.createArgument().setValue( FLAG_OBSOLETE );
        } else {
            getNusersCommand( cmd );
        }
        getCommentCommand( cmd );
        if (getObjselect() == null && getPname() == null) {
            throw new org.apache.tools.ant.BuildException( "Should select either an element " + "(pname) or an object (objselect)" );
        }
        getPnameCommand( cmd );
        if (getObjselect() != null) {
            cmd.createArgument().setValue( getObjselect() );
        }
    }

    public  void setReplace( boolean replace )
    {
        mReplace = replace;
    }

    public  boolean getReplace()
    {
        return mReplace;
    }

    public  void setObsolete( boolean obsolete )
    {
        mObsolete = obsolete;
    }

    public  boolean getObsolete()
    {
        return mObsolete;
    }

    public  void setNusers( java.lang.String nusers )
    {
        mNusers = nusers;
    }

    public  java.lang.String getNusers()
    {
        return mNusers;
    }

    public  void setComment( java.lang.String comment )
    {
        mComment = comment;
    }

    public  java.lang.String getComment()
    {
        return mComment;
    }

    public  void setPname( java.lang.String pname )
    {
        mPname = pname;
    }

    public  java.lang.String getPname()
    {
        return mPname;
    }

    public  void setObjSel( java.lang.String objsel )
    {
        mObjselect = objsel;
    }

    public  void setObjselect( java.lang.String objselect )
    {
        mObjselect = objselect;
    }

    public  java.lang.String getObjselect()
    {
        return mObjselect;
    }

    private  void getNusersCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getNusers() == null) {
            return;
        } else {
            cmd.createArgument().setValue( FLAG_NUSERS );
            cmd.createArgument().setValue( getNusers() );
        }
    }

    private  void getCommentCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() == null) {
            return;
        } else {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
    }

    private  void getPnameCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getPname() == null) {
            return;
        } else {
            cmd.createArgument().setValue( FLAG_PNAME );
            cmd.createArgument().setValue( getPname() );
        }
    }

    private  java.lang.String getOpType()
    {
        if (getPname() != null) {
            return getPname();
        } else {
            return getObjselect();
        }
    }

    public static final java.lang.String FLAG_REPLACE = "-replace";

    public static final java.lang.String FLAG_NUSERS = "-nusers";

    public static final java.lang.String FLAG_OBSOLETE = "-obsolete";

    public static final java.lang.String FLAG_COMMENT = "-comment";

    public static final java.lang.String FLAG_PNAME = "-pname";

}
