// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.clearcase;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.taskdefs.condition.Os;


public class CCMkattr extends org.apache.tools.ant.taskdefs.optional.clearcase.ClearCase
{

    private boolean mReplace = false;

    private boolean mRecurse = false;

    private java.lang.String mVersion = null;

    private java.lang.String mTypeName = null;

    private java.lang.String mTypeValue = null;

    private java.lang.String mComment = null;

    private java.lang.String mCfile = null;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        org.apache.tools.ant.Project aProj = getProject();
        int result = 0;
        if (getTypeName() == null) {
            throw new org.apache.tools.ant.BuildException( "Required attribute TypeName not specified" );
        }
        if (getTypeValue() == null) {
            throw new org.apache.tools.ant.BuildException( "Required attribute TypeValue not specified" );
        }
        if (getViewPath() == null) {
            setViewPath( aProj.getBaseDir().getPath() );
        }
        commandLine.setExecutable( getClearToolCommand() );
        commandLine.createArgument().setValue( COMMAND_MKATTR );
        checkOptions( commandLine );
        if (!getFailOnErr()) {
            getProject().log( "Ignoring any errors that occur for: " + getViewPathBasename(), Project.MSG_VERBOSE );
        }
        result = run( commandLine );
        if (Execute.isFailure( result ) && getFailOnErr()) {
            java.lang.String msg = "Failed executing: " + commandLine.toString();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  void checkOptions( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getReplace()) {
            cmd.createArgument().setValue( FLAG_REPLACE );
        }
        if (getRecurse()) {
            cmd.createArgument().setValue( FLAG_RECURSE );
        }
        if (getVersion() != null) {
            getVersionCommand( cmd );
        }
        if (getComment() != null) {
            getCommentCommand( cmd );
        } else {
            if (getCommentFile() != null) {
                getCommentFileCommand( cmd );
            } else {
                cmd.createArgument().setValue( FLAG_NOCOMMENT );
            }
        }
        if (getTypeName() != null) {
            getTypeCommand( cmd );
        }
        if (getTypeValue() != null) {
            getTypeValueCommand( cmd );
        }
        cmd.createArgument().setValue( getViewPath() );
    }

    public  void setReplace( boolean replace )
    {
        mReplace = replace;
    }

    public  boolean getReplace()
    {
        return mReplace;
    }

    public  void setRecurse( boolean recurse )
    {
        mRecurse = recurse;
    }

    public  boolean getRecurse()
    {
        return mRecurse;
    }

    public  void setVersion( java.lang.String version )
    {
        mVersion = version;
    }

    public  java.lang.String getVersion()
    {
        return mVersion;
    }

    public  void setComment( java.lang.String comment )
    {
        mComment = comment;
    }

    public  java.lang.String getComment()
    {
        return mComment;
    }

    public  void setCommentFile( java.lang.String cfile )
    {
        mCfile = cfile;
    }

    public  java.lang.String getCommentFile()
    {
        return mCfile;
    }

    public  void setTypeName( java.lang.String tn )
    {
        mTypeName = tn;
    }

    public  java.lang.String getTypeName()
    {
        return mTypeName;
    }

    public  void setTypeValue( java.lang.String tv )
    {
        mTypeValue = tv;
    }

    public  java.lang.String getTypeValue()
    {
        return mTypeValue;
    }

    private  void getVersionCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getVersion() != null) {
            cmd.createArgument().setValue( FLAG_VERSION );
            cmd.createArgument().setValue( getVersion() );
        }
    }

    private  void getCommentCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getComment() != null) {
            cmd.createArgument().setValue( FLAG_COMMENT );
            cmd.createArgument().setValue( getComment() );
        }
    }

    private  void getCommentFileCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        if (getCommentFile() != null) {
            cmd.createArgument().setValue( FLAG_COMMENTFILE );
            cmd.createArgument().setValue( getCommentFile() );
        }
    }

    private  void getTypeCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        java.lang.String typenm = getTypeName();
        if (typenm != null) {
            cmd.createArgument().setValue( typenm );
        }
    }

    private  void getTypeValueCommand( org.apache.tools.ant.types.Commandline cmd )
    {
        java.lang.String typevl = getTypeValue();
        if (typevl != null) {
            if (Os.isFamily( "windows" )) {
                typevl = "\\\"" + typevl + "\\\"";
            } else {
                typevl = "\"" + typevl + "\"";
            }
            cmd.createArgument().setValue( typevl );
        }
    }

    public static final java.lang.String FLAG_REPLACE = "-replace";

    public static final java.lang.String FLAG_RECURSE = "-recurse";

    public static final java.lang.String FLAG_VERSION = "-version";

    public static final java.lang.String FLAG_COMMENT = "-c";

    public static final java.lang.String FLAG_COMMENTFILE = "-cfile";

    public static final java.lang.String FLAG_NOCOMMENT = "-nc";

}
