// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.depend.constantpool;


import java.io.DataInputStream;
import java.io.IOException;


public class MethodRefCPInfo extends org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPoolEntry
{

    private java.lang.String methodClassName;

    private java.lang.String methodName;

    private java.lang.String methodType;

    private int classIndex;

    private int nameAndTypeIndex;

    public MethodRefCPInfo()
    {
        super( CONSTANT_METHODREF, 1 );
    }

    public  void read( java.io.DataInputStream cpStream )
        throws java.io.IOException
    {
        classIndex = cpStream.readUnsignedShort();
        nameAndTypeIndex = cpStream.readUnsignedShort();
    }

    public  java.lang.String toString()
    {
        java.lang.String value;
        if (isResolved()) {
            value = "Method : Class = " + methodClassName + ", name = " + methodName + ", type = " + methodType;
        } else {
            value = "Method : Class index = " + classIndex + ", name and type index = " + nameAndTypeIndex;
        }
        return value;
    }

    public  void resolve( org.apache.tools.ant.taskdefs.optional.depend.constantpool.ConstantPool constantPool )
    {
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo methodClass = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.ClassCPInfo) constantPool.getEntry( classIndex );
        methodClass.resolve( constantPool );
        methodClassName = methodClass.getClassName();
        org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo nt = (org.apache.tools.ant.taskdefs.optional.depend.constantpool.NameAndTypeCPInfo) constantPool.getEntry( nameAndTypeIndex );
        nt.resolve( constantPool );
        methodName = nt.getName();
        methodType = nt.getType();
        super.resolve( constantPool );
    }

    public  java.lang.String getMethodClassName()
    {
        return methodClassName;
    }

    public  java.lang.String getMethodName()
    {
        return methodName;
    }

    public  java.lang.String getMethodType()
    {
        return methodType;
    }

}
