// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ejb;


import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.xml.parsers.SAXParser;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Java;
import org.apache.tools.ant.types.Path;


public class JonasDeploymentTool extends org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool
{

    protected static final java.lang.String EJB_JAR_1_1_PUBLIC_ID = "-//Sun Microsystems, Inc.//DTD Enterprise JavaBeans 1.1//EN";

    protected static final java.lang.String EJB_JAR_2_0_PUBLIC_ID = "-//Sun Microsystems, Inc.//DTD Enterprise JavaBeans 2.0//EN";

    protected static final java.lang.String JONAS_EJB_JAR_2_4_PUBLIC_ID = "-//ObjectWeb//DTD JOnAS 2.4//EN";

    protected static final java.lang.String JONAS_EJB_JAR_2_5_PUBLIC_ID = "-//ObjectWeb//DTD JOnAS 2.5//EN";

    protected static final java.lang.String RMI_ORB = "RMI";

    protected static final java.lang.String JEREMIE_ORB = "JEREMIE";

    protected static final java.lang.String DAVID_ORB = "DAVID";

    protected static final java.lang.String EJB_JAR_1_1_DTD = "ejb-jar_1_1.dtd";

    protected static final java.lang.String EJB_JAR_2_0_DTD = "ejb-jar_2_0.dtd";

    protected static final java.lang.String JONAS_EJB_JAR_2_4_DTD = "jonas-ejb-jar_2_4.dtd";

    protected static final java.lang.String JONAS_EJB_JAR_2_5_DTD = "jonas-ejb-jar_2_5.dtd";

    protected static final java.lang.String JONAS_DD = "jonas-ejb-jar.xml";

    protected static final java.lang.String GENIC_CLASS = "org.objectweb.jonas_ejb.genic.GenIC";

    protected static final java.lang.String OLD_GENIC_CLASS_1 = "org.objectweb.jonas_ejb.tools.GenWholeIC";

    protected static final java.lang.String OLD_GENIC_CLASS_2 = "org.objectweb.jonas_ejb.tools.GenIC";

    private java.lang.String descriptorName;

    private java.lang.String jonasDescriptorName;

    private java.io.File outputdir;

    private boolean keepgenerated = false;

    private boolean nocompil = false;

    private boolean novalidation = false;

    private java.lang.String javac;

    private java.lang.String javacopts;

    private java.lang.String rmicopts;

    private boolean secpropag = false;

    private boolean verbose = false;

    private java.lang.String additionalargs;

    private java.io.File jonasroot;

    private boolean keepgeneric = false;

    private java.lang.String suffix = ".jar";

    private java.lang.String orb;

    private boolean nogenic = false;

    public  void setKeepgenerated( boolean aBoolean )
    {
        keepgenerated = aBoolean;
    }

    public  void setAdditionalargs( java.lang.String aString )
    {
        additionalargs = aString;
    }

    public  void setNocompil( boolean aBoolean )
    {
        nocompil = aBoolean;
    }

    public  void setNovalidation( boolean aBoolean )
    {
        novalidation = aBoolean;
    }

    public  void setJavac( java.lang.String aString )
    {
        javac = aString;
    }

    public  void setJavacopts( java.lang.String aString )
    {
        javacopts = aString;
    }

    public  void setRmicopts( java.lang.String aString )
    {
        rmicopts = aString;
    }

    public  void setSecpropag( boolean aBoolean )
    {
        secpropag = aBoolean;
    }

    public  void setVerbose( boolean aBoolean )
    {
        verbose = aBoolean;
    }

    public  void setJonasroot( java.io.File aFile )
    {
        jonasroot = aFile;
    }

    public  void setKeepgeneric( boolean aBoolean )
    {
        keepgeneric = aBoolean;
    }

    public  void setJarsuffix( java.lang.String aString )
    {
        suffix = aString;
    }

    public  void setOrb( java.lang.String aString )
    {
        orb = aString;
    }

    public  void setNogenic( boolean aBoolean )
    {
        nogenic = aBoolean;
    }

    public  void processDescriptor( java.lang.String aDescriptorName, javax.xml.parsers.SAXParser saxParser )
    {
        descriptorName = aDescriptorName;
        log( "JOnAS Deployment Tool processing: " + descriptorName, Project.MSG_VERBOSE );
        super.processDescriptor( descriptorName, saxParser );
        if (outputdir != null) {
            log( "Deleting temp output directory '" + outputdir + "'.", Project.MSG_VERBOSE );
            deleteAllFiles( outputdir );
        }
    }

    protected  void writeJar( java.lang.String baseName, java.io.File jarfile, java.util.Hashtable ejbFiles, java.lang.String publicId )
        throws org.apache.tools.ant.BuildException
    {
        java.io.File genericJarFile = super.getVendorOutputJarFile( baseName );
        super.writeJar( baseName, genericJarFile, ejbFiles, publicId );
        addGenICGeneratedFiles( genericJarFile, ejbFiles );
        super.writeJar( baseName, getVendorOutputJarFile( baseName ), ejbFiles, publicId );
        if (!keepgeneric) {
            log( "Deleting generic JAR " + genericJarFile.toString(), Project.MSG_VERBOSE );
            genericJarFile.delete();
        }
    }

    protected  void addVendorFiles( java.util.Hashtable ejbFiles, java.lang.String ddPrefix )
    {
        jonasDescriptorName = getJonasDescriptorName();
        java.io.File jonasDD = new java.io.File( getConfig().descriptorDir, jonasDescriptorName );
        if (jonasDD.exists()) {
            ejbFiles.put( META_DIR + JONAS_DD, jonasDD );
        } else {
            log( "Unable to locate the JOnAS deployment descriptor. It was expected to be in: " + jonasDD.getPath() + ".", Project.MSG_WARN );
        }
    }

    protected  java.io.File getVendorOutputJarFile( java.lang.String baseName )
    {
        return new java.io.File( getDestDir(), baseName + suffix );
    }

    private  java.lang.String getJonasDescriptorName()
    {
        java.lang.String jonasDN;
        boolean jonasConvention = false;
        java.lang.String path;
        java.lang.String fileName;
        java.lang.String baseName;
        java.lang.String remainder;
        int startOfFileName = descriptorName.lastIndexOf( File.separatorChar );
        if (startOfFileName != -1) {
            path = descriptorName.substring( 0, startOfFileName + 1 );
            fileName = descriptorName.substring( startOfFileName + 1 );
        } else {
            path = "";
            fileName = descriptorName;
        }
        if (fileName.startsWith( EJB_DD )) {
            return path + JONAS_DD;
        }
        int endOfBaseName = descriptorName.indexOf( getConfig().baseNameTerminator, startOfFileName );
        if (endOfBaseName < 0) {
            endOfBaseName = descriptorName.lastIndexOf( '.' ) - 1;
            if (endOfBaseName < 0) {
                endOfBaseName = descriptorName.length() - 1;
            }
            jonasConvention = true;
        }
        baseName = descriptorName.substring( startOfFileName + 1, endOfBaseName + 1 );
        remainder = descriptorName.substring( endOfBaseName + 1 );
        if (jonasConvention) {
            jonasDN = path + "jonas-" + baseName + ".xml";
        } else {
            jonasDN = path + baseName + "jonas-" + remainder;
        }
        log( "Standard EJB descriptor name: " + descriptorName, Project.MSG_VERBOSE );
        log( "JOnAS-specific descriptor name: " + jonasDN, Project.MSG_VERBOSE );
        return jonasDN;
    }

    protected  java.lang.String getJarBaseName( java.lang.String descriptorFileName )
    {
        java.lang.String baseName = null;
        if (getConfig().namingScheme.getValue().equals( EjbJar.NamingScheme.DESCRIPTOR )) {
            if (descriptorFileName.indexOf( getConfig().baseNameTerminator ) == -1) {
                java.lang.String aCanonicalDescriptor = descriptorFileName.replace( '\\', '/' );
                int lastSeparatorIndex = aCanonicalDescriptor.lastIndexOf( '/' );
                int endOfBaseName;
                if (lastSeparatorIndex != -1) {
                    endOfBaseName = descriptorFileName.indexOf( ".xml", lastSeparatorIndex );
                } else {
                    endOfBaseName = descriptorFileName.indexOf( ".xml" );
                }
                if (endOfBaseName != -1) {
                    baseName = descriptorFileName.substring( 0, endOfBaseName );
                }
            }
        }
        if (baseName == null) {
            baseName = super.getJarBaseName( descriptorFileName );
        }
        log( "JAR base name: " + baseName, Project.MSG_VERBOSE );
        return baseName;
    }

    protected  void registerKnownDTDs( org.apache.tools.ant.taskdefs.optional.ejb.DescriptorHandler handler )
    {
        handler.registerDTD( EJB_JAR_1_1_PUBLIC_ID, jonasroot + File.separator + "xml" + File.separator + EJB_JAR_1_1_DTD );
        handler.registerDTD( EJB_JAR_2_0_PUBLIC_ID, jonasroot + File.separator + "xml" + File.separator + EJB_JAR_2_0_DTD );
        handler.registerDTD( JONAS_EJB_JAR_2_4_PUBLIC_ID, jonasroot + File.separator + "xml" + File.separator + JONAS_EJB_JAR_2_4_DTD );
        handler.registerDTD( JONAS_EJB_JAR_2_5_PUBLIC_ID, jonasroot + File.separator + "xml" + File.separator + JONAS_EJB_JAR_2_5_DTD );
    }

    private  void addGenICGeneratedFiles( java.io.File genericJarFile, java.util.Hashtable ejbFiles )
    {
        org.apache.tools.ant.taskdefs.Java genicTask = null;
        java.lang.String genicClass = null;
        if (nogenic) {
            return;
        }
        genicTask = new org.apache.tools.ant.taskdefs.Java( getTask() );
        genicTask.setTaskName( "genic" );
        genicTask.setFork( true );
        genicTask.createJvmarg().setValue( "-Dinstall.root=" + jonasroot );
        java.lang.String jonasConfigDir = jonasroot + File.separator + "config";
        java.io.File javaPolicyFile = new java.io.File( jonasConfigDir, "java.policy" );
        if (javaPolicyFile.exists()) {
            genicTask.createJvmarg().setValue( "-Djava.security.policy=" + javaPolicyFile.toString() );
        }
        try {
            outputdir = createTempDir();
        } catch ( java.io.IOException aIOException ) {
            java.lang.String msg = "Cannot create temp dir: " + aIOException.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, aIOException );
        }
        log( "Using temporary output directory: " + outputdir, Project.MSG_VERBOSE );
        genicTask.createArg().setValue( "-d" );
        genicTask.createArg().setFile( outputdir );
        java.lang.String key;
        java.io.File f;
        java.util.Enumeration keys = ejbFiles.keys();
        while (keys.hasMoreElements()) {
            key = (java.lang.String) keys.nextElement();
            f = new java.io.File( outputdir + File.separator + key );
            f.getParentFile().mkdirs();
        }
        log( "Worked around a bug of GenIC 2.5.", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Path classpath = getCombinedClasspath();
        if (classpath == null) {
            classpath = new org.apache.tools.ant.types.Path( getTask().getProject() );
        }
        classpath.append( new org.apache.tools.ant.types.Path( classpath.getProject(), jonasConfigDir ) );
        classpath.append( new org.apache.tools.ant.types.Path( classpath.getProject(), outputdir.toString() ) );
        if (orb != null) {
            java.lang.String orbJar = jonasroot + File.separator + "lib" + File.separator + orb + "_jonas.jar";
            classpath.append( new org.apache.tools.ant.types.Path( classpath.getProject(), orbJar ) );
        }
        log( "Using classpath: " + classpath.toString(), Project.MSG_VERBOSE );
        genicTask.setClasspath( classpath );
        genicClass = getGenicClassName( classpath );
        if (genicClass == null) {
            log( "Cannot find GenIC class in classpath.", Project.MSG_ERR );
            throw new org.apache.tools.ant.BuildException( "GenIC class not found, please check the classpath." );
        } else {
            log( "Using '" + genicClass + "' GenIC class.", Project.MSG_VERBOSE );
            genicTask.setClassname( genicClass );
        }
        if (keepgenerated) {
            genicTask.createArg().setValue( "-keepgenerated" );
        }
        if (nocompil) {
            genicTask.createArg().setValue( "-nocompil" );
        }
        if (novalidation) {
            genicTask.createArg().setValue( "-novalidation" );
        }
        if (javac != null) {
            genicTask.createArg().setValue( "-javac" );
            genicTask.createArg().setLine( javac );
        }
        if (javacopts != null && !javacopts.equals( "" )) {
            genicTask.createArg().setValue( "-javacopts" );
            genicTask.createArg().setLine( javacopts );
        }
        if (rmicopts != null && !rmicopts.equals( "" )) {
            genicTask.createArg().setValue( "-rmicopts" );
            genicTask.createArg().setLine( rmicopts );
        }
        if (secpropag) {
            genicTask.createArg().setValue( "-secpropag" );
        }
        if (verbose) {
            genicTask.createArg().setValue( "-verbose" );
        }
        if (additionalargs != null) {
            genicTask.createArg().setValue( additionalargs );
        }
        genicTask.createArg().setValue( "-noaddinjar" );
        genicTask.createArg().setValue( genericJarFile.getPath() );
        log( "Calling " + genicClass + " for " + getConfig().descriptorDir + File.separator + descriptorName + ".", Project.MSG_VERBOSE );
        if (genicTask.executeJava() != 0) {
            log( "Deleting temp output directory '" + outputdir + "'.", Project.MSG_VERBOSE );
            deleteAllFiles( outputdir );
            if (!keepgeneric) {
                log( "Deleting generic JAR " + genericJarFile.toString(), Project.MSG_VERBOSE );
                genericJarFile.delete();
            }
            throw new org.apache.tools.ant.BuildException( "GenIC reported an error." );
        }
        addAllFiles( outputdir, "", ejbFiles );
    }

     java.lang.String getGenicClassName( org.apache.tools.ant.types.Path classpath )
    {
        log( "Looking for GenIC class in classpath: " + classpath.toString(), Project.MSG_VERBOSE );
        org.apache.tools.ant.AntClassLoader cl = null;
        try {
            cl = classpath.getProject().createClassLoader( classpath );
            try {
                cl.loadClass( JonasDeploymentTool.GENIC_CLASS );
                log( "Found GenIC class '" + JonasDeploymentTool.GENIC_CLASS + "' in classpath.", Project.MSG_VERBOSE );
                return JonasDeploymentTool.GENIC_CLASS;
            } catch ( java.lang.ClassNotFoundException cnf1 ) {
                log( "GenIC class '" + JonasDeploymentTool.GENIC_CLASS + "' not found in classpath.", Project.MSG_VERBOSE );
            }
            try {
                cl.loadClass( JonasDeploymentTool.OLD_GENIC_CLASS_1 );
                log( "Found GenIC class '" + JonasDeploymentTool.OLD_GENIC_CLASS_1 + "' in classpath.", Project.MSG_VERBOSE );
                return JonasDeploymentTool.OLD_GENIC_CLASS_1;
            } catch ( java.lang.ClassNotFoundException cnf2 ) {
                log( "GenIC class '" + JonasDeploymentTool.OLD_GENIC_CLASS_1 + "' not found in classpath.", Project.MSG_VERBOSE );
            }
            try {
                cl.loadClass( JonasDeploymentTool.OLD_GENIC_CLASS_2 );
                log( "Found GenIC class '" + JonasDeploymentTool.OLD_GENIC_CLASS_2 + "' in classpath.", Project.MSG_VERBOSE );
                return JonasDeploymentTool.OLD_GENIC_CLASS_2;
            } catch ( java.lang.ClassNotFoundException cnf3 ) {
                log( "GenIC class '" + JonasDeploymentTool.OLD_GENIC_CLASS_2 + "' not found in classpath.", Project.MSG_VERBOSE );
            }
        } finally 
{
            if (cl != null) {
                cl.cleanup();
            }
        }
        return null;
    }

    protected  void checkConfiguration( java.lang.String descriptorFileName, javax.xml.parsers.SAXParser saxParser )
        throws org.apache.tools.ant.BuildException
    {
        if (jonasroot == null) {
            throw new org.apache.tools.ant.BuildException( "The jonasroot attribut is not set." );
        } else {
            if (!jonasroot.isDirectory()) {
                throw new org.apache.tools.ant.BuildException( "The jonasroot attribut '" + jonasroot + "' is not a valid directory." );
            }
        }
        if (orb != null && !orb.equals( RMI_ORB ) && !orb.equals( JEREMIE_ORB ) && !orb.equals( DAVID_ORB )) {
            throw new org.apache.tools.ant.BuildException( "The orb attribut '" + orb + "' is not valid (must be either " + RMI_ORB + ", " + JEREMIE_ORB + " or " + DAVID_ORB + ")." );
        }
        if (additionalargs != null && additionalargs.equals( "" )) {
            throw new org.apache.tools.ant.BuildException( "Empty additionalargs attribut." );
        }
        if (javac != null && javac.equals( "" )) {
            throw new org.apache.tools.ant.BuildException( "Empty javac attribut." );
        }
    }

    private  java.io.File createTempDir()
        throws java.io.IOException
    {
        java.io.File tmpDir = File.createTempFile( "genic", null, null );
        tmpDir.delete();
        if (!tmpDir.mkdir()) {
            throw new java.io.IOException( "Cannot create the temporary directory '" + tmpDir + "'." );
        }
        return tmpDir;
    }

    private  void deleteAllFiles( java.io.File aFile )
    {
        if (aFile.isDirectory()) {
            java.io.File[] someFiles = aFile.listFiles();
            for (int i = 0; i < someFiles.length; i++) {
                deleteAllFiles( someFiles[i] );
            }
        }
        aFile.delete();
    }

    private  void addAllFiles( java.io.File file, java.lang.String rootDir, java.util.Hashtable hashtable )
    {
        if (!file.exists()) {
            throw new java.lang.IllegalArgumentException();
        }
        java.lang.String newRootDir;
        if (file.isDirectory()) {
            java.io.File[] files = file.listFiles();
            for (int i = 0; i < files.length; i++) {
                if (rootDir.length() > 0) {
                    newRootDir = rootDir + File.separator + files[i].getName();
                } else {
                    newRootDir = files[i].getName();
                }
                addAllFiles( files[i], newRootDir, hashtable );
            }
        } else {
            hashtable.put( rootDir, file );
        }
    }

}
