// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ejb;


import java.io.File;
import java.util.Hashtable;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;


public class WeblogicTOPLinkDeploymentTool extends org.apache.tools.ant.taskdefs.optional.ejb.WeblogicDeploymentTool
{

    private static final java.lang.String TL_DTD_LOC = "http://www.objectpeople.com/tlwl/dtd/toplink-cmp_2_5_1.dtd";

    private java.lang.String toplinkDescriptor;

    private java.lang.String toplinkDTD;

    public  void setToplinkdescriptor( java.lang.String inString )
    {
        this.toplinkDescriptor = inString;
    }

    public  void setToplinkdtd( java.lang.String inString )
    {
        this.toplinkDTD = inString;
    }

    protected  org.apache.tools.ant.taskdefs.optional.ejb.DescriptorHandler getDescriptorHandler( java.io.File srcDir )
    {
        org.apache.tools.ant.taskdefs.optional.ejb.DescriptorHandler handler = super.getDescriptorHandler( srcDir );
        if (toplinkDTD != null) {
            handler.registerDTD( "-//The Object People, Inc.//" + "DTD TOPLink for WebLogic CMP 2.5.1//EN", toplinkDTD );
        } else {
            handler.registerDTD( "-//The Object People, Inc.//" + "DTD TOPLink for WebLogic CMP 2.5.1//EN", TL_DTD_LOC );
        }
        return handler;
    }

    protected  void addVendorFiles( java.util.Hashtable ejbFiles, java.lang.String ddPrefix )
    {
        super.addVendorFiles( ejbFiles, ddPrefix );
        java.io.File toplinkDD = new java.io.File( getConfig().descriptorDir, ddPrefix + toplinkDescriptor );
        if (toplinkDD.exists()) {
            ejbFiles.put( META_DIR + toplinkDescriptor, toplinkDD );
        } else {
            log( "Unable to locate toplink deployment descriptor. " + "It was expected to be in " + toplinkDD.getPath(), Project.MSG_WARN );
        }
    }

    public  void validateConfigured()
        throws org.apache.tools.ant.BuildException
    {
        super.validateConfigured();
        if (toplinkDescriptor == null) {
            throw new org.apache.tools.ant.BuildException( "The toplinkdescriptor attribute must " + "be specified" );
        }
    }

}
