// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.DataType;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.util.DeweyDecimal;


public class ExtensionAdapter extends org.apache.tools.ant.types.DataType
{

    private java.lang.String extensionName;

    private org.apache.tools.ant.util.DeweyDecimal specificationVersion;

    private java.lang.String specificationVendor;

    private java.lang.String implementationVendorID;

    private java.lang.String implementationVendor;

    private org.apache.tools.ant.util.DeweyDecimal implementationVersion;

    private java.lang.String implementationURL;

    public  void setExtensionName( final java.lang.String extensionName )
    {
        verifyNotAReference();
        this.extensionName = extensionName;
    }

    public  void setSpecificationVersion( final java.lang.String specificationVersion )
    {
        verifyNotAReference();
        this.specificationVersion = new org.apache.tools.ant.util.DeweyDecimal( specificationVersion );
    }

    public  void setSpecificationVendor( final java.lang.String specificationVendor )
    {
        verifyNotAReference();
        this.specificationVendor = specificationVendor;
    }

    public  void setImplementationVendorId( final java.lang.String implementationVendorID )
    {
        verifyNotAReference();
        this.implementationVendorID = implementationVendorID;
    }

    public  void setImplementationVendor( final java.lang.String implementationVendor )
    {
        verifyNotAReference();
        this.implementationVendor = implementationVendor;
    }

    public  void setImplementationVersion( final java.lang.String implementationVersion )
    {
        verifyNotAReference();
        this.implementationVersion = new org.apache.tools.ant.util.DeweyDecimal( implementationVersion );
    }

    public  void setImplementationUrl( final java.lang.String implementationURL )
    {
        verifyNotAReference();
        this.implementationURL = implementationURL;
    }

    public  void setRefid( final org.apache.tools.ant.types.Reference reference )
        throws org.apache.tools.ant.BuildException
    {
        if (null != extensionName || null != specificationVersion || null != specificationVendor || null != implementationVersion || null != implementationVendorID || null != implementationVendor || null != implementationURL) {
            throw tooManyAttributes();
        }
        super.setRefid( reference );
    }

    private  void verifyNotAReference()
        throws org.apache.tools.ant.BuildException
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
    }

     org.apache.tools.ant.taskdefs.optional.extension.Extension toExtension()
        throws org.apache.tools.ant.BuildException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter) getCheckedRef()).toExtension();
        }
        dieOnCircularReference();
        if (null == extensionName) {
            final java.lang.String message = "Extension is missing name.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        java.lang.String specificationVersionString = null;
        if (null != specificationVersion) {
            specificationVersionString = specificationVersion.toString();
        }
        java.lang.String implementationVersionString = null;
        if (null != implementationVersion) {
            implementationVersionString = implementationVersion.toString();
        }
        return new org.apache.tools.ant.taskdefs.optional.extension.Extension( extensionName, specificationVersionString, specificationVendor, implementationVersionString, implementationVendor, implementationVendorID, implementationURL );
    }

    public  java.lang.String toString()
    {
        return "{" + toExtension().toString() + "}";
    }

}
