// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.jar.JarFile;
import java.util.jar.Manifest;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.FileSet;


public final class ExtensionUtil
{

    private ExtensionUtil()
    {
    }

    static  java.util.ArrayList toExtensions( final java.util.List adapters )
        throws org.apache.tools.ant.BuildException
    {
        final java.util.ArrayList results = new java.util.ArrayList();
        final int size = adapters.size();
        for (int i = 0; i < size; i++) {
            final org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter adapter = (org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter) adapters.get( i );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = adapter.toExtension();
            results.add( extension );
        }
        return results;
    }

    static  void extractExtensions( final org.apache.tools.ant.Project project, final java.util.List libraries, final java.util.List fileset )
        throws org.apache.tools.ant.BuildException
    {
        if (!fileset.isEmpty()) {
            final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = getExtensions( project, fileset );
            for (int i = 0; i < extensions.length; i++) {
                libraries.add( extensions[i] );
            }
        }
    }

    private static  org.apache.tools.ant.taskdefs.optional.extension.Extension[] getExtensions( final org.apache.tools.ant.Project project, final java.util.List libraries )
        throws org.apache.tools.ant.BuildException
    {
        final java.util.ArrayList extensions = new java.util.ArrayList();
        final java.util.Iterator iterator = libraries.iterator();
        while (iterator.hasNext()) {
            final org.apache.tools.ant.types.FileSet fileSet = (org.apache.tools.ant.types.FileSet) iterator.next();
            boolean includeImpl = true;
            boolean includeURL = true;
            if (fileSet instanceof org.apache.tools.ant.taskdefs.optional.extension.LibFileSet) {
                org.apache.tools.ant.taskdefs.optional.extension.LibFileSet libFileSet = (org.apache.tools.ant.taskdefs.optional.extension.LibFileSet) fileSet;
                includeImpl = libFileSet.isIncludeImpl();
                includeURL = libFileSet.isIncludeURL();
            }
            final org.apache.tools.ant.DirectoryScanner scanner = fileSet.getDirectoryScanner( project );
            final java.io.File basedir = scanner.getBasedir();
            final java.lang.String[] files = scanner.getIncludedFiles();
            for (int i = 0; i < files.length; i++) {
                final java.io.File file = new java.io.File( basedir, files[i] );
                loadExtensions( file, extensions, includeImpl, includeURL );
            }
        }
        return (org.apache.tools.ant.taskdefs.optional.extension.Extension[]) extensions.toArray( new org.apache.tools.ant.taskdefs.optional.extension.Extension[extensions.size()] );
    }

    private static  void loadExtensions( final java.io.File file, final java.util.List extensionList, final boolean includeImpl, final boolean includeURL )
        throws org.apache.tools.ant.BuildException
    {
        try {
            final java.util.jar.JarFile jarFile = new java.util.jar.JarFile( file );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = Extension.getAvailable( jarFile.getManifest() );
            for (int i = 0; i < extensions.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = extensions[i];
                addExtension( extensionList, extension, includeImpl, includeURL );
            }
        } catch ( final java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( e.getMessage(), e );
        }
    }

    private static  void addExtension( final java.util.List extensionList, final org.apache.tools.ant.taskdefs.optional.extension.Extension originalExtension, final boolean includeImpl, final boolean includeURL )
    {
        org.apache.tools.ant.taskdefs.optional.extension.Extension extension = originalExtension;
        if (!includeURL && null != extension.getImplementationURL()) {
            extension = new org.apache.tools.ant.taskdefs.optional.extension.Extension( extension.getExtensionName(), extension.getSpecificationVersion().toString(), extension.getSpecificationVendor(), extension.getImplementationVersion().toString(), extension.getImplementationVendor(), extension.getImplementationVendorID(), null );
        }
        final boolean hasImplAttributes = null != extension.getImplementationURL() || null != extension.getImplementationVersion() || null != extension.getImplementationVendorID() || null != extension.getImplementationVendor();
        if (!includeImpl && hasImplAttributes) {
            extension = new org.apache.tools.ant.taskdefs.optional.extension.Extension( extension.getExtensionName(), extension.getSpecificationVersion().toString(), extension.getSpecificationVendor(), null, null, null, extension.getImplementationURL() );
        }
        extensionList.add( extension );
    }

    static  java.util.jar.Manifest getManifest( final java.io.File file )
        throws org.apache.tools.ant.BuildException
    {
        try {
            final java.util.jar.JarFile jarFile = new java.util.jar.JarFile( file );
            java.util.jar.Manifest m = jarFile.getManifest();
            if (m == null) {
                throw new org.apache.tools.ant.BuildException( file + " doesn't have a MANIFEST" );
            }
            return m;
        } catch ( final java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( ioe.getMessage(), ioe );
        }
    }

}
