// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.io.File;
import java.util.Iterator;
import java.util.Vector;
import java.util.jar.Manifest;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;


public class JarLibAvailableTask extends org.apache.tools.ant.Task
{

    private java.io.File libraryFile;

    private final java.util.Vector extensionFileSets = new java.util.Vector();

    private java.lang.String propertyName;

    private org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter requiredExtension;

    public  void setProperty( final java.lang.String property )
    {
        this.propertyName = property;
    }

    public  void setFile( final java.io.File file )
    {
        this.libraryFile = file;
    }

    public  void addConfiguredExtension( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter extension )
    {
        if (null != requiredExtension) {
            final java.lang.String message = "Can not specify extension to " + "search for multiple times.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        requiredExtension = extension;
    }

    public  void addConfiguredExtensionSet( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet extensionSet )
    {
        extensionFileSets.addElement( extensionSet );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        validate();
        final org.apache.tools.ant.taskdefs.optional.extension.Extension test = requiredExtension.toExtension();
        if (!extensionFileSets.isEmpty()) {
            final java.util.Iterator iterator = extensionFileSets.iterator();
            while (iterator.hasNext()) {
                final org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet extensionSet = (org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet) iterator.next();
                final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = extensionSet.toExtensions( getProject() );
                for (int i = 0; i < extensions.length; i++) {
                    final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = extensions[i];
                    if (extension.isCompatibleWith( test )) {
                        getProject().setNewProperty( propertyName, "true" );
                    }
                }
            }
        } else {
            final java.util.jar.Manifest manifest = ExtensionUtil.getManifest( libraryFile );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = Extension.getAvailable( manifest );
            for (int i = 0; i < extensions.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = extensions[i];
                if (extension.isCompatibleWith( test )) {
                    getProject().setNewProperty( propertyName, "true" );
                }
            }
        }
    }

    private  void validate()
        throws org.apache.tools.ant.BuildException
    {
        if (null == requiredExtension) {
            final java.lang.String message = "Extension element must be specified.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        if (null == libraryFile && extensionFileSets.isEmpty()) {
            final java.lang.String message = "File attribute not specified.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        if (null != libraryFile && !libraryFile.exists()) {
            final java.lang.String message = "File '" + libraryFile + "' does not exist.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        if (null != libraryFile && !libraryFile.isFile()) {
            final java.lang.String message = "\'" + libraryFile + "\' is not a file.";
            throw new org.apache.tools.ant.BuildException( message );
        }
    }

}
