// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.io.File;
import java.text.ParseException;
import java.util.jar.Manifest;
import org.apache.tools.ant.BuildException;


class LibraryDisplayer
{

     void displayLibrary( final java.io.File file )
        throws org.apache.tools.ant.BuildException
    {
        final java.util.jar.Manifest manifest = ExtensionUtil.getManifest( file );
        displayLibrary( file, manifest );
    }

     void displayLibrary( final java.io.File file, final java.util.jar.Manifest manifest )
        throws org.apache.tools.ant.BuildException
    {
        final org.apache.tools.ant.taskdefs.optional.extension.Extension[] available = Extension.getAvailable( manifest );
        final org.apache.tools.ant.taskdefs.optional.extension.Extension[] required = Extension.getRequired( manifest );
        final org.apache.tools.ant.taskdefs.optional.extension.Extension[] options = Extension.getOptions( manifest );
        final org.apache.tools.ant.taskdefs.optional.extension.Specification[] specifications = getSpecifications( manifest );
        if (0 == available.length && 0 == required.length && 0 == options.length && 0 == specifications.length) {
            return;
        }
        final java.lang.String message = "File: " + file;
        final int size = message.length();
        printLine( size );
        System.out.println( message );
        printLine( size );
        if (0 != available.length) {
            System.out.println( "Extensions Supported By Library:" );
            for (int i = 0; i < available.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = available[i];
                System.out.println( extension.toString() );
            }
        }
        if (0 != required.length) {
            System.out.println( "Extensions Required By Library:" );
            for (int i = 0; i < required.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = required[i];
                System.out.println( extension.toString() );
            }
        }
        if (0 != options.length) {
            System.out.println( "Extensions that will be used by Library if present:" );
            for (int i = 0; i < options.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = options[i];
                System.out.println( extension.toString() );
            }
        }
        if (0 != specifications.length) {
            System.out.println( "Specifications Supported By Library:" );
            for (int i = 0; i < specifications.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Specification specification = specifications[i];
                displaySpecification( specification );
            }
        }
    }

    private  void printLine( final int size )
    {
        for (int i = 0; i < size; i++) {
            System.out.print( "-" );
        }
        System.out.println();
    }

    private  org.apache.tools.ant.taskdefs.optional.extension.Specification[] getSpecifications( final java.util.jar.Manifest manifest )
        throws org.apache.tools.ant.BuildException
    {
        try {
            return Specification.getSpecifications( manifest );
        } catch ( final java.text.ParseException pe ) {
            throw new org.apache.tools.ant.BuildException( pe.getMessage(), pe );
        }
    }

    private  void displaySpecification( final org.apache.tools.ant.taskdefs.optional.extension.Specification specification )
    {
        final java.lang.String[] sections = specification.getSections();
        if (null != sections) {
            final java.lang.StringBuffer sb = new java.lang.StringBuffer( "Sections: " );
            for (int i = 0; i < sections.length; i++) {
                sb.append( " " );
                sb.append( sections[i] );
            }
            System.out.println( sb );
        }
        System.out.println( specification.toString() );
    }

}
