// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension.resolvers;


import java.io.File;
import java.net.URL;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Get;
import org.apache.tools.ant.taskdefs.optional.extension.Extension;
import org.apache.tools.ant.taskdefs.optional.extension.ExtensionResolver;


public class URLResolver implements org.apache.tools.ant.taskdefs.optional.extension.ExtensionResolver
{

    private java.io.File destfile;

    private java.io.File destdir;

    private java.net.URL url;

    public  void setUrl( final java.net.URL url )
    {
        this.url = url;
    }

    public  void setDestfile( final java.io.File destfile )
    {
        this.destfile = destfile;
    }

    public  void setDestdir( final java.io.File destdir )
    {
        this.destdir = destdir;
    }

    public  java.io.File resolve( final org.apache.tools.ant.taskdefs.optional.extension.Extension extension, final org.apache.tools.ant.Project project )
        throws org.apache.tools.ant.BuildException
    {
        validate();
        final java.io.File file = getDest();
        final org.apache.tools.ant.taskdefs.Get get = new org.apache.tools.ant.taskdefs.Get();
        get.setProject( project );
        get.setDest( file );
        get.setSrc( url );
        get.execute();
        return file;
    }

    private  java.io.File getDest()
    {
        java.io.File result;
        if (null != destfile) {
            result = destfile;
        } else {
            final java.lang.String file = url.getFile();
            java.lang.String filename;
            if (null == file || file.length() <= 1) {
                filename = "default.file";
            } else {
                int index = file.lastIndexOf( '/' );
                if (-1 == index) {
                    index = 0;
                }
                filename = file.substring( index );
            }
            result = new java.io.File( destdir, filename );
        }
        return result;
    }

    private  void validate()
    {
        if (null == url) {
            final java.lang.String message = "Must specify URL";
            throw new org.apache.tools.ant.BuildException( message );
        }
        if (null == destdir && null == destfile) {
            final java.lang.String message = "Must specify destination file or directory";
            throw new org.apache.tools.ant.BuildException( message );
        } else {
            if (null != destdir && null != destfile) {
                final java.lang.String message = "Must not specify both destination file or directory";
                throw new org.apache.tools.ant.BuildException( message );
            }
        }
    }

    public  java.lang.String toString()
    {
        return "URL[" + url + "]";
    }

}
