// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.image;


import com.sun.media.jai.codec.FileSeekableStream;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Mapper;
import org.apache.tools.ant.types.optional.image.Draw;
import org.apache.tools.ant.types.optional.image.ImageOperation;
import org.apache.tools.ant.types.optional.image.Rotate;
import org.apache.tools.ant.types.optional.image.Scale;
import org.apache.tools.ant.types.optional.image.TransformOperation;
import org.apache.tools.ant.util.FileNameMapper;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.IdentityMapper;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Locale;
import java.util.Vector;


public class Image extends org.apache.tools.ant.taskdefs.MatchingTask
{

    protected java.util.Vector instructions = new java.util.Vector();

    protected boolean overwrite = false;

    protected java.util.Vector filesets = new java.util.Vector();

    protected java.io.File srcDir = null;

    protected java.io.File destDir = null;

    protected java.lang.String str_encoding = "JPEG";

    protected boolean garbage_collect = false;

    private boolean failonerror = true;

    private org.apache.tools.ant.types.Mapper mapperElement = null;

    public  void addFileset( org.apache.tools.ant.types.FileSet set )
    {
        filesets.addElement( set );
    }

    public  void setFailOnError( boolean failonerror )
    {
        this.failonerror = failonerror;
    }

    public  void setSrcdir( java.io.File srcDir )
    {
        this.srcDir = srcDir;
    }

    public  void setEncoding( java.lang.String encoding )
    {
        str_encoding = encoding;
    }

    public  void setOverwrite( boolean overwrite )
    {
        this.overwrite = overwrite;
    }

    public  void setGc( boolean gc )
    {
        garbage_collect = gc;
    }

    public  void setDestDir( java.io.File destDir )
    {
        this.destDir = destDir;
    }

    public  void addImageOperation( org.apache.tools.ant.types.optional.image.ImageOperation instr )
    {
        instructions.add( instr );
    }

    public  void addRotate( org.apache.tools.ant.types.optional.image.Rotate instr )
    {
        instructions.add( instr );
    }

    public  void addScale( org.apache.tools.ant.types.optional.image.Scale instr )
    {
        instructions.add( instr );
    }

    public  void addDraw( org.apache.tools.ant.types.optional.image.Draw instr )
    {
        instructions.add( instr );
    }

    public  void add( org.apache.tools.ant.types.optional.image.ImageOperation instr )
    {
        addImageOperation( instr );
    }

    public  org.apache.tools.ant.types.Mapper createMapper()
        throws org.apache.tools.ant.BuildException
    {
        if (mapperElement != null) {
            throw new org.apache.tools.ant.BuildException( "Cannot define more than one mapper", getLocation() );
        }
        mapperElement = new org.apache.tools.ant.types.Mapper( getProject() );
        return mapperElement;
    }

    public  void add( org.apache.tools.ant.util.FileNameMapper fileNameMapper )
    {
        createMapper().add( fileNameMapper );
    }

    public  int processDir( final java.io.File srcDir, final java.lang.String[] srcNames, final java.io.File dstDir, final org.apache.tools.ant.util.FileNameMapper mapper )
    {
        int writeCount = 0;
        for (int i = 0; i < srcNames.length; ++i) {
            final java.lang.String srcName = srcNames[i];
            final java.io.File srcFile = (new java.io.File( srcDir, srcName )).getAbsoluteFile();
            final java.lang.String[] dstNames = mapper.mapFileName( srcName );
            if (dstNames == null) {
                log( srcFile + " skipped, don't know how to handle it", Project.MSG_VERBOSE );
                continue;
            }
            for (int j = 0; j < dstNames.length; ++j) {
                final java.lang.String dstName = dstNames[j];
                final java.io.File dstFile = (new java.io.File( dstDir, dstName )).getAbsoluteFile();
                if (dstFile.exists()) {
                    if (!overwrite && srcFile.lastModified() <= dstFile.lastModified()) {
                        log( srcFile + " omitted as " + dstFile + " is up to date.", Project.MSG_VERBOSE );
                        continue;
                    }
                    if (!srcFile.equals( dstFile )) {
                        dstFile.delete();
                    }
                }
                processFile( srcFile, dstFile );
                ++writeCount;
            }
        }
        if (garbage_collect) {
            System.gc();
        }
        return writeCount;
    }

    public  void processFile( java.io.File file )
    {
        processFile( file, new java.io.File( destDir == null ? srcDir : destDir, file.getName() ) );
    }

    public  void processFile( java.io.File file, java.io.File newFile )
    {
        try {
            log( "Processing File: " + file.getAbsolutePath() );
            com.sun.media.jai.codec.FileSeekableStream input = null;
            javax.media.jai.PlanarImage image = null;
            try {
                input = new com.sun.media.jai.codec.FileSeekableStream( file );
                image = JAI.create( "stream", input );
                final int size = instructions.size();
                for (int i = 0; i < size; i++) {
                    java.lang.Object instr = instructions.elementAt( i );
                    if (instr instanceof org.apache.tools.ant.types.optional.image.TransformOperation) {
                        image = ((org.apache.tools.ant.types.optional.image.TransformOperation) instr).executeTransformOperation( image );
                    } else {
                        log( "Not a TransformOperation: " + instr );
                    }
                }
            } finally 
{
                FileUtils.close( input );
            }
            java.io.File dstParent = newFile.getParentFile();
            if (!dstParent.isDirectory() && !dstParent.mkdirs()) {
                throw new org.apache.tools.ant.BuildException( "Failed to create parent directory " + dstParent );
            }
            if (overwrite && newFile.exists() && !newFile.equals( file )) {
                newFile.delete();
            }
            java.io.FileOutputStream stream = null;
            try {
                stream = new java.io.FileOutputStream( newFile );
                JAI.create( "encode", image, stream, str_encoding.toUpperCase( Locale.ENGLISH ), null );
                stream.flush();
            } finally 
{
                FileUtils.close( stream );
            }
        } catch ( java.io.IOException err ) {
            if (!file.equals( newFile )) {
                newFile.delete();
            }
            if (!failonerror) {
                log( "Error processing file:  " + err );
            } else {
                throw new org.apache.tools.ant.BuildException( err );
            }
        } catch ( java.lang.RuntimeException rerr ) {
            if (!file.equals( newFile )) {
                newFile.delete();
            }
            if (!failonerror) {
                log( "Error processing file:  " + rerr );
            } else {
                throw new org.apache.tools.ant.BuildException( rerr );
            }
        }
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        validateAttributes();
        try {
            java.io.File dest = destDir != null ? destDir : srcDir;
            int writeCount = 0;
            final org.apache.tools.ant.util.FileNameMapper mapper;
            if (mapperElement == null) {
                mapper = new org.apache.tools.ant.util.IdentityMapper();
            } else {
                mapper = mapperElement.getImplementation();
            }
            if (srcDir != null) {
                final org.apache.tools.ant.DirectoryScanner ds = super.getDirectoryScanner( srcDir );
                final java.lang.String[] files = ds.getIncludedFiles();
                writeCount += processDir( srcDir, files, dest, mapper );
            }
            final int size = filesets.size();
            for (int i = 0; i < size; i++) {
                final org.apache.tools.ant.types.FileSet fs = (org.apache.tools.ant.types.FileSet) filesets.elementAt( i );
                final org.apache.tools.ant.DirectoryScanner ds = fs.getDirectoryScanner( getProject() );
                final java.lang.String[] files = ds.getIncludedFiles();
                final java.io.File fromDir = fs.getDir( getProject() );
                writeCount += processDir( fromDir, files, dest, mapper );
            }
            if (writeCount > 0) {
                log( "Processed " + writeCount + (writeCount == 1 ? " image." : " images.") );
            }
        } catch ( java.lang.Exception err ) {
            err.printStackTrace();
            throw new org.apache.tools.ant.BuildException( err.getMessage() );
        }
    }

    protected  void validateAttributes()
        throws org.apache.tools.ant.BuildException
    {
        if (srcDir == null && filesets.size() == 0) {
            throw new org.apache.tools.ant.BuildException( "Specify at least one source" + "--a srcDir or a fileset." );
        }
        if (srcDir == null && destDir == null) {
            throw new org.apache.tools.ant.BuildException( "Specify the destDir, or the srcDir." );
        }
        if (str_encoding.equalsIgnoreCase( "jpg" )) {
            str_encoding = "JPEG";
        } else {
            if (str_encoding.equalsIgnoreCase( "tif" )) {
                str_encoding = "TIFF";
            }
        }
    }

}
