// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.j2ee;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.Java;
import org.apache.tools.ant.types.Path;


public class JonasHotDeploymentTool extends org.apache.tools.ant.taskdefs.optional.j2ee.GenericHotDeploymentTool implements org.apache.tools.ant.taskdefs.optional.j2ee.HotDeploymentTool
{

    protected static final java.lang.String DEFAULT_ORB = "RMI";

    private static final java.lang.String JONAS_DEPLOY_CLASS_NAME = "org.objectweb.jonas.adm.JonasAdmin";

    private static final java.lang.String[] VALID_ACTIONS = { ACTION_DELETE, ACTION_DEPLOY, ACTION_LIST, ACTION_UNDEPLOY, ACTION_UPDATE };

    private java.io.File jonasroot;

    private java.lang.String orb = null;

    private java.lang.String davidHost;

    private int davidPort;

    public  void setDavidhost( final java.lang.String inValue )
    {
        davidHost = inValue;
    }

    public  void setDavidport( final int inValue )
    {
        davidPort = inValue;
    }

    public  void setJonasroot( final java.io.File inValue )
    {
        jonasroot = inValue;
    }

    public  void setOrb( final java.lang.String inValue )
    {
        orb = inValue;
    }

    public  org.apache.tools.ant.types.Path getClasspath()
    {
        org.apache.tools.ant.types.Path aClassPath = super.getClasspath();
        if (aClassPath == null) {
            aClassPath = new org.apache.tools.ant.types.Path( getTask().getProject() );
        }
        if (orb != null) {
            java.lang.String aOrbJar = (new java.io.File( jonasroot, "lib/" + orb + "_jonas.jar" )).toString();
            java.lang.String aConfigDir = (new java.io.File( jonasroot, "config/" )).toString();
            org.apache.tools.ant.types.Path aJOnASOrbPath = new org.apache.tools.ant.types.Path( aClassPath.getProject(), aOrbJar + File.pathSeparator + aConfigDir );
            aClassPath.append( aJOnASOrbPath );
        }
        return aClassPath;
    }

    public  void validateAttributes()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.taskdefs.Java java = getJava();
        java.lang.String action = getTask().getAction();
        if (action == null) {
            throw new org.apache.tools.ant.BuildException( "The \"action\" attribute must be set" );
        }
        if (!isActionValid()) {
            throw new org.apache.tools.ant.BuildException( "Invalid action \"" + action + "\" passed" );
        }
        if (getClassName() == null) {
            setClassName( JONAS_DEPLOY_CLASS_NAME );
        }
        if (jonasroot == null || jonasroot.isDirectory()) {
            java.createJvmarg().setValue( "-Dinstall.root=" + jonasroot );
            java.createJvmarg().setValue( "-Djava.security.policy=" + jonasroot + "/config/java.policy" );
            if ("DAVID".equals( orb )) {
                java.createJvmarg().setValue( "-Dorg.omg.CORBA.ORBClass" + "=org.objectweb.david.libs.binding.orbs.iiop.IIOPORB" );
                java.createJvmarg().setValue( "-Dorg.omg.CORBA.ORBSingletonClass=" + "org.objectweb.david.libs.binding.orbs.ORBSingletonClass" );
                java.createJvmarg().setValue( "-Djavax.rmi.CORBA.StubClass=" + "org.objectweb.david.libs.stub_factories.rmi.StubDelegate" );
                java.createJvmarg().setValue( "-Djavax.rmi.CORBA.PortableRemoteObjectClass=" + "org.objectweb.david.libs.binding.rmi.ORBPortableRemoteObjectDelegate" );
                java.createJvmarg().setValue( "-Djavax.rmi.CORBA.UtilClass=" + "org.objectweb.david.libs.helpers.RMIUtilDelegate" );
                java.createJvmarg().setValue( "-Ddavid.CosNaming.default_method=0" );
                java.createJvmarg().setValue( "-Ddavid.rmi.ValueHandlerClass=" + "com.sun.corba.se.internal.io.ValueHandlerImpl" );
                if (davidHost != null) {
                    java.createJvmarg().setValue( "-Ddavid.CosNaming.default_host=" + davidHost );
                }
                if (davidPort != 0) {
                    java.createJvmarg().setValue( "-Ddavid.CosNaming.default_port=" + davidPort );
                }
            }
        }
        if (getServer() != null) {
            java.createArg().setLine( "-n " + getServer() );
        }
        if (action.equals( ACTION_DEPLOY ) || action.equals( ACTION_UPDATE ) || action.equals( "redeploy" )) {
            java.createArg().setLine( "-a " + getTask().getSource() );
        } else {
            if (action.equals( ACTION_DELETE ) || action.equals( ACTION_UNDEPLOY )) {
                java.createArg().setLine( "-r " + getTask().getSource() );
            } else {
                if (action.equals( ACTION_LIST )) {
                    java.createArg().setValue( "-l" );
                }
            }
        }
    }

    protected  boolean isActionValid()
    {
        boolean valid = false;
        java.lang.String action = getTask().getAction();
        for (int i = 0; i < VALID_ACTIONS.length; i++) {
            if (action.equals( VALID_ACTIONS[i] )) {
                valid = true;
                break;
            }
        }
        return valid;
    }

}
