// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.j2ee;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.Java;


public class WebLogicHotDeploymentTool extends org.apache.tools.ant.taskdefs.optional.j2ee.AbstractHotDeploymentTool implements org.apache.tools.ant.taskdefs.optional.j2ee.HotDeploymentTool
{

    private static final int STRING_BUFFER_SIZE = 1024;

    private static final java.lang.String WEBLOGIC_DEPLOY_CLASS_NAME = "weblogic.deploy";

    private static final java.lang.String[] VALID_ACTIONS = { ACTION_DELETE, ACTION_DEPLOY, ACTION_LIST, ACTION_UNDEPLOY, ACTION_UPDATE };

    private boolean debug;

    private java.lang.String application;

    private java.lang.String component;

    public  void deploy()
    {
        org.apache.tools.ant.taskdefs.Java java = new org.apache.tools.ant.taskdefs.Java( getTask() );
        java.setFork( true );
        java.setFailonerror( true );
        java.setClasspath( getClasspath() );
        java.setClassname( WEBLOGIC_DEPLOY_CLASS_NAME );
        java.createArg().setLine( getArguments() );
        java.execute();
    }

    public  void validateAttributes()
        throws org.apache.tools.ant.BuildException
    {
        super.validateAttributes();
        java.lang.String action = getTask().getAction();
        if (getPassword() == null) {
            throw new org.apache.tools.ant.BuildException( "The password attribute must be set." );
        }
        if ((action.equals( ACTION_DEPLOY ) || action.equals( ACTION_UPDATE )) && application == null) {
            throw new org.apache.tools.ant.BuildException( "The application attribute must be set " + "if action = " + action );
        }
        if ((action.equals( ACTION_DEPLOY ) || action.equals( ACTION_UPDATE )) && getTask().getSource() == null) {
            throw new org.apache.tools.ant.BuildException( "The source attribute must be set if " + "action = " + action );
        }
        if ((action.equals( ACTION_DELETE ) || action.equals( ACTION_UNDEPLOY )) && application == null) {
            throw new org.apache.tools.ant.BuildException( "The application attribute must be set if " + "action = " + action );
        }
    }

    public  java.lang.String getArguments()
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String action = getTask().getAction();
        java.lang.String args = null;
        if (action.equals( ACTION_DEPLOY ) || action.equals( ACTION_UPDATE )) {
            args = buildDeployArgs();
        } else {
            if (action.equals( ACTION_DELETE ) || action.equals( ACTION_UNDEPLOY )) {
                args = buildUndeployArgs();
            } else {
                if (action.equals( ACTION_LIST )) {
                    args = buildListArgs();
                }
            }
        }
        return args;
    }

    protected  boolean isActionValid()
    {
        boolean valid = false;
        java.lang.String action = getTask().getAction();
        for (int i = 0; i < VALID_ACTIONS.length; i++) {
            if (action.equals( VALID_ACTIONS[i] )) {
                valid = true;
                break;
            }
        }
        return valid;
    }

    protected  java.lang.StringBuffer buildArgsPrefix()
    {
        org.apache.tools.ant.taskdefs.optional.j2ee.ServerDeploy task = getTask();
        return (new java.lang.StringBuffer( STRING_BUFFER_SIZE )).append( getServer() != null ? "-url " + getServer() : "" ).append( " " ).append( debug ? "-debug " : "" ).append( getUserName() != null ? "-username " + getUserName() : "" ).append( " " ).append( task.getAction() ).append( " " ).append( getPassword() ).append( " " );
    }

    protected  java.lang.String buildDeployArgs()
    {
        java.lang.String args = buildArgsPrefix().append( application ).append( " " ).append( getTask().getSource() ).toString();
        if (component != null) {
            args = "-component " + component + " " + args;
        }
        return args;
    }

    protected  java.lang.String buildUndeployArgs()
    {
        return buildArgsPrefix().append( application ).append( " " ).toString();
    }

    protected  java.lang.String buildListArgs()
    {
        return buildArgsPrefix().toString();
    }

    public  void setDebug( boolean debug )
    {
        this.debug = debug;
    }

    public  void setApplication( java.lang.String application )
    {
        this.application = application;
    }

    public  void setComponent( java.lang.String component )
    {
        this.component = component;
    }

}
