// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.javacc;


import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.LogStreamHandler;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.CommandlineJava;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.JavaEnvUtils;


public class JJDoc extends org.apache.tools.ant.Task
{

    private static final java.lang.String OUTPUT_FILE = "OUTPUT_FILE";

    private static final java.lang.String TEXT = "TEXT";

    private static final java.lang.String ONE_TABLE = "ONE_TABLE";

    private final java.util.Hashtable optionalAttrs = new java.util.Hashtable();

    private java.lang.String outputFile = null;

    private boolean plainText = false;

    private static final java.lang.String DEFAULT_SUFFIX_HTML = ".html";

    private static final java.lang.String DEFAULT_SUFFIX_TEXT = ".txt";

    private java.io.File targetFile = null;

    private java.io.File javaccHome = null;

    private org.apache.tools.ant.types.CommandlineJava cmdl = new org.apache.tools.ant.types.CommandlineJava();

    private java.lang.String maxMemory = null;

    public  void setText( boolean plainText )
    {
        optionalAttrs.put( TEXT, plainText ? Boolean.TRUE : Boolean.FALSE );
        this.plainText = plainText;
    }

    public  void setOnetable( boolean oneTable )
    {
        optionalAttrs.put( ONE_TABLE, oneTable ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setOutputfile( java.lang.String outputFile )
    {
        this.outputFile = outputFile;
    }

    public  void setTarget( java.io.File target )
    {
        this.targetFile = target;
    }

    public  void setJavacchome( java.io.File javaccHome )
    {
        this.javaccHome = javaccHome;
    }

    public  void setMaxmemory( java.lang.String max )
    {
        maxMemory = max;
    }

    public JJDoc()
    {
        cmdl.setVm( JavaEnvUtils.getJreExecutable( "java" ) );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        java.util.Enumeration iter = optionalAttrs.keys();
        while (iter.hasMoreElements()) {
            java.lang.String name = (java.lang.String) iter.nextElement();
            java.lang.Object value = optionalAttrs.get( name );
            cmdl.createArgument().setValue( "-" + name + ":" + value.toString() );
        }
        if (targetFile == null || !targetFile.isFile()) {
            throw new org.apache.tools.ant.BuildException( "Invalid target: " + targetFile );
        }
        if (outputFile != null) {
            cmdl.createArgument().setValue( "-" + OUTPUT_FILE + ":" + outputFile.replace( '\\', '/' ) );
        }
        java.io.File javaFile = new java.io.File( createOutputFileName( targetFile, outputFile, plainText ) );
        if (javaFile.exists() && targetFile.lastModified() < javaFile.lastModified()) {
            log( "Target is already built - skipping (" + targetFile + ")", Project.MSG_VERBOSE );
            return;
        }
        cmdl.createArgument().setValue( targetFile.getAbsolutePath() );
        final org.apache.tools.ant.types.Path classpath = cmdl.createClasspath( getProject() );
        final java.io.File javaccJar = JavaCC.getArchiveFile( javaccHome );
        classpath.createPathElement().setPath( javaccJar.getAbsolutePath() );
        classpath.addJavaRuntime();
        cmdl.setClassname( JavaCC.getMainClass( classpath, JavaCC.TASKDEF_TYPE_JJDOC ) );
        cmdl.setMaxmemory( maxMemory );
        final org.apache.tools.ant.types.Commandline.Argument arg = cmdl.createVmArgument();
        arg.setValue( "-Dinstall.root=" + javaccHome.getAbsolutePath() );
        final org.apache.tools.ant.taskdefs.Execute process = new org.apache.tools.ant.taskdefs.Execute( new org.apache.tools.ant.taskdefs.LogStreamHandler( this, Project.MSG_INFO, Project.MSG_INFO ), null );
        log( cmdl.describeCommand(), Project.MSG_VERBOSE );
        process.setCommandline( cmdl.getCommandline() );
        try {
            if (process.execute() != 0) {
                throw new org.apache.tools.ant.BuildException( "JJDoc failed." );
            }
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( "Failed to launch JJDoc", e );
        }
    }

    private  java.lang.String createOutputFileName( java.io.File destFile, java.lang.String optionalOutputFile, boolean plain )
    {
        java.lang.String suffix = DEFAULT_SUFFIX_HTML;
        java.lang.String javaccFile = destFile.getAbsolutePath().replace( '\\', '/' );
        if (plain) {
            suffix = DEFAULT_SUFFIX_TEXT;
        }
        if (optionalOutputFile == null || optionalOutputFile.equals( "" )) {
            int filePos = javaccFile.lastIndexOf( "/" );
            if (filePos >= 0) {
                javaccFile = javaccFile.substring( filePos + 1 );
            }
            int suffixPos = javaccFile.lastIndexOf( '.' );
            if (suffixPos == -1) {
                optionalOutputFile = javaccFile + suffix;
            } else {
                java.lang.String currentSuffix = javaccFile.substring( suffixPos );
                if (currentSuffix.equals( suffix )) {
                    optionalOutputFile = javaccFile + suffix;
                } else {
                    optionalOutputFile = javaccFile.substring( 0, suffixPos ) + suffix;
                }
            }
        } else {
            optionalOutputFile = optionalOutputFile.replace( '\\', '/' );
        }
        return (getProject().getBaseDir() + "/" + optionalOutputFile).replace( '\\', '/' );
    }

}
