// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.javacc;


import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.LogStreamHandler;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.CommandlineJava;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.JavaEnvUtils;


public class JJTree extends org.apache.tools.ant.Task
{

    private static final java.lang.String OUTPUT_FILE = "OUTPUT_FILE";

    private static final java.lang.String BUILD_NODE_FILES = "BUILD_NODE_FILES";

    private static final java.lang.String MULTI = "MULTI";

    private static final java.lang.String NODE_DEFAULT_VOID = "NODE_DEFAULT_VOID";

    private static final java.lang.String NODE_FACTORY = "NODE_FACTORY";

    private static final java.lang.String NODE_SCOPE_HOOK = "NODE_SCOPE_HOOK";

    private static final java.lang.String NODE_USES_PARSER = "NODE_USES_PARSER";

    private static final java.lang.String STATIC = "STATIC";

    private static final java.lang.String VISITOR = "VISITOR";

    private static final java.lang.String NODE_PACKAGE = "NODE_PACKAGE";

    private static final java.lang.String VISITOR_EXCEPTION = "VISITOR_EXCEPTION";

    private static final java.lang.String NODE_PREFIX = "NODE_PREFIX";

    private final java.util.Hashtable optionalAttrs = new java.util.Hashtable();

    private java.lang.String outputFile = null;

    private static final java.lang.String DEFAULT_SUFFIX = ".jj";

    private java.io.File outputDirectory = null;

    private java.io.File targetFile = null;

    private java.io.File javaccHome = null;

    private org.apache.tools.ant.types.CommandlineJava cmdl = new org.apache.tools.ant.types.CommandlineJava();

    private java.lang.String maxMemory = null;

    public  void setBuildnodefiles( boolean buildNodeFiles )
    {
        optionalAttrs.put( BUILD_NODE_FILES, buildNodeFiles ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setMulti( boolean multi )
    {
        optionalAttrs.put( MULTI, multi ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setNodedefaultvoid( boolean nodeDefaultVoid )
    {
        optionalAttrs.put( NODE_DEFAULT_VOID, nodeDefaultVoid ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setNodefactory( boolean nodeFactory )
    {
        optionalAttrs.put( NODE_FACTORY, nodeFactory ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setNodescopehook( boolean nodeScopeHook )
    {
        optionalAttrs.put( NODE_SCOPE_HOOK, nodeScopeHook ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setNodeusesparser( boolean nodeUsesParser )
    {
        optionalAttrs.put( NODE_USES_PARSER, nodeUsesParser ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setStatic( boolean staticParser )
    {
        optionalAttrs.put( STATIC, staticParser ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setVisitor( boolean visitor )
    {
        optionalAttrs.put( VISITOR, visitor ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setNodepackage( java.lang.String nodePackage )
    {
        optionalAttrs.put( NODE_PACKAGE, nodePackage );
    }

    public  void setVisitorException( java.lang.String visitorException )
    {
        optionalAttrs.put( VISITOR_EXCEPTION, visitorException );
    }

    public  void setNodeprefix( java.lang.String nodePrefix )
    {
        optionalAttrs.put( NODE_PREFIX, nodePrefix );
    }

    public  void setOutputdirectory( java.io.File outputDirectory )
    {
        this.outputDirectory = outputDirectory;
    }

    public  void setOutputfile( java.lang.String outputFile )
    {
        this.outputFile = outputFile;
    }

    public  void setTarget( java.io.File targetFile )
    {
        this.targetFile = targetFile;
    }

    public  void setJavacchome( java.io.File javaccHome )
    {
        this.javaccHome = javaccHome;
    }

    public  void setMaxmemory( java.lang.String max )
    {
        maxMemory = max;
    }

    public JJTree()
    {
        cmdl.setVm( JavaEnvUtils.getJreExecutable( "java" ) );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        java.util.Enumeration iter = optionalAttrs.keys();
        while (iter.hasMoreElements()) {
            java.lang.String name = (java.lang.String) iter.nextElement();
            java.lang.Object value = optionalAttrs.get( name );
            cmdl.createArgument().setValue( "-" + name + ":" + value.toString() );
        }
        if (targetFile == null || !targetFile.isFile()) {
            throw new org.apache.tools.ant.BuildException( "Invalid target: " + targetFile );
        }
        java.io.File javaFile = null;
        if (outputDirectory == null) {
            cmdl.createArgument().setValue( "-OUTPUT_DIRECTORY:" + getDefaultOutputDirectory() );
            javaFile = new java.io.File( createOutputFileName( targetFile, outputFile, null ) );
        } else {
            if (!outputDirectory.isDirectory()) {
                throw new org.apache.tools.ant.BuildException( "'outputdirectory' " + outputDirectory + " is not a directory." );
            }
            cmdl.createArgument().setValue( "-OUTPUT_DIRECTORY:" + outputDirectory.getAbsolutePath().replace( '\\', '/' ) );
            javaFile = new java.io.File( createOutputFileName( targetFile, outputFile, outputDirectory.getPath() ) );
        }
        if (javaFile.exists() && targetFile.lastModified() < javaFile.lastModified()) {
            log( "Target is already built - skipping (" + targetFile + ")", Project.MSG_VERBOSE );
            return;
        }
        if (outputFile != null) {
            cmdl.createArgument().setValue( "-" + OUTPUT_FILE + ":" + outputFile.replace( '\\', '/' ) );
        }
        cmdl.createArgument().setValue( targetFile.getAbsolutePath() );
        final org.apache.tools.ant.types.Path classpath = cmdl.createClasspath( getProject() );
        final java.io.File javaccJar = JavaCC.getArchiveFile( javaccHome );
        classpath.createPathElement().setPath( javaccJar.getAbsolutePath() );
        classpath.addJavaRuntime();
        cmdl.setClassname( JavaCC.getMainClass( classpath, JavaCC.TASKDEF_TYPE_JJTREE ) );
        cmdl.setMaxmemory( maxMemory );
        final org.apache.tools.ant.types.Commandline.Argument arg = cmdl.createVmArgument();
        arg.setValue( "-Dinstall.root=" + javaccHome.getAbsolutePath() );
        final org.apache.tools.ant.taskdefs.Execute process = new org.apache.tools.ant.taskdefs.Execute( new org.apache.tools.ant.taskdefs.LogStreamHandler( this, Project.MSG_INFO, Project.MSG_INFO ), null );
        log( cmdl.describeCommand(), Project.MSG_VERBOSE );
        process.setCommandline( cmdl.getCommandline() );
        try {
            if (process.execute() != 0) {
                throw new org.apache.tools.ant.BuildException( "JJTree failed." );
            }
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( "Failed to launch JJTree", e );
        }
    }

    private  java.lang.String createOutputFileName( java.io.File destFile, java.lang.String optionalOutputFile, java.lang.String outputDir )
    {
        optionalOutputFile = validateOutputFile( optionalOutputFile, outputDir );
        java.lang.String jjtreeFile = destFile.getAbsolutePath().replace( '\\', '/' );
        if (optionalOutputFile == null || optionalOutputFile.equals( "" )) {
            int filePos = jjtreeFile.lastIndexOf( "/" );
            if (filePos >= 0) {
                jjtreeFile = jjtreeFile.substring( filePos + 1 );
            }
            int suffixPos = jjtreeFile.lastIndexOf( '.' );
            if (suffixPos == -1) {
                optionalOutputFile = jjtreeFile + DEFAULT_SUFFIX;
            } else {
                java.lang.String currentSuffix = jjtreeFile.substring( suffixPos );
                if (currentSuffix.equals( DEFAULT_SUFFIX )) {
                    optionalOutputFile = jjtreeFile + DEFAULT_SUFFIX;
                } else {
                    optionalOutputFile = jjtreeFile.substring( 0, suffixPos ) + DEFAULT_SUFFIX;
                }
            }
        }
        if (outputDir == null || outputDir.equals( "" )) {
            outputDir = getDefaultOutputDirectory();
        }
        return (outputDir + "/" + optionalOutputFile).replace( '\\', '/' );
    }

    private  java.lang.String validateOutputFile( java.lang.String destFile, java.lang.String outputDir )
        throws org.apache.tools.ant.BuildException
    {
        if (destFile == null) {
            return null;
        }
        if (outputDir == null && (destFile.startsWith( "/" ) || destFile.startsWith( "\\" ))) {
            java.lang.String relativeOutputFile = makeOutputFileRelative( destFile );
            setOutputfile( relativeOutputFile );
            return relativeOutputFile;
        }
        java.lang.String root = getRoot( new java.io.File( destFile ) ).getAbsolutePath();
        if (root.length() > 1 && destFile.startsWith( root.substring( 0, root.length() - 1 ) )) {
            throw new org.apache.tools.ant.BuildException( "Drive letter in 'outputfile' not " + "supported: " + destFile );
        }
        return destFile;
    }

    private  java.lang.String makeOutputFileRelative( java.lang.String destFile )
    {
        java.lang.StringBuffer relativePath = new java.lang.StringBuffer();
        java.lang.String defaultOutputDirectory = getDefaultOutputDirectory();
        int nextPos = defaultOutputDirectory.indexOf( '/' );
        int startPos = nextPos + 1;
        while (startPos > -1 && startPos < defaultOutputDirectory.length()) {
            relativePath.append( "/.." );
            nextPos = defaultOutputDirectory.indexOf( '/', startPos );
            if (nextPos == -1) {
                startPos = nextPos;
            } else {
                startPos = nextPos + 1;
            }
        }
        relativePath.append( destFile );
        return relativePath.toString();
    }

    private  java.lang.String getDefaultOutputDirectory()
    {
        return getProject().getBaseDir().getAbsolutePath().replace( '\\', '/' );
    }

    private  java.io.File getRoot( java.io.File file )
    {
        java.io.File root = file.getAbsoluteFile();
        while (root.getParent() != null) {
            root = root.getParentFile();
        }
        return root;
    }

}
