// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.javacc;


import java.io.File;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.Hashtable;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.CommandlineJava;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.JavaEnvUtils;


public class JavaCC extends org.apache.tools.ant.Task
{

    private static final java.lang.String LOOKAHEAD = "LOOKAHEAD";

    private static final java.lang.String CHOICE_AMBIGUITY_CHECK = "CHOICE_AMBIGUITY_CHECK";

    private static final java.lang.String OTHER_AMBIGUITY_CHECK = "OTHER_AMBIGUITY_CHECK";

    private static final java.lang.String STATIC = "STATIC";

    private static final java.lang.String DEBUG_PARSER = "DEBUG_PARSER";

    private static final java.lang.String DEBUG_LOOKAHEAD = "DEBUG_LOOKAHEAD";

    private static final java.lang.String DEBUG_TOKEN_MANAGER = "DEBUG_TOKEN_MANAGER";

    private static final java.lang.String OPTIMIZE_TOKEN_MANAGER = "OPTIMIZE_TOKEN_MANAGER";

    private static final java.lang.String ERROR_REPORTING = "ERROR_REPORTING";

    private static final java.lang.String JAVA_UNICODE_ESCAPE = "JAVA_UNICODE_ESCAPE";

    private static final java.lang.String UNICODE_INPUT = "UNICODE_INPUT";

    private static final java.lang.String IGNORE_CASE = "IGNORE_CASE";

    private static final java.lang.String COMMON_TOKEN_ACTION = "COMMON_TOKEN_ACTION";

    private static final java.lang.String USER_TOKEN_MANAGER = "USER_TOKEN_MANAGER";

    private static final java.lang.String USER_CHAR_STREAM = "USER_CHAR_STREAM";

    private static final java.lang.String BUILD_PARSER = "BUILD_PARSER";

    private static final java.lang.String BUILD_TOKEN_MANAGER = "BUILD_TOKEN_MANAGER";

    private static final java.lang.String SANITY_CHECK = "SANITY_CHECK";

    private static final java.lang.String FORCE_LA_CHECK = "FORCE_LA_CHECK";

    private static final java.lang.String CACHE_TOKENS = "CACHE_TOKENS";

    private static final java.lang.String KEEP_LINE_COLUMN = "KEEP_LINE_COLUMN";

    private static final java.lang.String JDK_VERSION = "JDK_VERSION";

    private final java.util.Hashtable optionalAttrs = new java.util.Hashtable();

    private java.io.File outputDirectory = null;

    private java.io.File targetFile = null;

    private java.io.File javaccHome = null;

    private org.apache.tools.ant.types.CommandlineJava cmdl = new org.apache.tools.ant.types.CommandlineJava();

    protected static final int TASKDEF_TYPE_JAVACC = 1;

    protected static final int TASKDEF_TYPE_JJTREE = 2;

    protected static final int TASKDEF_TYPE_JJDOC = 3;

    protected static final java.lang.String[] ARCHIVE_LOCATIONS = new java.lang.String[]{ "JavaCC.zip", "bin/lib/JavaCC.zip", "bin/lib/javacc.jar", "javacc.jar", };

    protected static final int[] ARCHIVE_LOCATIONS_VS_MAJOR_VERSION = new int[]{ 1, 2, 3, 3, };

    protected static final java.lang.String COM_PACKAGE = "COM.sun.labs.";

    protected static final java.lang.String COM_JAVACC_CLASS = "javacc.Main";

    protected static final java.lang.String COM_JJTREE_CLASS = "jjtree.Main";

    protected static final java.lang.String COM_JJDOC_CLASS = "jjdoc.JJDocMain";

    protected static final java.lang.String ORG_PACKAGE_3_0 = "org.netbeans.javacc.";

    protected static final java.lang.String ORG_PACKAGE_3_1 = "org.javacc.";

    protected static final java.lang.String ORG_JAVACC_CLASS = "parser.Main";

    protected static final java.lang.String ORG_JJTREE_CLASS = COM_JJTREE_CLASS;

    protected static final java.lang.String ORG_JJDOC_CLASS = COM_JJDOC_CLASS;

    private java.lang.String maxMemory = null;

    public  void setLookahead( int lookahead )
    {
        optionalAttrs.put( LOOKAHEAD, new java.lang.Integer( lookahead ) );
    }

    public  void setChoiceambiguitycheck( int choiceAmbiguityCheck )
    {
        optionalAttrs.put( CHOICE_AMBIGUITY_CHECK, new java.lang.Integer( choiceAmbiguityCheck ) );
    }

    public  void setOtherambiguityCheck( int otherAmbiguityCheck )
    {
        optionalAttrs.put( OTHER_AMBIGUITY_CHECK, new java.lang.Integer( otherAmbiguityCheck ) );
    }

    public  void setStatic( boolean staticParser )
    {
        optionalAttrs.put( STATIC, staticParser ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setDebugparser( boolean debugParser )
    {
        optionalAttrs.put( DEBUG_PARSER, debugParser ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setDebuglookahead( boolean debugLookahead )
    {
        optionalAttrs.put( DEBUG_LOOKAHEAD, debugLookahead ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setDebugtokenmanager( boolean debugTokenManager )
    {
        optionalAttrs.put( DEBUG_TOKEN_MANAGER, debugTokenManager ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setOptimizetokenmanager( boolean optimizeTokenManager )
    {
        optionalAttrs.put( OPTIMIZE_TOKEN_MANAGER, optimizeTokenManager ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setErrorreporting( boolean errorReporting )
    {
        optionalAttrs.put( ERROR_REPORTING, errorReporting ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setJavaunicodeescape( boolean javaUnicodeEscape )
    {
        optionalAttrs.put( JAVA_UNICODE_ESCAPE, javaUnicodeEscape ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setUnicodeinput( boolean unicodeInput )
    {
        optionalAttrs.put( UNICODE_INPUT, unicodeInput ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setIgnorecase( boolean ignoreCase )
    {
        optionalAttrs.put( IGNORE_CASE, ignoreCase ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setCommontokenaction( boolean commonTokenAction )
    {
        optionalAttrs.put( COMMON_TOKEN_ACTION, commonTokenAction ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setUsertokenmanager( boolean userTokenManager )
    {
        optionalAttrs.put( USER_TOKEN_MANAGER, userTokenManager ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setUsercharstream( boolean userCharStream )
    {
        optionalAttrs.put( USER_CHAR_STREAM, userCharStream ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setBuildparser( boolean buildParser )
    {
        optionalAttrs.put( BUILD_PARSER, buildParser ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setBuildtokenmanager( boolean buildTokenManager )
    {
        optionalAttrs.put( BUILD_TOKEN_MANAGER, buildTokenManager ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setSanitycheck( boolean sanityCheck )
    {
        optionalAttrs.put( SANITY_CHECK, sanityCheck ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setForcelacheck( boolean forceLACheck )
    {
        optionalAttrs.put( FORCE_LA_CHECK, forceLACheck ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setCachetokens( boolean cacheTokens )
    {
        optionalAttrs.put( CACHE_TOKENS, cacheTokens ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setKeeplinecolumn( boolean keepLineColumn )
    {
        optionalAttrs.put( KEEP_LINE_COLUMN, keepLineColumn ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void setJDKversion( java.lang.String jdkVersion )
    {
        optionalAttrs.put( JDK_VERSION, jdkVersion );
    }

    public  void setOutputdirectory( java.io.File outputDirectory )
    {
        this.outputDirectory = outputDirectory;
    }

    public  void setTarget( java.io.File targetFile )
    {
        this.targetFile = targetFile;
    }

    public  void setJavacchome( java.io.File javaccHome )
    {
        this.javaccHome = javaccHome;
    }

    public  void setMaxmemory( java.lang.String max )
    {
        maxMemory = max;
    }

    public JavaCC()
    {
        cmdl.setVm( JavaEnvUtils.getJreExecutable( "java" ) );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        java.util.Enumeration iter = optionalAttrs.keys();
        while (iter.hasMoreElements()) {
            java.lang.String name = (java.lang.String) iter.nextElement();
            java.lang.Object value = optionalAttrs.get( name );
            cmdl.createArgument().setValue( "-" + name + ":" + value.toString() );
        }
        if (targetFile == null || !targetFile.isFile()) {
            throw new org.apache.tools.ant.BuildException( "Invalid target: " + targetFile );
        }
        if (outputDirectory == null) {
            outputDirectory = new java.io.File( targetFile.getParent() );
        } else {
            if (!outputDirectory.isDirectory()) {
                throw new org.apache.tools.ant.BuildException( "Outputdir not a directory." );
            }
        }
        cmdl.createArgument().setValue( "-OUTPUT_DIRECTORY:" + outputDirectory.getAbsolutePath() );
        final java.io.File javaFile = getOutputJavaFile( outputDirectory, targetFile );
        if (javaFile.exists() && targetFile.lastModified() < javaFile.lastModified()) {
            log( "Target is already built - skipping (" + targetFile + ")", Project.MSG_VERBOSE );
            return;
        }
        cmdl.createArgument().setValue( targetFile.getAbsolutePath() );
        final org.apache.tools.ant.types.Path classpath = cmdl.createClasspath( getProject() );
        final java.io.File javaccJar = JavaCC.getArchiveFile( javaccHome );
        classpath.createPathElement().setPath( javaccJar.getAbsolutePath() );
        classpath.addJavaRuntime();
        cmdl.setClassname( JavaCC.getMainClass( classpath, JavaCC.TASKDEF_TYPE_JAVACC ) );
        cmdl.setMaxmemory( maxMemory );
        final org.apache.tools.ant.types.Commandline.Argument arg = cmdl.createVmArgument();
        arg.setValue( "-Dinstall.root=" + javaccHome.getAbsolutePath() );
        Execute.runCommand( this, cmdl.getCommandline() );
    }

    protected static  java.io.File getArchiveFile( java.io.File home )
        throws org.apache.tools.ant.BuildException
    {
        return new java.io.File( home, ARCHIVE_LOCATIONS[getArchiveLocationIndex( home )] );
    }

    protected static  java.lang.String getMainClass( java.io.File home, int type )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Path p = new org.apache.tools.ant.types.Path( null );
        p.createPathElement().setLocation( getArchiveFile( home ) );
        p.addJavaRuntime();
        return getMainClass( p, type );
    }

    protected static  java.lang.String getMainClass( org.apache.tools.ant.types.Path path, int type )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String packagePrefix = null;
        java.lang.String mainClass = null;
        org.apache.tools.ant.AntClassLoader l = null;
        try {
            l = AntClassLoader.newAntClassLoader( null, null, path.concatSystemClasspath( "ignore" ), true );
            java.lang.String javaccClass = COM_PACKAGE + COM_JAVACC_CLASS;
            java.io.InputStream is = l.getResourceAsStream( javaccClass.replace( '.', '/' ) + ".class" );
            if (is != null) {
                packagePrefix = COM_PACKAGE;
                switch (type) {
                case TASKDEF_TYPE_JAVACC :
                    mainClass = COM_JAVACC_CLASS;
                    break;

                case TASKDEF_TYPE_JJTREE :
                    mainClass = COM_JJTREE_CLASS;
                    break;

                case TASKDEF_TYPE_JJDOC :
                    mainClass = COM_JJDOC_CLASS;
                    break;

                default  :

                }
            } else {
                javaccClass = ORG_PACKAGE_3_1 + ORG_JAVACC_CLASS;
                is = l.getResourceAsStream( javaccClass.replace( '.', '/' ) + ".class" );
                if (is != null) {
                    packagePrefix = ORG_PACKAGE_3_1;
                } else {
                    javaccClass = ORG_PACKAGE_3_0 + ORG_JAVACC_CLASS;
                    is = l.getResourceAsStream( javaccClass.replace( '.', '/' ) + ".class" );
                    if (is != null) {
                        packagePrefix = ORG_PACKAGE_3_0;
                    }
                }
                if (is != null) {
                    switch (type) {
                    case TASKDEF_TYPE_JAVACC :
                        mainClass = ORG_JAVACC_CLASS;
                        break;

                    case TASKDEF_TYPE_JJTREE :
                        mainClass = ORG_JJTREE_CLASS;
                        break;

                    case TASKDEF_TYPE_JJDOC :
                        mainClass = ORG_JJDOC_CLASS;
                        break;

                    default  :

                    }
                }
            }
            if (packagePrefix == null) {
                throw new org.apache.tools.ant.BuildException( "failed to load JavaCC" );
            }
            if (mainClass == null) {
                throw new org.apache.tools.ant.BuildException( "unknown task type " + type );
            }
            return packagePrefix + mainClass;
        } finally 
{
            if (l != null) {
                l.cleanup();
            }
        }
    }

    private static  int getArchiveLocationIndex( java.io.File home )
        throws org.apache.tools.ant.BuildException
    {
        if (home == null || !home.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "JavaCC home must be a valid directory." );
        }
        for (int i = 0; i < ARCHIVE_LOCATIONS.length; i++) {
            java.io.File f = new java.io.File( home, ARCHIVE_LOCATIONS[i] );
            if (f.exists()) {
                return i;
            }
        }
        throw new org.apache.tools.ant.BuildException( "Could not find a path to JavaCC.zip " + "or javacc.jar from '" + home + "'." );
    }

    protected static  int getMajorVersionNumber( java.io.File home )
        throws org.apache.tools.ant.BuildException
    {
        return ARCHIVE_LOCATIONS_VS_MAJOR_VERSION[getArchiveLocationIndex( home )];
    }

    private  java.io.File getOutputJavaFile( java.io.File outputdir, java.io.File srcfile )
    {
        java.lang.String path = srcfile.getPath();
        int startBasename = path.lastIndexOf( File.separator );
        if (startBasename != -1) {
            path = path.substring( startBasename + 1 );
        }
        int startExtn = path.lastIndexOf( '.' );
        if (startExtn != -1) {
            path = path.substring( 0, startExtn ) + ".java";
        } else {
            path += ".java";
        }
        if (outputdir != null) {
            path = outputdir + File.separator + path;
        }
        return new java.io.File( path );
    }

}
