// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.javah;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.optional.Javah;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.JavaEnvUtils;


public class Kaffeh implements org.apache.tools.ant.taskdefs.optional.javah.JavahAdapter
{

    public static final java.lang.String IMPLEMENTATION_NAME = "kaffeh";

    public  boolean compile( org.apache.tools.ant.taskdefs.optional.Javah javah )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline cmd = setupKaffehCommand( javah );
        try {
            Execute.runCommand( javah, cmd.getCommandline() );
            return true;
        } catch ( org.apache.tools.ant.BuildException e ) {
            if (e.getMessage().indexOf( "failed with return code" ) == -1) {
                throw e;
            }
        }
        return false;
    }

    private  org.apache.tools.ant.types.Commandline setupKaffehCommand( org.apache.tools.ant.taskdefs.optional.Javah javah )
    {
        org.apache.tools.ant.types.Commandline cmd = new org.apache.tools.ant.types.Commandline();
        cmd.setExecutable( JavaEnvUtils.getJdkExecutable( "kaffeh" ) );
        if (javah.getDestdir() != null) {
            cmd.createArgument().setValue( "-d" );
            cmd.createArgument().setFile( javah.getDestdir() );
        }
        if (javah.getOutputfile() != null) {
            cmd.createArgument().setValue( "-o" );
            cmd.createArgument().setFile( javah.getOutputfile() );
        }
        org.apache.tools.ant.types.Path cp = new org.apache.tools.ant.types.Path( javah.getProject() );
        if (javah.getBootclasspath() != null) {
            cp.append( javah.getBootclasspath() );
        }
        cp = cp.concatSystemBootClasspath( "ignore" );
        if (javah.getClasspath() != null) {
            cp.append( javah.getClasspath() );
        }
        if (cp.size() > 0) {
            cmd.createArgument().setValue( "-classpath" );
            cmd.createArgument().setPath( cp );
        }
        if (!javah.getOld()) {
            cmd.createArgument().setValue( "-jni" );
        }
        cmd.addArguments( javah.getCurrentArgs() );
        javah.logAndAddFiles( cmd );
        return cmd;
    }

}
