// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jlink;


import java.io.DataInput;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;


class ConstantPool
{

    static final byte UTF8 = 1;

    static final byte UNUSED = 2;

    static final byte INTEGER = 3;

    static final byte FLOAT = 4;

    static final byte LONG = 5;

    static final byte DOUBLE = 6;

    static final byte CLASS = 7;

    static final byte STRING = 8;

    static final byte FIELDREF = 9;

    static final byte METHODREF = 10;

    static final byte INTERFACEMETHODREF = 11;

    static final byte NAMEANDTYPE = 12;

    byte[] types;

    java.lang.Object[] values;

    ConstantPool( java.io.DataInput data )
        throws java.io.IOException
    {
        super();
        int count = data.readUnsignedShort();
        types = new byte[count];
        values = new java.lang.Object[count];
        for (int i = 1; i < count; i++) {
            byte type = data.readByte();
            types[i] = type;
            switch (type) {
            case UTF8 :
                values[i] = data.readUTF();
                break;

            case UNUSED :
                break;

            case INTEGER :
                values[i] = new java.lang.Integer( data.readInt() );
                break;

            case FLOAT :
                values[i] = new java.lang.Float( data.readFloat() );
                break;

            case LONG :
                values[i] = new java.lang.Long( data.readLong() );
                ++i;
                break;

            case DOUBLE :
                values[i] = new java.lang.Double( data.readDouble() );
                ++i;
                break;

            case CLASS :
            case STRING :
                values[i] = new java.lang.Integer( data.readUnsignedShort() );
                break;

            case FIELDREF :
            case METHODREF :
            case INTERFACEMETHODREF :
            case NAMEANDTYPE :
                values[i] = new java.lang.Integer( data.readInt() );
                break;

            default  :

            }
        }
    }

}

public class ClassNameReader extends java.lang.Object
{

    private static final int CLASS_MAGIC_NUMBER = 0xCAFEBABE;

    public static  java.lang.String getClassName( java.io.InputStream input )
        throws java.io.IOException
    {
        java.io.DataInputStream data = new java.io.DataInputStream( input );
        int cookie = data.readInt();
        if (cookie != CLASS_MAGIC_NUMBER) {
            return null;
        }
        data.readInt();
        org.apache.tools.ant.taskdefs.optional.jlink.ConstantPool constants = new org.apache.tools.ant.taskdefs.optional.jlink.ConstantPool( data );
        java.lang.Object[] values = constants.values;
        data.readUnsignedShort();
        int classIndex = data.readUnsignedShort();
        java.lang.Integer stringIndex = (java.lang.Integer) values[classIndex];
        java.lang.String className = (java.lang.String) values[stringIndex.intValue()];
        return className;
    }

}
