// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jlink;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.types.Path;


public class JlinkTask extends org.apache.tools.ant.taskdefs.MatchingTask
{

    public  void setOutfile( java.io.File outfile )
    {
        this.outfile = outfile;
    }

    public  org.apache.tools.ant.types.Path createMergefiles()
    {
        if (this.mergefiles == null) {
            this.mergefiles = new org.apache.tools.ant.types.Path( getProject() );
        }
        return this.mergefiles.createPath();
    }

    public  void setMergefiles( org.apache.tools.ant.types.Path mergefiles )
    {
        if (this.mergefiles == null) {
            this.mergefiles = mergefiles;
        } else {
            this.mergefiles.append( mergefiles );
        }
    }

    public  org.apache.tools.ant.types.Path createAddfiles()
    {
        if (this.addfiles == null) {
            this.addfiles = new org.apache.tools.ant.types.Path( getProject() );
        }
        return this.addfiles.createPath();
    }

    public  void setAddfiles( org.apache.tools.ant.types.Path addfiles )
    {
        if (this.addfiles == null) {
            this.addfiles = addfiles;
        } else {
            this.addfiles.append( addfiles );
        }
    }

    public  void setCompress( boolean compress )
    {
        this.compress = compress;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (outfile == null) {
            throw new org.apache.tools.ant.BuildException( "outfile attribute is required! " + "Please set." );
        }
        if (!haveAddFiles() && !haveMergeFiles()) {
            throw new org.apache.tools.ant.BuildException( "addfiles or mergefiles required! " + "Please set." );
        }
        log( "linking:     " + outfile.getPath() );
        log( "compression: " + compress, Project.MSG_VERBOSE );
        org.apache.tools.ant.taskdefs.optional.jlink.jlink linker = new org.apache.tools.ant.taskdefs.optional.jlink.jlink();
        linker.setOutfile( outfile.getPath() );
        linker.setCompression( compress );
        if (haveMergeFiles()) {
            log( "merge files: " + mergefiles.toString(), Project.MSG_VERBOSE );
            linker.addMergeFiles( mergefiles.list() );
        }
        if (haveAddFiles()) {
            log( "add files: " + addfiles.toString(), Project.MSG_VERBOSE );
            linker.addAddFiles( addfiles.list() );
        }
        try {
            linker.link();
        } catch ( java.lang.Exception ex ) {
            throw new org.apache.tools.ant.BuildException( ex, getLocation() );
        }
    }

    private  boolean haveAddFiles()
    {
        return haveEntries( addfiles );
    }

    private  boolean haveMergeFiles()
    {
        return haveEntries( mergefiles );
    }

    private  boolean haveEntries( org.apache.tools.ant.types.Path p )
    {
        if (p == null) {
            return false;
        }
        if (p.size() > 0) {
            return true;
        }
        return false;
    }

    private java.io.File outfile = null;

    private org.apache.tools.ant.types.Path mergefiles = null;

    private org.apache.tools.ant.types.Path addfiles = null;

    private boolean compress = false;

}
