// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jlink;


import org.apache.tools.ant.util.FileUtils;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.Vector;
import java.util.zip.CRC32;
import java.util.zip.Deflater;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;


public class jlink
{

    private static final int BUFFER_SIZE = 8192;

    private static final int VECTOR_INIT_SIZE = 10;

    private java.lang.String outfile = null;

    private java.util.Vector mergefiles = new java.util.Vector( VECTOR_INIT_SIZE );

    private java.util.Vector addfiles = new java.util.Vector( VECTOR_INIT_SIZE );

    private boolean compression = false;

    byte[] buffer = new byte[BUFFER_SIZE];

    public  void setOutfile( java.lang.String outfile )
    {
        if (outfile == null) {
            return;
        }
        this.outfile = outfile;
    }

    public  void addMergeFile( java.lang.String fileToMerge )
    {
        if (fileToMerge == null) {
            return;
        }
        mergefiles.addElement( fileToMerge );
    }

    public  void addAddFile( java.lang.String fileToAdd )
    {
        if (fileToAdd == null) {
            return;
        }
        addfiles.addElement( fileToAdd );
    }

    public  void addMergeFiles( java.lang.String[] filesToMerge )
    {
        if (filesToMerge == null) {
            return;
        }
        for (int i = 0; i < filesToMerge.length; i++) {
            addMergeFile( filesToMerge[i] );
        }
    }

    public  void addAddFiles( java.lang.String[] filesToAdd )
    {
        if (filesToAdd == null) {
            return;
        }
        for (int i = 0; i < filesToAdd.length; i++) {
            addAddFile( filesToAdd[i] );
        }
    }

    public  void setCompression( boolean compress )
    {
        this.compression = compress;
    }

    public  void link()
        throws java.lang.Exception
    {
        java.util.zip.ZipOutputStream output = new java.util.zip.ZipOutputStream( new java.io.FileOutputStream( outfile ) );
        if (compression) {
            output.setMethod( ZipOutputStream.DEFLATED );
            output.setLevel( Deflater.DEFAULT_COMPRESSION );
        } else {
            output.setMethod( ZipOutputStream.STORED );
        }
        java.util.Enumeration merges = mergefiles.elements();
        while (merges.hasMoreElements()) {
            java.lang.String path = (java.lang.String) merges.nextElement();
            java.io.File f = new java.io.File( path );
            if (f.getName().endsWith( ".jar" ) || f.getName().endsWith( ".zip" )) {
                mergeZipJarContents( output, f );
            } else {
                addAddFile( path );
            }
        }
        java.util.Enumeration adds = addfiles.elements();
        while (adds.hasMoreElements()) {
            java.lang.String name = (java.lang.String) adds.nextElement();
            java.io.File f = new java.io.File( name );
            if (f.isDirectory()) {
                addDirContents( output, f, f.getName() + '/', compression );
            } else {
                addFile( output, f, "", compression );
            }
        }
        FileUtils.close( output );
    }

    public static  void main( java.lang.String[] args )
    {
        if (args.length < 2) {
            System.out.println( "usage: jlink output input1 ... inputN" );
            System.exit( 1 );
        }
        org.apache.tools.ant.taskdefs.optional.jlink.jlink linker = new org.apache.tools.ant.taskdefs.optional.jlink.jlink();
        linker.setOutfile( args[0] );
        for (int i = 1; i < args.length; i++) {
            linker.addMergeFile( args[i] );
        }
        try {
            linker.link();
        } catch ( java.lang.Exception ex ) {
            System.err.print( ex.getMessage() );
        }
    }

    private  void mergeZipJarContents( java.util.zip.ZipOutputStream output, java.io.File f )
        throws java.io.IOException
    {
        if (!f.exists()) {
            return;
        }
        java.util.zip.ZipFile zipf = new java.util.zip.ZipFile( f );
        java.util.Enumeration entries = zipf.entries();
        while (entries.hasMoreElements()) {
            java.util.zip.ZipEntry inputEntry = (java.util.zip.ZipEntry) entries.nextElement();
            java.lang.String inputEntryName = inputEntry.getName();
            int index = inputEntryName.indexOf( "META-INF" );
            if (index < 0) {
                try {
                    output.putNextEntry( processEntry( zipf, inputEntry ) );
                } catch ( java.util.zip.ZipException ex ) {
                    java.lang.String mess = ex.getMessage();
                    if (mess.indexOf( "duplicate" ) >= 0) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
                java.io.InputStream in = zipf.getInputStream( inputEntry );
                int len = buffer.length;
                int count = -1;
                while ((count = in.read( buffer, 0, len )) > 0) {
                    output.write( buffer, 0, count );
                }
                in.close();
                output.closeEntry();
            }
        }
        zipf.close();
    }

    private  void addDirContents( java.util.zip.ZipOutputStream output, java.io.File dir, java.lang.String prefix, boolean compress )
        throws java.io.IOException
    {
        java.lang.String[] contents = dir.list();
        for (int i = 0; i < contents.length; ++i) {
            java.lang.String name = contents[i];
            java.io.File file = new java.io.File( dir, name );
            if (file.isDirectory()) {
                addDirContents( output, file, prefix + name + '/', compress );
            } else {
                addFile( output, file, prefix, compress );
            }
        }
    }

    private  java.lang.String getEntryName( java.io.File file, java.lang.String prefix )
    {
        java.lang.String name = file.getName();
        if (!name.endsWith( ".class" )) {
            java.io.InputStream input = null;
            try {
                input = new java.io.FileInputStream( file );
                java.lang.String className = ClassNameReader.getClassName( input );
                if (className != null) {
                    return className.replace( '.', '/' ) + ".class";
                }
            } catch ( java.io.IOException ioe ) {
            } finally 
{
                if (input != null) {
                    try {
                        input.close();
                    } catch ( java.io.IOException e ) {
                    }
                }
            }
        }
        System.out.println( "From " + file.getPath() + " and prefix " + prefix + ", creating entry " + prefix + name );
        return prefix + name;
    }

    private  void addFile( java.util.zip.ZipOutputStream output, java.io.File file, java.lang.String prefix, boolean compress )
        throws java.io.IOException
    {
        if (!file.exists()) {
            return;
        }
        java.util.zip.ZipEntry entry = new java.util.zip.ZipEntry( getEntryName( file, prefix ) );
        entry.setTime( file.lastModified() );
        entry.setSize( file.length() );
        if (!compress) {
            entry.setCrc( calcChecksum( file ) );
        }
        java.io.FileInputStream input = new java.io.FileInputStream( file );
        addToOutputStream( output, input, entry );
    }

    private  void addToOutputStream( java.util.zip.ZipOutputStream output, java.io.InputStream input, java.util.zip.ZipEntry ze )
        throws java.io.IOException
    {
        try {
            output.putNextEntry( ze );
        } catch ( java.util.zip.ZipException zipEx ) {
            input.close();
            return;
        }
        int numBytes = -1;
        while ((numBytes = input.read( buffer )) > 0) {
            output.write( buffer, 0, numBytes );
        }
        output.closeEntry();
        input.close();
    }

    private  java.util.zip.ZipEntry processEntry( java.util.zip.ZipFile zip, java.util.zip.ZipEntry inputEntry )
    {
        java.lang.String name = inputEntry.getName();
        if (!(inputEntry.isDirectory() || name.endsWith( ".class" ))) {
            try {
                java.io.InputStream input = zip.getInputStream( zip.getEntry( name ) );
                java.lang.String className = ClassNameReader.getClassName( input );
                input.close();
                if (className != null) {
                    name = className.replace( '.', '/' ) + ".class";
                }
            } catch ( java.io.IOException ioe ) {
            }
        }
        java.util.zip.ZipEntry outputEntry = new java.util.zip.ZipEntry( name );
        outputEntry.setTime( inputEntry.getTime() );
        outputEntry.setExtra( inputEntry.getExtra() );
        outputEntry.setComment( inputEntry.getComment() );
        outputEntry.setTime( inputEntry.getTime() );
        if (compression) {
            outputEntry.setMethod( ZipEntry.DEFLATED );
        } else {
            outputEntry.setMethod( ZipEntry.STORED );
            outputEntry.setCrc( inputEntry.getCrc() );
            outputEntry.setSize( inputEntry.getSize() );
        }
        return outputEntry;
    }

    private  long calcChecksum( java.io.File f )
        throws java.io.IOException
    {
        java.io.BufferedInputStream in = new java.io.BufferedInputStream( new java.io.FileInputStream( f ) );
        return calcChecksum( in );
    }

    private  long calcChecksum( java.io.InputStream in )
        throws java.io.IOException
    {
        java.util.zip.CRC32 crc = new java.util.zip.CRC32();
        int len = buffer.length;
        int count = -1;
        int haveRead = 0;
        while ((count = in.read( buffer, 0, len )) > 0) {
            haveRead += count;
            crc.update( buffer, 0, count );
        }
        in.close();
        return crc.getValue();
    }

}
