// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jsp;


import java.io.File;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Java;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.types.Path;


public class WLJspc extends org.apache.tools.ant.taskdefs.MatchingTask
{

    private java.io.File destinationDirectory;

    private java.io.File sourceDirectory;

    private java.lang.String destinationPackage;

    private org.apache.tools.ant.types.Path compileClasspath;

    private java.lang.String pathToPackage = "";

    private java.util.Vector filesToDo = new java.util.Vector();

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (!destinationDirectory.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "destination directory " + destinationDirectory.getPath() + " is not valid" );
        }
        if (!sourceDirectory.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "src directory " + sourceDirectory.getPath() + " is not valid" );
        }
        if (destinationPackage == null) {
            throw new org.apache.tools.ant.BuildException( "package attribute must be present.", getLocation() );
        }
        pathToPackage = this.destinationPackage.replace( '.', File.separatorChar );
        org.apache.tools.ant.DirectoryScanner ds = super.getDirectoryScanner( sourceDirectory );
        if (compileClasspath == null) {
            compileClasspath = new org.apache.tools.ant.types.Path( getProject() );
        }
        compileClasspath = compileClasspath.concatSystemClasspath();
        java.lang.String[] files = ds.getIncludedFiles();
        org.apache.tools.ant.taskdefs.Java helperTask = new org.apache.tools.ant.taskdefs.Java( this );
        helperTask.setFork( true );
        helperTask.setClassname( "weblogic.jspc" );
        helperTask.setTaskName( getTaskName() );
        java.lang.String[] args = new java.lang.String[12];
        java.io.File jspFile = null;
        java.lang.String parents = "";
        int j = 0;
        args[j++] = "-d";
        args[j++] = destinationDirectory.getAbsolutePath().trim();
        args[j++] = "-docroot";
        args[j++] = sourceDirectory.getAbsolutePath().trim();
        args[j++] = "-keepgenerated";
        args[j++] = "-compilerclass";
        args[j++] = "sun.tools.javac.Main";
        args[j++] = "-classpath";
        args[j++] = compileClasspath.toString();
        this.scanDir( files );
        log( "Compiling " + filesToDo.size() + " JSP files" );
        final int size = filesToDo.size();
        for (int i = 0; i < size; i++) {
            java.lang.String filename = (java.lang.String) filesToDo.elementAt( i );
            jspFile = new java.io.File( filename );
            args[j] = "-package";
            parents = jspFile.getParent();
            if (parents != null && !"".equals( parents )) {
                parents = this.replaceString( parents, File.separator, "_." );
                args[j + 1] = destinationPackage + "." + "_" + parents;
            } else {
                args[j + 1] = destinationPackage;
            }
            args[j + 2] = sourceDirectory + File.separator + filename;
            helperTask.clearArgs();
            for (int x = 0; x < j + 3; x++) {
                helperTask.createArg().setValue( args[x] );
            }
            helperTask.setClasspath( compileClasspath );
            if (helperTask.executeJava() != 0) {
                log( filename + " failed to compile", Project.MSG_WARN );
            }
        }
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (compileClasspath == null) {
            compileClasspath = classpath;
        } else {
            compileClasspath.append( classpath );
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (compileClasspath == null) {
            compileClasspath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return compileClasspath;
    }

    public  void setSrc( java.io.File dirName )
    {
        sourceDirectory = dirName;
    }

    public  void setDest( java.io.File dirName )
    {
        destinationDirectory = dirName;
    }

    public  void setPackage( java.lang.String packageName )
    {
        destinationPackage = packageName;
    }

    protected  void scanDir( java.lang.String[] files )
    {
        long now = (new java.util.Date()).getTime();
        java.io.File jspFile = null;
        java.lang.String parents = null;
        java.lang.String pack = "";
        for (int i = 0; i < files.length; i++) {
            java.io.File srcFile = new java.io.File( this.sourceDirectory, files[i] );
            jspFile = new java.io.File( files[i] );
            parents = jspFile.getParent();
            if (parents != null && !"".equals( parents )) {
                parents = this.replaceString( parents, File.separator, "_/" );
                pack = pathToPackage + File.separator + "_" + parents;
            } else {
                pack = pathToPackage;
            }
            java.lang.String filePath = pack + File.separator + "_";
            int startingIndex = files[i].lastIndexOf( File.separator ) != -1 ? files[i].lastIndexOf( File.separator ) + 1 : 0;
            int endingIndex = files[i].indexOf( ".jsp" );
            if (endingIndex == -1) {
                log( "Skipping " + files[i] + ". Not a JSP", Project.MSG_VERBOSE );
                continue;
            }
            filePath += files[i].substring( startingIndex, endingIndex );
            filePath += ".class";
            java.io.File classFile = new java.io.File( this.destinationDirectory, filePath );
            if (srcFile.lastModified() > now) {
                log( "Warning: file modified in the future: " + files[i], Project.MSG_WARN );
            }
            if (srcFile.lastModified() > classFile.lastModified()) {
                filesToDo.addElement( files[i] );
                log( "Recompiling File " + files[i], Project.MSG_VERBOSE );
            }
        }
    }

    protected  java.lang.String replaceString( java.lang.String inpString, java.lang.String escapeChars, java.lang.String replaceChars )
    {
        java.lang.String localString = "";
        int numTokens = 0;
        java.util.StringTokenizer st = new java.util.StringTokenizer( inpString, escapeChars, true );
        numTokens = st.countTokens();
        for (int i = 0; i < numTokens; i++) {
            java.lang.String test = st.nextToken();
            test = test.equals( escapeChars ) ? replaceChars : test;
            localString += test;
        }
        return localString;
    }

}
