// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.File;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.resources.Resources;


public final class BatchTest extends org.apache.tools.ant.taskdefs.optional.junit.BaseTest
{

    private org.apache.tools.ant.Project project;

    private org.apache.tools.ant.types.resources.Resources resources = new org.apache.tools.ant.types.resources.Resources();

    public BatchTest( org.apache.tools.ant.Project project )
    {
        this.project = project;
        resources.setCache( true );
    }

    public  void addFileSet( org.apache.tools.ant.types.FileSet fs )
    {
        add( fs );
        if (fs.getProject() == null) {
            fs.setProject( project );
        }
    }

    public  void add( org.apache.tools.ant.types.ResourceCollection rc )
    {
        resources.add( rc );
    }

    public  java.util.Enumeration elements()
    {
        org.apache.tools.ant.taskdefs.optional.junit.JUnitTest[] tests = createAllJUnitTest();
        return Enumerations.fromArray( tests );
    }

     void addTestsTo( java.util.Vector v )
    {
        org.apache.tools.ant.taskdefs.optional.junit.JUnitTest[] tests = createAllJUnitTest();
        v.ensureCapacity( v.size() + tests.length );
        for (int i = 0; i < tests.length; i++) {
            v.addElement( tests[i] );
        }
    }

    private  org.apache.tools.ant.taskdefs.optional.junit.JUnitTest[] createAllJUnitTest()
    {
        java.lang.String[] filenames = getFilenames();
        org.apache.tools.ant.taskdefs.optional.junit.JUnitTest[] tests = new org.apache.tools.ant.taskdefs.optional.junit.JUnitTest[filenames.length];
        for (int i = 0; i < tests.length; i++) {
            java.lang.String classname = javaToClass( filenames[i] );
            tests[i] = createJUnitTest( classname );
        }
        return tests;
    }

    private  java.lang.String[] getFilenames()
    {
        java.util.Vector v = new java.util.Vector();
        java.util.Iterator iter = resources.iterator();
        while (iter.hasNext()) {
            org.apache.tools.ant.types.Resource r = (org.apache.tools.ant.types.Resource) iter.next();
            if (r.isExists()) {
                java.lang.String pathname = r.getName();
                if (pathname.endsWith( ".java" )) {
                    v.addElement( pathname.substring( 0, pathname.length() - ".java".length() ) );
                } else {
                    if (pathname.endsWith( ".class" )) {
                        v.addElement( pathname.substring( 0, pathname.length() - ".class".length() ) );
                    }
                }
            }
        }
        java.lang.String[] files = new java.lang.String[v.size()];
        v.copyInto( files );
        return files;
    }

    public static  java.lang.String javaToClass( java.lang.String filename )
    {
        return filename.replace( File.separatorChar, '.' ).replace( '/', '.' ).replace( '\\', '.' );
    }

    private  org.apache.tools.ant.taskdefs.optional.junit.JUnitTest createJUnitTest( java.lang.String classname )
    {
        org.apache.tools.ant.taskdefs.optional.junit.JUnitTest test = new org.apache.tools.ant.taskdefs.optional.junit.JUnitTest();
        test.setName( classname );
        test.setHaltonerror( this.haltOnError );
        test.setHaltonfailure( this.haltOnFail );
        test.setFiltertrace( this.filtertrace );
        test.setFork( this.fork );
        test.setIf( getIfCondition() );
        test.setUnless( getUnlessCondition() );
        test.setTodir( this.destDir );
        test.setFailureProperty( failureProperty );
        test.setErrorProperty( errorProperty );
        java.util.Enumeration list = this.formatters.elements();
        while (list.hasMoreElements()) {
            test.addFormatter( (org.apache.tools.ant.taskdefs.optional.junit.FormatterElement) list.nextElement() );
        }
        return test;
    }

}
