// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.util.Vector;
import org.w3c.dom.Attr;
import org.w3c.dom.CDATASection;
import org.w3c.dom.Comment;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.Text;


public final class DOMUtil
{

    private DOMUtil()
    {
    }

    public interface NodeFilter
    {

         boolean accept( org.w3c.dom.Node node );

    }

    public static  org.w3c.dom.NodeList listChildNodes( org.w3c.dom.Node parent, org.apache.tools.ant.taskdefs.optional.junit.DOMUtil.NodeFilter filter, boolean recurse )
    {
        org.apache.tools.ant.taskdefs.optional.junit.DOMUtil.NodeListImpl matches = new org.apache.tools.ant.taskdefs.optional.junit.DOMUtil.NodeListImpl();
        org.w3c.dom.NodeList children = parent.getChildNodes();
        if (children != null) {
            final int len = children.getLength();
            for (int i = 0; i < len; i++) {
                org.w3c.dom.Node child = children.item( i );
                if (filter.accept( child )) {
                    matches.addElement( child );
                }
                if (recurse) {
                    org.w3c.dom.NodeList recmatches = listChildNodes( child, filter, recurse );
                    final int reclength = recmatches.getLength();
                    for (int j = 0; j < reclength; j++) {
                        matches.addElement( recmatches.item( i ) );
                    }
                }
            }
        }
        return matches;
    }

    public static class NodeListImpl extends java.util.Vector implements org.w3c.dom.NodeList
    {

        private static final long serialVersionUID = 3175749150080946423L;

        public  int getLength()
        {
            return size();
        }

        public  org.w3c.dom.Node item( int i )
        {
            try {
                return (org.w3c.dom.Node) elementAt( i );
            } catch ( java.lang.ArrayIndexOutOfBoundsException e ) {
                return null;
            }
        }

    }

    public static  java.lang.String getNodeAttribute( org.w3c.dom.Node node, java.lang.String name )
    {
        if (node instanceof org.w3c.dom.Element) {
            org.w3c.dom.Element element = (org.w3c.dom.Element) node;
            return element.getAttribute( name );
        }
        return null;
    }

    public static  org.w3c.dom.Element getChildByTagName( org.w3c.dom.Node parent, java.lang.String tagname )
    {
        if (parent == null) {
            return null;
        }
        org.w3c.dom.NodeList childList = parent.getChildNodes();
        final int len = childList.getLength();
        for (int i = 0; i < len; i++) {
            org.w3c.dom.Node child = childList.item( i );
            if (child != null && child.getNodeType() == Node.ELEMENT_NODE && child.getNodeName().equals( tagname )) {
                return (org.w3c.dom.Element) child;
            }
        }
        return null;
    }

    public static  org.w3c.dom.Node importNode( org.w3c.dom.Node parent, org.w3c.dom.Node child )
    {
        org.w3c.dom.Node copy = null;
        final org.w3c.dom.Document doc = parent.getOwnerDocument();
        switch (child.getNodeType()) {
        case Node.CDATA_SECTION_NODE :
            copy = doc.createCDATASection( ((org.w3c.dom.CDATASection) child).getData() );
            break;

        case Node.COMMENT_NODE :
            copy = doc.createComment( ((org.w3c.dom.Comment) child).getData() );
            break;

        case Node.DOCUMENT_FRAGMENT_NODE :
            copy = doc.createDocumentFragment();
            break;

        case Node.ELEMENT_NODE :
            final org.w3c.dom.Element elem = doc.createElement( ((org.w3c.dom.Element) child).getTagName() );
            copy = elem;
            final org.w3c.dom.NamedNodeMap attributes = child.getAttributes();
            if (attributes != null) {
                final int size = attributes.getLength();
                for (int i = 0; i < size; i++) {
                    final org.w3c.dom.Attr attr = (org.w3c.dom.Attr) attributes.item( i );
                    elem.setAttribute( attr.getName(), attr.getValue() );
                }
            }
            break;

        case Node.ENTITY_REFERENCE_NODE :
            copy = doc.createEntityReference( child.getNodeName() );
            break;

        case Node.PROCESSING_INSTRUCTION_NODE :
            final org.w3c.dom.ProcessingInstruction pi = (org.w3c.dom.ProcessingInstruction) child;
            copy = doc.createProcessingInstruction( pi.getTarget(), pi.getData() );
            break;

        case Node.TEXT_NODE :
            copy = doc.createTextNode( ((org.w3c.dom.Text) child).getData() );
            break;

        default  :
            throw new java.lang.IllegalStateException( "Invalid node type: " + child.getNodeType() );

        }
        try {
            final org.w3c.dom.NodeList children = child.getChildNodes();
            if (children != null) {
                final int size = children.getLength();
                for (int i = 0; i < size; i++) {
                    final org.w3c.dom.Node newChild = children.item( i );
                    if (newChild != null) {
                        importNode( copy, newChild );
                    }
                }
            }
        } catch ( org.w3c.dom.DOMException ignored ) {
        }
        parent.appendChild( copy );
        return copy;
    }

}
