// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.splash;


import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import javax.swing.ImageIcon;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.util.Base64Converter;
import org.apache.tools.ant.taskdefs.optional.net.SetProxy;


public class SplashTask extends org.apache.tools.ant.Task
{

    private static final int DEFAULT_SHOW_DURATION = 5000;

    private java.lang.String imgurl = null;

    private java.lang.String proxy = null;

    private java.lang.String user = null;

    private java.lang.String password = null;

    private java.lang.String port = "80";

    private int showDuration = DEFAULT_SHOW_DURATION;

    private boolean useProxy = false;

    private java.lang.String progressRegExp = null;

    private java.lang.String displayText = null;

    private static org.apache.tools.ant.taskdefs.optional.splash.SplashScreen splash = null;

    public  void setImageURL( java.lang.String imgurl )
    {
        this.imgurl = imgurl;
    }

    public  void setUseproxy( boolean useProxy )
    {
        this.useProxy = useProxy;
    }

    public  void setProxy( java.lang.String proxy )
    {
        this.proxy = proxy;
    }

    public  void setPort( java.lang.String port )
    {
        this.port = port;
    }

    public  void setUser( java.lang.String user )
    {
        this.user = user;
    }

    public  void setPassword( java.lang.String password )
    {
        this.password = password;
    }

    public  void setShowduration( int duration )
    {
        this.showDuration = duration;
    }

    public  void setProgressRegExp( java.lang.String progressRegExp )
    {
        this.progressRegExp = progressRegExp;
    }

    public  void setDisplayText( java.lang.String displayText )
    {
        this.displayText = displayText;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        if (splash != null) {
            splash.setVisible( false );
            getProject().removeBuildListener( splash );
            splash.dispose();
            splash = null;
        }
        log( "Creating new SplashScreen", Project.MSG_VERBOSE );
        java.io.InputStream in = null;
        if (imgurl != null) {
            try {
                java.net.URLConnection conn = null;
                org.apache.tools.ant.taskdefs.optional.net.SetProxy sp = new org.apache.tools.ant.taskdefs.optional.net.SetProxy();
                sp.setProxyHost( proxy );
                if (port != null) {
                    sp.setProxyPort( Integer.parseInt( port ) );
                }
                sp.setProxyUser( user );
                sp.setProxyPassword( password );
                sp.applyWebProxySettings();
                if (useProxy && (proxy != null && proxy.length() > 0) && (port != null && port.length() > 0)) {
                    log( "Using proxied Connection", Project.MSG_DEBUG );
                    System.getProperties().put( "http.proxySet", "true" );
                    java.net.URL url = new java.net.URL( imgurl );
                    conn = url.openConnection();
                    if (user != null && user.length() > 0) {
                        java.lang.String encodedcreds = (new org.apache.tools.ant.util.Base64Converter()).encode( user + ":" + password );
                        conn.setRequestProperty( "Proxy-Authorization", encodedcreds );
                    }
                } else {
                    System.getProperties().put( "http.proxySet", "false" );
                    log( "Using Direction HTTP Connection", Project.MSG_DEBUG );
                    java.net.URL url = new java.net.URL( imgurl );
                    conn = url.openConnection();
                }
                conn.setDoInput( true );
                conn.setDoOutput( false );
                in = conn.getInputStream();
            } catch ( java.lang.Throwable ioe ) {
                log( "Unable to download image, trying default Ant Logo", Project.MSG_DEBUG );
                log( "(Exception was \"" + ioe.getMessage() + "\"", Project.MSG_DEBUG );
            }
        }
        if (in == null) {
            java.lang.ClassLoader cl = (org.apache.tools.ant.taskdefs.optional.splash.SplashTask.class).getClassLoader();
            if (cl != null) {
                in = cl.getResourceAsStream( "images/ant_logo_large.gif" );
            } else {
                in = ClassLoader.getSystemResourceAsStream( "images/ant_logo_large.gif" );
            }
        }
        boolean success = false;
        if (in != null) {
            java.io.DataInputStream din = new java.io.DataInputStream( in );
            try {
                java.io.ByteArrayOutputStream bout = new java.io.ByteArrayOutputStream();
                int data;
                while ((data = din.read()) != -1) {
                    bout.write( (byte) data );
                }
                log( "Got ByteArray, creating splash", Project.MSG_DEBUG );
                try {
                    javax.swing.ImageIcon img = new javax.swing.ImageIcon( bout.toByteArray() );
                    splash = new org.apache.tools.ant.taskdefs.optional.splash.SplashScreen( img, progressRegExp, displayText );
                    success = true;
                } catch ( java.lang.Throwable e ) {
                    logHeadless( e );
                }
            } catch ( java.lang.Exception e ) {
                throw new org.apache.tools.ant.BuildException( e );
            } finally 
{
                try {
                    din.close();
                } catch ( java.io.IOException ioe ) {
                    if (success) {
                        throw new org.apache.tools.ant.BuildException( ioe );
                    }
                }
            }
        } else {
            try {
                splash = new org.apache.tools.ant.taskdefs.optional.splash.SplashScreen( "Image Unavailable.", progressRegExp, displayText );
                success = true;
            } catch ( java.lang.Throwable e ) {
                logHeadless( e );
            }
        }
        if (success) {
            splash.setVisible( true );
            splash.toFront();
            getProject().addBuildListener( splash );
            try {
                Thread.sleep( showDuration );
            } catch ( java.lang.InterruptedException e ) {
            }
        }
    }

    private  void logHeadless( java.lang.Throwable e )
    {
        log( "failed to display SplashScreen, caught " + e.getClass().getName() + " with message: " + e.getMessage(), Project.MSG_WARN );
    }

}
