// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.rmic;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.ExecuteJava;
import org.apache.tools.ant.types.Commandline;


public class KaffeRmic extends org.apache.tools.ant.taskdefs.rmic.DefaultRmicAdapter
{

    private static final java.lang.String[] RMIC_CLASSNAMES = new java.lang.String[]{ "gnu.classpath.tools.rmi.rmic.RMIC", "gnu.java.rmi.rmic.RMIC", "kaffe.rmi.rmic.RMIC", };

    public static final java.lang.String COMPILER_NAME = "kaffe";

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        getRmic().log( "Using Kaffe rmic", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Commandline cmd = setupRmicCommand();
        java.lang.Class c = getRmicClass();
        if (c == null) {
            java.lang.StringBuffer buf = new java.lang.StringBuffer( "Cannot use Kaffe rmic, as it" + " is not available.  None" + " of " );
            for (int i = 0; i < RMIC_CLASSNAMES.length; i++) {
                if (i != 0) {
                    buf.append( ", " );
                }
                buf.append( RMIC_CLASSNAMES[i] );
            }
            buf.append( " have been found. A common solution is to set the" + " environment variable JAVA_HOME or CLASSPATH." );
            throw new org.apache.tools.ant.BuildException( buf.toString(), getRmic().getLocation() );
        }
        cmd.setExecutable( c.getName() );
        if (!c.getName().equals( RMIC_CLASSNAMES[RMIC_CLASSNAMES.length - 1] )) {
            cmd.createArgument().setValue( "-verbose" );
            getRmic().log( Commandline.describeCommand( cmd ) );
        }
        org.apache.tools.ant.taskdefs.ExecuteJava ej = new org.apache.tools.ant.taskdefs.ExecuteJava();
        ej.setJavaCommand( cmd );
        return ej.fork( getRmic() ) == 0;
    }

    public static  boolean isAvailable()
    {
        return getRmicClass() != null;
    }

    private static  java.lang.Class getRmicClass()
    {
        for (int i = 0; i < RMIC_CLASSNAMES.length; i++) {
            try {
                return Class.forName( RMIC_CLASSNAMES[i] );
            } catch ( java.lang.ClassNotFoundException cnfe ) {
            }
        }
        return null;
    }

}
