// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.rmic;


import java.lang.reflect.Method;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Commandline;


public class WLRmic extends org.apache.tools.ant.taskdefs.rmic.DefaultRmicAdapter
{

    public static final java.lang.String WLRMIC_CLASSNAME = "weblogic.rmic";

    public static final java.lang.String COMPILER_NAME = "weblogic";

    public static final java.lang.String ERROR_NO_WLRMIC_ON_CLASSPATH = "Cannot use WebLogic rmic, as it is not " + "available. Add it to Ant's classpath with the -lib option";

    public static final java.lang.String ERROR_WLRMIC_FAILED = "Error starting WebLogic rmic: ";

    public static final java.lang.String WL_RMI_STUB_SUFFIX = "_WLStub";

    public static final java.lang.String WL_RMI_SKEL_SUFFIX = "_WLSkel";

    public static final java.lang.String UNSUPPORTED_STUB_OPTION = "Unsupported stub option: ";

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        getRmic().log( "Using WebLogic rmic", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.Commandline cmd = setupRmicCommand( new java.lang.String[]{ "-noexit" } );
        org.apache.tools.ant.AntClassLoader loader = null;
        try {
            java.lang.Class c = null;
            if (getRmic().getClasspath() == null) {
                c = Class.forName( WLRMIC_CLASSNAME );
            } else {
                loader = getRmic().getProject().createClassLoader( getRmic().getClasspath() );
                c = Class.forName( WLRMIC_CLASSNAME, true, loader );
            }
            java.lang.reflect.Method doRmic = c.getMethod( "main", new java.lang.Class[]{ java.lang.String[].class } );
            doRmic.invoke( null, new java.lang.Object[]{ cmd.getArguments() } );
            return true;
        } catch ( java.lang.ClassNotFoundException ex ) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_WLRMIC_ON_CLASSPATH, getRmic().getLocation() );
        } catch ( java.lang.Exception ex ) {
            if (ex instanceof org.apache.tools.ant.BuildException) {
                throw (org.apache.tools.ant.BuildException) ex;
            } else {
                throw new org.apache.tools.ant.BuildException( ERROR_WLRMIC_FAILED, ex, getRmic().getLocation() );
            }
        } finally 
{
            if (loader != null) {
                loader.cleanup();
            }
        }
    }

    public  java.lang.String getStubClassSuffix()
    {
        return WL_RMI_STUB_SUFFIX;
    }

    public  java.lang.String getSkelClassSuffix()
    {
        return WL_RMI_SKEL_SUFFIX;
    }

    protected  java.lang.String[] preprocessCompilerArgs( java.lang.String[] compilerArgs )
    {
        return filterJvmCompilerArgs( compilerArgs );
    }

    protected  java.lang.String addStubVersionOptions()
    {
        java.lang.String stubVersion = getRmic().getStubVersion();
        if (null != stubVersion) {
            getRmic().log( UNSUPPORTED_STUB_OPTION + stubVersion, Project.MSG_WARN );
        }
        return null;
    }

}
