// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;


public class Assertions extends org.apache.tools.ant.types.DataType implements java.lang.Cloneable
{

    private java.lang.Boolean enableSystemAssertions;

    private java.util.ArrayList assertionList = new java.util.ArrayList();

    public  void addEnable( org.apache.tools.ant.types.Assertions.EnabledAssertion assertion )
    {
        checkChildrenAllowed();
        assertionList.add( assertion );
    }

    public  void addDisable( org.apache.tools.ant.types.Assertions.DisabledAssertion assertion )
    {
        checkChildrenAllowed();
        assertionList.add( assertion );
    }

    public  void setEnableSystemAssertions( java.lang.Boolean enableSystemAssertions )
    {
        checkAttributesAllowed();
        this.enableSystemAssertions = enableSystemAssertions;
    }

    public  void setRefid( org.apache.tools.ant.types.Reference ref )
    {
        if (assertionList.size() > 0 || enableSystemAssertions != null) {
            throw tooManyAttributes();
        }
        super.setRefid( ref );
    }

    private  org.apache.tools.ant.types.Assertions getFinalReference()
    {
        if (getRefid() == null) {
            return this;
        } else {
            java.lang.Object o = getRefid().getReferencedObject( getProject() );
            if (!(o instanceof org.apache.tools.ant.types.Assertions)) {
                throw new org.apache.tools.ant.BuildException( "reference is of wrong type" );
            }
            return (org.apache.tools.ant.types.Assertions) o;
        }
    }

    public  int size()
    {
        org.apache.tools.ant.types.Assertions clause = getFinalReference();
        return clause.getFinalSize();
    }

    private  int getFinalSize()
    {
        return assertionList.size() + (enableSystemAssertions != null ? 1 : 0);
    }

    public  void applyAssertions( java.util.List commandList )
    {
        getProject().log( "Applying assertions", Project.MSG_DEBUG );
        org.apache.tools.ant.types.Assertions clause = getFinalReference();
        if (Boolean.TRUE.equals( clause.enableSystemAssertions )) {
            getProject().log( "Enabling system assertions", Project.MSG_DEBUG );
            commandList.add( "-enablesystemassertions" );
        } else {
            if (Boolean.FALSE.equals( clause.enableSystemAssertions )) {
                getProject().log( "disabling system assertions", Project.MSG_DEBUG );
                commandList.add( "-disablesystemassertions" );
            }
        }
        java.util.Iterator it = clause.assertionList.iterator();
        while (it.hasNext()) {
            org.apache.tools.ant.types.Assertions.BaseAssertion assertion = (org.apache.tools.ant.types.Assertions.BaseAssertion) it.next();
            java.lang.String arg = assertion.toCommand();
            getProject().log( "adding assertion " + arg, Project.MSG_DEBUG );
            commandList.add( arg );
        }
    }

    public  void applyAssertions( org.apache.tools.ant.types.CommandlineJava command )
    {
        org.apache.tools.ant.types.Assertions clause = getFinalReference();
        if (Boolean.TRUE.equals( clause.enableSystemAssertions )) {
            addVmArgument( command, "-enablesystemassertions" );
        } else {
            if (Boolean.FALSE.equals( clause.enableSystemAssertions )) {
                addVmArgument( command, "-disablesystemassertions" );
            }
        }
        java.util.Iterator it = clause.assertionList.iterator();
        while (it.hasNext()) {
            org.apache.tools.ant.types.Assertions.BaseAssertion assertion = (org.apache.tools.ant.types.Assertions.BaseAssertion) it.next();
            java.lang.String arg = assertion.toCommand();
            addVmArgument( command, arg );
        }
    }

    public  void applyAssertions( final java.util.ListIterator commandIterator )
    {
        getProject().log( "Applying assertions", Project.MSG_DEBUG );
        org.apache.tools.ant.types.Assertions clause = getFinalReference();
        if (Boolean.TRUE.equals( clause.enableSystemAssertions )) {
            getProject().log( "Enabling system assertions", Project.MSG_DEBUG );
            commandIterator.add( "-enablesystemassertions" );
        } else {
            if (Boolean.FALSE.equals( clause.enableSystemAssertions )) {
                getProject().log( "disabling system assertions", Project.MSG_DEBUG );
                commandIterator.add( "-disablesystemassertions" );
            }
        }
        java.util.Iterator it = clause.assertionList.iterator();
        while (it.hasNext()) {
            org.apache.tools.ant.types.Assertions.BaseAssertion assertion = (org.apache.tools.ant.types.Assertions.BaseAssertion) it.next();
            java.lang.String arg = assertion.toCommand();
            getProject().log( "adding assertion " + arg, Project.MSG_DEBUG );
            commandIterator.add( arg );
        }
    }

    private static  void addVmArgument( org.apache.tools.ant.types.CommandlineJava command, java.lang.String arg )
    {
        org.apache.tools.ant.types.Commandline.Argument argument;
        argument = command.createVmArgument();
        argument.setValue( arg );
    }

    public  java.lang.Object clone()
        throws java.lang.CloneNotSupportedException
    {
        org.apache.tools.ant.types.Assertions that = (org.apache.tools.ant.types.Assertions) super.clone();
        that.assertionList = (java.util.ArrayList) assertionList.clone();
        return that;
    }

    public abstract static class BaseAssertion
    {

        private java.lang.String packageName;

        private java.lang.String className;

        public  void setClass( java.lang.String className )
        {
            this.className = className;
        }

        public  void setPackage( java.lang.String packageName )
        {
            this.packageName = packageName;
        }

        protected  java.lang.String getClassName()
        {
            return className;
        }

        protected  java.lang.String getPackageName()
        {
            return packageName;
        }

        public abstract  java.lang.String getCommandPrefix();

        public  java.lang.String toCommand()
        {
            if (getPackageName() != null && getClassName() != null) {
                throw new org.apache.tools.ant.BuildException( "Both package and class have been set" );
            }
            java.lang.StringBuffer command = new java.lang.StringBuffer( getCommandPrefix() );
            if (getPackageName() != null) {
                command.append( ':' );
                command.append( getPackageName() );
                if (!command.toString().endsWith( "..." )) {
                    command.append( "..." );
                }
            } else {
                if (getClassName() != null) {
                    command.append( ':' );
                    command.append( getClassName() );
                }
            }
            return command.toString();
        }

    }

    public static class EnabledAssertion extends org.apache.tools.ant.types.Assertions.BaseAssertion
    {

        public  java.lang.String getCommandPrefix()
        {
            return "-ea";
        }

    }

    public static class DisabledAssertion extends org.apache.tools.ant.types.Assertions.BaseAssertion
    {

        public  java.lang.String getCommandPrefix()
        {
            return "-da";
        }

    }

}
