// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.io.File;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Iterator;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.resources.FileResourceIterator;


public class FileList extends org.apache.tools.ant.types.DataType implements org.apache.tools.ant.types.ResourceCollection
{

    private java.util.Vector filenames = new java.util.Vector();

    private java.io.File dir;

    public FileList()
    {
        super();
    }

    protected FileList( org.apache.tools.ant.types.FileList filelist )
    {
        this.dir = filelist.dir;
        this.filenames = filelist.filenames;
        setProject( filelist.getProject() );
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
        throws org.apache.tools.ant.BuildException
    {
        if (dir != null || filenames.size() != 0) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  void setDir( java.io.File dir )
        throws org.apache.tools.ant.BuildException
    {
        checkAttributesAllowed();
        this.dir = dir;
    }

    public  java.io.File getDir( org.apache.tools.ant.Project p )
    {
        if (isReference()) {
            return getRef( p ).getDir( p );
        }
        return dir;
    }

    public  void setFiles( java.lang.String filenames )
    {
        checkAttributesAllowed();
        if (filenames != null && filenames.length() > 0) {
            java.util.StringTokenizer tok = new java.util.StringTokenizer( filenames, ", \t\n\r\f", false );
            while (tok.hasMoreTokens()) {
                this.filenames.addElement( tok.nextToken() );
            }
        }
    }

    public  java.lang.String[] getFiles( org.apache.tools.ant.Project p )
    {
        if (isReference()) {
            return getRef( p ).getFiles( p );
        }
        if (dir == null) {
            throw new org.apache.tools.ant.BuildException( "No directory specified for filelist." );
        }
        if (filenames.size() == 0) {
            throw new org.apache.tools.ant.BuildException( "No files specified for filelist." );
        }
        java.lang.String[] result = new java.lang.String[filenames.size()];
        filenames.copyInto( result );
        return result;
    }

    protected  org.apache.tools.ant.types.FileList getRef( org.apache.tools.ant.Project p )
    {
        return (org.apache.tools.ant.types.FileList) getCheckedRef( p );
    }

    public static class FileName
    {

        private java.lang.String name;

        public  void setName( java.lang.String name )
        {
            this.name = name;
        }

        public  java.lang.String getName()
        {
            return name;
        }

    }

    public  void addConfiguredFile( org.apache.tools.ant.types.FileList.FileName name )
    {
        if (name.getName() == null) {
            throw new org.apache.tools.ant.BuildException( "No name specified in nested file element" );
        }
        filenames.addElement( name.getName() );
    }

    public  java.util.Iterator iterator()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.FileList) getRef( getProject() )).iterator();
        }
        return new org.apache.tools.ant.types.resources.FileResourceIterator( getProject(), dir, (java.lang.String[]) filenames.toArray( new java.lang.String[filenames.size()] ) );
    }

    public  int size()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.FileList) getRef( getProject() )).size();
        }
        return filenames.size();
    }

    public  boolean isFilesystemOnly()
    {
        return true;
    }

}
