// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import org.apache.tools.ant.BuildException;


public class Quantifier extends org.apache.tools.ant.types.EnumeratedAttribute
{

    private static final java.lang.String[] VALUES = new java.lang.String[]{ "all", "each", "every", "any", "some", "one", "majority", "most", "none" };

    public static final org.apache.tools.ant.types.Quantifier ALL = new org.apache.tools.ant.types.Quantifier( "all" );

    public static final org.apache.tools.ant.types.Quantifier ANY = new org.apache.tools.ant.types.Quantifier( "any" );

    public static final org.apache.tools.ant.types.Quantifier ONE = new org.apache.tools.ant.types.Quantifier( "one" );

    public static final org.apache.tools.ant.types.Quantifier MAJORITY = new org.apache.tools.ant.types.Quantifier( "majority" );

    public static final org.apache.tools.ant.types.Quantifier NONE = new org.apache.tools.ant.types.Quantifier( "none" );

    private abstract static class Predicate
    {

        abstract  boolean eval( int t, int f );

    }

    private static final org.apache.tools.ant.types.Quantifier.Predicate ALL_PRED = new org.apache.tools.ant.types.Quantifier.Predicate(){
         boolean eval( int t, int f )
        {
            return f == 0;
        }
    };

    private static final org.apache.tools.ant.types.Quantifier.Predicate ANY_PRED = new org.apache.tools.ant.types.Quantifier.Predicate(){
         boolean eval( int t, int f )
        {
            return t > 0;
        }
    };

    private static final org.apache.tools.ant.types.Quantifier.Predicate ONE_PRED = new org.apache.tools.ant.types.Quantifier.Predicate(){
         boolean eval( int t, int f )
        {
            return t == 1;
        }
    };

    private static final org.apache.tools.ant.types.Quantifier.Predicate MAJORITY_PRED = new org.apache.tools.ant.types.Quantifier.Predicate(){
         boolean eval( int t, int f )
        {
            return t > f;
        }
    };

    private static final org.apache.tools.ant.types.Quantifier.Predicate NONE_PRED = new org.apache.tools.ant.types.Quantifier.Predicate(){
         boolean eval( int t, int f )
        {
            return t == 0;
        }
    };

    private static final org.apache.tools.ant.types.Quantifier.Predicate[] PREDS = new org.apache.tools.ant.types.Quantifier.Predicate[VALUES.length];

    static {
        PREDS[0] = ALL_PRED;
        PREDS[1] = ALL_PRED;
        PREDS[2] = ALL_PRED;
        PREDS[3] = ANY_PRED;
        PREDS[4] = ANY_PRED;
        PREDS[5] = ONE_PRED;
        PREDS[6] = MAJORITY_PRED;
        PREDS[7] = MAJORITY_PRED;
        PREDS[8] = NONE_PRED;
    }

    public Quantifier()
    {
    }

    public Quantifier( java.lang.String value )
    {
        setValue( value );
    }

    public  java.lang.String[] getValues()
    {
        return VALUES;
    }

    public  boolean evaluate( boolean[] b )
    {
        int t = 0;
        for (int i = 0; i < b.length; i++) {
            if (b[i]) {
                t++;
            }
        }
        return evaluate( t, b.length - t );
    }

    public  boolean evaluate( int t, int f )
    {
        int index = getIndex();
        if (index == -1) {
            throw new org.apache.tools.ant.BuildException( "Quantifier value not set." );
        }
        return PREDS[index].eval( t, f );
    }

}
