// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.NoSuchElementException;
import org.apache.tools.ant.types.resources.FileProvider;


public class Resource extends org.apache.tools.ant.types.DataType implements java.lang.Cloneable, java.lang.Comparable, org.apache.tools.ant.types.ResourceCollection
{

    public static final long UNKNOWN_SIZE = -1;

    public static final long UNKNOWN_DATETIME = 0L;

    protected static final int MAGIC = getMagicNumber( "Resource".getBytes() );

    private static final int NULL_NAME = getMagicNumber( "null name".getBytes() );

    protected static  int getMagicNumber( byte[] seed )
    {
        return (new java.math.BigInteger( seed )).intValue();
    }

    private java.lang.String name = null;

    private java.lang.Boolean exists = null;

    private java.lang.Long lastmodified = null;

    private java.lang.Boolean directory = null;

    private java.lang.Long size = null;

    public Resource()
    {
    }

    public Resource( java.lang.String name )
    {
        this( name, false, 0, false );
    }

    public Resource( java.lang.String name, boolean exists, long lastmodified )
    {
        this( name, exists, lastmodified, false );
    }

    public Resource( java.lang.String name, boolean exists, long lastmodified, boolean directory )
    {
        this( name, exists, lastmodified, directory, UNKNOWN_SIZE );
    }

    public Resource( java.lang.String name, boolean exists, long lastmodified, boolean directory, long size )
    {
        this.name = name;
        setName( name );
        setExists( exists );
        setLastModified( lastmodified );
        setDirectory( directory );
        setSize( size );
    }

    public  java.lang.String getName()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).getName() : name;
    }

    public  void setName( java.lang.String name )
    {
        checkAttributesAllowed();
        this.name = name;
    }

    public  boolean isExists()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).isExists();
        }
        return exists == null || exists.booleanValue();
    }

    public  void setExists( boolean exists )
    {
        checkAttributesAllowed();
        this.exists = exists ? Boolean.TRUE : Boolean.FALSE;
    }

    public  long getLastModified()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getLastModified();
        }
        if (!isExists() || lastmodified == null) {
            return UNKNOWN_DATETIME;
        }
        long result = lastmodified.longValue();
        return result < UNKNOWN_DATETIME ? UNKNOWN_DATETIME : result;
    }

    public  void setLastModified( long lastmodified )
    {
        checkAttributesAllowed();
        this.lastmodified = new java.lang.Long( lastmodified );
    }

    public  boolean isDirectory()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).isDirectory();
        }
        return directory != null && directory.booleanValue();
    }

    public  void setDirectory( boolean directory )
    {
        checkAttributesAllowed();
        this.directory = directory ? Boolean.TRUE : Boolean.FALSE;
    }

    public  void setSize( long size )
    {
        checkAttributesAllowed();
        this.size = new java.lang.Long( size > UNKNOWN_SIZE ? size : UNKNOWN_SIZE );
    }

    public  long getSize()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getSize();
        }
        return isExists() ? size != null ? size.longValue() : UNKNOWN_SIZE : 0L;
    }

    public  java.lang.Object clone()
    {
        try {
            return super.clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
            throw new java.lang.UnsupportedOperationException( "CloneNotSupportedException for a Resource caught. " + "Derived classes must support cloning." );
        }
    }

    public  int compareTo( java.lang.Object other )
    {
        if (isReference()) {
            return ((java.lang.Comparable) getCheckedRef()).compareTo( other );
        }
        if (!(other instanceof org.apache.tools.ant.types.Resource)) {
            throw new java.lang.IllegalArgumentException( "Can only be compared with Resources" );
        }
        return toString().compareTo( other.toString() );
    }

    public  boolean equals( java.lang.Object other )
    {
        if (isReference()) {
            return getCheckedRef().equals( other );
        }
        return other.getClass().equals( getClass() ) && compareTo( other ) == 0;
    }

    public  int hashCode()
    {
        if (isReference()) {
            return getCheckedRef().hashCode();
        }
        java.lang.String name = getName();
        return MAGIC * (name == null ? NULL_NAME : name.hashCode());
    }

    public  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream();
        }
        throw new java.lang.UnsupportedOperationException();
    }

    public  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getOutputStream();
        }
        throw new java.lang.UnsupportedOperationException();
    }

    public  java.util.Iterator iterator()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).iterator() : new java.util.Iterator(){
            private boolean done = false;

            public  boolean hasNext()
            {
                return !done;
            }

            public  java.lang.Object next()
            {
                if (done) {
                    throw new java.util.NoSuchElementException();
                }
                done = true;
                return Resource.this;
            }

            public  void remove()
            {
                throw new java.lang.UnsupportedOperationException();
            }
        };
    }

    public  int size()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).size() : 1;
    }

    public  boolean isFilesystemOnly()
    {
        return isReference() && ((org.apache.tools.ant.types.Resource) getCheckedRef()).isFilesystemOnly() || this.as( org.apache.tools.ant.types.resources.FileProvider.class ) != null;
    }

    public  java.lang.String toString()
    {
        if (isReference()) {
            return getCheckedRef().toString();
        }
        java.lang.String n = getName();
        return n == null ? "(anonymous)" : n;
    }

    public final  java.lang.String toLongString()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).toLongString() : getDataTypeName() + " \"" + toString() + '"';
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
    {
        if (name != null || exists != null || lastmodified != null || directory != null || size != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  java.lang.Object as( java.lang.Class clazz )
    {
        return clazz.isAssignableFrom( getClass() ) ? this : null;
    }

}
