// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;


public class ZipFileSet extends org.apache.tools.ant.types.ArchiveFileSet
{

    private java.lang.String encoding = null;

    public ZipFileSet()
    {
        super();
    }

    protected ZipFileSet( org.apache.tools.ant.types.FileSet fileset )
    {
        super( fileset );
    }

    protected ZipFileSet( org.apache.tools.ant.types.ZipFileSet fileset )
    {
        super( fileset );
        encoding = fileset.encoding;
    }

    public  void setEncoding( java.lang.String enc )
    {
        checkZipFileSetAttributesAllowed();
        this.encoding = enc;
    }

    public  java.lang.String getEncoding()
    {
        if (isReference()) {
            org.apache.tools.ant.types.AbstractFileSet ref = getRef( getProject() );
            if (ref instanceof org.apache.tools.ant.types.ZipFileSet) {
                return ((org.apache.tools.ant.types.ZipFileSet) ref).getEncoding();
            } else {
                return null;
            }
        }
        return encoding;
    }

    protected  org.apache.tools.ant.types.ArchiveScanner newArchiveScanner()
    {
        org.apache.tools.ant.types.ZipScanner zs = new org.apache.tools.ant.types.ZipScanner();
        zs.setEncoding( encoding );
        return zs;
    }

    protected  org.apache.tools.ant.types.AbstractFileSet getRef( org.apache.tools.ant.Project p )
    {
        dieOnCircularReference( p );
        java.lang.Object o = getRefid().getReferencedObject( p );
        if (o instanceof org.apache.tools.ant.types.ZipFileSet) {
            return (org.apache.tools.ant.types.AbstractFileSet) o;
        } else {
            if (o instanceof org.apache.tools.ant.types.FileSet) {
                org.apache.tools.ant.types.ZipFileSet zfs = new org.apache.tools.ant.types.ZipFileSet( (org.apache.tools.ant.types.FileSet) o );
                configureFileSet( zfs );
                return zfs;
            } else {
                java.lang.String msg = getRefid().getRefId() + " doesn\'t denote a zipfileset or a fileset";
                throw new org.apache.tools.ant.BuildException( msg );
            }
        }
    }

    public  java.lang.Object clone()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.ZipFileSet) getRef( getProject() )).clone();
        } else {
            return super.clone();
        }
    }

    private  void checkZipFileSetAttributesAllowed()
    {
        if (getProject() == null || isReference() && getRefid().getReferencedObject( getProject() ) instanceof org.apache.tools.ant.types.ZipFileSet) {
            checkAttributesAllowed();
        }
    }

}
