// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.optional.image;


import javax.media.jai.PlanarImage;
import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.geom.Arc2D;
import java.awt.image.BufferedImage;


public class Arc extends org.apache.tools.ant.types.optional.image.BasicShape implements org.apache.tools.ant.types.optional.image.DrawOperation
{

    protected int width = 0;

    protected int height = 0;

    protected int start = 0;

    protected int stop = 0;

    protected int type = Arc2D.OPEN;

    public  void setWidth( int width )
    {
        this.width = width;
    }

    public  void setHeight( int height )
    {
        this.height = height;
    }

    public  void setStart( int start )
    {
        this.start = start;
    }

    public  void setStop( int stop )
    {
        this.stop = stop;
    }

    public  void setType( java.lang.String strType )
    {
        if (strType.equalsIgnoreCase( "open" )) {
            type = Arc2D.OPEN;
        } else {
            if (strType.equalsIgnoreCase( "pie" )) {
                type = Arc2D.PIE;
            } else {
                if (strType.equalsIgnoreCase( "chord" )) {
                    type = Arc2D.CHORD;
                }
            }
        }
    }

    public  javax.media.jai.PlanarImage executeDrawOperation()
    {
        java.awt.image.BufferedImage bi = new java.awt.image.BufferedImage( width + stroke_width * 2, height + stroke_width * 2, BufferedImage.TYPE_4BYTE_ABGR_PRE );
        java.awt.Graphics2D graphics = (java.awt.Graphics2D) bi.getGraphics();
        if (!stroke.equals( "transparent" )) {
            java.awt.BasicStroke bStroke = new java.awt.BasicStroke( stroke_width );
            graphics.setColor( ColorMapper.getColorByName( stroke ) );
            graphics.setStroke( bStroke );
            graphics.draw( new java.awt.geom.Arc2D.Double( stroke_width, stroke_width, width, height, start, stop, type ) );
        }
        if (!fill.equals( "transparent" )) {
            graphics.setColor( ColorMapper.getColorByName( fill ) );
            graphics.fill( new java.awt.geom.Arc2D.Double( stroke_width, stroke_width, width, height, start, stop, type ) );
        }
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                javax.media.jai.PlanarImage img = ((org.apache.tools.ant.types.optional.image.DrawOperation) instr).executeDrawOperation();
                graphics.drawImage( img.getAsBufferedImage(), null, 0, 0 );
            } else {
                if (instr instanceof org.apache.tools.ant.types.optional.image.TransformOperation) {
                    graphics = (java.awt.Graphics2D) bi.getGraphics();
                    javax.media.jai.PlanarImage image = ((org.apache.tools.ant.types.optional.image.TransformOperation) instr).executeTransformOperation( PlanarImage.wrapRenderedImage( bi ) );
                    bi = image.getAsBufferedImage();
                }
            }
        }
        return PlanarImage.wrapRenderedImage( bi );
    }

}
