// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.optional.image;


import javax.media.jai.PlanarImage;
import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;


public class Rectangle extends org.apache.tools.ant.types.optional.image.BasicShape implements org.apache.tools.ant.types.optional.image.DrawOperation
{

    protected int width = 0;

    protected int height = 0;

    protected int arcwidth = 0;

    protected int archeight = 0;

    public  void setWidth( int w )
    {
        width = w;
    }

    public  void setHeight( int h )
    {
        height = h;
    }

    public  void setArcwidth( int w )
    {
        arcwidth = w;
    }

    public  void setArcheight( int h )
    {
        archeight = h;
    }

    public  javax.media.jai.PlanarImage executeDrawOperation()
    {
        log( "\tCreating Rectangle w=" + width + " h=" + height + " arcw=" + arcwidth + " arch=" + archeight );
        java.awt.image.BufferedImage bi = new java.awt.image.BufferedImage( width, height, BufferedImage.TYPE_4BYTE_ABGR_PRE );
        java.awt.Graphics2D graphics = (java.awt.Graphics2D) bi.getGraphics();
        if (!stroke.equals( "transparent" )) {
            java.awt.BasicStroke bStroke = new java.awt.BasicStroke( stroke_width );
            graphics.setColor( ColorMapper.getColorByName( stroke ) );
            graphics.setStroke( bStroke );
            if (arcwidth != 0 || archeight != 0) {
                graphics.drawRoundRect( 0, 0, width, height, arcwidth, archeight );
            } else {
                graphics.drawRect( 0, 0, width, height );
            }
        }
        if (!fill.equals( "transparent" )) {
            graphics.setColor( ColorMapper.getColorByName( fill ) );
            if (arcwidth != 0 || archeight != 0) {
                graphics.fillRoundRect( stroke_width, stroke_width, width - stroke_width * 2, height - stroke_width * 2, arcwidth, archeight );
            } else {
                graphics.fillRect( stroke_width, stroke_width, width - stroke_width * 2, height - stroke_width * 2 );
            }
        }
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                javax.media.jai.PlanarImage img = ((org.apache.tools.ant.types.optional.image.DrawOperation) instr).executeDrawOperation();
                graphics.drawImage( img.getAsBufferedImage(), null, 0, 0 );
            } else {
                if (instr instanceof org.apache.tools.ant.types.optional.image.TransformOperation) {
                    graphics = (java.awt.Graphics2D) bi.getGraphics();
                    javax.media.jai.PlanarImage image = ((org.apache.tools.ant.types.optional.image.TransformOperation) instr).executeTransformOperation( PlanarImage.wrapRenderedImage( bi ) );
                    bi = image.getAsBufferedImage();
                }
            }
        }
        return PlanarImage.wrapRenderedImage( bi );
    }

}
