// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.optional.image;


import org.apache.tools.ant.types.EnumeratedAttribute;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.awt.image.BufferedImage;
import java.awt.image.renderable.ParameterBlock;


public class Scale extends org.apache.tools.ant.types.optional.image.TransformOperation implements org.apache.tools.ant.types.optional.image.DrawOperation
{

    private static final int HUNDRED = 100;

    private java.lang.String widthStr = "100%";

    private java.lang.String heightStr = "100%";

    private boolean xPercent = true;

    private boolean yPercent = true;

    private java.lang.String proportions = "ignore";

    public static class ProportionsAttribute extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "ignore", "width", "height", "cover", "fit" };
        }

    }

    public  void setProportions( org.apache.tools.ant.types.optional.image.Scale.ProportionsAttribute pa )
    {
        proportions = pa.getValue();
    }

    public  void setWidth( java.lang.String width )
    {
        widthStr = width;
    }

    public  void setHeight( java.lang.String height )
    {
        heightStr = height;
    }

    public  float getWidth()
    {
        float width = 0.0F;
        int percIndex = widthStr.indexOf( '%' );
        if (percIndex > 0) {
            width = Float.parseFloat( widthStr.substring( 0, percIndex ) );
            xPercent = true;
            return width / HUNDRED;
        } else {
            xPercent = false;
            return Float.parseFloat( widthStr );
        }
    }

    public  float getHeight()
    {
        int percIndex = heightStr.indexOf( '%' );
        if (percIndex > 0) {
            float height = Float.parseFloat( heightStr.substring( 0, percIndex ) );
            yPercent = true;
            return height / HUNDRED;
        } else {
            yPercent = false;
            return Float.parseFloat( heightStr );
        }
    }

    public  javax.media.jai.PlanarImage performScale( javax.media.jai.PlanarImage image )
    {
        java.awt.image.renderable.ParameterBlock pb = new java.awt.image.renderable.ParameterBlock();
        pb.addSource( image );
        float xFl = getWidth();
        float yFl = getHeight();
        if (!xPercent) {
            xFl = xFl / image.getWidth();
        }
        if (!yPercent) {
            yFl = yFl / image.getHeight();
        }
        if ("width".equals( proportions )) {
            yFl = xFl;
        } else {
            if ("height".equals( proportions )) {
                xFl = yFl;
            } else {
                if ("fit".equals( proportions )) {
                    yFl = Math.min( xFl, yFl );
                    xFl = yFl;
                } else {
                    if ("cover".equals( proportions )) {
                        yFl = Math.max( xFl, yFl );
                        xFl = yFl;
                    }
                }
            }
        }
        pb.add( new java.lang.Float( xFl ) );
        pb.add( new java.lang.Float( yFl ) );
        log( "\tScaling to " + xFl * HUNDRED + "% x " + yFl * HUNDRED + "%" );
        return JAI.create( "scale", pb );
    }

    public  javax.media.jai.PlanarImage executeTransformOperation( javax.media.jai.PlanarImage image )
    {
        java.awt.image.BufferedImage bi = null;
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                return performScale( image );
            } else {
                if (instr instanceof org.apache.tools.ant.types.optional.image.TransformOperation) {
                    bi = image.getAsBufferedImage();
                    image = ((org.apache.tools.ant.types.optional.image.TransformOperation) instr).executeTransformOperation( PlanarImage.wrapRenderedImage( bi ) );
                    bi = image.getAsBufferedImage();
                }
            }
        }
        return performScale( image );
    }

    public  javax.media.jai.PlanarImage executeDrawOperation()
    {
        final int size = instructions.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.optional.image.ImageOperation instr = (org.apache.tools.ant.types.optional.image.ImageOperation) instructions.elementAt( i );
            if (instr instanceof org.apache.tools.ant.types.optional.image.DrawOperation) {
                javax.media.jai.PlanarImage image = null;
                performScale( image );
                return image;
            }
        }
        return null;
    }

}
