// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.NoSuchElementException;
import org.apache.tools.ant.types.Resource;


public class LazyResourceCollectionWrapper extends org.apache.tools.ant.types.resources.AbstractResourceCollectionWrapper
{

    private java.util.List cachedResources = new java.util.ArrayList();

    private org.apache.tools.ant.types.resources.LazyResourceCollectionWrapper.FilteringIterator filteringIterator;

    protected  java.util.Iterator createIterator()
    {
        java.util.Iterator iterator;
        if (isCache()) {
            if (filteringIterator == null) {
                filteringIterator = new org.apache.tools.ant.types.resources.LazyResourceCollectionWrapper.FilteringIterator( getResourceCollection().iterator() );
            }
            iterator = new org.apache.tools.ant.types.resources.LazyResourceCollectionWrapper.CachedIterator( filteringIterator );
        } else {
            iterator = new org.apache.tools.ant.types.resources.LazyResourceCollectionWrapper.FilteringIterator( getResourceCollection().iterator() );
        }
        return iterator;
    }

    protected  int getSize()
    {
        java.util.Iterator it = createIterator();
        int size = 0;
        while (it.hasNext()) {
            it.next();
            size++;
        }
        return size;
    }

    protected  boolean filterResource( org.apache.tools.ant.types.Resource r )
    {
        return false;
    }

    private class FilteringIterator implements java.util.Iterator
    {

        org.apache.tools.ant.types.Resource next = null;

        boolean ended = false;

        protected final java.util.Iterator it;

        public FilteringIterator( java.util.Iterator it )
        {
            this.it = it;
        }

        public  boolean hasNext()
        {
            if (ended) {
                return false;
            }
            while (next == null) {
                if (!it.hasNext()) {
                    ended = true;
                    return false;
                }
                next = (org.apache.tools.ant.types.Resource) it.next();
                if (filterResource( next )) {
                    next = null;
                }
            }
            return true;
        }

        public  java.lang.Object next()
        {
            if (!hasNext()) {
                throw new java.lang.UnsupportedOperationException();
            }
            org.apache.tools.ant.types.Resource r = next;
            next = null;
            return r;
        }

        public  void remove()
        {
            throw new java.lang.UnsupportedOperationException();
        }

    }

    private class CachedIterator implements java.util.Iterator
    {

        int cusrsor = 0;

        private final java.util.Iterator it;

        public CachedIterator( java.util.Iterator it )
        {
            this.it = it;
        }

        public  boolean hasNext()
        {
            synchronized (cachedResources)
{
                if (cachedResources.size() > cusrsor) {
                    return true;
                }
                if (!it.hasNext()) {
                    return false;
                }
                org.apache.tools.ant.types.Resource r = (org.apache.tools.ant.types.Resource) it.next();
                cachedResources.add( r );
            }
            return true;
        }

        public  java.lang.Object next()
        {
            if (!hasNext()) {
                throw new java.util.NoSuchElementException();
            }
            synchronized (cachedResources)
{
                return cachedResources.get( cusrsor++ );
            }
        }

        public  void remove()
        {
            throw new java.lang.UnsupportedOperationException();
        }

    }

}
