// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.tar.TarEntry;
import org.apache.tools.tar.TarInputStream;


public class TarResource extends org.apache.tools.ant.types.resources.ArchiveResource
{

    private java.lang.String userName = "";

    private java.lang.String groupName = "";

    private int uid;

    private int gid;

    public TarResource()
    {
    }

    public TarResource( java.io.File a, org.apache.tools.tar.TarEntry e )
    {
        super( a, true );
        setEntry( e );
    }

    public TarResource( org.apache.tools.ant.types.Resource a, org.apache.tools.tar.TarEntry e )
    {
        super( a, true );
        setEntry( e );
    }

    public  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream();
        }
        org.apache.tools.ant.types.Resource archive = getArchive();
        final org.apache.tools.tar.TarInputStream i = new org.apache.tools.tar.TarInputStream( archive.getInputStream() );
        org.apache.tools.tar.TarEntry te = null;
        while ((te = i.getNextEntry()) != null) {
            if (te.getName().equals( getName() )) {
                return i;
            }
        }
        FileUtils.close( i );
        throw new org.apache.tools.ant.BuildException( "no entry " + getName() + " in " + getArchive() );
    }

    public  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getOutputStream();
        }
        throw new java.lang.UnsupportedOperationException( "Use the tar task for tar output." );
    }

    public  java.lang.String getUserName()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.TarResource) getCheckedRef()).getUserName();
        }
        checkEntry();
        return userName;
    }

    public  java.lang.String getGroup()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.TarResource) getCheckedRef()).getGroup();
        }
        checkEntry();
        return groupName;
    }

    public  int getUid()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.TarResource) getCheckedRef()).getUid();
        }
        checkEntry();
        return uid;
    }

    public  int getGid()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.TarResource) getCheckedRef()).getGid();
        }
        checkEntry();
        return gid;
    }

    protected  void fetchEntry()
    {
        org.apache.tools.ant.types.Resource archive = getArchive();
        org.apache.tools.tar.TarInputStream i = null;
        try {
            i = new org.apache.tools.tar.TarInputStream( archive.getInputStream() );
            org.apache.tools.tar.TarEntry te = null;
            while ((te = i.getNextEntry()) != null) {
                if (te.getName().equals( getName() )) {
                    setEntry( te );
                    return;
                }
            }
        } catch ( java.io.IOException e ) {
            log( e.getMessage(), Project.MSG_DEBUG );
            throw new org.apache.tools.ant.BuildException( e );
        } finally 
{
            if (i != null) {
                FileUtils.close( i );
            }
        }
        setEntry( null );
    }

    private  void setEntry( org.apache.tools.tar.TarEntry e )
    {
        if (e == null) {
            setExists( false );
            return;
        }
        setName( e.getName() );
        setExists( true );
        setLastModified( e.getModTime().getTime() );
        setDirectory( e.isDirectory() );
        setSize( e.getSize() );
        setMode( e.getMode() );
        userName = e.getUserName();
        groupName = e.getGroupName();
        uid = e.getUserId();
        gid = e.getGroupId();
    }

}
