// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.FilterInputStream;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.zip.ZipFile;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipExtraField;


public class ZipResource extends org.apache.tools.ant.types.resources.ArchiveResource
{

    private java.lang.String encoding;

    private org.apache.tools.zip.ZipExtraField[] extras;

    private int method;

    public ZipResource()
    {
    }

    public ZipResource( java.io.File z, java.lang.String enc, org.apache.tools.zip.ZipEntry e )
    {
        super( z, true );
        setEncoding( enc );
        setEntry( e );
    }

    public  void setZipfile( java.io.File z )
    {
        setArchive( z );
    }

    public  java.io.File getZipfile()
    {
        org.apache.tools.ant.types.resources.FileProvider fp = (org.apache.tools.ant.types.resources.FileProvider) getArchive().as( org.apache.tools.ant.types.resources.FileProvider.class );
        return fp.getFile();
    }

    public  void addConfigured( org.apache.tools.ant.types.ResourceCollection a )
    {
        super.addConfigured( a );
        if (!a.isFilesystemOnly()) {
            throw new org.apache.tools.ant.BuildException( "only filesystem resources are supported" );
        }
    }

    public  void setEncoding( java.lang.String enc )
    {
        checkAttributesAllowed();
        encoding = enc;
    }

    public  java.lang.String getEncoding()
    {
        return isReference() ? ((org.apache.tools.ant.types.resources.ZipResource) getCheckedRef()).getEncoding() : encoding;
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
    {
        if (encoding != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream();
        }
        final org.apache.tools.zip.ZipFile z = new org.apache.tools.zip.ZipFile( getZipfile(), getEncoding() );
        org.apache.tools.zip.ZipEntry ze = z.getEntry( getName() );
        if (ze == null) {
            z.close();
            throw new org.apache.tools.ant.BuildException( "no entry " + getName() + " in " + getArchive() );
        }
        return new java.io.FilterInputStream( z.getInputStream( ze ) ){
            public  void close()
                        throws java.io.IOException
            {
                FileUtils.close( in );
                z.close();
            }

            protected  void finalize()
                        throws java.lang.Throwable
            {
                try {
                    close();
                } finally 
{
                    super.finalize();
                }
            }
        };
    }

    public  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getOutputStream();
        }
        throw new java.lang.UnsupportedOperationException( "Use the zip task for zip output." );
    }

    public  org.apache.tools.zip.ZipExtraField[] getExtraFields()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.ZipResource) getCheckedRef()).getExtraFields();
        }
        checkEntry();
        if (extras == null) {
            return new org.apache.tools.zip.ZipExtraField[0];
        }
        return extras;
    }

    public  int getMethod()
    {
        return method;
    }

    protected  void fetchEntry()
    {
        org.apache.tools.zip.ZipFile z = null;
        try {
            z = new org.apache.tools.zip.ZipFile( getZipfile(), getEncoding() );
            setEntry( z.getEntry( getName() ) );
        } catch ( java.io.IOException e ) {
            log( e.getMessage(), Project.MSG_DEBUG );
            throw new org.apache.tools.ant.BuildException( e );
        } finally 
{
            ZipFile.closeQuietly( z );
        }
    }

    private  void setEntry( org.apache.tools.zip.ZipEntry e )
    {
        if (e == null) {
            setExists( false );
            return;
        }
        setName( e.getName() );
        setExists( true );
        setLastModified( e.getTime() );
        setDirectory( e.isDirectory() );
        setSize( e.getSize() );
        setMode( e.getUnixMode() );
        extras = e.getExtraFields( true );
        method = e.getMethod();
    }

}
