// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources.selectors;


import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.Locale;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.TimeComparison;
import org.apache.tools.ant.util.FileUtils;


public class Date implements org.apache.tools.ant.types.resources.selectors.ResourceSelector
{

    private static final java.lang.String MILLIS_OR_DATETIME = "Either the millis or the datetime attribute must be set.";

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private java.lang.Long millis = null;

    private java.lang.String dateTime = null;

    private java.lang.String pattern = null;

    private org.apache.tools.ant.types.TimeComparison when = TimeComparison.EQUAL;

    private long granularity = FILE_UTILS.getFileTimestampGranularity();

    public synchronized  void setMillis( long m )
    {
        millis = new java.lang.Long( m );
    }

    public synchronized  long getMillis()
    {
        return millis == null ? -1L : millis.longValue();
    }

    public synchronized  void setDateTime( java.lang.String s )
    {
        dateTime = s;
        millis = null;
    }

    public synchronized  java.lang.String getDatetime()
    {
        return dateTime;
    }

    public synchronized  void setGranularity( long g )
    {
        granularity = g;
    }

    public synchronized  long getGranularity()
    {
        return granularity;
    }

    public synchronized  void setPattern( java.lang.String p )
    {
        pattern = p;
    }

    public synchronized  java.lang.String getPattern()
    {
        return pattern;
    }

    public synchronized  void setWhen( org.apache.tools.ant.types.TimeComparison c )
    {
        when = c;
    }

    public synchronized  org.apache.tools.ant.types.TimeComparison getWhen()
    {
        return when;
    }

    public synchronized  boolean isSelected( org.apache.tools.ant.types.Resource r )
    {
        if (dateTime == null && millis == null) {
            throw new org.apache.tools.ant.BuildException( MILLIS_OR_DATETIME );
        }
        if (millis == null) {
            java.text.DateFormat df = pattern == null ? DateFormat.getDateTimeInstance( DateFormat.SHORT, DateFormat.SHORT, Locale.US ) : new java.text.SimpleDateFormat( pattern );
            try {
                long m = df.parse( dateTime ).getTime();
                if (m < 0) {
                    throw new org.apache.tools.ant.BuildException( "Date of " + dateTime + " results in negative milliseconds value" + " relative to epoch (January 1, 1970, 00:00:00 GMT)." );
                }
                setMillis( m );
            } catch ( java.text.ParseException pe ) {
                throw new org.apache.tools.ant.BuildException( "Date of " + dateTime + " Cannot be parsed correctly. It should be in" + (pattern == null ? " MM/DD/YYYY HH:MM AM_PM" : pattern) + " format." );
            }
        }
        return when.evaluate( r.getLastModified(), millis.longValue(), granularity );
    }

}
