// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import java.util.Vector;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Parameter;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;


public class ExtendSelector extends org.apache.tools.ant.types.selectors.BaseSelector
{

    private java.lang.String classname = null;

    private org.apache.tools.ant.types.selectors.FileSelector dynselector = null;

    private java.util.Vector paramVec = new java.util.Vector();

    private org.apache.tools.ant.types.Path classpath = null;

    public ExtendSelector()
    {
    }

    public  void setClassname( java.lang.String classname )
    {
        this.classname = classname;
    }

    public  void selectorCreate()
    {
        if (classname != null && classname.length() > 0) {
            try {
                java.lang.Class c = null;
                if (classpath == null) {
                    c = Class.forName( classname );
                } else {
                    org.apache.tools.ant.AntClassLoader al = getProject().createClassLoader( classpath );
                    c = Class.forName( classname, true, al );
                }
                dynselector = (org.apache.tools.ant.types.selectors.FileSelector) c.newInstance();
                final org.apache.tools.ant.Project p = getProject();
                if (p != null) {
                    p.setProjectReference( dynselector );
                }
            } catch ( java.lang.ClassNotFoundException cnfexcept ) {
                setError( "Selector " + classname + " not initialized, no such class" );
            } catch ( java.lang.InstantiationException iexcept ) {
                setError( "Selector " + classname + " not initialized, could not create class" );
            } catch ( java.lang.IllegalAccessException iaexcept ) {
                setError( "Selector " + classname + " not initialized, class not accessible" );
            }
        } else {
            setError( "There is no classname specified" );
        }
    }

    public  void addParam( org.apache.tools.ant.types.Parameter p )
    {
        paramVec.addElement( p );
    }

    public final  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append( classpath );
        }
    }

    public final  org.apache.tools.ant.types.Path createClasspath()
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        if (this.classpath == null) {
            this.classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return this.classpath.createPath();
    }

    public final  org.apache.tools.ant.types.Path getClasspath()
    {
        return classpath;
    }

    public  void setClasspathref( org.apache.tools.ant.types.Reference r )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        createClasspath().setRefid( r );
    }

    public  void verifySettings()
    {
        if (dynselector == null) {
            selectorCreate();
        }
        if (classname == null || classname.length() < 1) {
            setError( "The classname attribute is required" );
        } else {
            if (dynselector == null) {
                setError( "Internal Error: The custom selector was not created" );
            } else {
                if (!(dynselector instanceof org.apache.tools.ant.types.selectors.ExtendFileSelector) && paramVec.size() > 0) {
                    setError( "Cannot set parameters on custom selector that does not " + "implement ExtendFileSelector" );
                }
            }
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
        throws org.apache.tools.ant.BuildException
    {
        validate();
        if (paramVec.size() > 0 && dynselector instanceof org.apache.tools.ant.types.selectors.ExtendFileSelector) {
            org.apache.tools.ant.types.Parameter[] paramArray = new org.apache.tools.ant.types.Parameter[paramVec.size()];
            paramVec.copyInto( paramArray );
            ((org.apache.tools.ant.types.selectors.ExtendFileSelector) dynselector).setParameters( paramArray );
        }
        return dynselector.isSelected( basedir, filename, file );
    }

}
