// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;


public class TokenizedPattern
{

    public static final org.apache.tools.ant.types.selectors.TokenizedPattern EMPTY_PATTERN = new org.apache.tools.ant.types.selectors.TokenizedPattern( "", new java.lang.String[0] );

    private final java.lang.String pattern;

    private final java.lang.String[] tokenizedPattern;

    public TokenizedPattern( java.lang.String pattern )
    {
        this( pattern, SelectorUtils.tokenizePathAsArray( pattern ) );
    }

    TokenizedPattern( java.lang.String pattern, java.lang.String[] tokens )
    {
        this.pattern = pattern;
        this.tokenizedPattern = tokens;
    }

    public  boolean matchPath( org.apache.tools.ant.types.selectors.TokenizedPath path, boolean isCaseSensitive )
    {
        return SelectorUtils.matchPath( tokenizedPattern, path.getTokens(), isCaseSensitive );
    }

    public  boolean matchStartOf( org.apache.tools.ant.types.selectors.TokenizedPath path, boolean caseSensitive )
    {
        return SelectorUtils.matchPatternStart( tokenizedPattern, path.getTokens(), caseSensitive );
    }

    public  java.lang.String toString()
    {
        return pattern;
    }

    public  java.lang.String getPattern()
    {
        return pattern;
    }

    public  boolean equals( java.lang.Object o )
    {
        return o instanceof org.apache.tools.ant.types.selectors.TokenizedPattern && pattern.equals( ((org.apache.tools.ant.types.selectors.TokenizedPattern) o).pattern );
    }

    public  int hashCode()
    {
        return pattern.hashCode();
    }

    public  int depth()
    {
        return tokenizedPattern.length;
    }

    public  boolean containsPattern( java.lang.String pat )
    {
        for (int i = 0; i < tokenizedPattern.length; i++) {
            if (tokenizedPattern[i].equals( pat )) {
                return true;
            }
        }
        return false;
    }

    public  org.apache.tools.ant.types.selectors.TokenizedPath rtrimWildcardTokens()
    {
        java.lang.StringBuffer sb = new java.lang.StringBuffer();
        int newLen = 0;
        for (; newLen < tokenizedPattern.length; newLen++) {
            if (SelectorUtils.hasWildcards( tokenizedPattern[newLen] )) {
                break;
            }
            if (newLen > 0 && sb.charAt( sb.length() - 1 ) != File.separatorChar) {
                sb.append( File.separator );
            }
            sb.append( tokenizedPattern[newLen] );
        }
        if (newLen == 0) {
            return TokenizedPath.EMPTY_PATH;
        }
        java.lang.String[] newPats = new java.lang.String[newLen];
        System.arraycopy( tokenizedPattern, 0, newPats, 0, newLen );
        return new org.apache.tools.ant.types.selectors.TokenizedPath( sb.toString(), newPats );
    }

    public  boolean endsWith( java.lang.String s )
    {
        return tokenizedPattern.length > 0 && tokenizedPattern[tokenizedPattern.length - 1].equals( s );
    }

    public  org.apache.tools.ant.types.selectors.TokenizedPattern withoutLastToken()
    {
        if (tokenizedPattern.length == 0) {
            throw new java.lang.IllegalStateException( "cant strip a token from nothing" );
        } else {
            if (tokenizedPattern.length == 1) {
                return EMPTY_PATTERN;
            } else {
                java.lang.String toStrip = tokenizedPattern[tokenizedPattern.length - 1];
                int index = pattern.lastIndexOf( toStrip );
                java.lang.String[] tokens = new java.lang.String[tokenizedPattern.length - 1];
                System.arraycopy( tokenizedPattern, 0, tokens, 0, tokenizedPattern.length - 1 );
                return new org.apache.tools.ant.types.selectors.TokenizedPattern( pattern.substring( 0, index ), tokens );
            }
        }
    }

}
