// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors.modifiedselector;


import java.io.File;
import java.io.FileInputStream;
import java.util.Locale;
import java.security.DigestInputStream;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import org.apache.tools.ant.BuildException;


public class DigestAlgorithm implements org.apache.tools.ant.types.selectors.modifiedselector.Algorithm
{

    private static final int BYTE_MASK = 0xFF;

    private static final int BUFFER_SIZE = 8192;

    private java.lang.String algorithm = "MD5";

    private java.lang.String provider = null;

    private java.security.MessageDigest messageDigest = null;

    private int readBufferSize = BUFFER_SIZE;

    public  void setAlgorithm( java.lang.String algorithm )
    {
        this.algorithm = algorithm != null ? algorithm.toUpperCase( Locale.ENGLISH ) : null;
    }

    public  void setProvider( java.lang.String provider )
    {
        this.provider = provider;
    }

    public  void initMessageDigest()
    {
        if (messageDigest != null) {
            return;
        }
        if (provider != null && !"".equals( provider ) && !"null".equals( provider )) {
            try {
                messageDigest = MessageDigest.getInstance( algorithm, provider );
            } catch ( java.security.NoSuchAlgorithmException noalgo ) {
                throw new org.apache.tools.ant.BuildException( noalgo );
            } catch ( java.security.NoSuchProviderException noprovider ) {
                throw new org.apache.tools.ant.BuildException( noprovider );
            }
        } else {
            try {
                messageDigest = MessageDigest.getInstance( algorithm );
            } catch ( java.security.NoSuchAlgorithmException noalgo ) {
                throw new org.apache.tools.ant.BuildException( noalgo );
            }
        }
    }

    public  boolean isValid()
    {
        return "SHA".equals( algorithm ) || "MD5".equals( algorithm );
    }

    public  java.lang.String getValue( java.io.File file )
    {
        initMessageDigest();
        java.lang.String checksum = null;
        try {
            if (!file.canRead()) {
                return null;
            }
            java.io.FileInputStream fis = null;
            byte[] buf = new byte[readBufferSize];
            try {
                messageDigest.reset();
                fis = new java.io.FileInputStream( file );
                java.security.DigestInputStream dis = new java.security.DigestInputStream( fis, messageDigest );
                while (dis.read( buf, 0, readBufferSize ) != -1)  ;
                dis.close();
                fis.close();
                fis = null;
                byte[] fileDigest = messageDigest.digest();
                java.lang.StringBuffer checksumSb = new java.lang.StringBuffer();
                for (int i = 0; i < fileDigest.length; i++) {
                    java.lang.String hexStr = Integer.toHexString( BYTE_MASK & fileDigest[i] );
                    if (hexStr.length() < 2) {
                        checksumSb.append( "0" );
                    }
                    checksumSb.append( hexStr );
                }
                checksum = checksumSb.toString();
            } catch ( java.lang.Exception e ) {
                return null;
            }
        } catch ( java.lang.Exception e ) {
            return null;
        }
        return checksum;
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        buf.append( "<DigestAlgorithm:" );
        buf.append( "algorithm=" ).append( algorithm );
        buf.append( ";provider=" ).append( provider );
        buf.append( ">" );
        return buf.toString();
    }

}
