// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors.modifiedselector;


import java.util.Iterator;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Properties;
import java.io.File;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;


public class PropertiesfileCache implements org.apache.tools.ant.types.selectors.modifiedselector.Cache
{

    private java.io.File cachefile = null;

    private java.util.Properties cache = new java.util.Properties();

    private boolean cacheLoaded = false;

    private boolean cacheDirty = true;

    public PropertiesfileCache()
    {
    }

    public PropertiesfileCache( java.io.File cachefile )
    {
        this.cachefile = cachefile;
    }

    public  void setCachefile( java.io.File file )
    {
        cachefile = file;
    }

    public  java.io.File getCachefile()
    {
        return cachefile;
    }

    public  boolean isValid()
    {
        return cachefile != null;
    }

    public  void load()
    {
        if (cachefile != null && cachefile.isFile() && cachefile.canRead()) {
            try {
                java.io.BufferedInputStream bis = new java.io.BufferedInputStream( new java.io.FileInputStream( cachefile ) );
                cache.load( bis );
                bis.close();
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
            }
        }
        cacheLoaded = true;
        cacheDirty = false;
    }

    public  void save()
    {
        if (!cacheDirty) {
            return;
        }
        if (cachefile != null && cache.propertyNames().hasMoreElements()) {
            try {
                java.io.BufferedOutputStream bos = new java.io.BufferedOutputStream( new java.io.FileOutputStream( cachefile ) );
                cache.store( bos, null );
                bos.flush();
                bos.close();
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
            }
        }
        cacheDirty = false;
    }

    public  void delete()
    {
        cache = new java.util.Properties();
        cachefile.delete();
        cacheLoaded = true;
        cacheDirty = false;
    }

    public  java.lang.Object get( java.lang.Object key )
    {
        if (!cacheLoaded) {
            load();
        }
        try {
            return cache.getProperty( String.valueOf( key ) );
        } catch ( java.lang.ClassCastException e ) {
            return null;
        }
    }

    public  void put( java.lang.Object key, java.lang.Object value )
    {
        cache.put( String.valueOf( key ), String.valueOf( value ) );
        cacheDirty = true;
    }

    public  java.util.Iterator iterator()
    {
        java.util.Vector v = new java.util.Vector();
        java.util.Enumeration en = cache.propertyNames();
        while (en.hasMoreElements()) {
            v.add( en.nextElement() );
        }
        return v.iterator();
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        buf.append( "<PropertiesfileCache:" );
        buf.append( "cachefile=" ).append( cachefile );
        buf.append( ";noOfEntries=" ).append( cache.size() );
        buf.append( ">" );
        return buf.toString();
    }

}
