// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.HttpURLConnection;
import java.net.JarURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.nio.channels.Channel;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.jar.JarFile;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.PathTokenizer;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.launch.Locator;
import org.apache.tools.ant.taskdefs.condition.Os;
import org.apache.tools.ant.types.FilterSetCollection;
import org.apache.tools.ant.types.resources.FileResource;


public class FileUtils
{

    private static final int DELETE_RETRY_SLEEP_MILLIS = 10;

    private static final int EXPAND_SPACE = 50;

    private static final org.apache.tools.ant.util.FileUtils PRIMARY_INSTANCE = new org.apache.tools.ant.util.FileUtils();

    private static java.util.Random rand = new java.util.Random( System.currentTimeMillis() + Runtime.getRuntime().freeMemory() );

    private static final boolean ON_NETWARE = Os.isFamily( "netware" );

    private static final boolean ON_DOS = Os.isFamily( "dos" );

    private static final boolean ON_WIN9X = Os.isFamily( "win9x" );

    private static final boolean ON_WINDOWS = Os.isFamily( "windows" );

    static final int BUF_SIZE = 8192;

    public static final long FAT_FILE_TIMESTAMP_GRANULARITY = 2000;

    public static final long UNIX_FILE_TIMESTAMP_GRANULARITY = 1000;

    public static final long NTFS_FILE_TIMESTAMP_GRANULARITY = 1;

    private java.lang.Object cacheFromUriLock = new java.lang.Object();

    private java.lang.String cacheFromUriRequest = null;

    private java.lang.String cacheFromUriResponse = null;

    public static  org.apache.tools.ant.util.FileUtils newFileUtils()
    {
        return new org.apache.tools.ant.util.FileUtils();
    }

    public static  org.apache.tools.ant.util.FileUtils getFileUtils()
    {
        return PRIMARY_INSTANCE;
    }

    protected FileUtils()
    {
    }

    public  java.net.URL getFileURL( java.io.File file )
        throws java.net.MalformedURLException
    {
        return new java.net.URL( toURI( file.getAbsolutePath() ) );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), null, false, false );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, false, false );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, overwrite, false );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite, boolean preserveLastModified )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, overwrite, preserveLastModified );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite, boolean preserveLastModified, java.lang.String encoding )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, overwrite, preserveLastModified, encoding );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, java.lang.String encoding, org.apache.tools.ant.Project project )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, filterChains, overwrite, preserveLastModified, encoding, project );
    }

    public  void copyFile( java.lang.String sourceFile, java.lang.String destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, java.lang.String inputEncoding, java.lang.String outputEncoding, org.apache.tools.ant.Project project )
        throws java.io.IOException
    {
        copyFile( new java.io.File( sourceFile ), new java.io.File( destFile ), filters, filterChains, overwrite, preserveLastModified, inputEncoding, outputEncoding, project );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, null, false, false );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, false, false );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, overwrite, false );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite, boolean preserveLastModified )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, overwrite, preserveLastModified, null );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, boolean overwrite, boolean preserveLastModified, java.lang.String encoding )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, null, overwrite, preserveLastModified, encoding, null );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, java.lang.String encoding, org.apache.tools.ant.Project project )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, filterChains, overwrite, preserveLastModified, encoding, encoding, project );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, java.lang.String inputEncoding, java.lang.String outputEncoding, org.apache.tools.ant.Project project )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, filterChains, overwrite, preserveLastModified, false, inputEncoding, outputEncoding, project );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, boolean append, java.lang.String inputEncoding, java.lang.String outputEncoding, org.apache.tools.ant.Project project )
        throws java.io.IOException
    {
        copyFile( sourceFile, destFile, filters, filterChains, overwrite, preserveLastModified, append, inputEncoding, outputEncoding, project, false );
    }

    public  void copyFile( java.io.File sourceFile, java.io.File destFile, org.apache.tools.ant.types.FilterSetCollection filters, java.util.Vector filterChains, boolean overwrite, boolean preserveLastModified, boolean append, java.lang.String inputEncoding, java.lang.String outputEncoding, org.apache.tools.ant.Project project, boolean force )
        throws java.io.IOException
    {
        ResourceUtils.copyResource( new org.apache.tools.ant.types.resources.FileResource( sourceFile ), new org.apache.tools.ant.types.resources.FileResource( destFile ), filters, filterChains, overwrite, preserveLastModified, append, inputEncoding, outputEncoding, project, force );
    }

    public  void setFileLastModified( java.io.File file, long time )
    {
        ResourceUtils.setLastModified( new org.apache.tools.ant.types.resources.FileResource( file ), time );
    }

    public  java.io.File resolveFile( java.io.File file, java.lang.String filename )
    {
        if (!isAbsolutePath( filename )) {
            char sep = File.separatorChar;
            filename = filename.replace( '/', sep ).replace( '\\', sep );
            if (isContextRelativePath( filename )) {
                file = null;
                java.lang.String udir = System.getProperty( "user.dir" );
                if (filename.charAt( 0 ) == sep && udir.charAt( 0 ) == sep) {
                    filename = dissect( udir )[0] + filename.substring( 1 );
                }
            }
            filename = (new java.io.File( file, filename )).getAbsolutePath();
        }
        return normalize( filename );
    }

    public static  boolean isContextRelativePath( java.lang.String filename )
    {
        if (!(ON_DOS || ON_NETWARE) || filename.length() == 0) {
            return false;
        }
        char sep = File.separatorChar;
        filename = filename.replace( '/', sep ).replace( '\\', sep );
        char c = filename.charAt( 0 );
        int len = filename.length();
        return c == sep && (len == 1 || filename.charAt( 1 ) != sep) || Character.isLetter( c ) && len > 1 && filename.indexOf( ':' ) == 1 && (len == 2 || filename.charAt( 2 ) != sep);
    }

    public static  boolean isAbsolutePath( java.lang.String filename )
    {
        int len = filename.length();
        if (len == 0) {
            return false;
        }
        char sep = File.separatorChar;
        filename = filename.replace( '/', sep ).replace( '\\', sep );
        char c = filename.charAt( 0 );
        if (!(ON_DOS || ON_NETWARE)) {
            return c == sep;
        }
        if (c == sep) {
            if (!(ON_DOS && len > 4 && filename.charAt( 1 ) == sep)) {
                return false;
            }
            int nextsep = filename.indexOf( sep, 2 );
            return nextsep > 2 && nextsep + 1 < len;
        }
        int colon = filename.indexOf( ':' );
        return Character.isLetter( c ) && colon == 1 && filename.length() > 2 && filename.charAt( 2 ) == sep || ON_NETWARE && colon > 0;
    }

    public static  java.lang.String translatePath( java.lang.String toProcess )
    {
        if (toProcess == null || toProcess.length() == 0) {
            return "";
        }
        java.lang.StringBuffer path = new java.lang.StringBuffer( toProcess.length() + EXPAND_SPACE );
        org.apache.tools.ant.PathTokenizer tokenizer = new org.apache.tools.ant.PathTokenizer( toProcess );
        while (tokenizer.hasMoreTokens()) {
            java.lang.String pathComponent = tokenizer.nextToken();
            pathComponent = pathComponent.replace( '/', File.separatorChar );
            pathComponent = pathComponent.replace( '\\', File.separatorChar );
            if (path.length() != 0) {
                path.append( File.pathSeparatorChar );
            }
            path.append( pathComponent );
        }
        return path.toString();
    }

    public  java.io.File normalize( final java.lang.String path )
    {
        java.util.Stack s = new java.util.Stack();
        java.lang.String[] dissect = dissect( path );
        s.push( dissect[0] );
        java.util.StringTokenizer tok = new java.util.StringTokenizer( dissect[1], File.separator );
        while (tok.hasMoreTokens()) {
            java.lang.String thisToken = tok.nextToken();
            if (".".equals( thisToken )) {
                continue;
            }
            if ("..".equals( thisToken )) {
                if (s.size() < 2) {
                    return new java.io.File( path );
                }
                s.pop();
            } else {
                s.push( thisToken );
            }
        }
        java.lang.StringBuffer sb = new java.lang.StringBuffer();
        final int size = s.size();
        for (int i = 0; i < size; i++) {
            if (i > 1) {
                sb.append( File.separatorChar );
            }
            sb.append( s.elementAt( i ) );
        }
        return new java.io.File( sb.toString() );
    }

    public  java.lang.String[] dissect( java.lang.String path )
    {
        char sep = File.separatorChar;
        path = path.replace( '/', sep ).replace( '\\', sep );
        if (!isAbsolutePath( path )) {
            throw new org.apache.tools.ant.BuildException( path + " is not an absolute path" );
        }
        java.lang.String root = null;
        int colon = path.indexOf( ':' );
        if (colon > 0 && (ON_DOS || ON_NETWARE)) {
            int next = colon + 1;
            root = path.substring( 0, next );
            char[] ca = path.toCharArray();
            root += sep;
            next = ca[next] == sep ? next + 1 : next;
            java.lang.StringBuffer sbPath = new java.lang.StringBuffer();
            for (int i = next; i < ca.length; i++) {
                if (ca[i] != sep || ca[i - 1] != sep) {
                    sbPath.append( ca[i] );
                }
            }
            path = sbPath.toString();
        } else {
            if (path.length() > 1 && path.charAt( 1 ) == sep) {
                int nextsep = path.indexOf( sep, 2 );
                nextsep = path.indexOf( sep, nextsep + 1 );
                root = nextsep > 2 ? path.substring( 0, nextsep + 1 ) : path;
                path = path.substring( root.length() );
            } else {
                root = File.separator;
                path = path.substring( 1 );
            }
        }
        return new java.lang.String[]{ root, path };
    }

    public  java.lang.String toVMSPath( java.io.File f )
    {
        java.lang.String osPath;
        java.lang.String path = normalize( f.getAbsolutePath() ).getPath();
        java.lang.String name = f.getName();
        boolean isAbsolute = path.charAt( 0 ) == File.separatorChar;
        boolean isDirectory = f.isDirectory() && !name.regionMatches( true, name.length() - 4, ".DIR", 0, 4 );
        java.lang.String device = null;
        java.lang.StringBuffer directory = null;
        java.lang.String file = null;
        int index = 0;
        if (isAbsolute) {
            index = path.indexOf( File.separatorChar, 1 );
            if (index == -1) {
                return path.substring( 1 ) + ":[000000]";
            }
            device = path.substring( 1, index++ );
        }
        if (isDirectory) {
            directory = new java.lang.StringBuffer( path.substring( index ).replace( File.separatorChar, '.' ) );
        } else {
            int dirEnd = path.lastIndexOf( File.separatorChar, path.length() );
            if (dirEnd == -1 || dirEnd < index) {
                file = path.substring( index );
            } else {
                directory = new java.lang.StringBuffer( path.substring( index, dirEnd ).replace( File.separatorChar, '.' ) );
                index = dirEnd + 1;
                if (path.length() > index) {
                    file = path.substring( index );
                }
            }
        }
        if (!isAbsolute && directory != null) {
            directory.insert( 0, '.' );
        }
        osPath = (device != null ? device + ":" : "") + (directory != null ? "[" + directory + "]" : "") + (file != null ? file : "");
        return osPath;
    }

    public  java.io.File createTempFile( java.lang.String prefix, java.lang.String suffix, java.io.File parentDir )
    {
        return createTempFile( prefix, suffix, parentDir, false, false );
    }

    private static final java.lang.String NULL_PLACEHOLDER = "null";

    public  java.io.File createTempFile( java.lang.String prefix, java.lang.String suffix, java.io.File parentDir, boolean deleteOnExit, boolean createFile )
    {
        java.io.File result = null;
        java.lang.String parent = parentDir == null ? System.getProperty( "java.io.tmpdir" ) : parentDir.getPath();
        if (prefix == null) {
            prefix = NULL_PLACEHOLDER;
        }
        if (suffix == null) {
            suffix = NULL_PLACEHOLDER;
        }
        if (createFile) {
            try {
                result = File.createTempFile( prefix, suffix, new java.io.File( parent ) );
            } catch ( java.io.IOException e ) {
                throw new org.apache.tools.ant.BuildException( "Could not create tempfile in " + parent, e );
            }
        } else {
            java.text.DecimalFormat fmt = new java.text.DecimalFormat( "#####" );
            synchronized (rand)
{
                do {
                    result = new java.io.File( parent, prefix + fmt.format( rand.nextInt( Integer.MAX_VALUE ) ) + suffix );
                } while (result.exists());
            }
        }
        if (deleteOnExit) {
            result.deleteOnExit();
        }
        return result;
    }

    public  java.io.File createTempFile( java.lang.String prefix, java.lang.String suffix, java.io.File parentDir, boolean deleteOnExit )
    {
        return createTempFile( prefix, suffix, parentDir, deleteOnExit, false );
    }

    public  boolean contentEquals( java.io.File f1, java.io.File f2 )
        throws java.io.IOException
    {
        return contentEquals( f1, f2, false );
    }

    public  boolean contentEquals( java.io.File f1, java.io.File f2, boolean textfile )
        throws java.io.IOException
    {
        return ResourceUtils.contentEquals( new org.apache.tools.ant.types.resources.FileResource( f1 ), new org.apache.tools.ant.types.resources.FileResource( f2 ), textfile );
    }

    public  java.io.File getParentFile( java.io.File f )
    {
        return f == null ? null : f.getParentFile();
    }

    public static  java.lang.String readFully( java.io.Reader rdr )
        throws java.io.IOException
    {
        return readFully( rdr, BUF_SIZE );
    }

    public static  java.lang.String readFully( java.io.Reader rdr, int bufferSize )
        throws java.io.IOException
    {
        if (bufferSize <= 0) {
            throw new java.lang.IllegalArgumentException( "Buffer size must be greater " + "than 0" );
        }
        final char[] buffer = new char[bufferSize];
        int bufferLength = 0;
        java.lang.StringBuffer textBuffer = null;
        while (bufferLength != -1) {
            bufferLength = rdr.read( buffer );
            if (bufferLength > 0) {
                textBuffer = textBuffer == null ? new java.lang.StringBuffer() : textBuffer;
                textBuffer.append( new java.lang.String( buffer, 0, bufferLength ) );
            }
        }
        return textBuffer == null ? null : textBuffer.toString();
    }

    public static  java.lang.String safeReadFully( java.io.Reader reader )
        throws java.io.IOException
    {
        java.lang.String ret = readFully( reader );
        return ret == null ? "" : ret;
    }

    public  boolean createNewFile( java.io.File f )
        throws java.io.IOException
    {
        return f.createNewFile();
    }

    public  boolean createNewFile( java.io.File f, boolean mkdirs )
        throws java.io.IOException
    {
        java.io.File parent = f.getParentFile();
        if (mkdirs && !parent.exists()) {
            parent.mkdirs();
        }
        return f.createNewFile();
    }

    public  boolean isSymbolicLink( java.io.File parent, java.lang.String name )
        throws java.io.IOException
    {
        org.apache.tools.ant.util.SymbolicLinkUtils u = SymbolicLinkUtils.getSymbolicLinkUtils();
        if (parent == null) {
            return u.isSymbolicLink( name );
        }
        return u.isSymbolicLink( parent, name );
    }

    public  java.lang.String removeLeadingPath( java.io.File leading, java.io.File path )
    {
        java.lang.String l = normalize( leading.getAbsolutePath() ).getAbsolutePath();
        java.lang.String p = normalize( path.getAbsolutePath() ).getAbsolutePath();
        if (l.equals( p )) {
            return "";
        }
        if (!l.endsWith( File.separator )) {
            l += File.separator;
        }
        return p.startsWith( l ) ? p.substring( l.length() ) : p;
    }

    public  boolean isLeadingPath( java.io.File leading, java.io.File path )
    {
        java.lang.String l = normalize( leading.getAbsolutePath() ).getAbsolutePath();
        java.lang.String p = normalize( path.getAbsolutePath() ).getAbsolutePath();
        if (l.equals( p )) {
            return true;
        }
        if (!l.endsWith( File.separator )) {
            l += File.separator;
        }
        return p.startsWith( l );
    }

    public  java.lang.String toURI( java.lang.String path )
    {
        return (new java.io.File( path )).getAbsoluteFile().toURI().toASCIIString();
    }

    public  java.lang.String fromURI( java.lang.String uri )
    {
        synchronized (cacheFromUriLock)
{
            if (uri.equals( cacheFromUriRequest )) {
                return cacheFromUriResponse;
            }
            java.lang.String path = Locator.fromURI( uri );
            java.lang.String ret = isAbsolutePath( path ) ? normalize( path ).getAbsolutePath() : path;
            cacheFromUriRequest = uri;
            cacheFromUriResponse = ret;
            return ret;
        }
    }

    public  boolean fileNameEquals( java.io.File f1, java.io.File f2 )
    {
        return normalize( f1.getAbsolutePath() ).getAbsolutePath().equals( normalize( f2.getAbsolutePath() ).getAbsolutePath() );
    }

    public  boolean areSame( java.io.File f1, java.io.File f2 )
        throws java.io.IOException
    {
        if (f1 == null && f2 == null) {
            return true;
        }
        if (f1 == null || f2 == null) {
            return false;
        }
        java.io.File f1Normalized = normalize( f1.getAbsolutePath() );
        java.io.File f2Normalized = normalize( f2.getAbsolutePath() );
        return f1Normalized.equals( f2Normalized ) || f1Normalized.getCanonicalFile().equals( f2Normalized.getCanonicalFile() );
    }

    public  void rename( java.io.File from, java.io.File to )
        throws java.io.IOException
    {
        from = normalize( from.getAbsolutePath() ).getCanonicalFile();
        to = normalize( to.getAbsolutePath() );
        if (!from.exists()) {
            System.err.println( "Cannot rename nonexistent file " + from );
            return;
        }
        if (from.getAbsolutePath().equals( to.getAbsolutePath() )) {
            System.err.println( "Rename of " + from + " to " + to + " is a no-op." );
            return;
        }
        if (to.exists() && !(areSame( from, to ) || tryHardToDelete( to ))) {
            throw new java.io.IOException( "Failed to delete " + to + " while trying to rename " + from );
        }
        java.io.File parent = to.getParentFile();
        if (parent != null && !parent.exists() && !parent.mkdirs()) {
            throw new java.io.IOException( "Failed to create directory " + parent + " while trying to rename " + from );
        }
        if (!from.renameTo( to )) {
            copyFile( from, to );
            if (!tryHardToDelete( from )) {
                throw new java.io.IOException( "Failed to delete " + from + " while trying to rename it." );
            }
        }
    }

    public  long getFileTimestampGranularity()
    {
        if (ON_WIN9X) {
            return FAT_FILE_TIMESTAMP_GRANULARITY;
        }
        if (ON_WINDOWS) {
            return NTFS_FILE_TIMESTAMP_GRANULARITY;
        }
        if (ON_DOS) {
            return FAT_FILE_TIMESTAMP_GRANULARITY;
        }
        return UNIX_FILE_TIMESTAMP_GRANULARITY;
    }

    public  boolean hasErrorInCase( java.io.File localFile )
    {
        localFile = normalize( localFile.getAbsolutePath() );
        if (!localFile.exists()) {
            return false;
        }
        final java.lang.String localFileName = localFile.getName();
        java.io.FilenameFilter ff = new java.io.FilenameFilter(){
            public  boolean accept( java.io.File dir, java.lang.String name )
            {
                return name.equalsIgnoreCase( localFileName ) && !name.equals( localFileName );
            }
        };
        java.lang.String[] names = localFile.getParentFile().list( ff );
        return names != null && names.length == 1;
    }

    public  boolean isUpToDate( java.io.File source, java.io.File dest, long granularity )
    {
        if (!dest.exists()) {
            return false;
        }
        long sourceTime = source.lastModified();
        long destTime = dest.lastModified();
        return isUpToDate( sourceTime, destTime, granularity );
    }

    public  boolean isUpToDate( java.io.File source, java.io.File dest )
    {
        return isUpToDate( source, dest, getFileTimestampGranularity() );
    }

    public  boolean isUpToDate( long sourceTime, long destTime, long granularity )
    {
        return destTime != -1 && destTime >= sourceTime + granularity;
    }

    public  boolean isUpToDate( long sourceTime, long destTime )
    {
        return isUpToDate( sourceTime, destTime, getFileTimestampGranularity() );
    }

    public static  void close( java.io.Writer device )
    {
        if (null != device) {
            try {
                device.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

    public static  void close( java.io.Reader device )
    {
        if (null != device) {
            try {
                device.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

    public static  void close( java.io.OutputStream device )
    {
        if (null != device) {
            try {
                device.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

    public static  void close( java.io.InputStream device )
    {
        if (null != device) {
            try {
                device.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

    public static  void close( java.nio.channels.Channel device )
    {
        if (null != device) {
            try {
                device.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

    public static  void close( java.net.URLConnection conn )
    {
        if (conn != null) {
            try {
                if (conn instanceof java.net.JarURLConnection) {
                    java.net.JarURLConnection juc = (java.net.JarURLConnection) conn;
                    java.util.jar.JarFile jf = juc.getJarFile();
                    jf.close();
                    jf = null;
                } else {
                    if (conn instanceof java.net.HttpURLConnection) {
                        ((java.net.HttpURLConnection) conn).disconnect();
                    }
                }
            } catch ( java.io.IOException exc ) {
            }
        }
    }

    public static  void delete( java.io.File file )
    {
        if (file != null) {
            file.delete();
        }
    }

    public  boolean tryHardToDelete( java.io.File f )
    {
        return tryHardToDelete( f, ON_WINDOWS );
    }

    public  boolean tryHardToDelete( java.io.File f, boolean runGC )
    {
        if (!f.delete()) {
            if (runGC) {
                System.gc();
            }
            try {
                Thread.sleep( DELETE_RETRY_SLEEP_MILLIS );
            } catch ( java.lang.InterruptedException ex ) {
            }
            return f.delete();
        }
        return true;
    }

    public static  java.lang.String getRelativePath( java.io.File fromFile, java.io.File toFile )
        throws java.lang.Exception
    {
        java.lang.String fromPath = fromFile.getCanonicalPath();
        java.lang.String toPath = toFile.getCanonicalPath();
        java.lang.String[] fromPathStack = getPathStack( fromPath );
        java.lang.String[] toPathStack = getPathStack( toPath );
        if (0 < toPathStack.length && 0 < fromPathStack.length) {
            if (!fromPathStack[0].equals( toPathStack[0] )) {
                return getPath( Arrays.asList( toPathStack ) );
            }
        } else {
            return getPath( Arrays.asList( toPathStack ) );
        }
        int minLength = Math.min( fromPathStack.length, toPathStack.length );
        int same = 1;
        for (; same < minLength && fromPathStack[same].equals( toPathStack[same] ); same++) ;
        java.util.List relativePathStack = new java.util.ArrayList();
        for (int i = same; i < fromPathStack.length; i++) {
            relativePathStack.add( ".." );
        }
        for (int i = same; i < toPathStack.length; i++) {
            relativePathStack.add( toPathStack[i] );
        }
        return getPath( relativePathStack );
    }

    public static  java.lang.String[] getPathStack( java.lang.String path )
    {
        java.lang.String normalizedPath = path.replace( File.separatorChar, '/' );
        return normalizedPath.split( "/" );
    }

    public static  java.lang.String getPath( java.util.List pathStack )
    {
        return getPath( pathStack, '/' );
    }

    public static  java.lang.String getPath( final java.util.List pathStack, final char separatorChar )
    {
        final java.lang.StringBuffer buffer = new java.lang.StringBuffer();
        final java.util.Iterator iter = pathStack.iterator();
        if (iter.hasNext()) {
            buffer.append( iter.next() );
        }
        while (iter.hasNext()) {
            buffer.append( separatorChar );
            buffer.append( iter.next() );
        }
        return buffer.toString();
    }

    public  java.lang.String getDefaultEncoding()
    {
        java.io.InputStreamReader is = new java.io.InputStreamReader( new java.io.InputStream(){
            public  int read()
            {
                return -1;
            }
        } );
        try {
            return is.getEncoding();
        } finally 
{
            close( is );
        }
    }

}
