// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.BuildException;


public class GlobPatternMapper implements org.apache.tools.ant.util.FileNameMapper
{

    protected java.lang.String fromPrefix = null;

    protected java.lang.String fromPostfix = null;

    protected int prefixLength;

    protected int postfixLength;

    protected java.lang.String toPrefix = null;

    protected java.lang.String toPostfix = null;

    private boolean fromContainsStar = false;

    private boolean toContainsStar = false;

    private boolean handleDirSep = false;

    private boolean caseSensitive = true;

    public  void setHandleDirSep( boolean handleDirSep )
    {
        this.handleDirSep = handleDirSep;
    }

    public  boolean getHandleDirSep()
    {
        return handleDirSep;
    }

    public  void setCaseSensitive( boolean caseSensitive )
    {
        this.caseSensitive = caseSensitive;
    }

    public  void setFrom( java.lang.String from )
    {
        if (from != null) {
            int index = from.lastIndexOf( "*" );
            if (index == -1) {
                fromPrefix = from;
                fromPostfix = "";
            } else {
                fromPrefix = from.substring( 0, index );
                fromPostfix = from.substring( index + 1 );
                fromContainsStar = true;
            }
            prefixLength = fromPrefix.length();
            postfixLength = fromPostfix.length();
        } else {
            throw new org.apache.tools.ant.BuildException( "this mapper requires a 'from' attribute" );
        }
    }

    public  void setTo( java.lang.String to )
    {
        if (to != null) {
            int index = to.lastIndexOf( "*" );
            if (index == -1) {
                toPrefix = to;
                toPostfix = "";
            } else {
                toPrefix = to.substring( 0, index );
                toPostfix = to.substring( index + 1 );
                toContainsStar = true;
            }
        } else {
            throw new org.apache.tools.ant.BuildException( "this mapper requires a 'to' attribute" );
        }
    }

    public  java.lang.String[] mapFileName( java.lang.String sourceFileName )
    {
        java.lang.String modName = modifyName( sourceFileName );
        if (fromPrefix == null || sourceFileName.length() < prefixLength + postfixLength || !fromContainsStar && !modName.equals( modifyName( fromPrefix ) ) || fromContainsStar && (!modName.startsWith( modifyName( fromPrefix ) ) || !modName.endsWith( modifyName( fromPostfix ) ))) {
            return null;
        }
        return new java.lang.String[]{ toPrefix + (toContainsStar ? extractVariablePart( sourceFileName ) + toPostfix : "") };
    }

    protected  java.lang.String extractVariablePart( java.lang.String name )
    {
        return name.substring( prefixLength, name.length() - postfixLength );
    }

    private  java.lang.String modifyName( java.lang.String name )
    {
        if (!caseSensitive) {
            name = name.toLowerCase();
        }
        if (handleDirSep) {
            if (name.indexOf( '\\' ) != -1) {
                name = name.replace( '\\', '/' );
            }
        }
        return name;
    }

}
