// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;


public class LazyFileOutputStream extends java.io.OutputStream
{

    private java.io.FileOutputStream fos;

    private java.io.File file;

    private boolean append;

    private boolean alwaysCreate;

    private boolean opened = false;

    private boolean closed = false;

    public LazyFileOutputStream( java.lang.String name )
    {
        this( name, false );
    }

    public LazyFileOutputStream( java.lang.String name, boolean append )
    {
        this( new java.io.File( name ), append );
    }

    public LazyFileOutputStream( java.io.File f )
    {
        this( f, false );
    }

    public LazyFileOutputStream( java.io.File file, boolean append )
    {
        this( file, append, false );
    }

    public LazyFileOutputStream( java.io.File file, boolean append, boolean alwaysCreate )
    {
        this.file = file;
        this.append = append;
        this.alwaysCreate = alwaysCreate;
    }

    public  void open()
        throws java.io.IOException
    {
        ensureOpened();
    }

    public synchronized  void close()
        throws java.io.IOException
    {
        if (alwaysCreate && !closed) {
            ensureOpened();
        }
        if (opened) {
            fos.close();
        }
        closed = true;
    }

    public  void write( byte[] b )
        throws java.io.IOException
    {
        write( b, 0, b.length );
    }

    public synchronized  void write( byte[] b, int offset, int len )
        throws java.io.IOException
    {
        ensureOpened();
        fos.write( b, offset, len );
    }

    public synchronized  void write( int b )
        throws java.io.IOException
    {
        ensureOpened();
        fos.write( b );
    }

    private synchronized  void ensureOpened()
        throws java.io.IOException
    {
        if (closed) {
            throw new java.io.IOException( file + " has already been closed." );
        }
        if (!opened) {
            fos = new java.io.FileOutputStream( file.getAbsolutePath(), append );
            opened = true;
        }
    }

}
