// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.apache.tools.ant.BuildException;
import java.lang.reflect.Field;


public class ReflectUtil
{

    private ReflectUtil()
    {
    }

    public static  java.lang.Object newInstance( java.lang.Class ofClass, java.lang.Class[] argTypes, java.lang.Object[] args )
    {
        try {
            java.lang.reflect.Constructor con = ofClass.getConstructor( argTypes );
            return con.newInstance( args );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  java.lang.Object invoke( java.lang.Object obj, java.lang.String methodName )
    {
        try {
            java.lang.reflect.Method method;
            method = obj.getClass().getMethod( methodName, (java.lang.Class[]) null );
            return method.invoke( obj, (java.lang.Object[]) null );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  java.lang.Object invokeStatic( java.lang.Object obj, java.lang.String methodName )
    {
        try {
            java.lang.reflect.Method method;
            method = ((java.lang.Class) obj).getMethod( methodName, (java.lang.Class[]) null );
            return method.invoke( obj, (java.lang.Object[]) null );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  java.lang.Object invoke( java.lang.Object obj, java.lang.String methodName, java.lang.Class argType, java.lang.Object arg )
    {
        try {
            java.lang.reflect.Method method;
            method = obj.getClass().getMethod( methodName, new java.lang.Class[]{ argType } );
            return method.invoke( obj, new java.lang.Object[]{ arg } );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  java.lang.Object invoke( java.lang.Object obj, java.lang.String methodName, java.lang.Class argType1, java.lang.Object arg1, java.lang.Class argType2, java.lang.Object arg2 )
    {
        try {
            java.lang.reflect.Method method;
            method = obj.getClass().getMethod( methodName, new java.lang.Class[]{ argType1, argType2 } );
            return method.invoke( obj, new java.lang.Object[]{ arg1, arg2 } );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  java.lang.Object getField( java.lang.Object obj, java.lang.String fieldName )
        throws org.apache.tools.ant.BuildException
    {
        try {
            java.lang.reflect.Field field = obj.getClass().getDeclaredField( fieldName );
            field.setAccessible( true );
            return field.get( obj );
        } catch ( java.lang.Exception t ) {
            throwBuildException( t );
            return null;
        }
    }

    public static  void throwBuildException( java.lang.Exception t )
        throws org.apache.tools.ant.BuildException
    {
        throw toBuildException( t );
    }

    public static  org.apache.tools.ant.BuildException toBuildException( java.lang.Exception t )
    {
        if (t instanceof java.lang.reflect.InvocationTargetException) {
            java.lang.Throwable t2 = ((java.lang.reflect.InvocationTargetException) t).getTargetException();
            if (t2 instanceof org.apache.tools.ant.BuildException) {
                return (org.apache.tools.ant.BuildException) t2;
            }
            return new org.apache.tools.ant.BuildException( t2 );
        } else {
            return new org.apache.tools.ant.BuildException( t );
        }
    }

    public static  boolean respondsTo( java.lang.Object o, java.lang.String methodName )
        throws org.apache.tools.ant.BuildException
    {
        try {
            java.lang.reflect.Method[] methods = o.getClass().getMethods();
            for (int i = 0; i < methods.length; i++) {
                if (methods[i].getName().equals( methodName )) {
                    return true;
                }
            }
            return false;
        } catch ( java.lang.Exception t ) {
            throw toBuildException( t );
        }
    }

}
