// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.File;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.types.ResourceCollection;
import org.apache.tools.ant.types.resources.Union;


public class ScriptRunnerHelper
{

    private org.apache.tools.ant.util.ClasspathUtils.Delegate cpDelegate = null;

    private java.io.File srcFile;

    private java.lang.String manager = "auto";

    private java.lang.String language;

    private java.lang.String text;

    private boolean setBeans = true;

    private org.apache.tools.ant.ProjectComponent projectComponent;

    private java.lang.ClassLoader scriptLoader = null;

    private org.apache.tools.ant.types.resources.Union resources = new org.apache.tools.ant.types.resources.Union();

    public  void setProjectComponent( org.apache.tools.ant.ProjectComponent component )
    {
        this.projectComponent = component;
    }

    public  org.apache.tools.ant.util.ScriptRunnerBase getScriptRunner()
    {
        org.apache.tools.ant.util.ScriptRunnerBase runner = getRunner();
        if (srcFile != null) {
            runner.setSrc( srcFile );
        }
        if (text != null) {
            runner.addText( text );
        }
        if (resources != null) {
            runner.loadResources( resources );
        }
        if (setBeans) {
            runner.bindToComponent( projectComponent );
        } else {
            runner.bindToComponentMinimum( projectComponent );
        }
        return runner;
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        return getClassPathDelegate().createClasspath();
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        getClassPathDelegate().setClasspath( classpath );
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference r )
    {
        getClassPathDelegate().setClasspathref( r );
    }

    public  void setSrc( java.io.File file )
    {
        this.srcFile = file;
    }

    public  void addText( java.lang.String text )
    {
        this.text = text;
    }

    public  void setManager( java.lang.String manager )
    {
        this.manager = manager;
    }

    public  void setLanguage( java.lang.String language )
    {
        this.language = language;
    }

    public  java.lang.String getLanguage()
    {
        return language;
    }

    public  void setSetBeans( boolean setBeans )
    {
        this.setBeans = setBeans;
    }

    public  void setClassLoader( java.lang.ClassLoader loader )
    {
        scriptLoader = loader;
    }

    private synchronized  java.lang.ClassLoader generateClassLoader()
    {
        if (scriptLoader != null) {
            return scriptLoader;
        }
        if (cpDelegate == null) {
            scriptLoader = getClass().getClassLoader();
            return scriptLoader;
        }
        scriptLoader = cpDelegate.getClassLoader();
        return scriptLoader;
    }

    private  org.apache.tools.ant.util.ClasspathUtils.Delegate getClassPathDelegate()
    {
        if (cpDelegate == null) {
            cpDelegate = ClasspathUtils.getDelegate( projectComponent );
        }
        return cpDelegate;
    }

    private  org.apache.tools.ant.util.ScriptRunnerBase getRunner()
    {
        return (new org.apache.tools.ant.util.ScriptRunnerCreator( projectComponent.getProject() )).createRunner( manager, language, generateClassLoader() );
    }

    public  void add( org.apache.tools.ant.types.ResourceCollection resource )
    {
        resources.add( resource );
    }

}
