// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.util.Enumeration;
import java.util.Vector;


public class Watchdog implements java.lang.Runnable
{

    private java.util.Vector observers = new java.util.Vector( 1 );

    private long timeout = -1;

    private volatile boolean stopped = false;

    public static final java.lang.String ERROR_INVALID_TIMEOUT = "timeout less than 1.";

    public Watchdog( long timeout )
    {
        if (timeout < 1) {
            throw new java.lang.IllegalArgumentException( ERROR_INVALID_TIMEOUT );
        }
        this.timeout = timeout;
    }

    public  void addTimeoutObserver( org.apache.tools.ant.util.TimeoutObserver to )
    {
        observers.addElement( to );
    }

    public  void removeTimeoutObserver( org.apache.tools.ant.util.TimeoutObserver to )
    {
        observers.removeElement( to );
    }

    protected final  void fireTimeoutOccured()
    {
        java.util.Enumeration e = observers.elements();
        while (e.hasMoreElements()) {
            ((org.apache.tools.ant.util.TimeoutObserver) e.nextElement()).timeoutOccured( this );
        }
    }

    public synchronized  void start()
    {
        stopped = false;
        java.lang.Thread t = new java.lang.Thread( this, "WATCHDOG" );
        t.setDaemon( true );
        t.start();
    }

    public synchronized  void stop()
    {
        stopped = true;
        notifyAll();
    }

    public synchronized  void run()
    {
        long now = System.currentTimeMillis();
        final long until = now + timeout;
        try {
            while (!stopped && until > now) {
                wait( until - now );
                now = System.currentTimeMillis();
            }
        } catch ( java.lang.InterruptedException e ) {
        }
        if (!stopped) {
            fireTimeoutOccured();
        }
    }

}
