// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class Deprecated extends org.apache.bcel.classfile.Attribute
{

    private byte[] bytes;

    public Deprecated( org.apache.bcel.classfile.Deprecated c )
    {
        this( c.getNameIndex(), c.getLength(), c.getBytes(), c.getConstantPool() );
    }

    public Deprecated( int name_index, int length, byte[] bytes, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_DEPRECATED, name_index, length, constant_pool );
        this.bytes = bytes;
    }

    Deprecated( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (byte[]) null, constant_pool );
        if (length > 0) {
            bytes = new byte[length];
            file.readFully( bytes );
            System.err.println( "Deprecated attribute with length > 0" );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitDeprecated( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        if (length > 0) {
            file.write( bytes, 0, length );
        }
    }

    public final  byte[] getBytes()
    {
        return bytes;
    }

    public final  void setBytes( byte[] bytes )
    {
        this.bytes = bytes;
    }

    public final  java.lang.String toString()
    {
        return Constants.ATTRIBUTE_NAMES[Constants.ATTR_DEPRECATED];
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.Deprecated c = (org.apache.bcel.classfile.Deprecated) clone();
        if (bytes != null) {
            c.bytes = new byte[bytes.length];
            System.arraycopy( bytes, 0, c.bytes, 0, bytes.length );
        }
        c.constant_pool = _constant_pool;
        return c;
    }

}
