// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class InnerClasses extends org.apache.bcel.classfile.Attribute
{

    private org.apache.bcel.classfile.InnerClass[] inner_classes;

    private int number_of_classes;

    public InnerClasses( org.apache.bcel.classfile.InnerClasses c )
    {
        this( c.getNameIndex(), c.getLength(), c.getInnerClasses(), c.getConstantPool() );
    }

    public InnerClasses( int name_index, int length, org.apache.bcel.classfile.InnerClass[] inner_classes, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_INNER_CLASSES, name_index, length, constant_pool );
        setInnerClasses( inner_classes );
    }

    InnerClasses( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (org.apache.bcel.classfile.InnerClass[]) null, constant_pool );
        number_of_classes = file.readUnsignedShort();
        inner_classes = new org.apache.bcel.classfile.InnerClass[number_of_classes];
        for (int i = 0; i < number_of_classes; i++) {
            inner_classes[i] = new org.apache.bcel.classfile.InnerClass( file );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitInnerClasses( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( number_of_classes );
        for (int i = 0; i < number_of_classes; i++) {
            inner_classes[i].dump( file );
        }
    }

    public final  org.apache.bcel.classfile.InnerClass[] getInnerClasses()
    {
        return inner_classes;
    }

    public final  void setInnerClasses( org.apache.bcel.classfile.InnerClass[] inner_classes )
    {
        this.inner_classes = inner_classes;
        number_of_classes = inner_classes == null ? 0 : inner_classes.length;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        for (int i = 0; i < number_of_classes; i++) {
            buf.append( inner_classes[i].toString( constant_pool ) ).append( "\n" );
        }
        return buf.toString();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.InnerClasses c = (org.apache.bcel.classfile.InnerClasses) clone();
        c.inner_classes = new org.apache.bcel.classfile.InnerClass[number_of_classes];
        for (int i = 0; i < number_of_classes; i++) {
            c.inner_classes[i] = inner_classes[i].copy();
        }
        c.constant_pool = _constant_pool;
        return c;
    }

}
