// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;
import org.apache.bcel.Constants;


public final class LocalVariable implements org.apache.bcel.Constants, java.lang.Cloneable, org.apache.bcel.classfile.Node, java.io.Serializable
{

    private int start_pc;

    private int length;

    private int name_index;

    private int signature_index;

    private int index;

    private org.apache.bcel.classfile.ConstantPool constant_pool;

    public LocalVariable( org.apache.bcel.classfile.LocalVariable c )
    {
        this( c.getStartPC(), c.getLength(), c.getNameIndex(), c.getSignatureIndex(), c.getIndex(), c.getConstantPool() );
    }

    LocalVariable( java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( file.readUnsignedShort(), file.readUnsignedShort(), file.readUnsignedShort(), file.readUnsignedShort(), file.readUnsignedShort(), constant_pool );
    }

    public LocalVariable( int start_pc, int length, int name_index, int signature_index, int index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        this.start_pc = start_pc;
        this.length = length;
        this.name_index = name_index;
        this.signature_index = signature_index;
        this.index = index;
        this.constant_pool = constant_pool;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitLocalVariable( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        file.writeShort( start_pc );
        file.writeShort( length );
        file.writeShort( name_index );
        file.writeShort( signature_index );
        file.writeShort( index );
    }

    public final  org.apache.bcel.classfile.ConstantPool getConstantPool()
    {
        return constant_pool;
    }

    public final  int getLength()
    {
        return length;
    }

    public final  java.lang.String getName()
    {
        org.apache.bcel.classfile.ConstantUtf8 c;
        c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( name_index, CONSTANT_Utf8 );
        return c.getBytes();
    }

    public final  int getNameIndex()
    {
        return name_index;
    }

    public final  java.lang.String getSignature()
    {
        org.apache.bcel.classfile.ConstantUtf8 c;
        c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( signature_index, CONSTANT_Utf8 );
        return c.getBytes();
    }

    public final  int getSignatureIndex()
    {
        return signature_index;
    }

    public final  int getIndex()
    {
        return index;
    }

    public final  int getStartPC()
    {
        return start_pc;
    }

    public final  void setConstantPool( org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        this.constant_pool = constant_pool;
    }

    public final  void setLength( int length )
    {
        this.length = length;
    }

    public final  void setNameIndex( int name_index )
    {
        this.name_index = name_index;
    }

    public final  void setSignatureIndex( int signature_index )
    {
        this.signature_index = signature_index;
    }

    public final  void setIndex( int index )
    {
        this.index = index;
    }

    public final  void setStartPC( int start_pc )
    {
        this.start_pc = start_pc;
    }

    public final  java.lang.String toString()
    {
        java.lang.String name = getName();
        java.lang.String signature = Utility.signatureToString( getSignature() );
        return "LocalVariable(start_pc = " + start_pc + ", length = " + length + ", index = " + index + ":" + signature + " " + name + ")";
    }

    public  org.apache.bcel.classfile.LocalVariable copy()
    {
        try {
            return (org.apache.bcel.classfile.LocalVariable) clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
        }
        return null;
    }

}
