// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public class LocalVariableTable extends org.apache.bcel.classfile.Attribute
{

    private int local_variable_table_length;

    private org.apache.bcel.classfile.LocalVariable[] local_variable_table;

    public LocalVariableTable( org.apache.bcel.classfile.LocalVariableTable c )
    {
        this( c.getNameIndex(), c.getLength(), c.getLocalVariableTable(), c.getConstantPool() );
    }

    public LocalVariableTable( int name_index, int length, org.apache.bcel.classfile.LocalVariable[] local_variable_table, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_LOCAL_VARIABLE_TABLE, name_index, length, constant_pool );
        setLocalVariableTable( local_variable_table );
    }

    LocalVariableTable( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (org.apache.bcel.classfile.LocalVariable[]) null, constant_pool );
        local_variable_table_length = file.readUnsignedShort();
        local_variable_table = new org.apache.bcel.classfile.LocalVariable[local_variable_table_length];
        for (int i = 0; i < local_variable_table_length; i++) {
            local_variable_table[i] = new org.apache.bcel.classfile.LocalVariable( file, constant_pool );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitLocalVariableTable( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( local_variable_table_length );
        for (int i = 0; i < local_variable_table_length; i++) {
            local_variable_table[i].dump( file );
        }
    }

    public final  org.apache.bcel.classfile.LocalVariable[] getLocalVariableTable()
    {
        return local_variable_table;
    }

    public final  org.apache.bcel.classfile.LocalVariable getLocalVariable( int index )
    {
        for (int i = 0; i < local_variable_table_length; i++) {
            if (local_variable_table[i].getIndex() == index) {
                return local_variable_table[i];
            }
        }
        return null;
    }

    public final  org.apache.bcel.classfile.LocalVariable getLocalVariable( int index, int pc )
    {
        for (int i = 0; i < local_variable_table_length; i++) {
            if (local_variable_table[i].getIndex() == index) {
                int start_pc = local_variable_table[i].getStartPC();
                int end_pc = start_pc + local_variable_table[i].getLength();
                if (pc >= start_pc && pc < end_pc) {
                    return local_variable_table[i];
                }
            }
        }
        return null;
    }

    public final  void setLocalVariableTable( org.apache.bcel.classfile.LocalVariable[] local_variable_table )
    {
        this.local_variable_table = local_variable_table;
        local_variable_table_length = local_variable_table == null ? 0 : local_variable_table.length;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "" );
        for (int i = 0; i < local_variable_table_length; i++) {
            buf.append( local_variable_table[i].toString() );
            if (i < local_variable_table_length - 1) {
                buf.append( '\n' );
            }
        }
        return buf.toString();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.LocalVariableTable c = (org.apache.bcel.classfile.LocalVariableTable) clone();
        c.local_variable_table = new org.apache.bcel.classfile.LocalVariable[local_variable_table_length];
        for (int i = 0; i < local_variable_table_length; i++) {
            c.local_variable_table[i] = local_variable_table[i].copy();
        }
        c.constant_pool = _constant_pool;
        return c;
    }

    public final  int getTableLength()
    {
        return local_variable_table_length;
    }

}
