// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class SourceFile extends org.apache.bcel.classfile.Attribute
{

    private int sourcefile_index;

    public SourceFile( org.apache.bcel.classfile.SourceFile c )
    {
        this( c.getNameIndex(), c.getLength(), c.getSourceFileIndex(), c.getConstantPool() );
    }

    SourceFile( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, file.readUnsignedShort(), constant_pool );
    }

    public SourceFile( int name_index, int length, int sourcefile_index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_SOURCE_FILE, name_index, length, constant_pool );
        this.sourcefile_index = sourcefile_index;
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitSourceFile( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( sourcefile_index );
    }

    public final  int getSourceFileIndex()
    {
        return sourcefile_index;
    }

    public final  void setSourceFileIndex( int sourcefile_index )
    {
        this.sourcefile_index = sourcefile_index;
    }

    public final  java.lang.String getSourceFileName()
    {
        org.apache.bcel.classfile.ConstantUtf8 c = (org.apache.bcel.classfile.ConstantUtf8) constant_pool.getConstant( sourcefile_index, Constants.CONSTANT_Utf8 );
        return c.getBytes();
    }

    public final  java.lang.String toString()
    {
        return "SourceFile(" + getSourceFileName() + ")";
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        return (org.apache.bcel.classfile.SourceFile) clone();
    }

}
