// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class StackMapType implements java.lang.Cloneable
{

    private byte type;

    private int index = -1;

    private org.apache.bcel.classfile.ConstantPool constant_pool;

    StackMapType( java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( file.readByte(), -1, constant_pool );
        if (hasIndex()) {
            setIndex( file.readShort() );
        }
        setConstantPool( constant_pool );
    }

    public StackMapType( byte type, int index, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        setType( type );
        setIndex( index );
        setConstantPool( constant_pool );
    }

    public  void setType( byte t )
    {
        if (t < Constants.ITEM_Bogus || t > Constants.ITEM_NewObject) {
            throw new java.lang.RuntimeException( "Illegal type for StackMapType: " + t );
        }
        type = t;
    }

    public  byte getType()
    {
        return type;
    }

    public  void setIndex( int t )
    {
        index = t;
    }

    public  int getIndex()
    {
        return index;
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        file.writeByte( type );
        if (hasIndex()) {
            file.writeShort( getIndex() );
        }
    }

    public final  boolean hasIndex()
    {
        return type == Constants.ITEM_Object || type == Constants.ITEM_NewObject;
    }

    private  java.lang.String printIndex()
    {
        if (type == Constants.ITEM_Object) {
            if (index < 0) {
                return ", class=<unknown>";
            }
            return ", class=" + constant_pool.constantToString( index, Constants.CONSTANT_Class );
        } else {
            if (type == Constants.ITEM_NewObject) {
                return ", offset=" + index;
            } else {
                return "";
            }
        }
    }

    public final  java.lang.String toString()
    {
        return "(type=" + Constants.ITEM_NAMES[type] + printIndex() + ")";
    }

    public  org.apache.bcel.classfile.StackMapType copy()
    {
        try {
            return (org.apache.bcel.classfile.StackMapType) clone();
        } catch ( java.lang.CloneNotSupportedException e ) {
        }
        return null;
    }

    public final  org.apache.bcel.classfile.ConstantPool getConstantPool()
    {
        return constant_pool;
    }

    public final  void setConstantPool( org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        this.constant_pool = constant_pool;
    }

}
