// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class Synthetic extends org.apache.bcel.classfile.Attribute
{

    private byte[] bytes;

    public Synthetic( org.apache.bcel.classfile.Synthetic c )
    {
        this( c.getNameIndex(), c.getLength(), c.getBytes(), c.getConstantPool() );
    }

    public Synthetic( int name_index, int length, byte[] bytes, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_SYNTHETIC, name_index, length, constant_pool );
        this.bytes = bytes;
    }

    Synthetic( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (byte[]) null, constant_pool );
        if (length > 0) {
            bytes = new byte[length];
            file.readFully( bytes );
            System.err.println( "Synthetic attribute with length > 0" );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitSynthetic( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        if (length > 0) {
            file.write( bytes, 0, length );
        }
    }

    public final  byte[] getBytes()
    {
        return bytes;
    }

    public final  void setBytes( byte[] bytes )
    {
        this.bytes = bytes;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "Synthetic" );
        if (length > 0) {
            buf.append( " " ).append( Utility.toHexString( bytes ) );
        }
        return buf.toString();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.Synthetic c = (org.apache.bcel.classfile.Synthetic) clone();
        if (bytes != null) {
            c.bytes = new byte[bytes.length];
            System.arraycopy( bytes, 0, c.bytes, 0, bytes.length );
        }
        c.constant_pool = _constant_pool;
        return c;
    }

}
