// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.util.HashMap;
import java.util.Map;
import org.apache.bcel.Constants;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantCP;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantFieldref;
import org.apache.bcel.classfile.ConstantFloat;
import org.apache.bcel.classfile.ConstantInteger;
import org.apache.bcel.classfile.ConstantInterfaceMethodref;
import org.apache.bcel.classfile.ConstantLong;
import org.apache.bcel.classfile.ConstantMethodref;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantString;
import org.apache.bcel.classfile.ConstantUtf8;


public class ConstantPoolGen implements java.io.Serializable
{

    protected int size = 1024;

    protected org.apache.bcel.classfile.Constant[] constants = new org.apache.bcel.classfile.Constant[size];

    protected int index = 1;

    private static final java.lang.String METHODREF_DELIM = ":";

    private static final java.lang.String IMETHODREF_DELIM = "#";

    private static final java.lang.String FIELDREF_DELIM = "&";

    private static final java.lang.String NAT_DELIM = "%";

    private static class Index implements java.io.Serializable
    {

        int index;

        Index( int i )
        {
            index = i;
        }

    }

    public ConstantPoolGen( org.apache.bcel.classfile.Constant[] cs )
    {
        if (cs.length > size) {
            size = cs.length;
            constants = new org.apache.bcel.classfile.Constant[size];
        }
        System.arraycopy( cs, 0, constants, 0, cs.length );
        if (cs.length > 0) {
            index = cs.length;
        }
        for (int i = 1; i < index; i++) {
            org.apache.bcel.classfile.Constant c = constants[i];
            if (c instanceof org.apache.bcel.classfile.ConstantString) {
                org.apache.bcel.classfile.ConstantString s = (org.apache.bcel.classfile.ConstantString) c;
                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[s.getStringIndex()];
                java.lang.String key = u8.getBytes();
                if (!string_table.containsKey( key )) {
                    string_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( i ) );
                }
            } else {
                if (c instanceof org.apache.bcel.classfile.ConstantClass) {
                    org.apache.bcel.classfile.ConstantClass s = (org.apache.bcel.classfile.ConstantClass) c;
                    org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[s.getNameIndex()];
                    java.lang.String key = u8.getBytes();
                    if (!class_table.containsKey( key )) {
                        class_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( i ) );
                    }
                } else {
                    if (c instanceof org.apache.bcel.classfile.ConstantNameAndType) {
                        org.apache.bcel.classfile.ConstantNameAndType n = (org.apache.bcel.classfile.ConstantNameAndType) c;
                        org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getNameIndex()];
                        org.apache.bcel.classfile.ConstantUtf8 u8_2 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getSignatureIndex()];
                        java.lang.String key = u8.getBytes() + NAT_DELIM + u8_2.getBytes();
                        if (!n_a_t_table.containsKey( key )) {
                            n_a_t_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( i ) );
                        }
                    } else {
                        if (c instanceof org.apache.bcel.classfile.ConstantUtf8) {
                            org.apache.bcel.classfile.ConstantUtf8 u = (org.apache.bcel.classfile.ConstantUtf8) c;
                            java.lang.String key = u.getBytes();
                            if (!utf8_table.containsKey( key )) {
                                utf8_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( i ) );
                            }
                        } else {
                            if (c instanceof org.apache.bcel.classfile.ConstantCP) {
                                org.apache.bcel.classfile.ConstantCP m = (org.apache.bcel.classfile.ConstantCP) c;
                                org.apache.bcel.classfile.ConstantClass clazz = (org.apache.bcel.classfile.ConstantClass) constants[m.getClassIndex()];
                                org.apache.bcel.classfile.ConstantNameAndType n = (org.apache.bcel.classfile.ConstantNameAndType) constants[m.getNameAndTypeIndex()];
                                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[clazz.getNameIndex()];
                                java.lang.String class_name = u8.getBytes().replace( '/', '.' );
                                u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getNameIndex()];
                                java.lang.String method_name = u8.getBytes();
                                u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getSignatureIndex()];
                                java.lang.String signature = u8.getBytes();
                                java.lang.String delim = METHODREF_DELIM;
                                if (c instanceof org.apache.bcel.classfile.ConstantInterfaceMethodref) {
                                    delim = IMETHODREF_DELIM;
                                } else {
                                    if (c instanceof org.apache.bcel.classfile.ConstantFieldref) {
                                        delim = FIELDREF_DELIM;
                                    }
                                }
                                java.lang.String key = class_name + delim + method_name + delim + signature;
                                if (!cp_table.containsKey( key )) {
                                    cp_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( i ) );
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public ConstantPoolGen( org.apache.bcel.classfile.ConstantPool cp )
    {
        this( cp.getConstantPool() );
    }

    public ConstantPoolGen()
    {
    }

    protected  void adjustSize()
    {
        if (index + 3 >= size) {
            org.apache.bcel.classfile.Constant[] cs = constants;
            size *= 2;
            constants = new org.apache.bcel.classfile.Constant[size];
            System.arraycopy( cs, 0, constants, 0, index );
        }
    }

    private java.util.Map string_table = new java.util.HashMap();

    public  int lookupString( java.lang.String str )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) string_table.get( str );
        return index != null ? index.index : -1;
    }

    public  int addString( java.lang.String str )
    {
        int ret;
        if ((ret = lookupString( str )) != -1) {
            return ret;
        }
        int utf8 = addUtf8( str );
        adjustSize();
        org.apache.bcel.classfile.ConstantString s = new org.apache.bcel.classfile.ConstantString( utf8 );
        ret = index;
        constants[index++] = s;
        if (!string_table.containsKey( str )) {
            string_table.put( str, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    private java.util.Map class_table = new java.util.HashMap();

    public  int lookupClass( java.lang.String str )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) class_table.get( str.replace( '.', '/' ) );
        return index != null ? index.index : -1;
    }

    private  int addClass_( java.lang.String clazz )
    {
        int ret;
        if ((ret = lookupClass( clazz )) != -1) {
            return ret;
        }
        adjustSize();
        org.apache.bcel.classfile.ConstantClass c = new org.apache.bcel.classfile.ConstantClass( addUtf8( clazz ) );
        ret = index;
        constants[index++] = c;
        if (!class_table.containsKey( clazz )) {
            class_table.put( clazz, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    public  int addClass( java.lang.String str )
    {
        return addClass_( str.replace( '.', '/' ) );
    }

    public  int addClass( org.apache.bcel.generic.ObjectType type )
    {
        return addClass( type.getClassName() );
    }

    public  int addArrayClass( org.apache.bcel.generic.ArrayType type )
    {
        return addClass_( type.getSignature() );
    }

    public  int lookupInteger( int n )
    {
        for (int i = 1; i < index; i++) {
            if (constants[i] instanceof org.apache.bcel.classfile.ConstantInteger) {
                org.apache.bcel.classfile.ConstantInteger c = (org.apache.bcel.classfile.ConstantInteger) constants[i];
                if (c.getBytes() == n) {
                    return i;
                }
            }
        }
        return -1;
    }

    public  int addInteger( int n )
    {
        int ret;
        if ((ret = lookupInteger( n )) != -1) {
            return ret;
        }
        adjustSize();
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantInteger( n );
        return ret;
    }

    public  int lookupFloat( float n )
    {
        int bits = Float.floatToIntBits( n );
        for (int i = 1; i < index; i++) {
            if (constants[i] instanceof org.apache.bcel.classfile.ConstantFloat) {
                org.apache.bcel.classfile.ConstantFloat c = (org.apache.bcel.classfile.ConstantFloat) constants[i];
                if (Float.floatToIntBits( c.getBytes() ) == bits) {
                    return i;
                }
            }
        }
        return -1;
    }

    public  int addFloat( float n )
    {
        int ret;
        if ((ret = lookupFloat( n )) != -1) {
            return ret;
        }
        adjustSize();
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantFloat( n );
        return ret;
    }

    private java.util.Map utf8_table = new java.util.HashMap();

    public  int lookupUtf8( java.lang.String n )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) utf8_table.get( n );
        return index != null ? index.index : -1;
    }

    public  int addUtf8( java.lang.String n )
    {
        int ret;
        if ((ret = lookupUtf8( n )) != -1) {
            return ret;
        }
        adjustSize();
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantUtf8( n );
        if (!utf8_table.containsKey( n )) {
            utf8_table.put( n, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    public  int lookupLong( long n )
    {
        for (int i = 1; i < index; i++) {
            if (constants[i] instanceof org.apache.bcel.classfile.ConstantLong) {
                org.apache.bcel.classfile.ConstantLong c = (org.apache.bcel.classfile.ConstantLong) constants[i];
                if (c.getBytes() == n) {
                    return i;
                }
            }
        }
        return -1;
    }

    public  int addLong( long n )
    {
        int ret;
        if ((ret = lookupLong( n )) != -1) {
            return ret;
        }
        adjustSize();
        ret = index;
        constants[index] = new org.apache.bcel.classfile.ConstantLong( n );
        index += 2;
        return ret;
    }

    public  int lookupDouble( double n )
    {
        long bits = Double.doubleToLongBits( n );
        for (int i = 1; i < index; i++) {
            if (constants[i] instanceof org.apache.bcel.classfile.ConstantDouble) {
                org.apache.bcel.classfile.ConstantDouble c = (org.apache.bcel.classfile.ConstantDouble) constants[i];
                if (Double.doubleToLongBits( c.getBytes() ) == bits) {
                    return i;
                }
            }
        }
        return -1;
    }

    public  int addDouble( double n )
    {
        int ret;
        if ((ret = lookupDouble( n )) != -1) {
            return ret;
        }
        adjustSize();
        ret = index;
        constants[index] = new org.apache.bcel.classfile.ConstantDouble( n );
        index += 2;
        return ret;
    }

    private java.util.Map n_a_t_table = new java.util.HashMap();

    public  int lookupNameAndType( java.lang.String name, java.lang.String signature )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index _index = (org.apache.bcel.generic.ConstantPoolGen.Index) n_a_t_table.get( name + NAT_DELIM + signature );
        return _index != null ? _index.index : -1;
    }

    public  int addNameAndType( java.lang.String name, java.lang.String signature )
    {
        int ret;
        int name_index;
        int signature_index;
        if ((ret = lookupNameAndType( name, signature )) != -1) {
            return ret;
        }
        adjustSize();
        name_index = addUtf8( name );
        signature_index = addUtf8( signature );
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantNameAndType( name_index, signature_index );
        java.lang.String key = name + NAT_DELIM + signature;
        if (!n_a_t_table.containsKey( key )) {
            n_a_t_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    private java.util.Map cp_table = new java.util.HashMap();

    public  int lookupMethodref( java.lang.String class_name, java.lang.String method_name, java.lang.String signature )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) cp_table.get( class_name + METHODREF_DELIM + method_name + METHODREF_DELIM + signature );
        return index != null ? index.index : -1;
    }

    public  int lookupMethodref( org.apache.bcel.generic.MethodGen method )
    {
        return lookupMethodref( method.getClassName(), method.getName(), method.getSignature() );
    }

    public  int addMethodref( java.lang.String class_name, java.lang.String method_name, java.lang.String signature )
    {
        int ret;
        int class_index;
        int name_and_type_index;
        if ((ret = lookupMethodref( class_name, method_name, signature )) != -1) {
            return ret;
        }
        adjustSize();
        name_and_type_index = addNameAndType( method_name, signature );
        class_index = addClass( class_name );
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantMethodref( class_index, name_and_type_index );
        java.lang.String key = class_name + METHODREF_DELIM + method_name + METHODREF_DELIM + signature;
        if (!cp_table.containsKey( key )) {
            cp_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    public  int addMethodref( org.apache.bcel.generic.MethodGen method )
    {
        return addMethodref( method.getClassName(), method.getName(), method.getSignature() );
    }

    public  int lookupInterfaceMethodref( java.lang.String class_name, java.lang.String method_name, java.lang.String signature )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) cp_table.get( class_name + IMETHODREF_DELIM + method_name + IMETHODREF_DELIM + signature );
        return index != null ? index.index : -1;
    }

    public  int lookupInterfaceMethodref( org.apache.bcel.generic.MethodGen method )
    {
        return lookupInterfaceMethodref( method.getClassName(), method.getName(), method.getSignature() );
    }

    public  int addInterfaceMethodref( java.lang.String class_name, java.lang.String method_name, java.lang.String signature )
    {
        int ret;
        int class_index;
        int name_and_type_index;
        if ((ret = lookupInterfaceMethodref( class_name, method_name, signature )) != -1) {
            return ret;
        }
        adjustSize();
        class_index = addClass( class_name );
        name_and_type_index = addNameAndType( method_name, signature );
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantInterfaceMethodref( class_index, name_and_type_index );
        java.lang.String key = class_name + IMETHODREF_DELIM + method_name + IMETHODREF_DELIM + signature;
        if (!cp_table.containsKey( key )) {
            cp_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    public  int addInterfaceMethodref( org.apache.bcel.generic.MethodGen method )
    {
        return addInterfaceMethodref( method.getClassName(), method.getName(), method.getSignature() );
    }

    public  int lookupFieldref( java.lang.String class_name, java.lang.String field_name, java.lang.String signature )
    {
        org.apache.bcel.generic.ConstantPoolGen.Index index = (org.apache.bcel.generic.ConstantPoolGen.Index) cp_table.get( class_name + FIELDREF_DELIM + field_name + FIELDREF_DELIM + signature );
        return index != null ? index.index : -1;
    }

    public  int addFieldref( java.lang.String class_name, java.lang.String field_name, java.lang.String signature )
    {
        int ret;
        int class_index;
        int name_and_type_index;
        if ((ret = lookupFieldref( class_name, field_name, signature )) != -1) {
            return ret;
        }
        adjustSize();
        class_index = addClass( class_name );
        name_and_type_index = addNameAndType( field_name, signature );
        ret = index;
        constants[index++] = new org.apache.bcel.classfile.ConstantFieldref( class_index, name_and_type_index );
        java.lang.String key = class_name + FIELDREF_DELIM + field_name + FIELDREF_DELIM + signature;
        if (!cp_table.containsKey( key )) {
            cp_table.put( key, new org.apache.bcel.generic.ConstantPoolGen.Index( ret ) );
        }
        return ret;
    }

    public  org.apache.bcel.classfile.Constant getConstant( int i )
    {
        return constants[i];
    }

    public  void setConstant( int i, org.apache.bcel.classfile.Constant c )
    {
        constants[i] = c;
    }

    public  org.apache.bcel.classfile.ConstantPool getConstantPool()
    {
        return new org.apache.bcel.classfile.ConstantPool( constants );
    }

    public  int getSize()
    {
        return index;
    }

    public  org.apache.bcel.classfile.ConstantPool getFinalConstantPool()
    {
        org.apache.bcel.classfile.Constant[] cs = new org.apache.bcel.classfile.Constant[index];
        System.arraycopy( constants, 0, cs, 0, index );
        return new org.apache.bcel.classfile.ConstantPool( cs );
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        for (int i = 1; i < index; i++) {
            buf.append( i ).append( ")" ).append( constants[i] ).append( "\n" );
        }
        return buf.toString();
    }

    public  int addConstant( org.apache.bcel.classfile.Constant c, org.apache.bcel.generic.ConstantPoolGen cp )
    {
        org.apache.bcel.classfile.Constant[] constants = cp.getConstantPool().getConstantPool();
        switch (c.getTag()) {
        case Constants.CONSTANT_String :
            {
                org.apache.bcel.classfile.ConstantString s = (org.apache.bcel.classfile.ConstantString) c;
                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[s.getStringIndex()];
                return addString( u8.getBytes() );
            }

        case Constants.CONSTANT_Class :
            {
                org.apache.bcel.classfile.ConstantClass s = (org.apache.bcel.classfile.ConstantClass) c;
                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[s.getNameIndex()];
                return addClass( u8.getBytes() );
            }

        case Constants.CONSTANT_NameAndType :
            {
                org.apache.bcel.classfile.ConstantNameAndType n = (org.apache.bcel.classfile.ConstantNameAndType) c;
                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getNameIndex()];
                org.apache.bcel.classfile.ConstantUtf8 u8_2 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getSignatureIndex()];
                return addNameAndType( u8.getBytes(), u8_2.getBytes() );
            }

        case Constants.CONSTANT_Utf8 :
            return addUtf8( ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes() );

        case Constants.CONSTANT_Double :
            return addDouble( ((org.apache.bcel.classfile.ConstantDouble) c).getBytes() );

        case Constants.CONSTANT_Float :
            return addFloat( ((org.apache.bcel.classfile.ConstantFloat) c).getBytes() );

        case Constants.CONSTANT_Long :
            return addLong( ((org.apache.bcel.classfile.ConstantLong) c).getBytes() );

        case Constants.CONSTANT_Integer :
            return addInteger( ((org.apache.bcel.classfile.ConstantInteger) c).getBytes() );

        case Constants.CONSTANT_InterfaceMethodref :
        case Constants.CONSTANT_Methodref :
        case Constants.CONSTANT_Fieldref :
            {
                org.apache.bcel.classfile.ConstantCP m = (org.apache.bcel.classfile.ConstantCP) c;
                org.apache.bcel.classfile.ConstantClass clazz = (org.apache.bcel.classfile.ConstantClass) constants[m.getClassIndex()];
                org.apache.bcel.classfile.ConstantNameAndType n = (org.apache.bcel.classfile.ConstantNameAndType) constants[m.getNameAndTypeIndex()];
                org.apache.bcel.classfile.ConstantUtf8 u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[clazz.getNameIndex()];
                java.lang.String class_name = u8.getBytes().replace( '/', '.' );
                u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getNameIndex()];
                java.lang.String name = u8.getBytes();
                u8 = (org.apache.bcel.classfile.ConstantUtf8) constants[n.getSignatureIndex()];
                java.lang.String signature = u8.getBytes();
                switch (c.getTag()) {
                case Constants.CONSTANT_InterfaceMethodref :
                    return addInterfaceMethodref( class_name, name, signature );

                case Constants.CONSTANT_Methodref :
                    return addMethodref( class_name, name, signature );

                case Constants.CONSTANT_Fieldref :
                    return addFieldref( class_name, name, signature );

                default  :
                    throw new java.lang.RuntimeException( "Unknown constant type " + c );

                }
            }

        default  :
            throw new java.lang.RuntimeException( "Unknown constant type " + c );

        }
    }

}
