// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.util.ByteSequence;


public class IINC extends org.apache.bcel.generic.LocalVariableInstruction
{

    private boolean wide;

    private int c;

    IINC()
    {
    }

    public IINC( int n, int c )
    {
        super();
        this.opcode = org.apache.bcel.Constants.IINC;
        this.length = (short) 3;
        setIndex( n );
        setIncrement( c );
    }

    public  void dump( java.io.DataOutputStream out )
        throws java.io.IOException
    {
        if (wide) {
            out.writeByte( org.apache.bcel.Constants.WIDE );
        }
        out.writeByte( opcode );
        if (wide) {
            out.writeShort( n );
            out.writeShort( c );
        } else {
            out.writeByte( n );
            out.writeByte( c );
        }
    }

    private final  void setWide()
    {
        wide = n > org.apache.bcel.Constants.MAX_BYTE || Math.abs( c ) > Byte.MAX_VALUE;
        if (wide) {
            length = 6;
        } else {
            length = 3;
        }
    }

    protected  void initFromFile( org.apache.bcel.util.ByteSequence bytes, boolean wide )
        throws java.io.IOException
    {
        this.wide = wide;
        if (wide) {
            length = 6;
            n = bytes.readUnsignedShort();
            c = bytes.readShort();
        } else {
            length = 3;
            n = bytes.readUnsignedByte();
            c = bytes.readByte();
        }
    }

    public  java.lang.String toString( boolean verbose )
    {
        return super.toString( verbose ) + " " + c;
    }

    public final  void setIndex( int n )
    {
        if (n < 0) {
            throw new org.apache.bcel.generic.ClassGenException( "Negative index value: " + n );
        }
        this.n = n;
        setWide();
    }

    public final  int getIncrement()
    {
        return c;
    }

    public final  void setIncrement( int c )
    {
        this.c = c;
        setWide();
    }

    public  org.apache.bcel.generic.Type getType( org.apache.bcel.generic.ConstantPoolGen cp )
    {
        return Type.INT;
    }

    public  void accept( org.apache.bcel.generic.Visitor v )
    {
        v.visitLocalVariableInstruction( this );
        v.visitIINC( this );
    }

}
