// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import org.apache.bcel.Constants;


public class InstructionFactory implements org.apache.bcel.generic.InstructionConstants, java.io.Serializable
{

    protected org.apache.bcel.generic.ClassGen cg;

    protected org.apache.bcel.generic.ConstantPoolGen cp;

    public InstructionFactory( org.apache.bcel.generic.ClassGen cg, org.apache.bcel.generic.ConstantPoolGen cp )
    {
        this.cg = cg;
        this.cp = cp;
    }

    public InstructionFactory( org.apache.bcel.generic.ClassGen cg )
    {
        this( cg, cg.getConstantPool() );
    }

    public InstructionFactory( org.apache.bcel.generic.ConstantPoolGen cp )
    {
        this( null, cp );
    }

    public  org.apache.bcel.generic.InvokeInstruction createInvoke( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type ret_type, org.apache.bcel.generic.Type[] arg_types, short kind )
    {
        int index;
        int nargs = 0;
        java.lang.String signature = Type.getMethodSignature( ret_type, arg_types );
        for (int i = 0; i < arg_types.length; i++) {
            nargs += arg_types[i].getSize();
        }
        if (kind == Constants.INVOKEINTERFACE) {
            index = cp.addInterfaceMethodref( class_name, name, signature );
        } else {
            index = cp.addMethodref( class_name, name, signature );
        }
        switch (kind) {
        case Constants.INVOKESPECIAL :
            return new org.apache.bcel.generic.INVOKESPECIAL( index );

        case Constants.INVOKEVIRTUAL :
            return new org.apache.bcel.generic.INVOKEVIRTUAL( index );

        case Constants.INVOKESTATIC :
            return new org.apache.bcel.generic.INVOKESTATIC( index );

        case Constants.INVOKEINTERFACE :
            return new org.apache.bcel.generic.INVOKEINTERFACE( index, nargs + 1 );

        default  :
            throw new java.lang.RuntimeException( "Oops: Unknown invoke kind:" + kind );

        }
    }

    public  org.apache.bcel.generic.InstructionList createPrintln( java.lang.String s )
    {
        org.apache.bcel.generic.InstructionList il = new org.apache.bcel.generic.InstructionList();
        int out = cp.addFieldref( "java.lang.System", "out", "Ljava/io/PrintStream;" );
        int println = cp.addMethodref( "java.io.PrintStream", "println", "(Ljava/lang/String;)V" );
        il.append( new org.apache.bcel.generic.GETSTATIC( out ) );
        il.append( new org.apache.bcel.generic.PUSH( cp, s ) );
        il.append( new org.apache.bcel.generic.INVOKEVIRTUAL( println ) );
        return il;
    }

    public  org.apache.bcel.generic.Instruction createConstant( java.lang.Object value )
    {
        org.apache.bcel.generic.PUSH push;
        if (value instanceof java.lang.Number) {
            push = new org.apache.bcel.generic.PUSH( cp, (java.lang.Number) value );
        } else {
            if (value instanceof java.lang.String) {
                push = new org.apache.bcel.generic.PUSH( cp, (java.lang.String) value );
            } else {
                if (value instanceof java.lang.Boolean) {
                    push = new org.apache.bcel.generic.PUSH( cp, (java.lang.Boolean) value );
                } else {
                    if (value instanceof java.lang.Character) {
                        push = new org.apache.bcel.generic.PUSH( cp, (java.lang.Character) value );
                    } else {
                        throw new org.apache.bcel.generic.ClassGenException( "Illegal type: " + value.getClass() );
                    }
                }
            }
        }
        return push.getInstruction();
    }

    private static class MethodObject
    {

        org.apache.bcel.generic.Type[] arg_types;

        org.apache.bcel.generic.Type result_type;

        java.lang.String class_name;

        java.lang.String name;

        int access;

        MethodObject( java.lang.String c, java.lang.String n, org.apache.bcel.generic.Type r, org.apache.bcel.generic.Type[] a, int acc )
        {
            class_name = c;
            name = n;
            result_type = r;
            arg_types = a;
            access = acc;
        }

    }

    private  org.apache.bcel.generic.InvokeInstruction createInvoke( org.apache.bcel.generic.InstructionFactory.MethodObject m, short kind )
    {
        return createInvoke( m.class_name, m.name, m.result_type, m.arg_types, kind );
    }

    private static org.apache.bcel.generic.InstructionFactory.MethodObject[] append_mos = { new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.STRING }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.OBJECT }, Constants.ACC_PUBLIC ), null, null, new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.BOOLEAN }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.CHAR }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.FLOAT }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.DOUBLE }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.INT }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.INT }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.INT }, Constants.ACC_PUBLIC ), new org.apache.bcel.generic.InstructionFactory.MethodObject( "java.lang.StringBuffer", "append", Type.STRINGBUFFER, new org.apache.bcel.generic.Type[]{ Type.LONG }, Constants.ACC_PUBLIC ) };

    private static final  boolean isString( org.apache.bcel.generic.Type type )
    {
        return type instanceof org.apache.bcel.generic.ObjectType && ((org.apache.bcel.generic.ObjectType) type).getClassName().equals( "java.lang.String" );
    }

    public  org.apache.bcel.generic.Instruction createAppend( org.apache.bcel.generic.Type type )
    {
        byte t = type.getType();
        if (isString( type )) {
            return createInvoke( append_mos[0], Constants.INVOKEVIRTUAL );
        }
        switch (t) {
        case Constants.T_BOOLEAN :
        case Constants.T_CHAR :
        case Constants.T_FLOAT :
        case Constants.T_DOUBLE :
        case Constants.T_BYTE :
        case Constants.T_SHORT :
        case Constants.T_INT :
        case Constants.T_LONG :
            return createInvoke( append_mos[t], Constants.INVOKEVIRTUAL );

        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return createInvoke( append_mos[1], Constants.INVOKEVIRTUAL );

        default  :
            throw new java.lang.RuntimeException( "Oops: No append for this type? " + type );

        }
    }

    public  org.apache.bcel.generic.FieldInstruction createFieldAccess( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type type, short kind )
    {
        int index;
        java.lang.String signature = type.getSignature();
        index = cp.addFieldref( class_name, name, signature );
        switch (kind) {
        case Constants.GETFIELD :
            return new org.apache.bcel.generic.GETFIELD( index );

        case Constants.PUTFIELD :
            return new org.apache.bcel.generic.PUTFIELD( index );

        case Constants.GETSTATIC :
            return new org.apache.bcel.generic.GETSTATIC( index );

        case Constants.PUTSTATIC :
            return new org.apache.bcel.generic.PUTSTATIC( index );

        default  :
            throw new java.lang.RuntimeException( "Oops: Unknown getfield kind:" + kind );

        }
    }

    public static  org.apache.bcel.generic.Instruction createThis()
    {
        return new org.apache.bcel.generic.ALOAD( 0 );
    }

    public static  org.apache.bcel.generic.ReturnInstruction createReturn( org.apache.bcel.generic.Type type )
    {
        switch (type.getType()) {
        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return ARETURN;

        case Constants.T_INT :
        case Constants.T_SHORT :
        case Constants.T_BOOLEAN :
        case Constants.T_CHAR :
        case Constants.T_BYTE :
            return IRETURN;

        case Constants.T_FLOAT :
            return FRETURN;

        case Constants.T_DOUBLE :
            return DRETURN;

        case Constants.T_LONG :
            return LRETURN;

        case Constants.T_VOID :
            return RETURN;

        default  :
            throw new java.lang.RuntimeException( "Invalid type: " + type );

        }
    }

    private static final  org.apache.bcel.generic.ArithmeticInstruction createBinaryIntOp( char first, java.lang.String op )
    {
        switch (first) {
        case '-' :
            return ISUB;

        case '+' :
            return IADD;

        case '%' :
            return IREM;

        case '*' :
            return IMUL;

        case '/' :
            return IDIV;

        case '&' :
            return IAND;

        case '|' :
            return IOR;

        case '^' :
            return IXOR;

        case '<' :
            return ISHL;

        case '>' :
            return op.equals( ">>>" ) ? (org.apache.bcel.generic.ArithmeticInstruction) IUSHR : (org.apache.bcel.generic.ArithmeticInstruction) ISHR;

        default  :
            throw new java.lang.RuntimeException( "Invalid operand " + op );

        }
    }

    private static final  org.apache.bcel.generic.ArithmeticInstruction createBinaryLongOp( char first, java.lang.String op )
    {
        switch (first) {
        case '-' :
            return LSUB;

        case '+' :
            return LADD;

        case '%' :
            return LREM;

        case '*' :
            return LMUL;

        case '/' :
            return LDIV;

        case '&' :
            return LAND;

        case '|' :
            return LOR;

        case '^' :
            return LXOR;

        case '<' :
            return LSHL;

        case '>' :
            return op.equals( ">>>" ) ? (org.apache.bcel.generic.ArithmeticInstruction) LUSHR : (org.apache.bcel.generic.ArithmeticInstruction) LSHR;

        default  :
            throw new java.lang.RuntimeException( "Invalid operand " + op );

        }
    }

    private static final  org.apache.bcel.generic.ArithmeticInstruction createBinaryFloatOp( char op )
    {
        switch (op) {
        case '-' :
            return FSUB;

        case '+' :
            return FADD;

        case '*' :
            return FMUL;

        case '/' :
            return FDIV;

        default  :
            throw new java.lang.RuntimeException( "Invalid operand " + op );

        }
    }

    private static final  org.apache.bcel.generic.ArithmeticInstruction createBinaryDoubleOp( char op )
    {
        switch (op) {
        case '-' :
            return DSUB;

        case '+' :
            return DADD;

        case '*' :
            return DMUL;

        case '/' :
            return DDIV;

        default  :
            throw new java.lang.RuntimeException( "Invalid operand " + op );

        }
    }

    public static  org.apache.bcel.generic.ArithmeticInstruction createBinaryOperation( java.lang.String op, org.apache.bcel.generic.Type type )
    {
        char first = op.toCharArray()[0];
        switch (type.getType()) {
        case Constants.T_BYTE :
        case Constants.T_SHORT :
        case Constants.T_INT :
        case Constants.T_CHAR :
            return createBinaryIntOp( first, op );

        case Constants.T_LONG :
            return createBinaryLongOp( first, op );

        case Constants.T_FLOAT :
            return createBinaryFloatOp( first );

        case Constants.T_DOUBLE :
            return createBinaryDoubleOp( first );

        default  :
            throw new java.lang.RuntimeException( "Invalid type " + type );

        }
    }

    public static  org.apache.bcel.generic.StackInstruction createPop( int size )
    {
        return size == 2 ? (org.apache.bcel.generic.StackInstruction) POP2 : (org.apache.bcel.generic.StackInstruction) POP;
    }

    public static  org.apache.bcel.generic.StackInstruction createDup( int size )
    {
        return size == 2 ? (org.apache.bcel.generic.StackInstruction) DUP2 : (org.apache.bcel.generic.StackInstruction) DUP;
    }

    public static  org.apache.bcel.generic.StackInstruction createDup_2( int size )
    {
        return size == 2 ? (org.apache.bcel.generic.StackInstruction) DUP2_X2 : (org.apache.bcel.generic.StackInstruction) DUP_X2;
    }

    public static  org.apache.bcel.generic.StackInstruction createDup_1( int size )
    {
        return size == 2 ? (org.apache.bcel.generic.StackInstruction) DUP2_X1 : (org.apache.bcel.generic.StackInstruction) DUP_X1;
    }

    public static  org.apache.bcel.generic.LocalVariableInstruction createStore( org.apache.bcel.generic.Type type, int index )
    {
        switch (type.getType()) {
        case Constants.T_BOOLEAN :
        case Constants.T_CHAR :
        case Constants.T_BYTE :
        case Constants.T_SHORT :
        case Constants.T_INT :
            return new org.apache.bcel.generic.ISTORE( index );

        case Constants.T_FLOAT :
            return new org.apache.bcel.generic.FSTORE( index );

        case Constants.T_DOUBLE :
            return new org.apache.bcel.generic.DSTORE( index );

        case Constants.T_LONG :
            return new org.apache.bcel.generic.LSTORE( index );

        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return new org.apache.bcel.generic.ASTORE( index );

        default  :
            throw new java.lang.RuntimeException( "Invalid type " + type );

        }
    }

    public static  org.apache.bcel.generic.LocalVariableInstruction createLoad( org.apache.bcel.generic.Type type, int index )
    {
        switch (type.getType()) {
        case Constants.T_BOOLEAN :
        case Constants.T_CHAR :
        case Constants.T_BYTE :
        case Constants.T_SHORT :
        case Constants.T_INT :
            return new org.apache.bcel.generic.ILOAD( index );

        case Constants.T_FLOAT :
            return new org.apache.bcel.generic.FLOAD( index );

        case Constants.T_DOUBLE :
            return new org.apache.bcel.generic.DLOAD( index );

        case Constants.T_LONG :
            return new org.apache.bcel.generic.LLOAD( index );

        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return new org.apache.bcel.generic.ALOAD( index );

        default  :
            throw new java.lang.RuntimeException( "Invalid type " + type );

        }
    }

    public static  org.apache.bcel.generic.ArrayInstruction createArrayLoad( org.apache.bcel.generic.Type type )
    {
        switch (type.getType()) {
        case Constants.T_BOOLEAN :
        case Constants.T_BYTE :
            return BALOAD;

        case Constants.T_CHAR :
            return CALOAD;

        case Constants.T_SHORT :
            return SALOAD;

        case Constants.T_INT :
            return IALOAD;

        case Constants.T_FLOAT :
            return FALOAD;

        case Constants.T_DOUBLE :
            return DALOAD;

        case Constants.T_LONG :
            return LALOAD;

        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return AALOAD;

        default  :
            throw new java.lang.RuntimeException( "Invalid type " + type );

        }
    }

    public static  org.apache.bcel.generic.ArrayInstruction createArrayStore( org.apache.bcel.generic.Type type )
    {
        switch (type.getType()) {
        case Constants.T_BOOLEAN :
        case Constants.T_BYTE :
            return BASTORE;

        case Constants.T_CHAR :
            return CASTORE;

        case Constants.T_SHORT :
            return SASTORE;

        case Constants.T_INT :
            return IASTORE;

        case Constants.T_FLOAT :
            return FASTORE;

        case Constants.T_DOUBLE :
            return DASTORE;

        case Constants.T_LONG :
            return LASTORE;

        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return AASTORE;

        default  :
            throw new java.lang.RuntimeException( "Invalid type " + type );

        }
    }

    public  org.apache.bcel.generic.Instruction createCast( org.apache.bcel.generic.Type src_type, org.apache.bcel.generic.Type dest_type )
    {
        if (src_type instanceof org.apache.bcel.generic.BasicType && dest_type instanceof org.apache.bcel.generic.BasicType) {
            byte dest = dest_type.getType();
            byte src = src_type.getType();
            if (dest == Constants.T_LONG && (src == Constants.T_CHAR || src == Constants.T_BYTE || src == Constants.T_SHORT)) {
                src = Constants.T_INT;
            }
            java.lang.String[] short_names = { "C", "F", "D", "B", "S", "I", "L" };
            java.lang.String name = "org.apache.bcel.generic." + short_names[src - Constants.T_CHAR] + "2" + short_names[dest - Constants.T_CHAR];
            org.apache.bcel.generic.Instruction i = null;
            try {
                i = (org.apache.bcel.generic.Instruction) java.lang.Class.forName( name ).newInstance();
            } catch ( java.lang.Exception e ) {
                throw new java.lang.RuntimeException( "Could not find instruction: " + name );
            }
            return i;
        } else {
            if (src_type instanceof org.apache.bcel.generic.ReferenceType && dest_type instanceof org.apache.bcel.generic.ReferenceType) {
                if (dest_type instanceof org.apache.bcel.generic.ArrayType) {
                    return new org.apache.bcel.generic.CHECKCAST( cp.addArrayClass( (org.apache.bcel.generic.ArrayType) dest_type ) );
                } else {
                    return new org.apache.bcel.generic.CHECKCAST( cp.addClass( ((org.apache.bcel.generic.ObjectType) dest_type).getClassName() ) );
                }
            } else {
                throw new java.lang.RuntimeException( "Can not cast " + src_type + " to " + dest_type );
            }
        }
    }

    public  org.apache.bcel.generic.GETFIELD createGetField( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type t )
    {
        return new org.apache.bcel.generic.GETFIELD( cp.addFieldref( class_name, name, t.getSignature() ) );
    }

    public  org.apache.bcel.generic.GETSTATIC createGetStatic( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type t )
    {
        return new org.apache.bcel.generic.GETSTATIC( cp.addFieldref( class_name, name, t.getSignature() ) );
    }

    public  org.apache.bcel.generic.PUTFIELD createPutField( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type t )
    {
        return new org.apache.bcel.generic.PUTFIELD( cp.addFieldref( class_name, name, t.getSignature() ) );
    }

    public  org.apache.bcel.generic.PUTSTATIC createPutStatic( java.lang.String class_name, java.lang.String name, org.apache.bcel.generic.Type t )
    {
        return new org.apache.bcel.generic.PUTSTATIC( cp.addFieldref( class_name, name, t.getSignature() ) );
    }

    public  org.apache.bcel.generic.CHECKCAST createCheckCast( org.apache.bcel.generic.ReferenceType t )
    {
        if (t instanceof org.apache.bcel.generic.ArrayType) {
            return new org.apache.bcel.generic.CHECKCAST( cp.addArrayClass( (org.apache.bcel.generic.ArrayType) t ) );
        } else {
            return new org.apache.bcel.generic.CHECKCAST( cp.addClass( (org.apache.bcel.generic.ObjectType) t ) );
        }
    }

    public  org.apache.bcel.generic.INSTANCEOF createInstanceOf( org.apache.bcel.generic.ReferenceType t )
    {
        if (t instanceof org.apache.bcel.generic.ArrayType) {
            return new org.apache.bcel.generic.INSTANCEOF( cp.addArrayClass( (org.apache.bcel.generic.ArrayType) t ) );
        } else {
            return new org.apache.bcel.generic.INSTANCEOF( cp.addClass( (org.apache.bcel.generic.ObjectType) t ) );
        }
    }

    public  org.apache.bcel.generic.NEW createNew( org.apache.bcel.generic.ObjectType t )
    {
        return new org.apache.bcel.generic.NEW( cp.addClass( t ) );
    }

    public  org.apache.bcel.generic.NEW createNew( java.lang.String s )
    {
        return createNew( new org.apache.bcel.generic.ObjectType( s ) );
    }

    public  org.apache.bcel.generic.Instruction createNewArray( org.apache.bcel.generic.Type t, short dim )
    {
        if (dim == 1) {
            if (t instanceof org.apache.bcel.generic.ObjectType) {
                return new org.apache.bcel.generic.ANEWARRAY( cp.addClass( (org.apache.bcel.generic.ObjectType) t ) );
            } else {
                if (t instanceof org.apache.bcel.generic.ArrayType) {
                    return new org.apache.bcel.generic.ANEWARRAY( cp.addArrayClass( (org.apache.bcel.generic.ArrayType) t ) );
                } else {
                    return new org.apache.bcel.generic.NEWARRAY( ((org.apache.bcel.generic.BasicType) t).getType() );
                }
            }
        } else {
            org.apache.bcel.generic.ArrayType at;
            if (t instanceof org.apache.bcel.generic.ArrayType) {
                at = (org.apache.bcel.generic.ArrayType) t;
            } else {
                at = new org.apache.bcel.generic.ArrayType( t, dim );
            }
            return new org.apache.bcel.generic.MULTIANEWARRAY( cp.addArrayClass( at ), dim );
        }
    }

    public static  org.apache.bcel.generic.Instruction createNull( org.apache.bcel.generic.Type type )
    {
        switch (type.getType()) {
        case Constants.T_ARRAY :
        case Constants.T_OBJECT :
            return ACONST_NULL;

        case Constants.T_INT :
        case Constants.T_SHORT :
        case Constants.T_BOOLEAN :
        case Constants.T_CHAR :
        case Constants.T_BYTE :
            return ICONST_0;

        case Constants.T_FLOAT :
            return FCONST_0;

        case Constants.T_DOUBLE :
            return DCONST_0;

        case Constants.T_LONG :
            return LCONST_0;

        case Constants.T_VOID :
            return NOP;

        default  :
            throw new java.lang.RuntimeException( "Invalid type: " + type );

        }
    }

    public static  org.apache.bcel.generic.BranchInstruction createBranchInstruction( short opcode, org.apache.bcel.generic.InstructionHandle target )
    {
        switch (opcode) {
        case Constants.IFEQ :
            return new org.apache.bcel.generic.IFEQ( target );

        case Constants.IFNE :
            return new org.apache.bcel.generic.IFNE( target );

        case Constants.IFLT :
            return new org.apache.bcel.generic.IFLT( target );

        case Constants.IFGE :
            return new org.apache.bcel.generic.IFGE( target );

        case Constants.IFGT :
            return new org.apache.bcel.generic.IFGT( target );

        case Constants.IFLE :
            return new org.apache.bcel.generic.IFLE( target );

        case Constants.IF_ICMPEQ :
            return new org.apache.bcel.generic.IF_ICMPEQ( target );

        case Constants.IF_ICMPNE :
            return new org.apache.bcel.generic.IF_ICMPNE( target );

        case Constants.IF_ICMPLT :
            return new org.apache.bcel.generic.IF_ICMPLT( target );

        case Constants.IF_ICMPGE :
            return new org.apache.bcel.generic.IF_ICMPGE( target );

        case Constants.IF_ICMPGT :
            return new org.apache.bcel.generic.IF_ICMPGT( target );

        case Constants.IF_ICMPLE :
            return new org.apache.bcel.generic.IF_ICMPLE( target );

        case Constants.IF_ACMPEQ :
            return new org.apache.bcel.generic.IF_ACMPEQ( target );

        case Constants.IF_ACMPNE :
            return new org.apache.bcel.generic.IF_ACMPNE( target );

        case Constants.GOTO :
            return new org.apache.bcel.generic.GOTO( target );

        case Constants.JSR :
            return new org.apache.bcel.generic.JSR( target );

        case Constants.IFNULL :
            return new org.apache.bcel.generic.IFNULL( target );

        case Constants.IFNONNULL :
            return new org.apache.bcel.generic.IFNONNULL( target );

        case Constants.GOTO_W :
            return new org.apache.bcel.generic.GOTO_W( target );

        case Constants.JSR_W :
            return new org.apache.bcel.generic.JSR_W( target );

        default  :
            throw new java.lang.RuntimeException( "Invalid opcode: " + opcode );

        }
    }

    public  void setClassGen( org.apache.bcel.generic.ClassGen c )
    {
        cg = c;
    }

    public  org.apache.bcel.generic.ClassGen getClassGen()
    {
        return cg;
    }

    public  void setConstantPool( org.apache.bcel.generic.ConstantPoolGen c )
    {
        cp = c;
    }

    public  org.apache.bcel.generic.ConstantPoolGen getConstantPool()
    {
        return cp;
    }

}
