// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.util.ByteSequence;


public class LDC extends org.apache.bcel.generic.CPInstruction implements org.apache.bcel.generic.PushInstruction, org.apache.bcel.generic.ExceptionThrower, org.apache.bcel.generic.TypedInstruction
{

    LDC()
    {
    }

    public LDC( int index )
    {
        super( org.apache.bcel.Constants.LDC_W, index );
        setSize();
    }

    protected final  void setSize()
    {
        if (index <= org.apache.bcel.Constants.MAX_BYTE) {
            opcode = org.apache.bcel.Constants.LDC;
            length = 2;
        } else {
            opcode = org.apache.bcel.Constants.LDC_W;
            length = 3;
        }
    }

    public  void dump( java.io.DataOutputStream out )
        throws java.io.IOException
    {
        out.writeByte( opcode );
        if (length == 2) {
            out.writeByte( index );
        } else {
            out.writeShort( index );
        }
    }

    public final  void setIndex( int index )
    {
        super.setIndex( index );
        setSize();
    }

    protected  void initFromFile( org.apache.bcel.util.ByteSequence bytes, boolean wide )
        throws java.io.IOException
    {
        length = 2;
        index = bytes.readUnsignedByte();
    }

    public  java.lang.Object getValue( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        org.apache.bcel.classfile.Constant c = cpg.getConstantPool().getConstant( index );
        switch (c.getTag()) {
        case org.apache.bcel.Constants.CONSTANT_String :
            int i = ((org.apache.bcel.classfile.ConstantString) c).getStringIndex();
            c = cpg.getConstantPool().getConstant( i );
            return ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes();

        case org.apache.bcel.Constants.CONSTANT_Float :
            return new java.lang.Float( ((org.apache.bcel.classfile.ConstantFloat) c).getBytes() );

        case org.apache.bcel.Constants.CONSTANT_Integer :
            return new java.lang.Integer( ((org.apache.bcel.classfile.ConstantInteger) c).getBytes() );

        case org.apache.bcel.Constants.CONSTANT_Class :
            return c;

        default  :
            throw new java.lang.RuntimeException( "Unknown or invalid constant type at " + index );

        }
    }

    public  org.apache.bcel.generic.Type getType( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        switch (cpg.getConstantPool().getConstant( index ).getTag()) {
        case org.apache.bcel.Constants.CONSTANT_String :
            return Type.STRING;

        case org.apache.bcel.Constants.CONSTANT_Float :
            return Type.FLOAT;

        case org.apache.bcel.Constants.CONSTANT_Integer :
            return Type.INT;

        case org.apache.bcel.Constants.CONSTANT_Class :
            return Type.CLASS;

        default  :
            throw new java.lang.RuntimeException( "Unknown or invalid constant type at " + index );

        }
    }

    public  java.lang.Class[] getExceptions()
    {
        return org.apache.bcel.ExceptionConstants.EXCS_STRING_RESOLUTION;
    }

    public  void accept( org.apache.bcel.generic.Visitor v )
    {
        v.visitStackProducer( this );
        v.visitPushInstruction( this );
        v.visitExceptionThrower( this );
        v.visitTypedInstruction( this );
        v.visitCPInstruction( this );
        v.visitLDC( this );
    }

}
