// This is a mutant program.
// Author : ysma

package org.apache.bcel.generic;


import org.apache.bcel.Constants;


public final class PUSH implements org.apache.bcel.generic.CompoundInstruction, org.apache.bcel.generic.VariableLengthInstruction, org.apache.bcel.generic.InstructionConstants
{

    private org.apache.bcel.generic.Instruction instruction;

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, int value )
    {
        if (value >= -1 && value <= 5) {
            instruction = INSTRUCTIONS[Constants.ICONST_0 + value];
        } else {
            if (value >= -128 && value <= 127) {
                instruction = new org.apache.bcel.generic.BIPUSH( (byte) value );
            } else {
                if (value >= -32768 && value <= 32767) {
                    instruction = new org.apache.bcel.generic.SIPUSH( (short) value );
                } else {
                    instruction = new org.apache.bcel.generic.LDC( cp.addInteger( value ) );
                }
            }
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, boolean value )
    {
        instruction = INSTRUCTIONS[Constants.ICONST_0 + (value ? 1 : 0)];
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, float value )
    {
        if (value == 0.0) {
            instruction = FCONST_0;
        } else {
            if (value == 1.0) {
                instruction = FCONST_1;
            } else {
                if (value == 2.0) {
                    instruction = FCONST_2;
                } else {
                    instruction = new org.apache.bcel.generic.LDC( cp.addFloat( value ) );
                }
            }
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, long value )
    {
        if (value == 0) {
            instruction = LCONST_0;
        } else {
            if (value == 1) {
                instruction = LCONST_1;
            } else {
                instruction = new org.apache.bcel.generic.LDC2_W( cp.addLong( value ) );
            }
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, double value )
    {
        if (value == 0.0) {
            instruction = DCONST_0;
        } else {
            if (value == 1.0) {
                instruction = DCONST_1;
            } else {
                instruction = new org.apache.bcel.generic.LDC2_W( cp.addDouble( value ) );
            }
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, java.lang.String value )
    {
        if (value == null) {
            instruction = ACONST_NULL;
        } else {
            instruction = new org.apache.bcel.generic.LDC( cp.addString( value ) );
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, java.lang.Number value )
    {
        if (value instanceof java.lang.Integer || value instanceof java.lang.Short || value instanceof java.lang.Byte) {
            instruction = (new org.apache.bcel.generic.PUSH( cp, value.intValue() )).instruction;
        } else {
            if (value instanceof java.lang.Double) {
                instruction = (new org.apache.bcel.generic.PUSH( cp, value.doubleValue() )).instruction;
            } else {
                if (value instanceof java.lang.Float) {
                    instruction = (new org.apache.bcel.generic.PUSH( cp, value.floatValue() )).instruction;
                } else {
                    if (value instanceof java.lang.Long) {
                        instruction = (new org.apache.bcel.generic.PUSH( cp, value.longValue() )).instruction;
                    } else {
                        throw new org.apache.bcel.generic.ClassGenException( "What's this: " + value );
                    }
                }
            }
        }
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, java.lang.Character value )
    {
        this( cp, value.charValue() );
    }

    public PUSH( org.apache.bcel.generic.ConstantPoolGen cp, java.lang.Boolean value )
    {
        this( cp, value.booleanValue() );
    }

    public final  org.apache.bcel.generic.InstructionList getInstructionList()
    {
        return new org.apache.bcel.generic.InstructionList( instruction );
    }

    public final  org.apache.bcel.generic.Instruction getInstruction()
    {
        return instruction;
    }

    public  java.lang.String toString()
    {
        return instruction.toString() + " (PUSH)";
    }

}
