// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.ByteArrayInputStream;
import java.util.Hashtable;
import org.apache.bcel.Constants;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Utility;


public class ClassLoader extends java.lang.ClassLoader
{

    public static final java.lang.String[] DEFAULT_IGNORED_PACKAGES = { "java.", "javax.", "sun." };

    private java.util.Hashtable classes = new java.util.Hashtable();

    private java.lang.String[] ignored_packages;

    private org.apache.bcel.util.Repository repository = SyntheticRepository.getInstance();

    public ClassLoader()
    {
        this( DEFAULT_IGNORED_PACKAGES );
    }

    public ClassLoader( java.lang.ClassLoader deferTo )
    {
        super( deferTo );
        this.ignored_packages = DEFAULT_IGNORED_PACKAGES;
        this.repository = new org.apache.bcel.util.ClassLoaderRepository( deferTo );
    }

    public ClassLoader( java.lang.String[] ignored_packages )
    {
        this.ignored_packages = ignored_packages;
    }

    public ClassLoader( java.lang.ClassLoader deferTo, java.lang.String[] ignored_packages )
    {
        this( ignored_packages );
        this.repository = new org.apache.bcel.util.ClassLoaderRepository( deferTo );
    }

    protected  java.lang.Class loadClass( java.lang.String class_name, boolean resolve )
        throws java.lang.ClassNotFoundException
    {
        java.lang.Class cl = null;
        if ((cl = (java.lang.Class) classes.get( class_name )) == null) {
            for (int i = 0; i < ignored_packages.length; i++) {
                if (class_name.startsWith( ignored_packages[i] )) {
                    cl = getParent().loadClass( class_name );
                    break;
                }
            }
            if (cl == null) {
                org.apache.bcel.classfile.JavaClass clazz = null;
                if (class_name.indexOf( "$$BCEL$$" ) >= 0) {
                    clazz = createClass( class_name );
                } else {
                    if ((clazz = repository.loadClass( class_name )) != null) {
                        clazz = modifyClass( clazz );
                    } else {
                        throw new java.lang.ClassNotFoundException( class_name );
                    }
                }
                if (clazz != null) {
                    byte[] bytes = clazz.getBytes();
                    cl = defineClass( class_name, bytes, 0, bytes.length );
                } else {
                    cl = Class.forName( class_name );
                }
            }
            if (resolve) {
                resolveClass( cl );
            }
        }
        classes.put( class_name, cl );
        return cl;
    }

    protected  org.apache.bcel.classfile.JavaClass modifyClass( org.apache.bcel.classfile.JavaClass clazz )
    {
        return clazz;
    }

    protected  org.apache.bcel.classfile.JavaClass createClass( java.lang.String class_name )
    {
        int index = class_name.indexOf( "$$BCEL$$" );
        java.lang.String real_name = class_name.substring( index + 8 );
        org.apache.bcel.classfile.JavaClass clazz = null;
        try {
            byte[] bytes = Utility.decode( real_name, true );
            org.apache.bcel.classfile.ClassParser parser = new org.apache.bcel.classfile.ClassParser( new java.io.ByteArrayInputStream( bytes ), "foo" );
            clazz = parser.parse();
        } catch ( java.lang.Throwable e ) {
            e.printStackTrace();
            return null;
        }
        org.apache.bcel.classfile.ConstantPool cp = clazz.getConstantPool();
        org.apache.bcel.classfile.ConstantClass cl = (org.apache.bcel.classfile.ConstantClass) cp.getConstant( clazz.getClassNameIndex(), Constants.CONSTANT_Class );
        org.apache.bcel.classfile.ConstantUtf8 name = (org.apache.bcel.classfile.ConstantUtf8) cp.getConstant( cl.getNameIndex(), Constants.CONSTANT_Utf8 );
        name.setBytes( class_name.replace( '.', '/' ) );
        return clazz;
    }

}
