// This is a mutant program.
// Author : ysma

package com.mongodb;


public class CommandResult extends com.mongodb.BasicDBObject
{

    CommandResult( com.mongodb.ServerAddress srv )
    {
        if (srv == null) {
            throw new java.lang.IllegalArgumentException( "server address is null" );
        }
        _host = srv;
        put( "serverUsed", srv.toString() );
    }

    public  boolean ok()
    {
        java.lang.Object okValue = get( "ok" );
        if (okValue == null) {
            return false;
        }
        if (okValue instanceof java.lang.Boolean) {
            return (java.lang.Boolean) okValue;
        }
        if (okValue instanceof java.lang.Number) {
            return ((java.lang.Number) okValue).intValue() == 1;
        }
        throw new com.mongodb.MongoInternalException( "Unexpected value type for 'ok' field in command result: " + okValue.getClass().getSimpleName() );
    }

    public  java.lang.String getErrorMessage()
    {
        java.lang.Object errorMessage = get( "errmsg" );
        if (errorMessage == null) {
            return null;
        }
        return errorMessage.toString();
    }

    public  com.mongodb.MongoException getException()
    {
        if (!ok()) {
            if (getCode() == 50) {
                return new com.mongodb.MongoExecutionTimeoutException( getCode(), getErrorMessage() );
            } else {
                return new com.mongodb.CommandFailureException( this );
            }
        } else {
            if (hasErr()) {
                if (getCode() == 11000 || getCode() == 11001 || getCode() == 12582) {
                    return new com.mongodb.MongoException.DuplicateKey( this );
                } else {
                    return new com.mongodb.WriteConcernException( this );
                }
            }
        }
        return null;
    }

     int getCode()
    {
        int code = -1;
        if (get( "code" ) instanceof java.lang.Number) {
            code = ((java.lang.Number) get( "code" )).intValue();
        }
        return code;
    }

     boolean hasErr()
    {
        java.lang.Object o = get( "err" );
        return o != null && ((java.lang.String) o).length() > 0;
    }

    public  void throwOnError()
    {
        if (!ok() || hasErr()) {
            throw getException();
        }
    }

    public  com.mongodb.ServerAddress getServerUsed()
    {
        return _host;
    }

    private final com.mongodb.ServerAddress _host;

    private static final long serialVersionUID = 1L;

}
