// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.ArrayList;
import java.util.List;


class CompositeServerSelector implements com.mongodb.ServerSelector
{

    private final java.util.List<ServerSelector> serverSelectors;

    CompositeServerSelector( final java.util.List<ServerSelector> serverSelectors )
    {
        if (serverSelectors.isEmpty()) {
            throw new java.lang.IllegalArgumentException( "Server selectors can not be an empty list" );
        }
        this.serverSelectors = new java.util.ArrayList<ServerSelector>( serverSelectors );
    }

    public  java.util.List<ServerDescription> choose( final com.mongodb.ClusterDescription clusterDescription )
    {
        com.mongodb.ClusterDescription curClusterDescription = clusterDescription;
        java.util.List<ServerDescription> choices = null;
        for (com.mongodb.ServerSelector cur: serverSelectors) {
            choices = cur.choose( curClusterDescription );
            curClusterDescription = new com.mongodb.ClusterDescription( clusterDescription.getConnectionMode(), clusterDescription.getType(), choices );
        }
        return choices;
    }

    public  java.lang.String toString()
    {
        return "CompositeServerSelector{" + "serverSelectors=" + serverSelectors + '}';
    }

}
