// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.BSONObject;
import org.bson.BasicBSONCallback;
import org.bson.types.ObjectId;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;


public class DefaultDBCallback extends org.bson.BasicBSONCallback implements com.mongodb.DBCallback
{

    static class DefaultFactory implements com.mongodb.DBCallbackFactory
    {

        public  com.mongodb.DBCallback create( com.mongodb.DBCollection collection )
        {
            return new com.mongodb.DefaultDBCallback( collection );
        }

    }

    public static com.mongodb.DBCallbackFactory FACTORY = new com.mongodb.DefaultDBCallback.DefaultFactory();

    public DefaultDBCallback( com.mongodb.DBCollection coll )
    {
        _collection = coll;
        _db = _collection == null ? null : _collection.getDB();
    }

    public  void gotDBRef( java.lang.String name, java.lang.String ns, org.bson.types.ObjectId id )
    {
        if (id.equals( Bytes.COLLECTION_REF_ID )) {
            cur().put( name, _collection );
        } else {
            cur().put( name, new com.mongodb.DBRef( _db, ns, id ) );
        }
    }

    public  void objectStart( boolean array, java.lang.String name )
    {
        _nameStack.addLast( name );
        super.objectStart( array, name );
    }

    public  java.lang.Object objectDone()
    {
        org.bson.BSONObject o = (org.bson.BSONObject) super.objectDone();
        java.lang.String lastName = null;
        if (_nameStack.size() > 0) {
            lastName = _nameStack.removeLast();
        }
        if (!(o instanceof java.util.List) && lastName != null && o.containsField( "$ref" ) && o.containsField( "$id" )) {
            return cur().put( lastName, new com.mongodb.DBRef( _db, o ) );
        }
        return o;
    }

    public  org.bson.BSONObject create()
    {
        return _create( null );
    }

    public  org.bson.BSONObject create( boolean array, java.util.List<String> path )
    {
        if (array) {
            return new com.mongodb.BasicDBList();
        }
        return _create( path );
    }

    private  com.mongodb.DBObject _create( java.util.List<String> path )
    {
        java.lang.Class c = null;
        if (_collection != null && _collection._objectClass != null) {
            if (path == null || path.size() == 0) {
                c = _collection._objectClass;
            } else {
                java.lang.StringBuilder buf = new java.lang.StringBuilder();
                for (int i = 0; i < path.size(); i++) {
                    if (i > 0) {
                        buf.append( "." );
                    }
                    buf.append( path.get( i ) );
                }
                c = _collection.getInternalClass( buf.toString() );
            }
        }
        if (c != null) {
            try {
                return (com.mongodb.DBObject) c.newInstance();
            } catch ( java.lang.InstantiationException ie ) {
                LOGGER.log( Level.FINE, "can't create a: " + c, ie );
                throw new com.mongodb.MongoInternalException( "can't instantiate a : " + c, ie );
            } catch ( java.lang.IllegalAccessException iae ) {
                LOGGER.log( Level.FINE, "can't create a: " + c, iae );
                throw new com.mongodb.MongoInternalException( "can't instantiate a : " + c, iae );
            }
        }
        return new com.mongodb.BasicDBObject();
    }

     com.mongodb.DBObject dbget()
    {
        return (com.mongodb.DBObject) get();
    }

    public  void reset()
    {
        _nameStack = new java.util.LinkedList<String>();
        super.reset();
    }

    private java.util.LinkedList<String> _nameStack;

    final com.mongodb.DBCollection _collection;

    final com.mongodb.DB _db;

    static final java.util.logging.Logger LOGGER = Logger.getLogger( "com.mongo.DECODING" );

}
