// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.io.OutputBuffer;
import org.bson.types.ObjectId;
import java.util.List;


class InsertCommandMessage extends com.mongodb.BaseWriteCommandMessage
{

    private final java.util.List<DBObject> documents;

    private final com.mongodb.DBEncoder encoder;

    public InsertCommandMessage( final com.mongodb.MongoNamespace namespace, final com.mongodb.WriteConcern writeConcern, final java.util.List<DBObject> documents, final com.mongodb.DBEncoder commandEncoder, final com.mongodb.DBEncoder encoder, final com.mongodb.MessageSettings settings )
    {
        super( namespace, writeConcern, commandEncoder, settings );
        this.documents = documents;
        this.encoder = encoder;
    }

    protected  java.lang.String getCommandName()
    {
        return "insert";
    }

    protected  com.mongodb.InsertCommandMessage writeTheWrites( final org.bson.io.OutputBuffer buffer, final int commandStartPosition, final com.mongodb.BSONBinaryWriter writer )
    {
        com.mongodb.InsertCommandMessage nextMessage = null;
        writer.writeStartArray( "documents" );
        writer.pushMaxDocumentSize( getSettings().getMaxDocumentSize() );
        for (int i = 0; i < documents.size(); i++) {
            writer.mark();
            writer.encodeDocument( encoder, documents.get( i ) );
            if (maximumCommandDocumentSizeExceeded( buffer, commandStartPosition )) {
                writer.reset();
                nextMessage = new com.mongodb.InsertCommandMessage( getWriteNamespace(), getWriteConcern(), documents.subList( i, documents.size() ), getCommandEncoder(), encoder, getSettings() );
                break;
            }
        }
        writer.popMaxDocumentSize();
        writer.writeEndArray();
        return nextMessage;
    }

}
