// This is a mutant program.
// Author : ysma

package com.mongodb;


class QueryOpBuilder
{

    static final java.lang.String READ_PREFERENCE_META_OPERATOR = "$readPreference";

    private com.mongodb.DBObject query;

    private com.mongodb.DBObject orderBy;

    private com.mongodb.DBObject hintObj;

    private java.lang.String hintStr;

    private boolean explain;

    private boolean snapshot;

    private long maxTimeMS;

    private com.mongodb.ReadPreference readPref;

    private com.mongodb.DBObject specialFields;

    public QueryOpBuilder()
    {
    }

    public  com.mongodb.QueryOpBuilder addQuery( com.mongodb.DBObject query )
    {
        this.query = query;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addOrderBy( com.mongodb.DBObject orderBy )
    {
        this.orderBy = orderBy;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addHint( java.lang.String hint )
    {
        this.hintStr = hint;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addHint( com.mongodb.DBObject hint )
    {
        this.hintObj = hint;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addSpecialFields( com.mongodb.DBObject specialFields )
    {
        this.specialFields = specialFields;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addExplain( boolean explain )
    {
        this.explain = explain;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addSnapshot( boolean snapshot )
    {
        this.snapshot = snapshot;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addReadPreference( com.mongodb.ReadPreference readPref )
    {
        this.readPref = readPref;
        return this;
    }

    public  com.mongodb.QueryOpBuilder addMaxTimeMS( final long maxTimeMS )
    {
        this.maxTimeMS = maxTimeMS;
        return this;
    }

    public  com.mongodb.DBObject get()
    {
        com.mongodb.DBObject lclQuery = query;
        if (lclQuery == null) {
            lclQuery = new com.mongodb.BasicDBObject();
        }
        if (hasSpecialQueryFields()) {
            com.mongodb.DBObject queryop = specialFields == null ? new com.mongodb.BasicDBObject() : specialFields;
            addToQueryObject( queryop, "$query", lclQuery, true );
            addToQueryObject( queryop, "$orderby", orderBy, false );
            if (hintStr != null) {
                addToQueryObject( queryop, "$hint", hintStr );
            }
            if (hintObj != null) {
                addToQueryObject( queryop, "$hint", hintObj );
            }
            if (explain) {
                queryop.put( "$explain", true );
            }
            if (snapshot) {
                queryop.put( "$snapshot", true );
            }
            if (readPref != null && readPref != ReadPreference.primary()) {
                queryop.put( READ_PREFERENCE_META_OPERATOR, readPref.toDBObject() );
            }
            if (maxTimeMS > 0) {
                queryop.put( "$maxTimeMS", maxTimeMS );
            }
            return queryop;
        }
        return lclQuery;
    }

    private  boolean hasSpecialQueryFields()
    {
        if (readPref != null) {
            return true;
        }
        if (specialFields != null) {
            return true;
        }
        if (orderBy != null && orderBy.keySet().size() > 0) {
            return true;
        }
        if (hintStr != null || hintObj != null || snapshot || explain) {
            return true;
        }
        if (maxTimeMS > 0) {
            return true;
        }
        return false;
    }

    private  void addToQueryObject( com.mongodb.DBObject dbobj, java.lang.String field, com.mongodb.DBObject obj, boolean sendEmpty )
    {
        if (obj == null) {
            return;
        }
        if (!sendEmpty && obj.keySet().size() == 0) {
            return;
        }
        addToQueryObject( dbobj, field, obj );
    }

    private  void addToQueryObject( com.mongodb.DBObject dbobj, java.lang.String field, java.lang.Object obj )
    {
        if (obj == null) {
            return;
        }
        dbobj.put( field, obj );
    }

}
