// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.concurrent.TimeUnit;
import static org.bson.util.Assertions.notNull;


class ServerSettings
{

    private final long heartbeatFrequencyMS;

    private final long heartbeatConnectRetryFrequencyMS;

    private final com.mongodb.SocketSettings heartbeatSocketSettings;

    public static  com.mongodb.ServerSettings.Builder builder()
    {
        return new com.mongodb.ServerSettings.Builder();
    }

    public static class Builder
    {

        private long heartbeatFrequencyMS = 5000;

        private long heartbeatConnectRetryFrequencyMS = 10;

        private com.mongodb.SocketSettings heartbeatSocketSettings = SocketSettings.builder().build();

        public  com.mongodb.ServerSettings.Builder heartbeatFrequency( final long heartbeatFrequency, final java.util.concurrent.TimeUnit timeUnit )
        {
            this.heartbeatFrequencyMS = TimeUnit.MILLISECONDS.convert( heartbeatFrequency, timeUnit );
            return this;
        }

        public  com.mongodb.ServerSettings.Builder heartbeatConnectRetryFrequency( final long heartbeatConnectRetryFrequency, final java.util.concurrent.TimeUnit timeUnit )
        {
            this.heartbeatConnectRetryFrequencyMS = TimeUnit.MILLISECONDS.convert( heartbeatConnectRetryFrequency, timeUnit );
            return this;
        }

        public  com.mongodb.ServerSettings.Builder heartbeatSocketSettings( final com.mongodb.SocketSettings heartbeatSocketSettings )
        {
            this.heartbeatSocketSettings = org.bson.util.Assertions.notNull( "heartbeatSocketSettings", heartbeatSocketSettings );
            return this;
        }

        public  com.mongodb.ServerSettings build()
        {
            return new com.mongodb.ServerSettings( this );
        }

    }

    public  long getHeartbeatFrequency( final java.util.concurrent.TimeUnit timeUnit )
    {
        return timeUnit.convert( heartbeatFrequencyMS, TimeUnit.MILLISECONDS );
    }

    public  long getHeartbeatConnectRetryFrequency( final java.util.concurrent.TimeUnit timeUnit )
    {
        return timeUnit.convert( heartbeatConnectRetryFrequencyMS, TimeUnit.MILLISECONDS );
    }

    public  com.mongodb.SocketSettings getHeartbeatSocketSettings()
    {
        return heartbeatSocketSettings;
    }

    ServerSettings( final com.mongodb.ServerSettings.Builder builder )
    {
        heartbeatFrequencyMS = builder.heartbeatFrequencyMS;
        heartbeatConnectRetryFrequencyMS = builder.heartbeatConnectRetryFrequencyMS;
        heartbeatSocketSettings = builder.heartbeatSocketSettings;
    }

}
