// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


class StickyHAShardedClusterServerSelector implements com.mongodb.ServerSelector
{

    private com.mongodb.ServerAddress stickyMongos;

    private java.util.Set<ServerAddress> consideredServers = new java.util.HashSet<ServerAddress>();

    public  java.util.List<ServerDescription> choose( final com.mongodb.ClusterDescription clusterDescription )
    {
        if (clusterDescription.getConnectionMode() != ClusterConnectionMode.Multiple || clusterDescription.getType() != ClusterType.Sharded) {
            throw new java.lang.IllegalArgumentException( "This is not a sharded cluster with multiple mongos servers" );
        }
        java.util.Set<ServerAddress> okServers = getOkServers( clusterDescription );
        synchronized (this)
{
            if (!consideredServers.containsAll( okServers ) || !okServers.contains( stickyMongos )) {
                if (stickyMongos != null && !okServers.contains( stickyMongos )) {
                    stickyMongos = null;
                    consideredServers.clear();
                }
                com.mongodb.ServerDescription fastestServer = null;
                for (com.mongodb.ServerDescription cur: clusterDescription.getAny()) {
                    if (fastestServer == null || cur.getAveragePingTimeNanos() < fastestServer.getAveragePingTimeNanos()) {
                        fastestServer = cur;
                    }
                }
                if (fastestServer != null) {
                    stickyMongos = fastestServer.getAddress();
                    consideredServers.addAll( okServers );
                }
            }
            if (stickyMongos == null) {
                return Collections.emptyList();
            } else {
                return Arrays.asList( clusterDescription.getByServerAddress( stickyMongos ) );
            }
        }
    }

    public  java.lang.String toString()
    {
        return "StickyHAShardedClusterServerSelector{" + "stickyMongos=" + stickyMongos + '}';
    }

    private  java.util.Set<ServerAddress> getOkServers( final com.mongodb.ClusterDescription clusterDescription )
    {
        java.util.Set<ServerAddress> okServers = new java.util.HashSet<ServerAddress>();
        for (com.mongodb.ServerDescription cur: clusterDescription.getAny()) {
            okServers.add( cur.getAddress() );
        }
        return okServers;
    }

}
