// This is a mutant program.
// Author : ysma

package com.mongodb.io;


import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;


public class ByteBufferHolder
{

    public ByteBufferHolder()
    {
        this( 1024 * 1024 * 1024 );
    }

    public ByteBufferHolder( int max )
    {
        _max = max;
    }

    public  byte get( int i )
    {
        if (i >= _pos) {
            throw new java.lang.RuntimeException( "out of bounds" );
        }
        final int num = i / _bufSize;
        final int pos = i % _bufSize;
        return _buffers.get( num ).get( pos );
    }

    public  void get( int pos, byte[] b )
    {
        for (int i = 0; i < b.length; i++) {
            b[i] = get( i + pos );
        }
    }

    public  void put( int i, byte val )
    {
        if (i >= _pos) {
            throw new java.lang.RuntimeException( "out of bounds" );
        }
        final int num = i / _bufSize;
        final int pos = i % _bufSize;
        _buffers.get( num ).put( pos, val );
    }

    public  int position()
    {
        return _pos;
    }

    public  void position( int p )
    {
        _pos = p;
        int num = _pos / _bufSize;
        int pos = _pos % _bufSize;
        while (_buffers.size() <= num) {
            _addBucket();
        }
        java.nio.ByteBuffer bb = _buffers.get( num );
        bb.position( pos );
        for (int i = num + 1; i < _buffers.size(); i++) {
            _buffers.get( i ).position( 0 );
        }
    }

    public  int remaining()
    {
        return Integer.MAX_VALUE;
    }

    public  void put( java.nio.ByteBuffer in )
    {
        while (in.hasRemaining()) {
            int num = _pos / _bufSize;
            if (num >= _buffers.size()) {
                _addBucket();
            }
            java.nio.ByteBuffer bb = _buffers.get( num );
            final int canRead = Math.min( bb.remaining(), in.remaining() );
            final int oldLimit = in.limit();
            in.limit( in.position() + canRead );
            bb.put( in );
            in.limit( oldLimit );
            _pos += canRead;
        }
    }

    private  void _addBucket()
    {
        if (capacity() + _bufSize > _max) {
            throw new java.lang.RuntimeException( "too big current:" + capacity() );
        }
        _buffers.add( ByteBuffer.allocateDirect( _bufSize ) );
    }

    public  int capacity()
    {
        return _buffers.size() * _bufSize;
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuilder buf = new java.lang.StringBuilder();
        buf.append( "{ ByteBufferHolder pos:" + _pos + " " );
        for (java.nio.ByteBuffer bb: _buffers) {
            buf.append( bb ).append( " " );
        }
        return buf.append( "}" ).toString();
    }

    java.util.List<ByteBuffer> _buffers = new java.util.ArrayList<ByteBuffer>();

    int _pos = 0;

    final int _max;

    static final int _bufSize = 4096;

}
