// This is a mutant program.
// Author : ysma

package com.mongodb.io;


import java.io.InputStream;
import java.nio.ByteBuffer;
import java.util.List;


public class ByteBufferInputStream extends java.io.InputStream
{

    public ByteBufferInputStream( java.util.List<ByteBuffer> lst )
    {
        this( lst, false );
    }

    public ByteBufferInputStream( java.util.List<ByteBuffer> lst, boolean flip )
    {
        _lst = lst;
        if (flip) {
            for (java.nio.ByteBuffer buf: _lst) {
                buf.flip();
            }
        }
    }

    public  int available()
    {
        int avail = 0;
        for (int i = _pos; i < _lst.size(); i++) {
            avail += _lst.get( i ).remaining();
        }
        return avail;
    }

    public  void close()
    {
    }

    public  void mark( int readlimit )
    {
        throw new java.lang.RuntimeException( "mark not supported" );
    }

    public  void reset()
    {
        throw new java.lang.RuntimeException( "mark not supported" );
    }

    public  boolean markSupported()
    {
        return false;
    }

    public  int read()
    {
        if (_pos >= _lst.size()) {
            return -1;
        }
        java.nio.ByteBuffer buf = _lst.get( _pos );
        if (buf.remaining() > 0) {
            return buf.get() & 0xff;
        }
        _pos++;
        return read();
    }

    public  int read( byte[] b )
    {
        return read( b, 0, b.length );
    }

    public  int read( byte[] b, int off, int len )
    {
        if (_pos >= _lst.size()) {
            return -1;
        }
        java.nio.ByteBuffer buf = _lst.get( _pos );
        if (buf.remaining() == 0) {
            _pos++;
            return read( b, off, len );
        }
        int toRead = Math.min( len, buf.remaining() );
        buf.get( b, off, toRead );
        if (toRead == len || _pos + 1 >= _lst.size()) {
            return toRead;
        }
        _pos++;
        return toRead + read( b, off + toRead, len - toRead );
    }

    public  long skip( long n )
    {
        long skipped = 0;
        while (n >= 0 && _pos < _lst.size()) {
            java.nio.ByteBuffer b = _lst.get( _pos );
            if (b.remaining() < n) {
                skipped += b.remaining();
                n -= b.remaining();
                b.position( b.limit() );
                _pos++;
                continue;
            }
            skipped += n;
            b.position( (int) (b.position() + n) );
            return skipped;
        }
        return skipped;
    }

    final java.util.List<ByteBuffer> _lst;

    private int _pos = 0;

}
