// This is a mutant program.
// Author : ysma

package com.mongodb.util;


import org.bson.BSONCallback;
import com.mongodb.DBObject;


public class JSON
{

    public static  java.lang.String serialize( java.lang.Object o )
    {
        java.lang.StringBuilder buf = new java.lang.StringBuilder();
        serialize( o, buf );
        return buf.toString();
    }

    public static  void serialize( java.lang.Object o, java.lang.StringBuilder buf )
    {
        JSONSerializers.getLegacy().serialize( o, buf );
    }

    public static  java.lang.Object parse( java.lang.String s )
    {
        return parse( s, null );
    }

    public static  java.lang.Object parse( java.lang.String s, org.bson.BSONCallback c )
    {
        if (s == null || (s = s.trim()).equals( "" )) {
            return (com.mongodb.DBObject) null;
        }
        com.mongodb.util.JSONParser p = new com.mongodb.util.JSONParser( s, c );
        return p.parse();
    }

    static  void string( java.lang.StringBuilder a, java.lang.String s )
    {
        a.append( "\"" );
        for (int i = 0; i < s.length(); ++i) {
            char c = s.charAt( i );
            if (c == '\\') {
                a.append( "\\\\" );
            } else {
                if (c == '"') {
                    a.append( "\\\"" );
                } else {
                    if (c == '\n') {
                        a.append( "\\n" );
                    } else {
                        if (c == '\r') {
                            a.append( "\\r" );
                        } else {
                            if (c == '\t') {
                                a.append( "\\t" );
                            } else {
                                if (c == '\b') {
                                    a.append( "\\b" );
                                } else {
                                    if (c < 32) {
                                        continue;
                                    } else {
                                        a.append( c );
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        a.append( "\"" );
    }

}

class JSONParser
{

    java.lang.String s;

    int pos = 0;

    org.bson.BSONCallback _callback;

    public JSONParser( java.lang.String s )
    {
        this( s, null );
    }

    public JSONParser( java.lang.String s, org.bson.BSONCallback callback )
    {
        this.s = s;
        _callback = callback == null ? new com.mongodb.util.JSONCallback() : callback;
    }

    public  java.lang.Object parse()
    {
        return parse( null );
    }

    protected  java.lang.Object parse( java.lang.String name )
    {
        java.lang.Object value = null;
        char current = get();
        switch (current) {
        case 'n' :
            read( 'n' );
            read( 'u' );
            read( 'l' );
            read( 'l' );
            value = null;
            break;

        case 'N' :
            read( 'N' );
            read( 'a' );
            read( 'N' );
            value = Double.NaN;
            break;

        case 't' :
            read( 't' );
            read( 'r' );
            read( 'u' );
            read( 'e' );
            value = true;
            break;

        case 'f' :
            read( 'f' );
            read( 'a' );
            read( 'l' );
            read( 's' );
            read( 'e' );
            value = false;
            break;

        case '\'' :
        case '\"' :
            value = parseString( true );
            break;

        case '0' :
        case '1' :
        case '2' :
        case '3' :
        case '4' :
        case '5' :
        case '6' :
        case '7' :
        case '8' :
        case '9' :
        case '+' :
        case '-' :
            value = parseNumber();
            break;

        case '[' :
            value = parseArray( name );
            break;

        case '{' :
            value = parseObject( name );
            break;

        default  :
            throw new com.mongodb.util.JSONParseException( s, pos );

        }
        return value;
    }

    public  java.lang.Object parseObject()
    {
        return parseObject( null );
    }

    protected  java.lang.Object parseObject( java.lang.String name )
    {
        if (name != null) {
            _callback.objectStart( name );
        } else {
            _callback.objectStart();
        }
        read( '{' );
        char current = get();
        while (get() != '}') {
            java.lang.String key = parseString( false );
            read( ':' );
            java.lang.Object value = parse( key );
            doCallback( key, value );
            if ((current = get()) == ',') {
                read( ',' );
            } else {
                break;
            }
        }
        read( '}' );
        return _callback.objectDone();
    }

    protected  void doCallback( java.lang.String name, java.lang.Object value )
    {
        if (value == null) {
            _callback.gotNull( name );
        } else {
            if (value instanceof java.lang.String) {
                _callback.gotString( name, (java.lang.String) value );
            } else {
                if (value instanceof java.lang.Boolean) {
                    _callback.gotBoolean( name, (java.lang.Boolean) value );
                } else {
                    if (value instanceof java.lang.Integer) {
                        _callback.gotInt( name, (java.lang.Integer) value );
                    } else {
                        if (value instanceof java.lang.Long) {
                            _callback.gotLong( name, (java.lang.Long) value );
                        } else {
                            if (value instanceof java.lang.Double) {
                                _callback.gotDouble( name, (java.lang.Double) value );
                            }
                        }
                    }
                }
            }
        }
    }

    public  void read( char ch )
    {
        if (!check( ch )) {
            throw new com.mongodb.util.JSONParseException( s, pos );
        }
        pos++;
    }

    public  char read()
    {
        if (pos >= s.length()) {
            throw new java.lang.IllegalStateException( "string done" );
        }
        return s.charAt( pos++ );
    }

    public  void readHex()
    {
        if (pos < s.length() && (s.charAt( pos ) >= '0' && s.charAt( pos ) <= '9' || s.charAt( pos ) >= 'A' && s.charAt( pos ) <= 'F' || s.charAt( pos ) >= 'a' && s.charAt( pos ) <= 'f')) {
            pos++;
        } else {
            throw new com.mongodb.util.JSONParseException( s, pos );
        }
    }

    public  boolean check( char ch )
    {
        return get() == ch;
    }

    public  void skipWS()
    {
        while (pos < s.length() && Character.isWhitespace( s.charAt( pos ) )) {
            pos++;
        }
    }

    public  char get()
    {
        skipWS();
        if (pos < s.length()) {
            return s.charAt( pos );
        }
        return (char) (-1);
    }

    public  java.lang.String parseString( boolean needQuote )
    {
        char quot = 0;
        if (check( '\'' )) {
            quot = '\'';
        } else {
            if (check( '\"' )) {
                quot = '\"';
            } else {
                if (needQuote) {
                    throw new com.mongodb.util.JSONParseException( s, pos );
                }
            }
        }
        char current;
        if (quot > 0) {
            read( quot );
        }
        java.lang.StringBuilder buf = new java.lang.StringBuilder();
        int start = pos;
        while (pos < s.length()) {
            current = s.charAt( pos );
            if (quot > 0) {
                if (current == quot) {
                    break;
                }
            } else {
                if (current == ':' || current == ' ') {
                    break;
                }
            }
            if (current == '\\') {
                pos++;
                char x = get();
                char special = 0;
                switch (x) {
                case 'u' :
                    {
                        buf.append( s.substring( start, pos - 1 ) );
                        pos++;
                        int tempPos = pos;
                        readHex();
                        readHex();
                        readHex();
                        readHex();
                        int codePoint = Integer.parseInt( s.substring( tempPos, tempPos + 4 ), 16 );
                        buf.append( (char) codePoint );
                        start = pos;
                        continue;
                    }

                case 'n' :
                    special = '\n';
                    break;

                case 'r' :
                    special = '\r';
                    break;

                case 't' :
                    special = '\t';
                    break;

                case 'b' :
                    special = '\b';
                    break;

                case '"' :
                    special = '\"';
                    break;

                case '\\' :
                    special = '\\';
                    break;

                }
                buf.append( s.substring( start, pos - 1 ) );
                if (special != 0) {
                    pos++;
                    buf.append( special );
                }
                start = pos;
                continue;
            }
            pos++;
        }
        buf.append( s.substring( start, pos ) );
        if (quot > 0) {
            read( quot );
        }
        return buf.toString();
    }

    public  java.lang.Number parseNumber()
    {
        char current = get();
        int start = this.pos;
        boolean isDouble = false;
        if (check( '-' ) || check( '+' )) {
            pos++;
        }
        outer : 
        while (pos < s.length()) {
            switch (s.charAt( pos )) {
            case '0' :
            case '1' :
            case '2' :
            case '3' :
            case '4' :
            case '5' :
            case '6' :
            case '7' :
            case '8' :
            case '9' :
                pos++;
                break;

            case '.' :
                isDouble = true;
                parseFraction();
                break;

            case 'e' :
            case 'E' :
                isDouble = true;
                parseExponent();
                break;

            default  :
                break outer;

            }
        }
        try {
            if (isDouble) {
                return Double.valueOf( s.substring( start, pos ) );
            }
            java.lang.Long val = Long.valueOf( s.substring( start, pos ) );
            if (val <= Integer.MAX_VALUE && val >= Integer.MIN_VALUE) {
                return val.intValue();
            }
            return val;
        } catch ( java.lang.NumberFormatException e ) {
            throw new com.mongodb.util.JSONParseException( s, start, e );
        }
    }

    public  void parseFraction()
    {
        pos++;
        outer : 
        while (pos < s.length()) {
            switch (s.charAt( pos )) {
            case '0' :
            case '1' :
            case '2' :
            case '3' :
            case '4' :
            case '5' :
            case '6' :
            case '7' :
            case '8' :
            case '9' :
                pos++;
                break;

            case 'e' :
            case 'E' :
                parseExponent();
                break;

            default  :
                break outer;

            }
        }
    }

    public  void parseExponent()
    {
        pos++;
        if (check( '-' ) || check( '+' )) {
            pos++;
        }
        outer : 
        while (pos < s.length()) {
            switch (s.charAt( pos )) {
            case '0' :
            case '1' :
            case '2' :
            case '3' :
            case '4' :
            case '5' :
            case '6' :
            case '7' :
            case '8' :
            case '9' :
                pos++;
                break;

            default  :
                break outer;

            }
        }
    }

    public  java.lang.Object parseArray()
    {
        return parseArray( null );
    }

    protected  java.lang.Object parseArray( java.lang.String name )
    {
        if (name != null) {
            _callback.arrayStart( name );
        } else {
            _callback.arrayStart();
        }
        read( '[' );
        int i = 0;
        char current = get();
        while (current != ']') {
            java.lang.String elemName = String.valueOf( i++ );
            java.lang.Object elem = parse( elemName );
            doCallback( elemName, elem );
            if ((current = get()) == ',') {
                read( ',' );
            } else {
                if (current == ']') {
                    break;
                } else {
                    throw new com.mongodb.util.JSONParseException( s, pos );
                }
            }
        }
        read( ']' );
        return _callback.arrayDone();
    }

}
