package com.mongodb;


import com.mongodb.MongoClientOptions;

import com.mongodb.util.TestCase;
import com.mongodb.MongoClientOptions.Builder;
import org.testng.annotations.Test;
import com.mongodb.DBDecoderFactory;
import com.mongodb.MongoOptions;
import com.mongodb.WriteConcern;
import com.mongodb.DBEncoderFactory;
import java.lang.String;
import com.mongodb.ReadPreference;
import javax.net.SocketFactory;

public class MongoOptionsGenTest extends TestCase {
	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions585() throws Exception {
		MongoOptions var723 = new MongoOptions(
				new MongoClientOptions.Builder().build());
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions586() throws Exception {
		MongoClientOptions var724 = new MongoClientOptions.Builder()
				.connectionsPerHost(500).build();
		MongoOptions var725 = new MongoOptions(var724);
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions587() throws Exception {
		MongoOptions var723 = new MongoOptions(
				new MongoClientOptions.Builder().build());
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions588() throws Exception {
		MongoOptions var723 = new MongoOptions(
				new MongoClientOptions.Builder().build());
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions589() throws Exception {
		MongoOptions var723 = new MongoOptions(
				new MongoClientOptions.Builder().build());
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions590() throws Exception {
		MongoOptions var726 = new MongoOptions();
		var726.copy();
		var726.setReadPreference(ReadPreference.nearest());
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions591() throws Exception {
		MongoOptions var726 = new MongoOptions();
		var726.setReadPreference(ReadPreference.nearest());
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions592() throws Exception {
		MongoOptions var726 = new MongoOptions();
		var726.setReadPreference(ReadPreference.nearest());
		var726.setConnectionsPerHost(100);
		var726.setThreadsAllowedToBlockForConnectionMultiplier(101);
		var726.setMaxWaitTime(102);
		var726.setConnectTimeout(103);
		var726.setSocketTimeout(104);
		var726.setSocketKeepAlive(true);
		var726.setAutoConnectRetry(true);
		var726.setMaxAutoConnectRetryTime(105);
		var726.setSafe(true);
		var726.setW(106);
		var726.setWtimeout(107);
		var726.setFsync(true);
		var726.setJ(false);
		var726.setDbDecoderFactory(null);
		var726.setDbEncoderFactory(null);
		var726.setSocketFactory(null);
		var726.setDescription("very cool");
		var726.setReadPreference(ReadPreference.secondary());
		var726.setCursorFinalizerEnabled(true);
		var726.setAlwaysUseMBeans(true);
		var726.getConnectionsPerHost();
		var726.getThreadsAllowedToBlockForConnectionMultiplier();
		var726.getMaxWaitTime();
		var726.getConnectTimeout();
		var726.getSocketTimeout();
		var726.isSocketKeepAlive();
		var726.isAutoConnectRetry();
		var726.getMaxAutoConnectRetryTime();
		var726.isSafe();
		var726.getW();
		var726.getWtimeout();
		var726.isFsync();
		var726.isJ();
		var726.getDbDecoderFactory();
		var726.getDbEncoderFactory();
		var726.getSocketFactory();
		var726.getDescription();
		var726.getReadPreference();
		var726.isCursorFinalizerEnabled();
		var726.isAlwaysUseMBeans();
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions593() throws Exception {
		MongoOptions var726 = new MongoOptions();
		var726.setReadPreference(ReadPreference.nearest());
		var726.setConnectionsPerHost(100);
		var726.setThreadsAllowedToBlockForConnectionMultiplier(101);
		var726.setMaxWaitTime(102);
		var726.setConnectTimeout(103);
		var726.setSocketTimeout(104);
		var726.setSocketKeepAlive(true);
		var726.setAutoConnectRetry(true);
		var726.setMaxAutoConnectRetryTime(105);
		var726.setSafe(true);
		var726.setW(106);
		var726.setWtimeout(107);
		var726.setFsync(true);
		var726.setJ(false);
		var726.setDbDecoderFactory(null);
		var726.setDbEncoderFactory(null);
		var726.setSocketFactory(null);
		var726.setDescription("very cool");
		var726.setReadPreference(ReadPreference.secondary());
		var726.setCursorFinalizerEnabled(true);
		var726.setAlwaysUseMBeans(true);
		var726.getConnectionsPerHost();
		var726.getThreadsAllowedToBlockForConnectionMultiplier();
		var726.getMaxWaitTime();
		var726.getConnectTimeout();
		var726.getSocketTimeout();
		var726.isSocketKeepAlive();
		var726.isAutoConnectRetry();
		var726.getMaxAutoConnectRetryTime();
		var726.isSafe();
		var726.getW();
		var726.getWtimeout();
		var726.isFsync();
		var726.isJ();
		var726.getDbDecoderFactory();
		var726.getDbEncoderFactory();
		var726.getSocketFactory();
		var726.getDescription();
		var726.getReadPreference();
		var726.isCursorFinalizerEnabled();
		var726.isAlwaysUseMBeans();
	}

	/**
	 * Test method for the class com.mongodb.MongoOptions
	 */
	@Test
	public void testMongoOptions594() throws Exception {
		MongoOptions var726 = new MongoOptions();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
		var726.reset();
		var726.getWriteConcern();
	}
}